/* ApiCallable.c generated by valac 0.36.3, the Vala compiler
 * generated from ApiCallable.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_API_CALLABLE (drt_api_callable_get_type ())
#define DRT_API_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_API_CALLABLE, DrtApiCallable))
#define DRT_API_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_API_CALLABLE, DrtApiCallableClass))
#define DRT_IS_API_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_API_CALLABLE))
#define DRT_IS_API_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_API_CALLABLE))
#define DRT_API_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_API_CALLABLE, DrtApiCallableClass))

typedef struct _DrtApiCallable DrtApiCallable;
typedef struct _DrtApiCallableClass DrtApiCallableClass;
typedef struct _DrtApiCallablePrivate DrtApiCallablePrivate;

#define DRT_TYPE_API_FLAGS (drt_api_flags_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DrtParamSpecApiCallable DrtParamSpecApiCallable;

struct _DrtApiCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtApiCallablePrivate * priv;
};

struct _DrtApiCallableClass {
	GTypeClass parent_class;
	void (*finalize) (DrtApiCallable *self);
	void (*run_with_args_tuple) (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
	void (*run_with_args_dict) (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
};

typedef enum  {
	DRT_API_FLAGS_PRIVATE = 1 << 0,
	DRT_API_FLAGS_READABLE = 1 << 1,
	DRT_API_FLAGS_WRITABLE = 1 << 2,
	DRT_API_FLAGS_SUBSCRIBE = 1 << 3
} DrtApiFlags;

struct _DrtApiCallablePrivate {
	gchar* _path;
	DrtApiFlags _flags;
	gchar* _description;
};

struct _DrtParamSpecApiCallable {
	GParamSpec parent_instance;
};


static gpointer drt_api_callable_parent_class = NULL;

gpointer drt_api_callable_ref (gpointer instance);
void drt_api_callable_unref (gpointer instance);
GParamSpec* drt_param_spec_api_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_api_callable (GValue* value, gpointer v_object);
void drt_value_take_api_callable (GValue* value, gpointer v_object);
gpointer drt_value_get_api_callable (const GValue* value);
GType drt_api_callable_get_type (void) G_GNUC_CONST;
GType drt_api_flags_get_type (void) G_GNUC_CONST;
#define DRT_API_CALLABLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_API_CALLABLE, DrtApiCallablePrivate))
enum  {
	DRT_API_CALLABLE_DUMMY_PROPERTY
};
void drt_api_callable_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
static void drt_api_callable_real_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
void drt_api_callable_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
static void drt_api_callable_real_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error);
DrtApiCallable* drt_api_callable_construct (GType object_type);
const gchar* drt_api_callable_get_path (DrtApiCallable* self);
void drt_api_callable_set_path (DrtApiCallable* self, const gchar* value);
DrtApiFlags drt_api_callable_get_flags (DrtApiCallable* self);
void drt_api_callable_set_flags (DrtApiCallable* self, DrtApiFlags value);
const gchar* drt_api_callable_get_description (DrtApiCallable* self);
void drt_api_callable_set_description (DrtApiCallable* self, const gchar* value);
static void drt_api_callable_finalize (DrtApiCallable * obj);


static void drt_api_callable_real_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_critical ("Type `%s' does not implement abstract method `drt_api_callable_run_with_args_tuple'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return;
#line 115 "ApiCallable.c"
}


void drt_api_callable_run_with_args_tuple (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	DRT_API_CALLABLE_GET_CLASS (self)->run_with_args_tuple (self, conn, data, response, error);
#line 124 "ApiCallable.c"
}


static void drt_api_callable_real_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_critical ("Type `%s' does not implement abstract method `drt_api_callable_run_with_args_dict'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return;
#line 133 "ApiCallable.c"
}


void drt_api_callable_run_with_args_dict (DrtApiCallable* self, GObject* conn, GVariant* data, GVariant* * response, GError** error) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	DRT_API_CALLABLE_GET_CLASS (self)->run_with_args_dict (self, conn, data, response, error);
#line 142 "ApiCallable.c"
}


DrtApiCallable* drt_api_callable_construct (GType object_type) {
	DrtApiCallable* self = NULL;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self = (DrtApiCallable*) g_type_create_instance (object_type);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return self;
#line 152 "ApiCallable.c"
}


const gchar* drt_api_callable_get_path (DrtApiCallable* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = self->priv->_path;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return result;
#line 167 "ApiCallable.c"
}


void drt_api_callable_set_path (DrtApiCallable* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_g_free0 (self->priv->_path);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self->priv->_path = _tmp1_;
#line 184 "ApiCallable.c"
}


DrtApiFlags drt_api_callable_get_flags (DrtApiCallable* self) {
	DrtApiFlags result;
	DrtApiFlags _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = self->priv->_flags;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return result;
#line 199 "ApiCallable.c"
}


void drt_api_callable_set_flags (DrtApiCallable* self, DrtApiFlags value) {
	DrtApiFlags _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self->priv->_flags = _tmp0_;
#line 211 "ApiCallable.c"
}


const gchar* drt_api_callable_get_description (DrtApiCallable* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = self->priv->_description;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return result;
#line 226 "ApiCallable.c"
}


void drt_api_callable_set_description (DrtApiCallable* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_g_free0 (self->priv->_description);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self->priv->_description = _tmp1_;
#line 243 "ApiCallable.c"
}


static void drt_value_api_callable_init (GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	value->data[0].v_pointer = NULL;
#line 250 "ApiCallable.c"
}


static void drt_value_api_callable_free_value (GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		drt_api_callable_unref (value->data[0].v_pointer);
#line 259 "ApiCallable.c"
	}
}


static void drt_value_api_callable_copy_value (const GValue* src_value, GValue* dest_value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		dest_value->data[0].v_pointer = drt_api_callable_ref (src_value->data[0].v_pointer);
#line 269 "ApiCallable.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 273 "ApiCallable.c"
	}
}


static gpointer drt_value_api_callable_peek_pointer (const GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return value->data[0].v_pointer;
#line 281 "ApiCallable.c"
}


static gchar* drt_value_api_callable_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (collect_values[0].v_pointer) {
#line 288 "ApiCallable.c"
		DrtApiCallable * object;
		object = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 295 "ApiCallable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 299 "ApiCallable.c"
		}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = drt_api_callable_ref (object);
#line 303 "ApiCallable.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = NULL;
#line 307 "ApiCallable.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return NULL;
#line 311 "ApiCallable.c"
}


static gchar* drt_value_api_callable_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtApiCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (!object_p) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 322 "ApiCallable.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (!value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		*object_p = NULL;
#line 328 "ApiCallable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		*object_p = value->data[0].v_pointer;
#line 332 "ApiCallable.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		*object_p = drt_api_callable_ref (value->data[0].v_pointer);
#line 336 "ApiCallable.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return NULL;
#line 340 "ApiCallable.c"
}


GParamSpec* drt_param_spec_api_callable (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecApiCallable* spec;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_API_CALLABLE), NULL);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return G_PARAM_SPEC (spec);
#line 354 "ApiCallable.c"
}


gpointer drt_value_get_api_callable (const GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE), NULL);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return value->data[0].v_pointer;
#line 363 "ApiCallable.c"
}


void drt_value_set_api_callable (GValue* value, gpointer v_object) {
	DrtApiCallable * old;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_API_CALLABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = v_object;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		drt_api_callable_ref (value->data[0].v_pointer);
#line 383 "ApiCallable.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = NULL;
#line 387 "ApiCallable.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		drt_api_callable_unref (old);
#line 393 "ApiCallable.c"
	}
}


void drt_value_take_api_callable (GValue* value, gpointer v_object) {
	DrtApiCallable * old;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_API_CALLABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_API_CALLABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = v_object;
#line 412 "ApiCallable.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		value->data[0].v_pointer = NULL;
#line 416 "ApiCallable.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		drt_api_callable_unref (old);
#line 422 "ApiCallable.c"
	}
}


static void drt_api_callable_class_init (DrtApiCallableClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	drt_api_callable_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	((DrtApiCallableClass *) klass)->finalize = drt_api_callable_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_type_class_add_private (klass, sizeof (DrtApiCallablePrivate));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	((DrtApiCallableClass *) klass)->run_with_args_tuple = (void (*) (DrtApiCallable *, GObject*, GVariant*, GVariant* *, GError**)) drt_api_callable_real_run_with_args_tuple;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	((DrtApiCallableClass *) klass)->run_with_args_dict = (void (*) (DrtApiCallable *, GObject*, GVariant*, GVariant* *, GError**)) drt_api_callable_real_run_with_args_dict;
#line 438 "ApiCallable.c"
}


static void drt_api_callable_instance_init (DrtApiCallable * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self->priv = DRT_API_CALLABLE_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self->ref_count = 1;
#line 447 "ApiCallable.c"
}


static void drt_api_callable_finalize (DrtApiCallable * obj) {
	DrtApiCallable * self;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_API_CALLABLE, DrtApiCallable);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_signal_handlers_destroy (self);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_g_free0 (self->priv->_path);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	_g_free0 (self->priv->_description);
#line 461 "ApiCallable.c"
}


GType drt_api_callable_get_type (void) {
	static volatile gsize drt_api_callable_type_id__volatile = 0;
	if (g_once_init_enter (&drt_api_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_api_callable_init, drt_value_api_callable_free_value, drt_value_api_callable_copy_value, drt_value_api_callable_peek_pointer, "p", drt_value_api_callable_collect_value, "p", drt_value_api_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtApiCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_api_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtApiCallable), 0, (GInstanceInitFunc) drt_api_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_api_callable_type_id;
		drt_api_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtApiCallable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&drt_api_callable_type_id__volatile, drt_api_callable_type_id);
	}
	return drt_api_callable_type_id__volatile;
}


gpointer drt_api_callable_ref (gpointer instance) {
	DrtApiCallable * self;
	self = instance;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	return instance;
#line 486 "ApiCallable.c"
}


void drt_api_callable_unref (gpointer instance) {
	DrtApiCallable * self;
	self = instance;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		DRT_API_CALLABLE_GET_CLASS (self)->finalize (self);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/ApiCallable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 499 "ApiCallable.c"
	}
}



