/* BluetoothConnection.c generated by valac 0.36.3, the Vala compiler
 * generated from BluetoothConnection.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gfiledescriptorbased.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>


#define DRT_TYPE_BLUETOOTH_CONNECTION (drt_bluetooth_connection_get_type ())
#define DRT_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection))
#define DRT_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))
#define DRT_IS_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_IS_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_BLUETOOTH_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))

typedef struct _DrtBluetoothConnection DrtBluetoothConnection;
typedef struct _DrtBluetoothConnectionClass DrtBluetoothConnectionClass;
typedef struct _DrtBluetoothConnectionPrivate DrtBluetoothConnectionPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DrtBluetoothConnection {
	GObject parent_instance;
	DrtBluetoothConnectionPrivate * priv;
};

struct _DrtBluetoothConnectionClass {
	GObjectClass parent_class;
};

struct _DrtBluetoothConnectionPrivate {
	gchar* _device;
	gint _fd;
	GOutputStream* _output;
	GInputStream* _input;
	GSocket* socket;
};


static gpointer drt_bluetooth_connection_parent_class = NULL;
static GFileDescriptorBasedIface * drt_bluetooth_connection_g_file_descriptor_based_parent_iface = NULL;

GType drt_bluetooth_connection_get_type (void) G_GNUC_CONST;
#define DRT_BLUETOOTH_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionPrivate))
enum  {
	DRT_BLUETOOTH_CONNECTION_DUMMY_PROPERTY,
	DRT_BLUETOOTH_CONNECTION_DEVICE,
	DRT_BLUETOOTH_CONNECTION_FD,
	DRT_BLUETOOTH_CONNECTION_OUTPUT,
	DRT_BLUETOOTH_CONNECTION_INPUT
};
void drt_bluetooth_connection_close (DrtBluetoothConnection* self, GError** error);
DrtBluetoothConnection* drt_bluetooth_connection_new (GSocket* socket, const gchar* device);
DrtBluetoothConnection* drt_bluetooth_connection_construct (GType object_type, GSocket* socket, const gchar* device);
static void drt_bluetooth_connection_set_device (DrtBluetoothConnection* self, const gchar* value);
static void drt_bluetooth_connection_set_fd (DrtBluetoothConnection* self, gint value);
gint drt_bluetooth_connection_get_fd (DrtBluetoothConnection* self);
static void drt_bluetooth_connection_set_output (DrtBluetoothConnection* self, GOutputStream* value);
static void drt_bluetooth_connection_set_input (DrtBluetoothConnection* self, GInputStream* value);
DrtBluetoothConnection* drt_bluetooth_connection_new_from_fd (gint fd, const gchar* device, GError** error);
DrtBluetoothConnection* drt_bluetooth_connection_construct_from_fd (GType object_type, gint fd, const gchar* device, GError** error);
static gint drt_bluetooth_connection_real_get_fd (GFileDescriptorBased* base);
const gchar* drt_bluetooth_connection_get_device (DrtBluetoothConnection* self);
GOutputStream* drt_bluetooth_connection_get_output (DrtBluetoothConnection* self);
GInputStream* drt_bluetooth_connection_get_input (DrtBluetoothConnection* self);
static void drt_bluetooth_connection_finalize (GObject * obj);
static void _vala_drt_bluetooth_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_bluetooth_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return self ? g_object_ref (self) : NULL;
#line 105 "BluetoothConnection.c"
}


DrtBluetoothConnection* drt_bluetooth_connection_construct (GType object_type, GSocket* socket, const gchar* device) {
	DrtBluetoothConnection * self = NULL;
	const gchar* _tmp0_;
	GSocket* _tmp1_;
	GSocket* _tmp2_;
	GSocket* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GUnixOutputStream* _tmp7_;
	GUnixOutputStream* _tmp8_;
	gint _tmp9_;
	GUnixInputStream* _tmp10_;
	GUnixInputStream* _tmp11_;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (socket != NULL, NULL);
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self = (DrtBluetoothConnection*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = device;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_set_device (self, _tmp0_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp1_ = socket;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (self->priv->socket);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self->priv->socket = _tmp2_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp3_ = socket;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp4_ = g_socket_get_fd (_tmp3_);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp5_ = _tmp4_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_set_fd (self, _tmp5_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp6_ = self->priv->_fd;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp7_ = (GUnixOutputStream*) g_unix_output_stream_new (_tmp6_, TRUE);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp8_ = _tmp7_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_set_output (self, (GOutputStream*) _tmp8_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (_tmp8_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp9_ = self->priv->_fd;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp10_ = (GUnixInputStream*) g_unix_input_stream_new (_tmp9_, TRUE);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp11_ = _tmp10_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_set_input (self, (GInputStream*) _tmp11_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (_tmp11_);
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return self;
#line 171 "BluetoothConnection.c"
}


DrtBluetoothConnection* drt_bluetooth_connection_new (GSocket* socket, const gchar* device) {
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return drt_bluetooth_connection_construct (DRT_TYPE_BLUETOOTH_CONNECTION, socket, device);
#line 178 "BluetoothConnection.c"
}


DrtBluetoothConnection* drt_bluetooth_connection_construct_from_fd (GType object_type, gint fd, const gchar* device, GError** error) {
	DrtBluetoothConnection * self = NULL;
	GSocket* _tmp0_ = NULL;
	gint _tmp1_;
	GSocket* _tmp2_;
	const gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp1_ = fd;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp2_ = g_socket_new_from_fd (_tmp1_, &_inner_error_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = _tmp2_;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_propagate_error (error, _inner_error_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_object_unref0 (self);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		return NULL;
#line 205 "BluetoothConnection.c"
	}
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp3_ = device;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self = (DrtBluetoothConnection*) drt_bluetooth_connection_construct (object_type, _tmp0_, _tmp3_);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (_tmp0_);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return self;
#line 215 "BluetoothConnection.c"
}


DrtBluetoothConnection* drt_bluetooth_connection_new_from_fd (gint fd, const gchar* device, GError** error) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return drt_bluetooth_connection_construct_from_fd (DRT_TYPE_BLUETOOTH_CONNECTION, fd, device, error);
#line 222 "BluetoothConnection.c"
}


static gint drt_bluetooth_connection_real_get_fd (GFileDescriptorBased* base) {
	DrtBluetoothConnection * self;
	gint result = 0;
	gint _tmp0_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self = (DrtBluetoothConnection*) base;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = self->priv->_fd;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	result = _tmp0_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return result;
#line 238 "BluetoothConnection.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return self ? g_error_copy (self) : NULL;
#line 245 "BluetoothConnection.c"
}


void drt_bluetooth_connection_close (DrtBluetoothConnection* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_if_fail (self != NULL);
#line 253 "BluetoothConnection.c"
	{
		GSocket* _tmp0_;
		gboolean _tmp1_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp0_ = self->priv->socket;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp1_ = g_socket_is_closed (_tmp0_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		if (!_tmp1_) {
#line 263 "BluetoothConnection.c"
			GSocket* _tmp2_;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			_tmp2_ = self->priv->socket;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			g_socket_close (_tmp2_, &_inner_error_);
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 271 "BluetoothConnection.c"
				goto __catch5_g_error;
			}
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		GError* _tmp4_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		e = _inner_error_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp3_ = e;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp4_ = _g_error_copy0 ((GError*) _tmp3_);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_inner_error_ = _tmp4_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_error_free0 (e);
#line 294 "BluetoothConnection.c"
		goto __finally5;
	}
	__finally5:
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		if (_inner_error_->domain == G_IO_ERROR) {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			g_propagate_error (error, _inner_error_);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			return;
#line 306 "BluetoothConnection.c"
		} else {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			g_clear_error (&_inner_error_);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
			return;
#line 314 "BluetoothConnection.c"
		}
	}
}


const gchar* drt_bluetooth_connection_get_device (DrtBluetoothConnection* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = self->priv->_device;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return result;
#line 331 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_set_device (DrtBluetoothConnection* self, const gchar* value) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (g_strcmp0 (value, drt_bluetooth_connection_get_device (self)) != 0) {
#line 340 "BluetoothConnection.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp0_ = value;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_free0 (self->priv->_device);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		self->priv->_device = _tmp1_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_object_notify ((GObject *) self, "device");
#line 353 "BluetoothConnection.c"
	}
}


gint drt_bluetooth_connection_get_fd (DrtBluetoothConnection* self) {
	gint result;
	gint _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = self->priv->_fd;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return result;
#line 369 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_set_fd (DrtBluetoothConnection* self, gint value) {
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (drt_bluetooth_connection_get_fd (self) != value) {
#line 378 "BluetoothConnection.c"
		gint _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp0_ = value;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		self->priv->_fd = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_object_notify ((GObject *) self, "fd");
#line 386 "BluetoothConnection.c"
	}
}


GOutputStream* drt_bluetooth_connection_get_output (DrtBluetoothConnection* self) {
	GOutputStream* result;
	GOutputStream* _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = self->priv->_output;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return result;
#line 402 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_set_output (DrtBluetoothConnection* self, GOutputStream* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (drt_bluetooth_connection_get_output (self) != value) {
#line 411 "BluetoothConnection.c"
		GOutputStream* _tmp0_;
		GOutputStream* _tmp1_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp0_ = value;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_object_unref0 (self->priv->_output);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		self->priv->_output = _tmp1_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_object_notify ((GObject *) self, "output");
#line 424 "BluetoothConnection.c"
	}
}


GInputStream* drt_bluetooth_connection_get_input (DrtBluetoothConnection* self) {
	GInputStream* result;
	GInputStream* _tmp0_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_tmp0_ = self->priv->_input;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	return result;
#line 440 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_set_input (DrtBluetoothConnection* self, GInputStream* value) {
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (drt_bluetooth_connection_get_input (self) != value) {
#line 449 "BluetoothConnection.c"
		GInputStream* _tmp0_;
		GInputStream* _tmp1_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp0_ = value;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_object_unref0 (self->priv->_input);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		self->priv->_input = _tmp1_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_object_notify ((GObject *) self, "input");
#line 462 "BluetoothConnection.c"
	}
}


static void drt_bluetooth_connection_class_init (DrtBluetoothConnectionClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_type_class_add_private (klass, sizeof (DrtBluetoothConnectionPrivate));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_bluetooth_connection_get_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_bluetooth_connection_set_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	G_OBJECT_CLASS (klass)->finalize = drt_bluetooth_connection_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_DEVICE, g_param_spec_string ("device", "device", "device", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_FD, g_param_spec_int ("fd", "fd", "fd", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_OUTPUT, g_param_spec_object ("output", "output", "output", g_output_stream_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CONNECTION_INPUT, g_param_spec_object ("input", "input", "input", g_input_stream_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 486 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_g_file_descriptor_based_interface_init (GFileDescriptorBasedIface * iface) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	drt_bluetooth_connection_g_file_descriptor_based_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	iface->get_fd = (gint (*) (GFileDescriptorBased *)) drt_bluetooth_connection_real_get_fd;
#line 495 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_instance_init (DrtBluetoothConnection * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self->priv = DRT_BLUETOOTH_CONNECTION_GET_PRIVATE (self);
#line 502 "BluetoothConnection.c"
}


static void drt_bluetooth_connection_finalize (GObject * obj) {
	DrtBluetoothConnection * self;
	GError * _inner_error_ = NULL;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
#line 511 "BluetoothConnection.c"
	{
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		drt_bluetooth_connection_close (self, &_inner_error_);
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 517 "BluetoothConnection.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		e = _inner_error_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_inner_error_ = NULL;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		_g_error_free0 (e);
#line 531 "BluetoothConnection.c"
	}
	__finally4:
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_clear_error (&_inner_error_);
#line 540 "BluetoothConnection.c"
	}
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_free0 (self->priv->_device);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (self->priv->_output);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (self->priv->_input);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	_g_object_unref0 (self->priv->socket);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	G_OBJECT_CLASS (drt_bluetooth_connection_parent_class)->finalize (obj);
#line 552 "BluetoothConnection.c"
}


GType drt_bluetooth_connection_get_type (void) {
	static volatile gsize drt_bluetooth_connection_type_id__volatile = 0;
	if (g_once_init_enter (&drt_bluetooth_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtBluetoothConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_bluetooth_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtBluetoothConnection), 0, (GInstanceInitFunc) drt_bluetooth_connection_instance_init, NULL };
		static const GInterfaceInfo g_file_descriptor_based_info = { (GInterfaceInitFunc) drt_bluetooth_connection_g_file_descriptor_based_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType drt_bluetooth_connection_type_id;
		drt_bluetooth_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtBluetoothConnection", &g_define_type_info, 0);
		g_type_add_interface_static (drt_bluetooth_connection_type_id, G_TYPE_FILE_DESCRIPTOR_BASED, &g_file_descriptor_based_info);
		g_once_init_leave (&drt_bluetooth_connection_type_id__volatile, drt_bluetooth_connection_type_id);
	}
	return drt_bluetooth_connection_type_id__volatile;
}


static void _vala_drt_bluetooth_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtBluetoothConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_DEVICE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_value_set_string (value, drt_bluetooth_connection_get_device (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_FD:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_value_set_int (value, drt_bluetooth_connection_get_fd (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_OUTPUT:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_value_set_object (value, drt_bluetooth_connection_get_output (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_INPUT:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		g_value_set_object (value, drt_bluetooth_connection_get_input (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 599 "BluetoothConnection.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 605 "BluetoothConnection.c"
	}
}


static void _vala_drt_bluetooth_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtBluetoothConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_DEVICE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		drt_bluetooth_connection_set_device (self, g_value_get_string (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_FD:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		drt_bluetooth_connection_set_fd (self, g_value_get_int (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_OUTPUT:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		drt_bluetooth_connection_set_output (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		case DRT_BLUETOOTH_CONNECTION_INPUT:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		drt_bluetooth_connection_set_input (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 639 "BluetoothConnection.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BluetoothConnection.vala"
		break;
#line 645 "BluetoothConnection.c"
	}
}



