/* Connection.c generated by valac 0.36.3, the Vala compiler
 * generated from Connection.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DIORITEDB_TYPE_CONNECTION (dioritedb_connection_get_type ())
#define DIORITEDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnection))
#define DIORITEDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))
#define DIORITEDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))

typedef struct _DioritedbConnection DioritedbConnection;
typedef struct _DioritedbConnectionClass DioritedbConnectionClass;
typedef struct _DioritedbConnectionPrivate DioritedbConnectionPrivate;

#define DIORITEDB_TYPE_DATABASE (dioritedb_database_get_type ())
#define DIORITEDB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabase))
#define DIORITEDB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))
#define DIORITEDB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))

typedef struct _DioritedbDatabase DioritedbDatabase;
typedef struct _DioritedbDatabaseClass DioritedbDatabaseClass;
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DIORITEDB_TYPE_QUERY (dioritedb_query_get_type ())
#define DIORITEDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_QUERY, DioritedbQuery))
#define DIORITEDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))
#define DIORITEDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))

typedef struct _DioritedbQuery DioritedbQuery;
typedef struct _DioritedbQueryClass DioritedbQueryClass;

#define DIORITEDB_TYPE_RAW_QUERY (dioritedb_raw_query_get_type ())
#define DIORITEDB_RAW_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQuery))
#define DIORITEDB_RAW_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQueryClass))
#define DIORITEDB_IS_RAW_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_RAW_QUERY))
#define DIORITEDB_IS_RAW_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_RAW_QUERY))
#define DIORITEDB_RAW_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQueryClass))

typedef struct _DioritedbRawQuery DioritedbRawQuery;
typedef struct _DioritedbRawQueryClass DioritedbRawQueryClass;

#define DIORITEDB_TYPE_OBJECT_QUERY (dioritedb_object_query_get_type ())
#define DIORITEDB_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQuery))
#define DIORITEDB_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQueryClass))
#define DIORITEDB_IS_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_QUERY))
#define DIORITEDB_IS_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_QUERY))
#define DIORITEDB_OBJECT_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQueryClass))

typedef struct _DioritedbObjectQuery DioritedbObjectQuery;
typedef struct _DioritedbObjectQueryClass DioritedbObjectQueryClass;

#define DIORITEDB_TYPE_OBJECT_SPEC (dioritedb_object_spec_get_type ())
#define DIORITEDB_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpec))
#define DIORITEDB_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))
#define DIORITEDB_IS_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_IS_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_OBJECT_SPEC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))

typedef struct _DioritedbObjectSpec DioritedbObjectSpec;
typedef struct _DioritedbObjectSpecClass DioritedbObjectSpecClass;
#define _dioritedb_object_spec_unref0(var) ((var == NULL) ? NULL : (var = (dioritedb_object_spec_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _t_destroy_func0(var) (((var == NULL) || (t_destroy_func == NULL)) ? NULL : (var = (t_destroy_func (var), NULL)))

struct _DioritedbConnection {
	GObject parent_instance;
	DioritedbConnectionPrivate * priv;
	sqlite3* db;
};

struct _DioritedbConnectionClass {
	GObjectClass parent_class;
};

struct _DioritedbConnectionPrivate {
	DioritedbDatabase* _database;
};

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()

static gpointer dioritedb_connection_parent_class = NULL;

GType dioritedb_connection_get_type (void) G_GNUC_CONST;
GType dioritedb_database_get_type (void) G_GNUC_CONST;
#define DIORITEDB_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionPrivate))
enum  {
	DIORITEDB_CONNECTION_DUMMY_PROPERTY,
	DIORITEDB_CONNECTION_DATABASE
};
GQuark dioritedb_database_error_quark (void);
DioritedbConnection* dioritedb_connection_new (DioritedbDatabase* database, GCancellable* cancellable, GError** error);
DioritedbConnection* dioritedb_connection_construct (GType object_type, DioritedbDatabase* database, GCancellable* cancellable, GError** error);
void dioritedb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error);
static void dioritedb_connection_set_database (DioritedbConnection* self, DioritedbDatabase* value);
gint dioritedb_connection_throw_on_error (DioritedbConnection* self, gint _result_, const gchar* sql, GError** error);
GFile* dioritedb_database_get_db_file (DioritedbDatabase* self);
void dioritedb_connection_exec (DioritedbConnection* self, const gchar* sql, GCancellable* cancellable, GError** error);
GType dioritedb_query_get_type (void) G_GNUC_CONST;
GType dioritedb_raw_query_get_type (void) G_GNUC_CONST;
DioritedbRawQuery* dioritedb_connection_query (DioritedbConnection* self, const gchar* sql, GCancellable* cancellable, GError** error);
DioritedbRawQuery* dioritedb_raw_query_new (DioritedbConnection* connection, const gchar* sql, GError** error);
DioritedbRawQuery* dioritedb_raw_query_construct (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** error);
GType dioritedb_object_query_get_type (void) G_GNUC_CONST;
DioritedbObjectQuery* dioritedb_connection_query_objects (DioritedbConnection* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, const gchar* sql_filter, GCancellable* cancellable, GError** error);
gpointer dioritedb_object_spec_ref (gpointer instance);
void dioritedb_object_spec_unref (gpointer instance);
GParamSpec* dioritedb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void dioritedb_value_set_object_spec (GValue* value, gpointer v_object);
void dioritedb_value_take_object_spec (GValue* value, gpointer v_object);
gpointer dioritedb_value_get_object_spec (const GValue* value);
GType dioritedb_object_spec_get_type (void) G_GNUC_CONST;
DioritedbDatabase* dioritedb_connection_get_database (DioritedbConnection* self);
DioritedbObjectSpec* dioritedb_database_get_object_spec (DioritedbDatabase* self, GType type);
GParamSpec** dioritedb_object_spec_get_properties (DioritedbObjectSpec* self, int* result_length1);
gchar* dioritedb_escape_sql_id (const gchar* sql);
const gchar* dioritedb_object_spec_get_table_name (DioritedbObjectSpec* self);
gboolean dioritedb_is_type_supported (GType* type);
DioritedbObjectQuery* dioritedb_object_query_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbConnection* connection, const gchar* sql, GError** error);
DioritedbObjectQuery* dioritedb_object_query_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbConnection* connection, const gchar* sql, GError** error);
gpointer dioritedb_connection_get_object (DioritedbConnection* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
GParamSpec* dioritedb_object_spec_get_primary_key (DioritedbObjectSpec* self);
DioritedbObjectQuery* dioritedb_object_query_bind (DioritedbObjectQuery* self, gint index, GValue* value, GError** error);
gpointer dioritedb_object_query_get_one (DioritedbObjectQuery* self, GCancellable* cancellable, GError** error);
gint dioritedb_convert_error (sqlite3* db, gint _result_, const gchar* sql, sqlite3_stmt* stm, GError** error);
static void dioritedb_connection_finalize (GObject * obj);
static void _vala_dioritedb_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dioritedb_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DioritedbConnection* dioritedb_connection_construct (GType object_type, DioritedbDatabase* database, GCancellable* cancellable, GError** error) {
	DioritedbConnection * self = NULL;
	GCancellable* _tmp0_;
	DioritedbDatabase* _tmp1_;
	DioritedbDatabase* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	sqlite3* _tmp7_ = NULL;
	gint _tmp8_;
	GError * _inner_error_ = NULL;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (database != NULL, NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	self = (DioritedbConnection*) g_object_new (object_type, NULL);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = cancellable;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Connection.new", "Connection.vala", 35, &_inner_error_);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_object_unref0 (self);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 211 "Connection.c"
	}
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = database;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_connection_set_database (self, _tmp1_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = database;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp3_ = dioritedb_database_get_db_file (_tmp2_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp4_ = _tmp3_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp6_ = _tmp5_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp8_ = sqlite3_open_v2 (_tmp6_, &_tmp7_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_sqlite3_close0 (self->db);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	self->db = _tmp7_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_connection_throw_on_error (self, _tmp8_, NULL, &_inner_error_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_free0 (_tmp6_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_object_unref0 (self);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 245 "Connection.c"
	}
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return self;
#line 249 "Connection.c"
}


DioritedbConnection* dioritedb_connection_new (DioritedbDatabase* database, GCancellable* cancellable, GError** error) {
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return dioritedb_connection_construct (DIORITEDB_TYPE_CONNECTION, database, cancellable, error);
#line 256 "Connection.c"
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar* * errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_;
	sqlite3_callback _tmp1_;
	void* _tmp1__target;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_;
	const gchar* _tmp6_;
#line 34 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	_tmp0_ = sql;
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	_tmp1_ = callback;
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	_tmp1__target = callback_target;
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	sqlite_errmsg = _tmp2_;
#line 36 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	ec = _tmp3_;
#line 37 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 289 "Connection.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 38 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		_tmp4_ = sqlite_errmsg;
#line 38 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		_tmp5_ = g_strdup (_tmp4_);
#line 38 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		_vala_errmsg = _tmp5_;
#line 300 "Connection.c"
	}
#line 40 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	_tmp6_ = sqlite_errmsg;
#line 40 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	sqlite3_free ((void*) _tmp6_);
#line 41 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	result = ec;
#line 41 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	if (errmsg) {
#line 41 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 312 "Connection.c"
	} else {
#line 41 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 316 "Connection.c"
	}
#line 41 "/usr/share/vala-0.36/vapi/sqlite3.vapi"
	return result;
#line 320 "Connection.c"
}


void dioritedb_connection_exec (DioritedbConnection* self, const gchar* sql, GCancellable* cancellable, GError** error) {
	GCancellable* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	GError * _inner_error_ = NULL;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_if_fail (sql != NULL);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = cancellable;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Connection.exec", "Connection.vala", 43, &_inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return;
#line 345 "Connection.c"
	}
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = self->db;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = sql;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp3_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, NULL);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp4_ = sql;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_connection_throw_on_error (self, _tmp3_, _tmp4_, &_inner_error_);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return;
#line 363 "Connection.c"
	}
}


DioritedbRawQuery* dioritedb_connection_query (DioritedbConnection* self, const gchar* sql, GCancellable* cancellable, GError** error) {
	DioritedbRawQuery* result = NULL;
	GCancellable* _tmp0_;
	DioritedbRawQuery* _tmp1_ = NULL;
	const gchar* _tmp2_;
	DioritedbRawQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = cancellable;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Connection.query", "Connection.vala", 49, &_inner_error_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 390 "Connection.c"
	}
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = sql;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp3_ = dioritedb_raw_query_new (self, _tmp2_, &_inner_error_);
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = _tmp3_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 404 "Connection.c"
	}
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp4_ = _tmp1_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = NULL;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	result = _tmp4_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return result;
#line 416 "Connection.c"
}


static gpointer _g_param_spec_ref0 (gpointer self) {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 423 "Connection.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 441 "Connection.c"
}


DioritedbObjectQuery* dioritedb_connection_query_objects (DioritedbConnection* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, const gchar* sql_filter, GCancellable* cancellable, GError** error) {
	DioritedbObjectQuery* result = NULL;
	GCancellable* _tmp0_;
	GType type = 0UL;
	GType _tmp1_;
	gboolean _tmp2_;
	DioritedbObjectSpec* object_spec = NULL;
	DioritedbDatabase* _tmp6_;
	GType _tmp7_;
	DioritedbObjectSpec* _tmp8_;
	DioritedbObjectSpec* _tmp9_;
	GParamSpec** param_specs = NULL;
	DioritedbObjectSpec* _tmp13_;
	GParamSpec** _tmp14_;
	gint _tmp14__length1;
	GParamSpec** _tmp15_;
	gint _tmp15__length1;
	gint param_specs_length1;
	gint _param_specs_size_;
	GString* sql = NULL;
	GString* _tmp16_;
	gchar* table_name_escaped = NULL;
	DioritedbObjectSpec* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GString* _tmp47_;
	const gchar* _tmp48_;
	gboolean _tmp49_ = FALSE;
	const gchar* _tmp50_;
	DioritedbObjectQuery* _tmp55_ = NULL;
	GString* _tmp56_;
	const gchar* _tmp57_;
	DioritedbObjectQuery* _tmp58_;
	DioritedbObjectQuery* _tmp59_;
	GError * _inner_error_ = NULL;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = cancellable;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Connection.query_objects", "Connection.vala", 56, &_inner_error_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 493 "Connection.c"
	}
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	type = t_type;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = type;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = G_TYPE_IS_OBJECT (_tmp1_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (!_tmp2_) {
#line 503 "Connection.c"
		GType _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp3_ = type;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp4_ = g_type_name (_tmp3_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp5_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp4_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_inner_error_ = _tmp5_;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 519 "Connection.c"
	}
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp6_ = self->priv->_database;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp7_ = type;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp8_ = dioritedb_database_get_object_spec (_tmp6_, _tmp7_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	object_spec = _tmp8_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp9_ = object_spec;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (_tmp9_ == NULL) {
#line 533 "Connection.c"
		GType _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp10_ = type;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp11_ = g_type_name (_tmp10_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp12_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "ObjectSpec for %s has not been found.", _tmp11_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_inner_error_ = _tmp12_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 551 "Connection.c"
	}
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp13_ = object_spec;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp14_ = dioritedb_object_spec_get_properties (_tmp13_, &_tmp14__length1);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp15_ = _tmp14_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp15__length1 = _tmp14__length1;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	param_specs = _tmp15_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	param_specs_length1 = _tmp15__length1;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_param_specs_size_ = param_specs_length1;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp16_ = g_string_new ("SELECT");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	sql = _tmp16_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp17_ = object_spec;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp18_ = dioritedb_object_spec_get_table_name (_tmp17_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp19_ = _tmp18_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp20_ = dioritedb_escape_sql_id (_tmp19_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	table_name_escaped = _tmp20_;
#line 581 "Connection.c"
	{
		gint i = 0;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		i = 0;
#line 586 "Connection.c"
		{
			gboolean _tmp21_ = FALSE;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			_tmp21_ = TRUE;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			while (TRUE) {
#line 593 "Connection.c"
				gint _tmp23_;
				GParamSpec** _tmp24_;
				gint _tmp24__length1;
				GParamSpec* param = NULL;
				GParamSpec** _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				GParamSpec* _tmp27_;
				GParamSpec* _tmp28_;
				gboolean _tmp29_ = FALSE;
				GParamSpec* _tmp30_;
				GType _tmp31_;
				gint _tmp39_;
				GString* _tmp41_;
				const gchar* _tmp42_;
				GParamSpec* _tmp43_;
				const gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				if (!_tmp21_) {
#line 615 "Connection.c"
					gint _tmp22_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp22_ = i;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					i = _tmp22_ + 1;
#line 621 "Connection.c"
				}
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp21_ = FALSE;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp23_ = i;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp24_ = param_specs;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp24__length1 = param_specs_length1;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				if (!(_tmp23_ < _tmp24__length1)) {
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					break;
#line 635 "Connection.c"
				}
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp25_ = param_specs;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp25__length1 = param_specs_length1;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp26_ = i;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp27_ = _tmp25_[_tmp26_];
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp28_ = _g_param_spec_ref0 (_tmp27_);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				param = _tmp28_;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp30_ = param;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp31_ = _tmp30_->value_type;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				if (_tmp31_ == G_TYPE_POINTER) {
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp29_ = TRUE;
#line 657 "Connection.c"
				} else {
					GParamSpec* _tmp32_;
					GType _tmp33_;
					gboolean _tmp34_;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp32_ = param;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp33_ = _tmp32_->value_type;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp34_ = dioritedb_is_type_supported (&_tmp33_);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp29_ = !_tmp34_;
#line 670 "Connection.c"
				}
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				if (_tmp29_) {
#line 674 "Connection.c"
					GParamSpec* _tmp35_;
					GType _tmp36_;
					const gchar* _tmp37_;
					GError* _tmp38_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp35_ = param;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp36_ = _tmp35_->value_type;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp37_ = g_type_name (_tmp36_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp38_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp37_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_inner_error_ = _tmp38_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					g_propagate_error (error, _inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_g_param_spec_unref0 (param);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_g_free0 (table_name_escaped);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_g_string_free0 (sql);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_dioritedb_object_spec_unref0 (object_spec);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					return NULL;
#line 701 "Connection.c"
				}
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp39_ = i;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				if (_tmp39_ != 0) {
#line 707 "Connection.c"
					GString* _tmp40_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					_tmp40_ = sql;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
					g_string_append_c (_tmp40_, ',');
#line 713 "Connection.c"
				}
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp41_ = sql;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp42_ = table_name_escaped;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp43_ = param;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp44_ = _tmp43_->name;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp45_ = dioritedb_escape_sql_id (_tmp44_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_tmp46_ = _tmp45_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				g_string_append_printf (_tmp41_, " \"%1$s\".\"%2$s\" AS \"%2$s\"", _tmp42_, _tmp46_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_g_free0 (_tmp46_);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
				_g_param_spec_unref0 (param);
#line 733 "Connection.c"
			}
		}
	}
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp47_ = sql;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp48_ = table_name_escaped;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_string_append_printf (_tmp47_, " FROM \"%s\" ", _tmp48_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp50_ = sql_filter;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (_tmp50_ != NULL) {
#line 747 "Connection.c"
		const gchar* _tmp51_;
		gchar _tmp52_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp51_ = sql_filter;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp52_ = string_get (_tmp51_, (glong) 0);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp49_ = _tmp52_ != '\0';
#line 756 "Connection.c"
	} else {
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp49_ = FALSE;
#line 760 "Connection.c"
	}
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (_tmp49_) {
#line 764 "Connection.c"
		GString* _tmp53_;
		const gchar* _tmp54_;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp53_ = sql;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp54_ = sql_filter;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_string_append (_tmp53_, _tmp54_);
#line 773 "Connection.c"
	}
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp56_ = sql;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp57_ = _tmp56_->str;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp58_ = dioritedb_object_query_new (t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, self, _tmp57_, &_inner_error_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp55_ = _tmp58_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (table_name_escaped);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_string_free0 (sql);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 795 "Connection.c"
	}
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp59_ = _tmp55_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp55_ = NULL;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	result = _tmp59_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp55_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_free0 (table_name_escaped);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_string_free0 (sql);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_dioritedb_object_spec_unref0 (object_spec);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return result;
#line 813 "Connection.c"
}


gpointer dioritedb_connection_get_object (DioritedbConnection* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error) {
	gpointer result = NULL;
	GCancellable* _tmp0_;
	GType type = 0UL;
	GType _tmp1_;
	gboolean _tmp2_;
	DioritedbObjectSpec* object_spec = NULL;
	DioritedbDatabase* _tmp6_;
	GType _tmp7_;
	DioritedbObjectSpec* _tmp8_;
	DioritedbObjectSpec* _tmp9_;
	gchar* table_escaped = NULL;
	DioritedbObjectSpec* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* column_escaped = NULL;
	DioritedbObjectSpec* _tmp17_;
	GParamSpec* _tmp18_;
	GParamSpec* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	DioritedbObjectQuery* _tmp22_ = NULL;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GCancellable* _tmp27_;
	DioritedbObjectQuery* _tmp28_;
	DioritedbObjectQuery* _tmp29_;
	DioritedbObjectQuery* _tmp30_ = NULL;
	DioritedbObjectQuery* _tmp31_;
	DioritedbObjectQuery* _tmp32_;
	GValue _tmp33_;
	DioritedbObjectQuery* _tmp34_;
	DioritedbObjectQuery* _tmp35_;
	gpointer _tmp36_ = NULL;
	DioritedbObjectQuery* _tmp37_;
	DioritedbObjectQuery* _tmp38_;
	GCancellable* _tmp39_;
	gpointer _tmp40_;
	gpointer _tmp41_;
	gpointer _tmp42_;
	GError * _inner_error_ = NULL;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (pk != NULL, NULL);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = cancellable;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Connection.get_object", "Connection.vala", 95, &_inner_error_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 875 "Connection.c"
	}
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	type = t_type;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = type;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = G_TYPE_IS_OBJECT (_tmp1_);
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (!_tmp2_) {
#line 885 "Connection.c"
		GType _tmp3_;
		const gchar* _tmp4_;
		GError* _tmp5_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp3_ = type;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp4_ = g_type_name (_tmp3_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp5_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp4_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_inner_error_ = _tmp5_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 901 "Connection.c"
	}
#line 100 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp6_ = self->priv->_database;
#line 100 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp7_ = type;
#line 100 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp8_ = dioritedb_database_get_object_spec (_tmp6_, _tmp7_);
#line 100 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	object_spec = _tmp8_;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp9_ = object_spec;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (_tmp9_ == NULL) {
#line 915 "Connection.c"
		GType _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp10_ = type;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp11_ = g_type_name (_tmp10_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp12_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "ObjectSpec for %s has not been found.", _tmp11_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_inner_error_ = _tmp12_;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 933 "Connection.c"
	}
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp13_ = object_spec;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp14_ = dioritedb_object_spec_get_table_name (_tmp13_);
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp15_ = _tmp14_;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp16_ = dioritedb_escape_sql_id (_tmp15_);
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	table_escaped = _tmp16_;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp17_ = object_spec;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp18_ = dioritedb_object_spec_get_primary_key (_tmp17_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp19_ = _tmp18_;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp20_ = _tmp19_->name;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp21_ = dioritedb_escape_sql_id (_tmp20_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	column_escaped = _tmp21_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp23_ = table_escaped;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp24_ = column_escaped;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp25_ = g_strdup_printf ("WHERE \"%s\".\"%s\" == ?1", _tmp23_, _tmp24_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp26_ = _tmp25_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp27_ = cancellable;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp28_ = dioritedb_connection_query_objects (self, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, _tmp26_, _tmp27_, &_inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp29_ = _tmp28_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_free0 (_tmp26_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp22_ = _tmp29_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (column_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (table_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 987 "Connection.c"
	}
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp31_ = _tmp22_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp22_ = NULL;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp32_ = _tmp31_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp33_ = *pk;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp34_ = dioritedb_object_query_bind (_tmp32_, 1, &_tmp33_, &_inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp35_ = _tmp34_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp32_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp30_ = _tmp35_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_object_unref0 (_tmp22_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (column_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (table_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 1019 "Connection.c"
	}
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp37_ = _tmp30_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp30_ = NULL;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp38_ = _tmp37_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp39_ = cancellable;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp40_ = dioritedb_object_query_get_one (_tmp38_, _tmp39_, &_inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp41_ = _tmp40_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp38_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp36_ = _tmp41_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_object_unref0 (_tmp30_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_object_unref0 (_tmp22_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (column_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_g_free0 (table_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_dioritedb_object_spec_unref0 (object_spec);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		return NULL;
#line 1053 "Connection.c"
	}
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp42_ = _tmp36_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp36_ = NULL;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	result = _tmp42_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_t_destroy_func0 (_tmp36_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp30_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_object_unref0 (_tmp22_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_free0 (column_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_g_free0 (table_escaped);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_dioritedb_object_spec_unref0 (object_spec);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return result;
#line 1075 "Connection.c"
}


gint dioritedb_connection_throw_on_error (DioritedbConnection* self, gint _result_, const gchar* sql, GError** error) {
	gint result = 0;
	gint _tmp0_ = 0;
	sqlite3* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp1_ = self->db;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp2_ = _result_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp3_ = sql;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp4_ = dioritedb_convert_error (_tmp1_, _tmp2_, _tmp3_, NULL, &_inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = _tmp4_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 1103 "Connection.c"
			gint _tmp5_ = 0;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			g_propagate_error (error, _inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			return _tmp5_;
#line 1109 "Connection.c"
		} else {
			gint _tmp6_ = 0;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			g_clear_error (&_inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
			return _tmp6_;
#line 1118 "Connection.c"
		}
	}
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	result = _tmp0_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return result;
#line 1125 "Connection.c"
}


DioritedbDatabase* dioritedb_connection_get_database (DioritedbConnection* self) {
	DioritedbDatabase* result;
	DioritedbDatabase* _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_tmp0_ = self->priv->_database;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	return result;
#line 1140 "Connection.c"
}


static void dioritedb_connection_set_database (DioritedbConnection* self, DioritedbDatabase* value) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	if (dioritedb_connection_get_database (self) != value) {
#line 1149 "Connection.c"
		DioritedbDatabase* _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		_tmp0_ = value;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		self->priv->_database = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_object_notify ((GObject *) self, "database");
#line 1157 "Connection.c"
	}
}


static void dioritedb_connection_class_init (DioritedbConnectionClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	dioritedb_connection_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_type_class_add_private (klass, sizeof (DioritedbConnectionPrivate));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dioritedb_connection_get_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dioritedb_connection_set_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	G_OBJECT_CLASS (klass)->finalize = dioritedb_connection_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_CONNECTION_DATABASE, g_param_spec_object ("database", "database", "database", DIORITEDB_TYPE_DATABASE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1175 "Connection.c"
}


static void dioritedb_connection_instance_init (DioritedbConnection * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	self->priv = DIORITEDB_CONNECTION_GET_PRIVATE (self);
#line 1182 "Connection.c"
}


static void dioritedb_connection_finalize (GObject * obj) {
	DioritedbConnection * self;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_CONNECTION, DioritedbConnection);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	_sqlite3_close0 (self->db);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	G_OBJECT_CLASS (dioritedb_connection_parent_class)->finalize (obj);
#line 1194 "Connection.c"
}


GType dioritedb_connection_get_type (void) {
	static volatile gsize dioritedb_connection_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbConnection), 0, (GInstanceInitFunc) dioritedb_connection_instance_init, NULL };
		GType dioritedb_connection_type_id;
		dioritedb_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "DioritedbConnection", &g_define_type_info, 0);
		g_once_init_leave (&dioritedb_connection_type_id__volatile, dioritedb_connection_type_id);
	}
	return dioritedb_connection_type_id__volatile;
}


static void _vala_dioritedb_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioritedbConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_CONNECTION, DioritedbConnection);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		case DIORITEDB_CONNECTION_DATABASE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		g_value_set_object (value, dioritedb_connection_get_database (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		break;
#line 1221 "Connection.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		break;
#line 1227 "Connection.c"
	}
}


static void _vala_dioritedb_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioritedbConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_CONNECTION, DioritedbConnection);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		case DIORITEDB_CONNECTION_DATABASE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		dioritedb_connection_set_database (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		break;
#line 1243 "Connection.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Connection.vala"
		break;
#line 1249 "Connection.c"
	}
}



