/* Convert.c generated by valac 0.36.3, the Vala compiler
 * generated from Convert.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



void diorite_int64_to_bin (gint64 val, guint8** _result_, int* _result__length1);
gboolean diorite_bin_to_int64 (guint8* array, int array_length1, gint64* _result_);
void diorite_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator);
void diorite_bin_to_hex_buf (guint8* array, int array_length1, GString* buffer, gchar separator);
gboolean diorite_uint8v_equal (guint8* array1, int array1_length1, guint8* array2, int array2_length1);
gboolean diorite_hex_to_bin (const gchar* hex, guint8** _result_, int* _result__length1, gchar separator);
gboolean diorite_hex_to_int64 (const gchar* hex, gint64* _result_, gchar separator);
void diorite_int64_to_hex (gint64 val, gchar* * _result_, gchar separator);
void diorite_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset);
void diorite_int32_to_bytes (guint8** buffer, int* buffer_length1, gint32 data, guint offset);
void diorite_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset);
void diorite_int32_from_bytes (guint8* buffer, int buffer_length1, gint32* data, guint offset);


/**
 * Convert int64 value to byte array 
 * 
 * @param val       value to convert
 * @param result    byte array representation (8 bytes)
 */
void diorite_int64_to_bin (gint64 val, guint8** _result_, int* _result__length1) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gint size = 0;
	gint _tmp0_;
	guint8* _tmp1_;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = (gint) sizeof (gint64);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = size;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = g_new0 (guint8, _tmp0_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = (g_free (_vala_result), NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = _tmp1_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result_length1 = _tmp0_;
#line 81 "Convert.c"
	{
		gint i = 0;
		gint _tmp2_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp2_ = size;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = _tmp2_ - 1;
#line 89 "Convert.c"
		{
			gboolean _tmp3_ = FALSE;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp3_ = TRUE;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 96 "Convert.c"
				gint _tmp5_;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint64 _tmp8_;
				guint8 _tmp9_;
				gint64 _tmp10_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp3_) {
#line 106 "Convert.c"
					gint _tmp4_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp4_ = i;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp4_ - 1;
#line 112 "Convert.c"
				}
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = FALSE;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = i;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(_tmp5_ >= 0)) {
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 122 "Convert.c"
				}
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = _vala_result;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6__length1 = _vala_result_length1;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = i;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = val;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_[_tmp7_] = (guint8) (_tmp8_ & 0xFF);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = _tmp6_[_tmp7_];
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = val;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				val = _tmp10_ >> 8;
#line 140 "Convert.c"
			}
		}
	}
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 148 "Convert.c"
	} else {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_vala_result = (g_free (_vala_result), NULL);
#line 152 "Convert.c"
	}
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result__length1) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result__length1 = _vala_result_length1;
#line 158 "Convert.c"
	}
}


/**
 * Converts byte array to int64 value
 * 
 * @param array     byte array to convert
 * @param result    converted value
 * @return          true on success, false on overflow
 */
gboolean diorite_bin_to_int64 (guint8* array, int array_length1, gint64* _result_) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = (gint64) 0;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = array;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = array_length1;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (((gulong) _tmp0__length1) > sizeof (gint64)) {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		result = FALSE;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		if (_result_) {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			*_result_ = _vala_result;
#line 189 "Convert.c"
		}
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		return result;
#line 193 "Convert.c"
	}
	{
		gint i = 0;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 199 "Convert.c"
		{
			gboolean _tmp1_ = FALSE;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp1_ = TRUE;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 206 "Convert.c"
				gint _tmp3_;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint64 _tmp5_;
				gint64 _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				guint8 _tmp9_;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp1_) {
#line 218 "Convert.c"
					gint _tmp2_;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp2_ = i;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp2_ + 1;
#line 224 "Convert.c"
				}
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp1_ = FALSE;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = i;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp4_ = array;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp4__length1 = array_length1;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 238 "Convert.c"
				}
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = _vala_result;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_result = _tmp5_ << 8;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = _vala_result;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = array;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7__length1 = array_length1;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = i;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = _tmp7_[_tmp8_];
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_result = _tmp6_ | ((gint64) (_tmp9_ & 0xFF));
#line 256 "Convert.c"
			}
		}
	}
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	result = TRUE;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 266 "Convert.c"
	}
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	return result;
#line 270 "Convert.c"
}


/**
 * Converts byte array to hexadecimal string.
 * 
 * @param array        byte array to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
void diorite_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator) {
	gchar* _vala_result = NULL;
	gint _tmp0_ = 0;
	gchar _tmp1_;
	gint size = 0;
	GString* buffer = NULL;
	GString* _tmp4_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	gchar _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = separator;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_tmp1_ == '\0') {
#line 297 "Convert.c"
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp2_ = array;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp2__length1 = array_length1;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp0_ = 2 * _tmp2__length1;
#line 306 "Convert.c"
	} else {
		guint8* _tmp3_;
		gint _tmp3__length1;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp3_ = array;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp3__length1 = array_length1;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp0_ = (3 * _tmp3__length1) - 1;
#line 316 "Convert.c"
	}
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp4_ = g_string_sized_new ((gsize) size);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	buffer = _tmp4_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp5_ = array;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp5__length1 = array_length1;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp6_ = separator;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	diorite_bin_to_hex_buf (_tmp5_, _tmp5__length1, buffer, _tmp6_);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp7_ = buffer->str;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_g_free0 (_vala_result);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = _tmp8_;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_g_string_free0 (buffer);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 346 "Convert.c"
	} else {
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_g_free0 (_vala_result);
#line 350 "Convert.c"
	}
}


/**
 * Converts byte array to hexadecimal string and stores in buffer.
 * 
 * @param array        byte array to convert
 * @param buffer       where to store converted value in
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 376 "Convert.c"
}


void diorite_bin_to_hex_buf (guint8* array, int array_length1, GString* buffer, gchar separator) {
	gchar* hex_chars = NULL;
	gchar* _tmp0_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_if_fail (buffer != NULL);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = g_strdup ("0123456789abcdef");
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	hex_chars = _tmp0_;
#line 389 "Convert.c"
	{
		gint i = 0;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 394 "Convert.c"
		{
			gboolean _tmp1_ = FALSE;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp1_ = TRUE;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 401 "Convert.c"
				gint _tmp3_;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_ = FALSE;
				gint _tmp6_;
				GString* _tmp10_;
				const gchar* _tmp11_;
				guint8* _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				guint8 _tmp14_;
				gchar _tmp15_;
				GString* _tmp16_;
				const gchar* _tmp17_;
				guint8* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				guint8 _tmp20_;
				gchar _tmp21_;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp1_) {
#line 423 "Convert.c"
					gint _tmp2_;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp2_ = i;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp2_ + 1;
#line 429 "Convert.c"
				}
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp1_ = FALSE;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = i;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp4_ = array;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp4__length1 = array_length1;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(_tmp3_ < _tmp4__length1)) {
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 443 "Convert.c"
				}
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = i;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (_tmp6_ > 0) {
#line 449 "Convert.c"
					gchar _tmp7_;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp7_ = separator;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp5_ = _tmp7_ != '\0';
#line 455 "Convert.c"
				} else {
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp5_ = FALSE;
#line 459 "Convert.c"
				}
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (_tmp5_) {
#line 463 "Convert.c"
					GString* _tmp8_;
					gchar _tmp9_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp8_ = buffer;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp9_ = separator;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					g_string_append_c (_tmp8_, _tmp9_);
#line 472 "Convert.c"
				}
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = buffer;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = hex_chars;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12_ = array;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12__length1 = array_length1;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp13_ = i;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp14_ = _tmp12_[_tmp13_];
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp15_ = string_get (_tmp11_, (glong) ((_tmp14_ >> 4) & 0x0F));
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp16_ = g_string_append_c (_tmp10_, _tmp15_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp17_ = hex_chars;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp18_ = array;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp18__length1 = array_length1;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp19_ = i;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp20_ = _tmp18_[_tmp19_];
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp21_ = string_get (_tmp17_, (glong) (_tmp20_ & 0x0F));
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				g_string_append_c (_tmp16_, _tmp21_);
#line 504 "Convert.c"
			}
		}
	}
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_g_free0 (hex_chars);
#line 510 "Convert.c"
}


gboolean diorite_uint8v_equal (guint8* array1, int array1_length1, guint8* array2, int array2_length1) {
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = array1;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = array1_length1;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = array2;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1__length1 = array2_length1;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_tmp0__length1 != _tmp1__length1) {
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		result = FALSE;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		return result;
#line 534 "Convert.c"
	}
	{
		gint i = 0;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 540 "Convert.c"
		{
			gboolean _tmp2_ = FALSE;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp2_ = TRUE;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 547 "Convert.c"
				gint _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				guint8 _tmp8_;
				guint8* _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				guint8 _tmp11_;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp2_) {
#line 561 "Convert.c"
					gint _tmp3_;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp3_ = i;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp3_ + 1;
#line 567 "Convert.c"
				}
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp2_ = FALSE;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp4_ = i;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = array1;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5__length1 = array1_length1;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(_tmp4_ < _tmp5__length1)) {
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 581 "Convert.c"
				}
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = array1;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6__length1 = array1_length1;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = i;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = _tmp6_[_tmp7_];
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = array2;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9__length1 = array2_length1;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = i;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = _tmp9_[_tmp10_];
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (_tmp8_ != _tmp11_) {
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					result = FALSE;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					return result;
#line 605 "Convert.c"
				}
			}
		}
	}
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	result = TRUE;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	return result;
#line 614 "Convert.c"
}


/**
 * Converts hexadecimal string to byte array
 * 
 * @param hex          hexadecimal string to convert
 * @param result       byte array
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 * @return             true on success, false on failure (invalid input)
 */
gboolean diorite_hex_to_bin (const gchar* hex, guint8** _result_, int* _result__length1, gchar separator) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gboolean result = FALSE;
	guint8* hex_data = NULL;
	const gchar* _tmp0_;
	gint hex_data_length1;
	gint _hex_data_size_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gint size = 0;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gchar _tmp9_;
	gint _tmp15_;
	guint8* _tmp16_;
	guint8 c = 0U;
	guint8 j = 0U;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_val_if_fail (hex != NULL, FALSE);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = (g_free (_vala_result), NULL);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = NULL;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result_length1 = 0;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = hex;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	hex_data = (guint8*) _tmp0_;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	hex_data_length1 = -1;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_hex_data_size_ = hex_data_length1;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = hex;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp2_ = strlen (_tmp1_);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp3_ = _tmp2_;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	hex_data_length1 = _tmp3_;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp4_ = hex_data_length1;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp6_ = hex;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_tmp6_ != NULL) {
#line 678 "Convert.c"
		guint8* _tmp7_;
		gint _tmp7__length1;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp7_ = hex_data;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp7__length1 = hex_data_length1;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp5_ = _tmp7__length1 > 0;
#line 687 "Convert.c"
	} else {
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp5_ = FALSE;
#line 691 "Convert.c"
	}
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_val_if_fail (_tmp5_, FALSE);
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp8_ = hex_data;
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp8__length1 = hex_data_length1;
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = _tmp8__length1;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp9_ = separator;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_tmp9_ != '\0') {
#line 705 "Convert.c"
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp10_ = size;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		size = _tmp10_ + 1;
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp11_ = size;
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		if ((_tmp11_ % 3) != 0) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			result = FALSE;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			if (_result_) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				*_result_ = _vala_result;
#line 723 "Convert.c"
			} else {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_result = (g_free (_vala_result), NULL);
#line 727 "Convert.c"
			}
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			if (_result__length1) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				*_result__length1 = _vala_result_length1;
#line 733 "Convert.c"
			}
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			return result;
#line 737 "Convert.c"
		}
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp12_ = size;
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		size = _tmp12_ / 3;
#line 743 "Convert.c"
	} else {
		gint _tmp13_;
		gint _tmp14_;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp13_ = size;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		if ((_tmp13_ % 2) != 0) {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			result = FALSE;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			if (_result_) {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				*_result_ = _vala_result;
#line 757 "Convert.c"
			} else {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_result = (g_free (_vala_result), NULL);
#line 761 "Convert.c"
			}
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			if (_result__length1) {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				*_result__length1 = _vala_result_length1;
#line 767 "Convert.c"
			}
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			return result;
#line 771 "Convert.c"
		}
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_tmp14_ = size;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		size = _tmp14_ / 2;
#line 777 "Convert.c"
	}
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp15_ = size;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp16_ = g_new0 (guint8, _tmp15_);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = (g_free (_vala_result), NULL);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = _tmp16_;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result_length1 = _tmp15_;
#line 789 "Convert.c"
	{
		gint i = 0;
		gint pos = 0;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		pos = 0;
#line 797 "Convert.c"
		{
			gboolean _tmp17_ = FALSE;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp17_ = TRUE;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 804 "Convert.c"
				gboolean _tmp19_ = FALSE;
				guint8* _tmp20_;
				gint _tmp20__length1;
				gint _tmp21_;
				guint8 _tmp22_;
				guint8 _tmp23_;
				guint8 _tmp26_;
				gchar _tmp27_;
				guint8 _tmp29_;
				gint _tmp30_;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp17_) {
#line 817 "Convert.c"
					gint _tmp18_;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp18_ = i;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp18_ + 1;
#line 823 "Convert.c"
				}
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp17_ = FALSE;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp20_ = hex_data;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp20__length1 = hex_data_length1;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp21_ = pos;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				pos = _tmp21_ + 1;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp22_ = _tmp20_[_tmp21_];
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				c = _tmp22_;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp23_ = c;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (((gint) _tmp23_) != 0) {
#line 843 "Convert.c"
					gint _tmp24_;
					gint _tmp25_;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp24_ = i;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp25_ = size;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp19_ = _tmp24_ < (2 * _tmp25_);
#line 852 "Convert.c"
				} else {
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp19_ = FALSE;
#line 856 "Convert.c"
				}
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp19_) {
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 862 "Convert.c"
				}
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp26_ = c;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp27_ = separator;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (_tmp26_ == ((guint8) _tmp27_)) {
#line 870 "Convert.c"
					gint _tmp28_;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp28_ = i;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp28_ - 1;
#line 149 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					continue;
#line 878 "Convert.c"
				}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp29_ = c;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				switch (_tmp29_) {
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '0':
#line 886 "Convert.c"
					{
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 0;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 892 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '1':
#line 896 "Convert.c"
					{
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 1;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 902 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '2':
#line 906 "Convert.c"
					{
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 2;
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 912 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '3':
#line 916 "Convert.c"
					{
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 3;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 922 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '4':
#line 926 "Convert.c"
					{
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 4;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 932 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '5':
#line 936 "Convert.c"
					{
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 5;
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 942 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '6':
#line 946 "Convert.c"
					{
#line 160 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 6;
#line 160 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 952 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '7':
#line 956 "Convert.c"
					{
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 7;
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 962 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '8':
#line 966 "Convert.c"
					{
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 8;
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 972 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case '9':
#line 976 "Convert.c"
					{
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 9;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 982 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'A':
#line 986 "Convert.c"
					{
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 10;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 992 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'B':
#line 996 "Convert.c"
					{
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 11;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1002 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'C':
#line 1006 "Convert.c"
					{
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 12;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1012 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'D':
#line 1016 "Convert.c"
					{
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 13;
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1022 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'E':
#line 1026 "Convert.c"
					{
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 14;
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1032 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'F':
#line 1036 "Convert.c"
					{
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 15;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1042 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'a':
#line 1046 "Convert.c"
					{
#line 170 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 10;
#line 170 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1052 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'b':
#line 1056 "Convert.c"
					{
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 11;
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1062 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'c':
#line 1066 "Convert.c"
					{
#line 172 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 12;
#line 172 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1072 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'd':
#line 1076 "Convert.c"
					{
#line 173 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 13;
#line 173 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1082 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'e':
#line 1086 "Convert.c"
					{
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 14;
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1092 "Convert.c"
					}
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					case 'f':
#line 1096 "Convert.c"
					{
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						j = (guint8) 15;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						break;
#line 1102 "Convert.c"
					}
					default:
					{
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						result = FALSE;
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						if (_result_) {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
							*_result_ = _vala_result;
#line 1112 "Convert.c"
						} else {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
							_vala_result = (g_free (_vala_result), NULL);
#line 1116 "Convert.c"
						}
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						if (_result__length1) {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
							*_result__length1 = _vala_result_length1;
#line 1122 "Convert.c"
						}
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
						return result;
#line 1126 "Convert.c"
					}
				}
#line 180 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp30_ = i;
#line 180 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if ((_tmp30_ % 2) == 0) {
#line 1133 "Convert.c"
					guint8* _tmp31_;
					gint _tmp31__length1;
					gint _tmp32_;
					guint8 _tmp33_;
					guint8 _tmp34_;
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp31_ = _vala_result;
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp31__length1 = _vala_result_length1;
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp32_ = i;
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp33_ = j;
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp31_[_tmp32_ / 2] += (guint8) (_tmp33_ << 4);
#line 181 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp34_ = _tmp31_[_tmp32_ / 2];
#line 1151 "Convert.c"
				} else {
					guint8* _tmp35_;
					gint _tmp35__length1;
					gint _tmp36_;
					guint8 _tmp37_;
					guint8 _tmp38_;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp35_ = _vala_result;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp35__length1 = _vala_result_length1;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp36_ = i;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp37_ = j;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp35_[_tmp36_ / 2] += _tmp37_;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp38_ = _tmp35_[_tmp36_ / 2];
#line 1170 "Convert.c"
				}
			}
		}
	}
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	result = TRUE;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 1181 "Convert.c"
	} else {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_vala_result = (g_free (_vala_result), NULL);
#line 1185 "Convert.c"
	}
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result__length1) {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result__length1 = _vala_result_length1;
#line 1191 "Convert.c"
	}
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	return result;
#line 1195 "Convert.c"
}


/**
 * Converts hexadecimal string to int64 value
 * 
 * @param hex          hexadecimal string to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 * @return             true on success, false on failure (invalid input, overflow)
 */
gboolean diorite_hex_to_int64 (const gchar* hex, gint64* _result_, gchar separator) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp0_;
	gchar _tmp1_;
	guint8* _tmp2_ = NULL;
	gint _tmp3_;
	gboolean _tmp4_;
	gint64 _tmp5_ = 0LL;
	gboolean _tmp6_;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_val_if_fail (hex != NULL, FALSE);
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = hex;
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = separator;
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp4_ = diorite_hex_to_bin (_tmp0_, &_tmp2_, &_tmp3_, _tmp1_);
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = (g_free (data), NULL);
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = _tmp2_;
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data_length1 = _tmp3_;
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_data_size_ = data_length1;
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_val_if_fail (_tmp4_, FALSE);
#line 200 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp6_ = diorite_bin_to_int64 (data, data_length1, &_tmp5_);
#line 200 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = _tmp5_;
#line 200 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	g_return_val_if_fail (_tmp6_, FALSE);
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	result = TRUE;
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = (g_free (data), NULL);
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 1252 "Convert.c"
	}
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	return result;
#line 1256 "Convert.c"
}


/**
 * Converts int64 value to hexadecimal string.
 * 
 * @param val        value to convert
 * @param result       converted value
 * @param separator    separator of hexadecimal pairs ('\0' for none)
 */
void diorite_int64_to_hex (gint64 val, gchar* * _result_, gchar separator) {
	gchar* _vala_result = NULL;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	gint64 _tmp0_;
	guint8* _tmp1_ = NULL;
	gint _tmp2_;
	gchar _tmp3_;
	gchar* _tmp4_ = NULL;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = val;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	diorite_int64_to_bin (_tmp0_, &_tmp1_, &_tmp2_);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = (g_free (data), NULL);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = _tmp1_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data_length1 = _tmp2_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_data_size_ = data_length1;
#line 215 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp3_ = separator;
#line 215 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	diorite_bin_to_hex (data, data_length1, &_tmp4_, _tmp3_);
#line 215 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_g_free0 (_vala_result);
#line 215 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_result = _tmp4_;
#line 211 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	data = (g_free (data), NULL);
#line 211 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (_result_) {
#line 211 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*_result_ = _vala_result;
#line 1303 "Convert.c"
	} else {
#line 211 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		_g_free0 (_vala_result);
#line 1307 "Convert.c"
	}
}


/**
 * Converts uint32 value to bytes
 * 
 * @param buffer    buffer of size at least `sizeof(uint32)` where the result will be stored
 * @param data      uint32 value to convert
 * @param offset    offset of the buffer where the result will be stored
 */
void diorite_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset) {
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
#line 227 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = sizeof (guint32);
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = *buffer;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = *buffer_length1;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = offset;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp2_ = size;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
#line 1337 "Convert.c"
	{
		gint i = 0;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 1342 "Convert.c"
		{
			gboolean _tmp3_ = FALSE;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp3_ = TRUE;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 1349 "Convert.c"
				gint _tmp5_;
				gulong _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gint _tmp9_;
				guint32 _tmp10_;
				gulong _tmp11_;
				gint _tmp12_;
				guint8 _tmp13_;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp3_) {
#line 1362 "Convert.c"
					gint _tmp4_;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp4_ = i;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp4_ + 1;
#line 1368 "Convert.c"
				}
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = FALSE;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = i;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = size;
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(((gulong) _tmp5_) < _tmp6_)) {
#line 229 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 1380 "Convert.c"
				}
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = *buffer;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7__length1 = *buffer_length1;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = offset;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = i;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = data;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = size;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12_ = i;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_[_tmp8_ + _tmp9_] = (guint8) ((_tmp10_ >> (((_tmp11_ - 1) - _tmp12_) * 8)) & 0xFF);
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp13_ = _tmp7_[_tmp8_ + _tmp9_];
#line 1400 "Convert.c"
			}
		}
	}
}


/**
 * Converts int32 value to bytes
 * 
 * @param buffer    buffer of size at least `sizeof(int32)` where the result will be stored
 * @param data      int32 value to convert
 * @param offset    offset of the buffer where the result will be stored
 */
void diorite_int32_to_bytes (guint8** buffer, int* buffer_length1, gint32 data, guint offset) {
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
#line 242 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = sizeof (gint32);
#line 243 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = *buffer;
#line 243 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = *buffer_length1;
#line 243 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = offset;
#line 243 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp2_ = size;
#line 243 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
#line 1432 "Convert.c"
	{
		gint i = 0;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 1437 "Convert.c"
		{
			gboolean _tmp3_ = FALSE;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp3_ = TRUE;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 1444 "Convert.c"
				gint _tmp5_;
				gulong _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gint _tmp9_;
				gint32 _tmp10_;
				gulong _tmp11_;
				gint _tmp12_;
				guint8 _tmp13_;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp3_) {
#line 1457 "Convert.c"
					gint _tmp4_;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp4_ = i;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp4_ + 1;
#line 1463 "Convert.c"
				}
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = FALSE;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = i;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = size;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(((gulong) _tmp5_) < _tmp6_)) {
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 1475 "Convert.c"
				}
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = *buffer;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7__length1 = *buffer_length1;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = offset;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = i;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = data;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = size;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12_ = i;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_[_tmp8_ + _tmp9_] = (guint8) ((_tmp10_ >> (((_tmp11_ - 1) - _tmp12_) * 8)) & 0xFF);
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp13_ = _tmp7_[_tmp8_ + _tmp9_];
#line 1495 "Convert.c"
			}
		}
	}
}


/**
 * Converts bytes to uint32 value
 * 
 * @param buffer    buffer that contains the uint32 value
 * @param data      where the uint32 value will be stored
 * @param offset    offset of the buffer where the uint32 value is located
 */
void diorite_uint32_from_bytes (guint8* buffer, int buffer_length1, guint32* data, guint offset) {
	guint32 _vala_data = 0U;
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
#line 257 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = sizeof (guint32);
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = buffer;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = buffer_length1;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = offset;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp2_ = size;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
#line 259 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_data = (guint32) 0;
#line 1530 "Convert.c"
	{
		gint i = 0;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 1535 "Convert.c"
		{
			gboolean _tmp3_ = FALSE;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp3_ = TRUE;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 1542 "Convert.c"
				gint _tmp5_;
				gulong _tmp6_;
				guint32 _tmp7_;
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint _tmp9_;
				gint _tmp10_;
				guint8 _tmp11_;
				gulong _tmp12_;
				gint _tmp13_;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp3_) {
#line 1555 "Convert.c"
					gint _tmp4_;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp4_ = i;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp4_ + 1;
#line 1561 "Convert.c"
				}
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = FALSE;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = i;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = size;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(((gulong) _tmp5_) < _tmp6_)) {
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 1573 "Convert.c"
				}
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = _vala_data;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = buffer;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8__length1 = buffer_length1;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = offset;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = i;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = _tmp8_[_tmp9_ + _tmp10_];
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12_ = size;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp13_ = i;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_data = _tmp7_ + (_tmp11_ * (1 << (((((guint32) _tmp12_) - 1) - _tmp13_) * 8)));
#line 1593 "Convert.c"
			}
		}
	}
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (data) {
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*data = _vala_data;
#line 1601 "Convert.c"
	}
}


/**
 * Converts bytes to int32 value
 * 
 * @param buffer    buffer that contains the int32 value
 * @param data      where the int32 value will be stored
 * @param offset    offset of the buffer where the int32 value is located
 */
void diorite_int32_from_bytes (guint8* buffer, int buffer_length1, gint32* data, guint offset) {
	gint32 _vala_data = 0;
	gulong size = 0UL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	gulong _tmp2_;
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	size = sizeof (gint32);
#line 274 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0_ = buffer;
#line 274 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp0__length1 = buffer_length1;
#line 274 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp1_ = offset;
#line 274 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_tmp2_ = size;
#line 274 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_assert (((gulong) _tmp0__length1) >= (_tmp1_ + _tmp2_), "buffer.length >= offset + size");
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	_vala_data = (gint32) 0;
#line 1634 "Convert.c"
	{
		gint i = 0;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		i = 0;
#line 1639 "Convert.c"
		{
			gboolean _tmp3_ = FALSE;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			_tmp3_ = TRUE;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
			while (TRUE) {
#line 1646 "Convert.c"
				gint _tmp5_;
				gulong _tmp6_;
				gint32 _tmp7_;
				guint8* _tmp8_;
				gint _tmp8__length1;
				guint _tmp9_;
				gint _tmp10_;
				guint8 _tmp11_;
				gulong _tmp12_;
				gint _tmp13_;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!_tmp3_) {
#line 1659 "Convert.c"
					gint _tmp4_;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					_tmp4_ = i;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					i = _tmp4_ + 1;
#line 1665 "Convert.c"
				}
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp3_ = FALSE;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp5_ = i;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp6_ = size;
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				if (!(((gulong) _tmp5_) < _tmp6_)) {
#line 276 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
					break;
#line 1677 "Convert.c"
				}
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp7_ = _vala_data;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8_ = buffer;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp8__length1 = buffer_length1;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp9_ = offset;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp10_ = i;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp11_ = _tmp8_[_tmp9_ + _tmp10_];
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp12_ = size;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_tmp13_ = i;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
				_vala_data = _tmp7_ + (_tmp11_ * (1 << (((((gint32) _tmp12_) - 1) - _tmp13_) * 8)));
#line 1697 "Convert.c"
			}
		}
	}
#line 271 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
	if (data) {
#line 271 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Convert.vala"
		*data = _vala_data;
#line 1705 "Convert.c"
	}
}



