/* Database.c generated by valac 0.36.3, the Vala compiler
 * generated from Database.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <dioriteglib4.h>
#include <stdlib.h>
#include <string.h>


#define DIORITEDB_TYPE_DATABASE (dioritedb_database_get_type ())
#define DIORITEDB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabase))
#define DIORITEDB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))
#define DIORITEDB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))

typedef struct _DioritedbDatabase DioritedbDatabase;
typedef struct _DioritedbDatabaseClass DioritedbDatabaseClass;
typedef struct _DioritedbDatabasePrivate DioritedbDatabasePrivate;

#define DIORITEDB_TYPE_CONNECTION (dioritedb_connection_get_type ())
#define DIORITEDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnection))
#define DIORITEDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))
#define DIORITEDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))

typedef struct _DioritedbConnection DioritedbConnection;
typedef struct _DioritedbConnectionClass DioritedbConnectionClass;

#define DIORITEDB_TYPE_OBJECT_SPEC (dioritedb_object_spec_get_type ())
#define DIORITEDB_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpec))
#define DIORITEDB_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))
#define DIORITEDB_IS_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_IS_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_OBJECT_SPEC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))

typedef struct _DioritedbObjectSpec DioritedbObjectSpec;
typedef struct _DioritedbObjectSpecClass DioritedbObjectSpecClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()
struct _DioritedbDatabase {
	GObject parent_instance;
	DioritedbDatabasePrivate * priv;
};

struct _DioritedbDatabaseClass {
	GObjectClass parent_class;
	void (*open) (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
	void (*close) (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
	DioritedbConnection* (*get_master_connection) (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
};

struct _DioritedbDatabasePrivate {
	GFile* _db_file;
	gboolean _opened;
	GRecMutex __lock__opened;
	DioritedbConnection* master_connection;
	GHashTable* object_specs;
};


static gpointer dioritedb_database_parent_class = NULL;

GType dioritedb_database_get_type (void) G_GNUC_CONST;
GQuark dioritedb_database_error_quark (void);
GType dioritedb_connection_get_type (void) G_GNUC_CONST;
gpointer dioritedb_object_spec_ref (gpointer instance);
void dioritedb_object_spec_unref (gpointer instance);
GParamSpec* dioritedb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void dioritedb_value_set_object_spec (GValue* value, gpointer v_object);
void dioritedb_value_take_object_spec (GValue* value, gpointer v_object);
gpointer dioritedb_value_get_object_spec (const GValue* value);
GType dioritedb_object_spec_get_type (void) G_GNUC_CONST;
#define DIORITEDB_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_DATABASE, DioritedbDatabasePrivate))
enum  {
	DIORITEDB_DATABASE_DUMMY_PROPERTY,
	DIORITEDB_DATABASE_DB_FILE,
	DIORITEDB_DATABASE_OPENED
};
DioritedbDatabase* dioritedb_database_new (GFile* db_file);
DioritedbDatabase* dioritedb_database_construct (GType object_type, GFile* db_file);
static guint _diorite_types_type_hash_ghash_func (gconstpointer key);
static gboolean _diorite_types_type_equal_gequal_func (gconstpointer a, gconstpointer b);
static void _dioritedb_object_spec_unref0_ (gpointer var);
void dioritedb_database_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static void dioritedb_database_real_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
void dioritedb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error);
gboolean dioritedb_database_get_opened (DioritedbDatabase* self);
GFile* dioritedb_database_get_db_file (DioritedbDatabase* self);
DioritedbConnection* dioritedb_connection_new (DioritedbDatabase* database, GCancellable* cancellable, GError** error);
DioritedbConnection* dioritedb_connection_construct (GType object_type, DioritedbDatabase* database, GCancellable* cancellable, GError** error);
static void dioritedb_database_set_opened (DioritedbDatabase* self, gboolean value);
void dioritedb_database_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static void dioritedb_database_real_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
DioritedbConnection* dioritedb_database_get_master_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static DioritedbConnection* dioritedb_database_real_get_master_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static DioritedbConnection* dioritedb_database_open_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
void dioritedb_database_exec (DioritedbDatabase* self, const gchar* sql, GCancellable* cancellable, GError** error);
void dioritedb_connection_exec (DioritedbConnection* self, const gchar* sql, GCancellable* cancellable, GError** error);
void dioritedb_database_add_object_spec (DioritedbDatabase* self, DioritedbObjectSpec* spec);
GType dioritedb_object_spec_get_object_type (DioritedbObjectSpec* self);
DioritedbObjectSpec* dioritedb_database_get_object_spec (DioritedbDatabase* self, GType type);
static void dioritedb_database_throw_if_not_opened (DioritedbDatabase* self, GError** error);
static void dioritedb_database_set_db_file (DioritedbDatabase* self, GFile* value);
static void dioritedb_database_finalize (GObject * obj);
static void _vala_dioritedb_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dioritedb_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static guint _diorite_types_type_hash_ghash_func (gconstpointer key) {
	guint result;
	result = diorite_types_type_hash ((GType) ((gintptr) key));
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 159 "Database.c"
}


static gboolean _diorite_types_type_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = diorite_types_type_equal ((GType) ((gintptr) a), (GType) ((gintptr) b));
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 168 "Database.c"
}


static void _dioritedb_object_spec_unref0_ (gpointer var) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	(var == NULL) ? NULL : (var = (dioritedb_object_spec_unref (var), NULL));
#line 175 "Database.c"
}


DioritedbDatabase* dioritedb_database_construct (GType object_type, GFile* db_file) {
	DioritedbDatabase * self = NULL;
	GFile* _tmp0_;
	GHashTable* _tmp1_;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (db_file != NULL, NULL);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = db_file;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self = (DioritedbDatabase*) g_object_new (object_type, "db-file", _tmp0_, NULL);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = g_hash_table_new_full (_diorite_types_type_hash_ghash_func, _diorite_types_type_equal_gequal_func, NULL, _dioritedb_object_spec_unref0_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_hash_table_unref0 (self->priv->object_specs);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv->object_specs = _tmp1_;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return self;
#line 197 "Database.c"
}


DioritedbDatabase* dioritedb_database_new (GFile* db_file) {
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return dioritedb_database_construct (DIORITEDB_TYPE_DATABASE, db_file);
#line 204 "Database.c"
}


static void dioritedb_database_real_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* db_dir = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GCancellable* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp11_;
	GCancellable* _tmp12_;
	gboolean _tmp13_;
	DioritedbConnection* _tmp22_ = NULL;
	GCancellable* _tmp23_;
	DioritedbConnection* _tmp24_;
	DioritedbConnection* _tmp25_;
	GError * _inner_error_ = NULL;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = cancellable;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.open", "Database.vala", 63, &_inner_error_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 237 "Database.c"
	}
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = dioritedb_database_get_opened (self);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = _tmp1_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (!_tmp2_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp3_ = self->priv->_db_file;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp4_ = g_file_get_parent (_tmp3_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	db_dir = _tmp4_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp5_ = db_dir;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp6_ = cancellable;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp7_ = g_file_query_exists (_tmp5_, _tmp6_);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (!_tmp7_) {
#line 259 "Database.c"
		GFile* _tmp8_;
		GCancellable* _tmp9_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp8_ = db_dir;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp9_ = cancellable;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_file_make_directory_with_parents (_tmp8_, _tmp9_, &_inner_error_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			_g_object_unref0 (db_dir);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return;
#line 276 "Database.c"
		}
	}
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp11_ = self->priv->_db_file;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp12_ = cancellable;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp13_ = g_file_query_exists (_tmp11_, _tmp12_);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (_tmp13_) {
#line 287 "Database.c"
		GFile* _tmp14_;
		GCancellable* _tmp15_;
		GFileType _tmp16_;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp14_ = self->priv->_db_file;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp15_ = cancellable;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp16_ = g_file_query_file_type (_tmp14_, 0, _tmp15_);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp10_ = _tmp16_ != G_FILE_TYPE_REGULAR;
#line 299 "Database.c"
	} else {
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp10_ = FALSE;
#line 303 "Database.c"
	}
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (_tmp10_) {
#line 307 "Database.c"
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GError* _tmp20_;
		GError* _tmp21_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp17_ = self->priv->_db_file;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp19_ = _tmp18_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp20_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_IOERROR, "'%s' exists, but is not a file.", _tmp19_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp21_ = _tmp20_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_free0 (_tmp19_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_inner_error_ = _tmp21_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (db_dir);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 333 "Database.c"
	}
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp23_ = cancellable;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp24_ = dioritedb_connection_new (self, _tmp23_, &_inner_error_);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp22_ = _tmp24_;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (db_dir);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 349 "Database.c"
	}
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp25_ = _tmp22_;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp22_ = NULL;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (self->priv->master_connection);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv->master_connection = _tmp25_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_database_set_opened (self, TRUE);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (_tmp22_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (db_dir);
#line 365 "Database.c"
}


void dioritedb_database_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	DIORITEDB_DATABASE_GET_CLASS (self)->open (self, cancellable, error);
#line 374 "Database.c"
}


static void dioritedb_database_real_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = cancellable;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.close", "Database.vala", 79, &_inner_error_);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 393 "Database.c"
	}
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = dioritedb_database_get_opened (self);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = _tmp1_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (_tmp2_);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (self->priv->master_connection);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv->master_connection = NULL;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_database_set_opened (self, FALSE);
#line 407 "Database.c"
}


void dioritedb_database_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	DIORITEDB_DATABASE_GET_CLASS (self)->close (self, cancellable, error);
#line 416 "Database.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return self ? g_object_ref (self) : NULL;
#line 423 "Database.c"
}


static DioritedbConnection* dioritedb_database_real_get_master_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	DioritedbConnection* result = NULL;
	DioritedbConnection* _tmp0_;
	DioritedbConnection* _tmp5_;
	DioritedbConnection* _tmp6_;
	GError * _inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = self->priv->master_connection;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (_tmp0_ == NULL) {
#line 437 "Database.c"
		DioritedbConnection* _tmp1_ = NULL;
		GCancellable* _tmp2_;
		DioritedbConnection* _tmp3_;
		DioritedbConnection* _tmp4_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp2_ = cancellable;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp3_ = dioritedb_database_open_connection (self, _tmp2_, &_inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp1_ = _tmp3_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return NULL;
#line 454 "Database.c"
		}
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp4_ = _tmp1_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp1_ = NULL;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (self->priv->master_connection);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		self->priv->master_connection = _tmp4_;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (_tmp1_);
#line 466 "Database.c"
	}
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp5_ = self->priv->master_connection;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	result = _tmp6_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 476 "Database.c"
}


DioritedbConnection* dioritedb_database_get_master_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return DIORITEDB_DATABASE_GET_CLASS (self)->get_master_connection (self, cancellable, error);
#line 485 "Database.c"
}


void dioritedb_database_exec (DioritedbDatabase* self, const gchar* sql, GCancellable* cancellable, GError** error) {
	DioritedbConnection* _tmp0_ = NULL;
	GCancellable* _tmp1_;
	DioritedbConnection* _tmp2_;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	const gchar* _tmp5_;
	GCancellable* _tmp6_;
	GError * _inner_error_ = NULL;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (sql != NULL);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = cancellable;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = dioritedb_database_get_master_connection (self, _tmp1_, &_inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = _tmp2_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 514 "Database.c"
	}
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp3_ = _tmp0_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = NULL;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp4_ = _tmp3_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp5_ = sql;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp6_ = cancellable;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_connection_exec (_tmp4_, _tmp5_, _tmp6_, &_inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (_tmp4_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (_tmp0_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return;
#line 538 "Database.c"
	}
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (_tmp0_);
#line 542 "Database.c"
}


static gpointer _dioritedb_object_spec_ref0 (gpointer self) {
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return self ? dioritedb_object_spec_ref (self) : NULL;
#line 549 "Database.c"
}


void dioritedb_database_add_object_spec (DioritedbDatabase* self, DioritedbObjectSpec* spec) {
	GHashTable* _tmp0_;
	DioritedbObjectSpec* _tmp1_;
	GType _tmp2_;
	GType _tmp3_;
	DioritedbObjectSpec* _tmp4_;
	DioritedbObjectSpec* _tmp5_;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (spec != NULL);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = self->priv->object_specs;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = spec;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = dioritedb_object_spec_get_object_type (_tmp1_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp3_ = _tmp2_;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp4_ = spec;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp5_ = _dioritedb_object_spec_ref0 (_tmp4_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_hash_table_insert (_tmp0_, (gpointer) ((gintptr) _tmp3_), _tmp5_);
#line 578 "Database.c"
}


DioritedbObjectSpec* dioritedb_database_get_object_spec (DioritedbDatabase* self, GType type) {
	DioritedbObjectSpec* result = NULL;
	GHashTable* _tmp0_;
	GType _tmp1_;
	gconstpointer _tmp2_;
	DioritedbObjectSpec* _tmp3_;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = self->priv->object_specs;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = type;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) _tmp1_));
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp3_ = _dioritedb_object_spec_ref0 ((DioritedbObjectSpec*) _tmp2_);
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	result = _tmp3_;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 602 "Database.c"
}


static DioritedbConnection* dioritedb_database_open_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	DioritedbConnection* result = NULL;
	GCancellable* _tmp0_;
	DioritedbConnection* _tmp1_ = NULL;
	GCancellable* _tmp2_;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GError * _inner_error_ = NULL;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = cancellable;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.open_connection", "Database.vala", 109, &_inner_error_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return NULL;
#line 626 "Database.c"
	}
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_database_throw_if_not_opened (self, &_inner_error_);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return NULL;
#line 636 "Database.c"
	}
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp2_ = cancellable;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp3_ = dioritedb_connection_new (self, _tmp2_, &_inner_error_);
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = _tmp3_;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_propagate_error (error, _inner_error_);
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return NULL;
#line 650 "Database.c"
	}
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp4_ = _tmp1_;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = NULL;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	result = _tmp4_;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (_tmp1_);
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 662 "Database.c"
}


static void dioritedb_database_throw_if_not_opened (DioritedbDatabase* self, GError** error) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = dioritedb_database_get_opened (self);
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp1_ = _tmp0_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (!_tmp1_) {
#line 678 "Database.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp2_ = self->priv->_db_file;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp4_ = _tmp3_;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp5_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED, "Database '%s' is not opened.", _tmp4_);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp6_ = _tmp5_;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_free0 (_tmp4_);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_inner_error_ = _tmp6_;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_propagate_error (error, _inner_error_);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return;
#line 704 "Database.c"
		} else {
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_clear_error (&_inner_error_);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return;
#line 712 "Database.c"
		}
	}
}


GFile* dioritedb_database_get_db_file (DioritedbDatabase* self) {
	GFile* result;
	GFile* _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_tmp0_ = self->priv->_db_file;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	return result;
#line 729 "Database.c"
}


static void dioritedb_database_set_db_file (DioritedbDatabase* self, GFile* value) {
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	if (dioritedb_database_get_db_file (self) != value) {
#line 738 "Database.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp0_ = value;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_g_object_unref0 (self->priv->_db_file);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		self->priv->_db_file = _tmp1_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_object_notify ((GObject *) self, "db-file");
#line 751 "Database.c"
	}
}


gboolean dioritedb_database_get_opened (DioritedbDatabase* self) {
	gboolean result;
	GError * _inner_error_ = NULL;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 761 "Database.c"
	{
		gboolean _tmp0_;
		gboolean _tmp4_ = FALSE;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp0_ = self->priv->_opened;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__opened);
#line 769 "Database.c"
		{
			gboolean _tmp1_;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			_tmp1_ = self->priv->_opened;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			result = _tmp1_;
#line 776 "Database.c"
			{
				gboolean _tmp2_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
				_tmp2_ = self->priv->_opened;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
				g_rec_mutex_unlock (&self->priv->__lock__opened);
#line 783 "Database.c"
			}
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return result;
#line 787 "Database.c"
		}
		__finally0:
		{
			gboolean _tmp3_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			_tmp3_ = self->priv->_opened;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__opened);
#line 796 "Database.c"
		}
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_clear_error (&_inner_error_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		return _tmp4_;
#line 804 "Database.c"
	}
}


static void dioritedb_database_set_opened (DioritedbDatabase* self, gboolean value) {
	GError * _inner_error_ = NULL;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_return_if_fail (self != NULL);
#line 813 "Database.c"
	{
		gboolean _tmp0_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		_tmp0_ = self->priv->_opened;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_rec_mutex_lock (&self->priv->__lock__opened);
#line 820 "Database.c"
		{
			gboolean _tmp1_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			_tmp1_ = value;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			self->priv->_opened = _tmp1_;
#line 827 "Database.c"
		}
		__finally1:
		{
			gboolean _tmp2_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			_tmp2_ = self->priv->_opened;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_rec_mutex_unlock (&self->priv->__lock__opened);
#line 836 "Database.c"
		}
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			g_clear_error (&_inner_error_);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
			return;
#line 846 "Database.c"
		}
	}
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_object_notify ((GObject *) self, "opened");
#line 851 "Database.c"
}


static void dioritedb_database_class_init (DioritedbDatabaseClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	dioritedb_database_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_type_class_add_private (klass, sizeof (DioritedbDatabasePrivate));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	((DioritedbDatabaseClass *) klass)->open = (void (*) (DioritedbDatabase *, GCancellable*, GError**)) dioritedb_database_real_open;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	((DioritedbDatabaseClass *) klass)->close = (void (*) (DioritedbDatabase *, GCancellable*, GError**)) dioritedb_database_real_close;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	((DioritedbDatabaseClass *) klass)->get_master_connection = (DioritedbConnection* (*) (DioritedbDatabase *, GCancellable*, GError**)) dioritedb_database_real_get_master_connection;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dioritedb_database_get_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dioritedb_database_set_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	G_OBJECT_CLASS (klass)->finalize = dioritedb_database_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_DATABASE_DB_FILE, g_param_spec_object ("db-file", "db-file", "db-file", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_DATABASE_OPENED, g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 876 "Database.c"
}


static void dioritedb_database_instance_init (DioritedbDatabase * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv = DIORITEDB_DATABASE_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_rec_mutex_init (&self->priv->__lock__opened);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv->_opened = FALSE;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self->priv->master_connection = NULL;
#line 889 "Database.c"
}


static void dioritedb_database_finalize (GObject * obj) {
	DioritedbDatabase * self;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (self->priv->_db_file);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	g_rec_mutex_clear (&self->priv->__lock__opened);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_object_unref0 (self->priv->master_connection);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	_g_hash_table_unref0 (self->priv->object_specs);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	G_OBJECT_CLASS (dioritedb_database_parent_class)->finalize (obj);
#line 907 "Database.c"
}


GType dioritedb_database_get_type (void) {
	static volatile gsize dioritedb_database_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbDatabase), 0, (GInstanceInitFunc) dioritedb_database_instance_init, NULL };
		GType dioritedb_database_type_id;
		dioritedb_database_type_id = g_type_register_static (G_TYPE_OBJECT, "DioritedbDatabase", &g_define_type_info, 0);
		g_once_init_leave (&dioritedb_database_type_id__volatile, dioritedb_database_type_id);
	}
	return dioritedb_database_type_id__volatile;
}


static void _vala_dioritedb_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioritedbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		case DIORITEDB_DATABASE_DB_FILE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_value_set_object (value, dioritedb_database_get_db_file (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		case DIORITEDB_DATABASE_OPENED:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		g_value_set_boolean (value, dioritedb_database_get_opened (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 940 "Database.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 946 "Database.c"
	}
}


static void _vala_dioritedb_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioritedbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		case DIORITEDB_DATABASE_DB_FILE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		dioritedb_database_set_db_file (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		case DIORITEDB_DATABASE_OPENED:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		dioritedb_database_set_opened (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 968 "Database.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Database.vala"
		break;
#line 974 "Database.c"
	}
}



