/* JsonValue.c generated by valac 0.36.3, the Vala compiler
 * generated from JsonValue.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define DRT_TYPE_JSON_VALUE_TYPE (drt_json_value_type_get_type ())

#define DRT_TYPE_JSON_NODE (drt_json_node_get_type ())
#define DRT_JSON_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_JSON_NODE, DrtJsonNode))
#define DRT_JSON_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_JSON_NODE, DrtJsonNodeClass))
#define DRT_IS_JSON_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_JSON_NODE))
#define DRT_IS_JSON_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_JSON_NODE))
#define DRT_JSON_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_JSON_NODE, DrtJsonNodeClass))

typedef struct _DrtJsonNode DrtJsonNode;
typedef struct _DrtJsonNodeClass DrtJsonNodeClass;
typedef struct _DrtJsonNodePrivate DrtJsonNodePrivate;

#define DRT_TYPE_JSON_VALUE (drt_json_value_get_type ())
#define DRT_JSON_VALUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_JSON_VALUE, DrtJsonValue))
#define DRT_JSON_VALUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_JSON_VALUE, DrtJsonValueClass))
#define DRT_IS_JSON_VALUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_JSON_VALUE))
#define DRT_IS_JSON_VALUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_JSON_VALUE))
#define DRT_JSON_VALUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_JSON_VALUE, DrtJsonValueClass))

typedef struct _DrtJsonValue DrtJsonValue;
typedef struct _DrtJsonValueClass DrtJsonValueClass;
typedef struct _DrtJsonValuePrivate DrtJsonValuePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DRT_JSON_VALUE_TYPE_NULL,
	DRT_JSON_VALUE_TYPE_BOOLEAN,
	DRT_JSON_VALUE_TYPE_STRING,
	DRT_JSON_VALUE_TYPE_INTEGER,
	DRT_JSON_VALUE_TYPE_DOUBLE
} DrtJsonValueType;

struct _DrtJsonNode {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtJsonNodePrivate * priv;
	DrtJsonNode* parent;
};

struct _DrtJsonNodeClass {
	GTypeClass parent_class;
	void (*finalize) (DrtJsonNode *self);
	gchar* (*to_string) (DrtJsonNode* self);
};

struct _DrtJsonValue {
	DrtJsonNode parent_instance;
	DrtJsonValuePrivate * priv;
};

struct _DrtJsonValueClass {
	DrtJsonNodeClass parent_class;
};

struct _DrtJsonValuePrivate {
	DrtJsonValueType _value_type;
	gint int_value;
	gdouble double_value;
	gchar* string_value;
};


static gpointer drt_json_value_parent_class = NULL;

GType drt_json_value_type_get_type (void) G_GNUC_CONST;
gpointer drt_json_node_ref (gpointer instance);
void drt_json_node_unref (gpointer instance);
GParamSpec* drt_param_spec_json_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_json_node (GValue* value, gpointer v_object);
void drt_value_take_json_node (GValue* value, gpointer v_object);
gpointer drt_value_get_json_node (const GValue* value);
GType drt_json_node_get_type (void) G_GNUC_CONST;
GType drt_json_value_get_type (void) G_GNUC_CONST;
#define DRT_JSON_VALUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_JSON_VALUE, DrtJsonValuePrivate))
enum  {
	DRT_JSON_VALUE_DUMMY_PROPERTY
};
gchar* drt_json_value_escape_string (const gchar* str);
DrtJsonValue* drt_json_value_new_null (void);
DrtJsonValue* drt_json_value_construct_null (GType object_type);
DrtJsonNode* drt_json_node_construct (GType object_type);
void drt_json_value_set_value_type (DrtJsonValue* self, DrtJsonValueType value);
DrtJsonValue* drt_json_value_new_bool (gboolean bool_value);
DrtJsonValue* drt_json_value_construct_bool (GType object_type, gboolean bool_value);
DrtJsonValue* drt_json_value_new_int (gint int_value);
DrtJsonValue* drt_json_value_construct_int (GType object_type, gint int_value);
DrtJsonValue* drt_json_value_new_double (gdouble double_value);
DrtJsonValue* drt_json_value_construct_double (GType object_type, gdouble double_value);
DrtJsonValue* drt_json_value_new_string (const gchar* string_value);
DrtJsonValue* drt_json_value_construct_string (GType object_type, const gchar* string_value);
const gchar* drt_json_value_get_string (DrtJsonValue* self);
DrtJsonValueType drt_json_value_get_value_type (DrtJsonValue* self);
gchar* drt_json_value_dup_string (DrtJsonValue* self);
gboolean drt_json_value_try_string (DrtJsonValue* self, gchar* * _result_);
gboolean drt_json_value_get_bool (DrtJsonValue* self);
gboolean drt_json_value_try_bool (DrtJsonValue* self, gboolean* _result_);
gint drt_json_value_get_int (DrtJsonValue* self);
gboolean drt_json_value_try_int (DrtJsonValue* self, gint* _result_);
gdouble drt_json_value_get_double (DrtJsonValue* self);
gboolean drt_json_value_try_double (DrtJsonValue* self, gdouble* _result_);
static gchar* drt_json_value_real_to_string (DrtJsonNode* base);
DrtJsonValue* drt_json_value_new (void);
DrtJsonValue* drt_json_value_construct (GType object_type);
static void drt_json_value_finalize (DrtJsonNode * obj);


/**
 * Types of values the {@link JsonValue} object can hold.
 */
GType drt_json_value_type_get_type (void) {
	static volatile gsize drt_json_value_type_type_id__volatile = 0;
	if (g_once_init_enter (&drt_json_value_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DRT_JSON_VALUE_TYPE_NULL, "DRT_JSON_VALUE_TYPE_NULL", "null"}, {DRT_JSON_VALUE_TYPE_BOOLEAN, "DRT_JSON_VALUE_TYPE_BOOLEAN", "boolean"}, {DRT_JSON_VALUE_TYPE_STRING, "DRT_JSON_VALUE_TYPE_STRING", "string"}, {DRT_JSON_VALUE_TYPE_INTEGER, "DRT_JSON_VALUE_TYPE_INTEGER", "integer"}, {DRT_JSON_VALUE_TYPE_DOUBLE, "DRT_JSON_VALUE_TYPE_DOUBLE", "double"}, {0, NULL, NULL}};
		GType drt_json_value_type_type_id;
		drt_json_value_type_type_id = g_enum_register_static ("DrtJsonValueType", values);
		g_once_init_leave (&drt_json_value_type_type_id__volatile, drt_json_value_type_type_id);
	}
	return drt_json_value_type_type_id__volatile;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 170 "JsonValue.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 201 "JsonValue.c"
				goto __catch30_g_regex_error;
			}
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			return NULL;
#line 210 "JsonValue.c"
		}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 226 "JsonValue.c"
				goto __catch30_g_regex_error;
			}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			return NULL;
#line 237 "JsonValue.c"
		}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 251 "JsonValue.c"
	}
	goto __finally30;
	__catch30_g_regex_error:
	{
		GError* e = NULL;
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1385 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 265 "JsonValue.c"
	}
	__finally30:
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return NULL;
#line 276 "JsonValue.c"
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1398 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1399 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1399 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1399 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1400 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1400 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1400 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1400 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 321 "JsonValue.c"
	}
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1401 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 327 "JsonValue.c"
}


gchar* drt_json_value_escape_string (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* _result_ = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	guint8 c = 0U;
	gint len = 0;
	const gchar* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = str;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_tmp0_ == NULL) {
#line 361 "JsonValue.c"
		gchar* _tmp1_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp1_ = g_strdup ("");
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		result = _tmp1_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		return result;
#line 369 "JsonValue.c"
	}
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp2_ = str;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp3_ = g_utf8_validate (_tmp2_, (gssize) -1, NULL);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp3_, "");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp4_ = str;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp5_ = string_replace (_tmp4_, "\\", "\\\\");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp6_ = _tmp5_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp7_ = string_replace (_tmp6_, "\"", "\\\"");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp8_ = _tmp7_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp9_ = string_replace (_tmp8_, "\n", "\\n");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp10_ = _tmp9_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp11_ = string_replace (_tmp10_, "\t", "\\t");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp12_ = _tmp11_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp13_ = string_replace (_tmp12_, "\r", "\\r");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp14_ = _tmp13_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp15_ = string_replace (_tmp14_, "\b", "\\b");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp16_ = _tmp15_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp17_ = string_replace (_tmp16_, "\f", "\\f");
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp18_ = _tmp17_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp16_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp14_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp12_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp10_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp8_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_tmp6_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_result_ = _tmp18_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	c = (guint8) 0;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp19_ = _result_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp20_ = strlen (_tmp19_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp21_ = _tmp20_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	len = _tmp21_;
#line 431 "JsonValue.c"
	{
		gint i = 0;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		i = 0;
#line 436 "JsonValue.c"
		{
			gboolean _tmp22_ = FALSE;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp22_ = TRUE;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			while (TRUE) {
#line 443 "JsonValue.c"
				gboolean _tmp24_ = FALSE;
				gint _tmp25_;
				gint _tmp26_;
				guint8 _tmp33_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				if (!_tmp22_) {
#line 450 "JsonValue.c"
					gint _tmp23_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp23_ = i;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					i = _tmp23_ + 1;
#line 456 "JsonValue.c"
				}
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp22_ = FALSE;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp25_ = i;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp26_ = len;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				if (_tmp25_ < _tmp26_) {
#line 466 "JsonValue.c"
					const gchar* _tmp27_;
					guint8* _tmp28_;
					gint _tmp28__length1;
					guint8* _tmp29_;
					gint _tmp29__length1;
					gint _tmp30_;
					guint8 _tmp31_;
					guint8 _tmp32_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp27_ = _result_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp28_ = string_get_data (_tmp27_, &_tmp28__length1);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp29_ = _tmp28_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp29__length1 = _tmp28__length1;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp30_ = i;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp31_ = _tmp29_[_tmp30_];
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					c = _tmp31_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp32_ = c;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp24_ = ((gint) _tmp32_) != 0;
#line 493 "JsonValue.c"
				} else {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp24_ = FALSE;
#line 497 "JsonValue.c"
				}
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				if (!_tmp24_) {
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					break;
#line 503 "JsonValue.c"
				}
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp33_ = c;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				if (((gint) _tmp33_) < 32) {
#line 509 "JsonValue.c"
					const gchar* _tmp34_;
					guint8* _tmp35_;
					gint _tmp35__length1;
					guint8* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_;
					guint8 _tmp38_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp34_ = _result_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp35_ = string_get_data (_tmp34_, &_tmp35__length1);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp36_ = _tmp35_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp36__length1 = _tmp35__length1;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp37_ = i;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp36_[_tmp37_] = (guint8) 32;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
					_tmp38_ = _tmp36_[_tmp37_];
#line 531 "JsonValue.c"
				}
			}
		}
	}
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _result_;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 540 "JsonValue.c"
}


/**
 * Creates a new null {@link JsonValue}.
 */
DrtJsonValue* drt_json_value_construct_null (GType object_type) {
	DrtJsonValue* self = NULL;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_NULL);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 555 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new_null (void) {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct_null (DRT_TYPE_JSON_VALUE);
#line 562 "JsonValue.c"
}


/**
 * Creates a new boolean {@link JsonValue}.
 * 
 * @param bool_value    Boolean value.
 */
DrtJsonValue* drt_json_value_construct_bool (GType object_type, gboolean bool_value) {
	DrtJsonValue* self = NULL;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_BOOLEAN);
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = bool_value;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_tmp1_) {
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp0_ = 1;
#line 585 "JsonValue.c"
	} else {
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp0_ = 0;
#line 589 "JsonValue.c"
	}
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->int_value = _tmp0_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 595 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new_bool (gboolean bool_value) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct_bool (DRT_TYPE_JSON_VALUE, bool_value);
#line 602 "JsonValue.c"
}


/**
 * Creates a new integer number {@link JsonValue}.
 * 
 * @param int_value    Integer value.
 */
DrtJsonValue* drt_json_value_construct_int (GType object_type, gint int_value) {
	DrtJsonValue* self = NULL;
	gint _tmp0_;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_INTEGER);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = int_value;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->int_value = _tmp0_;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 624 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new_int (gint int_value) {
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct_int (DRT_TYPE_JSON_VALUE, int_value);
#line 631 "JsonValue.c"
}


/**
 * Creates a new floating point number {@link JsonValue}.
 * 
 * @param double_value    Double value.
 */
DrtJsonValue* drt_json_value_construct_double (GType object_type, gdouble double_value) {
	DrtJsonValue* self = NULL;
	gdouble _tmp0_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_DOUBLE);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = double_value;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->double_value = _tmp0_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 653 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new_double (gdouble double_value) {
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct_double (DRT_TYPE_JSON_VALUE, double_value);
#line 660 "JsonValue.c"
}


/**
 * Creates a new string {@link JsonValue}.
 * 
 * @param string_value    String value.
 */
DrtJsonValue* drt_json_value_construct_string (GType object_type, const gchar* string_value) {
	DrtJsonValue* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_STRING);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = string_value;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (self->priv->string_value);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->string_value = _tmp1_;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 687 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new_string (const gchar* string_value) {
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct_string (DRT_TYPE_JSON_VALUE, string_value);
#line 694 "JsonValue.c"
}


/**
 * Get a string value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.STRING}. You might want to use {@link JsonNode.is_string} or
 * {@link JsonValue.try_string}.
 * 
 * @return the actual string value if this is of type {@link JsonValueType.STRING},
 *     undefined result otherwise
 */
const gchar* drt_json_value_get_string (DrtJsonValue* self) {
	const gchar* result = NULL;
	DrtJsonValueType _tmp0_;
	const gchar* _tmp1_;
#line 143 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_STRING, NULL);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->string_value;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 724 "JsonValue.c"
}


/**
 * Duplicate a string value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.STRING}. You might want to use {@link JsonNode.is_string} or
 * {@link JsonValue.try_string}.
 * 
 * @return the copy of the actual string value if this is of type {@link JsonValueType.STRING},
 *     undefined result otherwise
 */
gchar* drt_json_value_dup_string (DrtJsonValue* self) {
	gchar* result = NULL;
	DrtJsonValueType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_STRING, NULL);
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->string_value;
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp2_;
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 757 "JsonValue.c"
}


/**
 * Try getting a string value
 * 
 * @param result    String value.
 * @return `true` if this holds {@link JsonValueType.STRING} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_string (DrtJsonValue* self, gchar* * _result_) {
	gchar* _vala_result = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	DrtJsonValueType _tmp2_;
#line 172 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->string_value;
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (_vala_result);
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_vala_result = _tmp1_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp2_ = self->priv->_value_type;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp2_ == DRT_JSON_VALUE_TYPE_STRING;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_result_) {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		*_result_ = _vala_result;
#line 792 "JsonValue.c"
	} else {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_g_free0 (_vala_result);
#line 796 "JsonValue.c"
	}
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 800 "JsonValue.c"
}


/**
 * Get a boolean value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.BOOLEAN}. You might want to use {@link JsonNode.is_bool} or
 * {@link JsonValue.try_bool}.
 * 
 * @return the actual boolean value if this is of type {@link JsonValueType.BOOLEAN},
 *     undefined result otherwise
 */
gboolean drt_json_value_get_bool (DrtJsonValue* self) {
	gboolean result = FALSE;
	DrtJsonValueType _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_BOOLEAN, FALSE);
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp2_ = self->priv->int_value;
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_tmp2_ != 0) {
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp1_ = TRUE;
#line 831 "JsonValue.c"
	} else {
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp1_ = FALSE;
#line 835 "JsonValue.c"
	}
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_;
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 841 "JsonValue.c"
}


/**
 * Try getting a boolean value
 * 
 * @param result    Boolean value.
 * @return `true` if this holds {@link JsonValueType.BOOLEAN} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_bool (DrtJsonValue* self, gboolean* _result_) {
	gboolean _vala_result = FALSE;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	DrtJsonValueType _tmp2_;
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->int_value;
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_tmp1_ != 0) {
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp0_ = TRUE;
#line 866 "JsonValue.c"
	} else {
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		_tmp0_ = FALSE;
#line 870 "JsonValue.c"
	}
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_vala_result = _tmp0_;
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp2_ = self->priv->_value_type;
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp2_ == DRT_JSON_VALUE_TYPE_BOOLEAN;
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_result_) {
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		*_result_ = _vala_result;
#line 882 "JsonValue.c"
	}
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 886 "JsonValue.c"
}


/**
 * Get an integer value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.INTEGER}. You might want to use {@link JsonNode.is_int} or
 * {@link JsonValue.try_int}.
 * 
 * @return the actual integer value if this is of type {@link JsonValueType.INTEGER},
 *     undefined result otherwise
 */
gint drt_json_value_get_int (DrtJsonValue* self) {
	gint result = 0;
	DrtJsonValueType _tmp0_;
	gint _tmp1_;
#line 217 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 219 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 219 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_INTEGER, 0);
#line 220 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->int_value;
#line 220 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_;
#line 220 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 916 "JsonValue.c"
}


/**
 * Try getting an integer number value
 * 
 * @param result    Integer value.
 * @return `true` if this holds {@link JsonValueType.INTEGER} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_int (DrtJsonValue* self, gint* _result_) {
	gint _vala_result = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	DrtJsonValueType _tmp1_;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->int_value;
#line 232 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_vala_result = _tmp0_;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->_value_type;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_ == DRT_JSON_VALUE_TYPE_INTEGER;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_result_) {
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		*_result_ = _vala_result;
#line 946 "JsonValue.c"
	}
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 950 "JsonValue.c"
}


/**
 * Get a floating point number value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.DOUBLE}. You might want to use {@link JsonNode.is_double} or
 * {@link JsonValue.try_double}.
 * 
 * @return the actual double value if this is of type {@link JsonValueType.DOUBLE},
 *     undefined result otherwise
 */
gdouble drt_json_value_get_double (DrtJsonValue* self) {
	gdouble result = 0.0;
	DrtJsonValueType _tmp0_;
	gdouble _tmp1_;
#line 246 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 248 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 248 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_DOUBLE, 0.0);
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->double_value;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 980 "JsonValue.c"
}


/**
 * Try getting a floating point number value
 * 
 * @param result    Double value.
 * @return `true` if this holds {@link JsonValueType.DOUBLE} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_double (DrtJsonValue* self, gdouble* _result_) {
	gdouble _vala_result = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_;
	DrtJsonValueType _tmp1_;
#line 259 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->double_value;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_vala_result = _tmp0_;
#line 262 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp1_ = self->priv->_value_type;
#line 262 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp1_ == DRT_JSON_VALUE_TYPE_DOUBLE;
#line 262 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	if (_result_) {
#line 262 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		*_result_ = _vala_result;
#line 1010 "JsonValue.c"
	}
#line 262 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 1014 "JsonValue.c"
}


/**
 * Return string representation of the node.
 * 
 * @return a string representation of the node
 */
static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 863 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 1049 "JsonValue.c"
}


static gchar* drt_json_value_real_to_string (DrtJsonNode* base) {
	DrtJsonValue * self;
	gchar* result = NULL;
	DrtJsonValueType _tmp0_;
#line 270 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) base;
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	switch (_tmp0_) {
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		case DRT_JSON_VALUE_TYPE_NULL:
#line 1065 "JsonValue.c"
		{
			gchar* _tmp1_;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp1_ = g_strdup ("null");
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			result = _tmp1_;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			return result;
#line 1074 "JsonValue.c"
		}
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		case DRT_JSON_VALUE_TYPE_BOOLEAN:
#line 1078 "JsonValue.c"
		{
			const gchar* _tmp2_ = NULL;
			gint _tmp3_;
			gchar* _tmp4_;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp3_ = self->priv->int_value;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			if (_tmp3_ != 0) {
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp2_ = "true";
#line 1089 "JsonValue.c"
			} else {
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
				_tmp2_ = "false";
#line 1093 "JsonValue.c"
			}
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp4_ = g_strdup (_tmp2_);
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			result = _tmp4_;
#line 277 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			return result;
#line 1101 "JsonValue.c"
		}
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		case DRT_JSON_VALUE_TYPE_INTEGER:
#line 1105 "JsonValue.c"
		{
			gint _tmp5_;
			gchar* _tmp6_;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp5_ = self->priv->int_value;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			result = _tmp6_;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			return result;
#line 1117 "JsonValue.c"
		}
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		case DRT_JSON_VALUE_TYPE_DOUBLE:
#line 1121 "JsonValue.c"
		{
			gdouble _tmp7_;
			gchar* _tmp8_;
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp7_ = self->priv->double_value;
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp8_ = double_to_string (_tmp7_);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			result = _tmp8_;
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			return result;
#line 1133 "JsonValue.c"
		}
#line 272 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
		case DRT_JSON_VALUE_TYPE_STRING:
#line 1137 "JsonValue.c"
		{
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp9_ = self->priv->string_value;
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp10_ = drt_json_value_escape_string (_tmp9_);
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp11_ = _tmp10_;
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp12_ = g_strdup_printf ("\"%s\"", _tmp11_);
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_tmp13_ = _tmp12_;
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			_g_free0 (_tmp11_);
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			result = _tmp13_;
#line 283 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			return result;
#line 1160 "JsonValue.c"
		}
		default:
		{
#line 285 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
			g_assert_not_reached ();
#line 1166 "JsonValue.c"
		}
	}
}


DrtJsonValue* drt_json_value_construct (GType object_type) {
	DrtJsonValue* self = NULL;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return self;
#line 1178 "JsonValue.c"
}


DrtJsonValue* drt_json_value_new (void) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return drt_json_value_construct (DRT_TYPE_JSON_VALUE);
#line 1185 "JsonValue.c"
}


DrtJsonValueType drt_json_value_get_value_type (DrtJsonValue* self) {
	DrtJsonValueType result;
	DrtJsonValueType _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = self->priv->_value_type;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	result = _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	return result;
#line 1200 "JsonValue.c"
}


void drt_json_value_set_value_type (DrtJsonValue* self, DrtJsonValueType value) {
	DrtJsonValueType _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_tmp0_ = value;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->_value_type = _tmp0_;
#line 1212 "JsonValue.c"
}


static void drt_json_value_class_init (DrtJsonValueClass * klass) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	drt_json_value_parent_class = g_type_class_peek_parent (klass);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	((DrtJsonNodeClass *) klass)->finalize = drt_json_value_finalize;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	g_type_class_add_private (klass, sizeof (DrtJsonValuePrivate));
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	((DrtJsonNodeClass *) klass)->to_string = (gchar* (*) (DrtJsonNode *)) drt_json_value_real_to_string;
#line 1225 "JsonValue.c"
}


static void drt_json_value_instance_init (DrtJsonValue * self) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv = DRT_JSON_VALUE_GET_PRIVATE (self);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->_value_type = DRT_JSON_VALUE_TYPE_NULL;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->int_value = 0;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->double_value = 0.0;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self->priv->string_value = NULL;
#line 1240 "JsonValue.c"
}


static void drt_json_value_finalize (DrtJsonNode * obj) {
	DrtJsonValue * self;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_JSON_VALUE, DrtJsonValue);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	_g_free0 (self->priv->string_value);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/JsonValue.vala"
	DRT_JSON_NODE_CLASS (drt_json_value_parent_class)->finalize (obj);
#line 1252 "JsonValue.c"
}


/**
 * JSON Value holds boolean, integer, float, string and null values.
 */
GType drt_json_value_get_type (void) {
	static volatile gsize drt_json_value_type_id__volatile = 0;
	if (g_once_init_enter (&drt_json_value_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtJsonValueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_json_value_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtJsonValue), 0, (GInstanceInitFunc) drt_json_value_instance_init, NULL };
		GType drt_json_value_type_id;
		drt_json_value_type_id = g_type_register_static (DRT_TYPE_JSON_NODE, "DrtJsonValue", &g_define_type_info, 0);
		g_once_init_leave (&drt_json_value_type_id__volatile, drt_json_value_type_id);
	}
	return drt_json_value_type_id__volatile;
}



