/* Logger.c generated by valac 0.36.3, the Vala compiler
 * generated from Logger.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_TYPE_LOGGER (diorite_logger_get_type ())
#define DIORITE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_LOGGER, DioriteLogger))
#define DIORITE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_LOGGER, DioriteLoggerClass))
#define DIORITE_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_LOGGER))
#define DIORITE_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_LOGGER))
#define DIORITE_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_LOGGER, DioriteLoggerClass))

typedef struct _DioriteLogger DioriteLogger;
typedef struct _DioriteLoggerClass DioriteLoggerClass;
typedef struct _DioriteLoggerPrivate DioriteLoggerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_pattern_spec_free0(var) ((var == NULL) ? NULL : (var = (g_pattern_spec_free (var), NULL)))
typedef struct _DioriteParamSpecLogger DioriteParamSpecLogger;

struct _DioriteLogger {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteLoggerPrivate * priv;
};

struct _DioriteLoggerClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteLogger *self);
};

struct _DioriteParamSpecLogger {
	GParamSpec parent_instance;
};


static gpointer diorite_logger_parent_class = NULL;
static GLogLevelFlags diorite_logger_display_level;
static GLogLevelFlags diorite_logger_display_level = 0;
static FILE* diorite_logger_output;
static GRecMutex __lock_diorite_logger_output = {0};
static FILE* diorite_logger_output = NULL;
static gboolean diorite_logger_colorful;
static gboolean diorite_logger_colorful = FALSE;
static gchar* diorite_logger_hint;
static gchar* diorite_logger_hint = NULL;
static GDateTime* diorite_logger_time_ref;
static GRecMutex __lock_diorite_logger_time_ref = {0};
static GDateTime* diorite_logger_time_ref = NULL;
static GPatternSpec* diorite_logger_fatal_string;
static GPatternSpec* diorite_logger_fatal_string = NULL;

#define G_LOG_DOMAIN "DioriteGlib"
gpointer diorite_logger_ref (gpointer instance);
void diorite_logger_unref (gpointer instance);
GParamSpec* diorite_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_value_set_logger (GValue* value, gpointer v_object);
void diorite_value_take_logger (GValue* value, gpointer v_object);
gpointer diorite_value_get_logger (const GValue* value);
GType diorite_logger_get_type (void) G_GNUC_CONST;
enum  {
	DIORITE_LOGGER_DUMMY_PROPERTY
};
#define DIORITE_LOGGER_COLOR_FOREGROUND 30
#define DIORITE_LOGGER_COLOR_BACKGROUND 40
#define DIORITE_LOGGER_COLOR_BLACK 0
#define DIORITE_LOGGER_COLOR_RED 1
#define DIORITE_LOGGER_COLOR_GREEN 2
#define DIORITE_LOGGER_COLOR_YELLOW 3
#define DIORITE_LOGGER_COLOR_BLUE 4
#define DIORITE_LOGGER_COLOR_MAGENTA 5
#define DIORITE_LOGGER_COLOR_CYAN 6
#define DIORITE_LOGGER_COLOR_WHITE 7
void diorite_logger_init (FILE* output, GLogLevelFlags display_level, gboolean time, const gchar* hint);
gboolean diorite_logger_colors_supported (void);
static void diorite_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message);
static void _diorite_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self);
void diorite_logger_printf (const gchar* format, ...) G_GNUC_PRINTF(1,2);
void diorite_logger_puts (const gchar* line);
void diorite_logger_logf (const gchar* format, ...) G_GNUC_PRINTF(1,2);
void diorite_logger_log (const gchar* line);
static void diorite_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message);
DioriteLogger* diorite_logger_new (void);
DioriteLogger* diorite_logger_construct (GType object_type);
static void diorite_logger_finalize (DioriteLogger * obj);


/**
 * Initializes new logger for GLib
 * 
 * @param output           output to write logger messages to (e. g. sys.stderr)
 * @param display_level    lowest log level to log
 */
static gpointer _g_date_time_ref0 (gpointer self) {
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 130 "Logger.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 148 "Logger.c"
}


static void _diorite_logger_log_handler_glog_func (const gchar* log_domain, GLogLevelFlags log_levels, const gchar* message, gpointer self) {
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_log_handler (log_domain, log_levels, message);
#line 155 "Logger.c"
}


void diorite_logger_init (FILE* output, GLogLevelFlags display_level, gboolean time, const gchar* hint) {
	FILE* _tmp0_;
	GLogLevelFlags _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp6_;
	gchar* use_colors = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GDateTime* _tmp14_ = NULL;
	gboolean _tmp15_;
	GDateTime* _tmp17_;
	gchar* fatal_string = NULL;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (output != NULL);
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp0_ = output;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_output = _tmp0_;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp1_ = display_level;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_display_level = _tmp1_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp3_ = hint;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp3_ != NULL) {
#line 191 "Logger.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp4_ = hint;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp5_ = g_strconcat (_tmp4_, ": ", NULL);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_g_free0 (_tmp2_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp2_ = _tmp5_;
#line 202 "Logger.c"
	} else {
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_g_free0 (_tmp2_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp2_ = NULL;
#line 208 "Logger.c"
	}
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp6_ = g_strdup (_tmp2_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (diorite_logger_hint);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_hint = _tmp6_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp7_ = g_getenv ("DIORITE_LOGGER_USE_COLORS");
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	use_colors = _tmp8_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp9_ = use_colors;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (g_strcmp0 (_tmp9_, "yes") == 0) {
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_colorful = TRUE;
#line 228 "Logger.c"
	} else {
		const gchar* _tmp10_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp10_ = use_colors;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (g_strcmp0 (_tmp10_, "no") == 0) {
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			diorite_logger_colorful = FALSE;
#line 237 "Logger.c"
		} else {
			gboolean _tmp11_;
			const gchar* _tmp12_ = NULL;
			gboolean _tmp13_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp11_ = diorite_logger_colors_supported ();
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			diorite_logger_colorful = _tmp11_;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp13_ = diorite_logger_colorful;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp13_) {
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp12_ = "yes";
#line 252 "Logger.c"
			} else {
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp12_ = "no";
#line 256 "Logger.c"
			}
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_setenv ("DIORITE_LOGGER_USE_COLORS", _tmp12_, FALSE);
#line 260 "Logger.c"
		}
	}
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp15_ = time;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp15_) {
#line 267 "Logger.c"
		GDateTime* _tmp16_;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp16_ = g_date_time_new_now_local ();
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_g_date_time_unref0 (_tmp14_);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp14_ = _tmp16_;
#line 275 "Logger.c"
	} else {
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_g_date_time_unref0 (_tmp14_);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp14_ = NULL;
#line 281 "Logger.c"
	}
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp17_ = _g_date_time_ref0 (_tmp14_);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_date_time_unref0 (diorite_logger_time_ref);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_time_ref = _tmp17_;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp18_ = g_getenv ("DIORITE_LOGGER_FATAL_STRING");
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	fatal_string = _tmp19_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp21_ = fatal_string;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp21_ != NULL) {
#line 299 "Logger.c"
		const gchar* _tmp22_;
		gchar _tmp23_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp22_ = fatal_string;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp23_ = string_get (_tmp22_, (glong) 0);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp20_ = _tmp23_ != '\0';
#line 308 "Logger.c"
	} else {
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp20_ = FALSE;
#line 312 "Logger.c"
	}
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp20_) {
#line 316 "Logger.c"
		const gchar* _tmp24_;
		GPatternSpec* _tmp25_;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp24_ = fatal_string;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp25_ = g_pattern_spec_new (_tmp24_);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_g_pattern_spec_free0 (diorite_logger_fatal_string);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_fatal_string = _tmp25_;
#line 327 "Logger.c"
	}
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_log_set_default_handler (_diorite_logger_log_handler_glog_func, NULL);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (fatal_string);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_date_time_unref0 (_tmp14_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (use_colors);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (_tmp2_);
#line 339 "Logger.c"
}


gboolean diorite_logger_colors_supported (void) {
	gboolean result = FALSE;
	FILE* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp0_ = diorite_logger_output;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp1_ = fileno (_tmp0_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp2_ = isatty (_tmp1_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	result = _tmp2_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return result;
#line 358 "Logger.c"
}


/**
 * Prints message to log without any hint
 * 
 * @param format    message format
 */
void diorite_logger_printf (const gchar* format, ...) {
	GError * _inner_error_ = NULL;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (format != NULL);
#line 371 "Logger.c"
	{
		FILE* _tmp0_;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = diorite_logger_output;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_rec_mutex_lock (&__lock_diorite_logger_output);
#line 378 "Logger.c"
		{
			FILE* _tmp1_;
			const gchar* _tmp2_;
			va_list _tmp3_ = {0};
			FILE* _tmp4_;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp1_ = diorite_logger_output;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp2_ = format;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			va_start (_tmp3_, format);
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			vfprintf (_tmp1_, _tmp2_, _tmp3_);
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			va_end (_tmp3_);
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp4_ = diorite_logger_output;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fflush (_tmp4_);
#line 398 "Logger.c"
		}
		__finally39:
		{
			FILE* _tmp5_;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp5_ = diorite_logger_output;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 407 "Logger.c"
		}
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_clear_error (&_inner_error_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return;
#line 417 "Logger.c"
		}
	}
}


/**
 * Prints line to log without any hint
 * 
 * @param line    line to log
 */
void diorite_logger_puts (const gchar* line) {
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (line != NULL);
#line 432 "Logger.c"
	{
		FILE* _tmp0_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = diorite_logger_output;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_rec_mutex_lock (&__lock_diorite_logger_output);
#line 439 "Logger.c"
		{
			FILE* _tmp1_;
			const gchar* _tmp2_;
			FILE* _tmp3_;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp1_ = diorite_logger_output;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp2_ = line;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fputs (_tmp2_, _tmp1_);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp3_ = diorite_logger_output;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fflush (_tmp3_);
#line 454 "Logger.c"
		}
		__finally40:
		{
			FILE* _tmp4_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp4_ = diorite_logger_output;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 463 "Logger.c"
		}
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_clear_error (&_inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return;
#line 473 "Logger.c"
		}
	}
}


/**
 * Prints message to log with hint if specified
 * 
 * @param format    message format
 */
void diorite_logger_logf (const gchar* format, ...) {
	GError * _inner_error_ = NULL;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (format != NULL);
#line 488 "Logger.c"
	{
		FILE* _tmp0_;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = diorite_logger_output;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_rec_mutex_lock (&__lock_diorite_logger_output);
#line 495 "Logger.c"
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			const gchar* _tmp6_;
			va_list _tmp7_ = {0};
			FILE* _tmp8_;
#line 132 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp1_ = diorite_logger_hint;
#line 132 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp1_ != NULL) {
#line 506 "Logger.c"
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp2_ = diorite_logger_output;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp3_ = diorite_logger_hint;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fputs (_tmp3_, _tmp2_);
#line 135 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp4_ = diorite_logger_output;
#line 135 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fputc (' ', _tmp4_);
#line 520 "Logger.c"
			}
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp5_ = diorite_logger_output;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp6_ = format;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			va_start (_tmp7_, format);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			vfprintf (_tmp5_, _tmp6_, _tmp7_);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			va_end (_tmp7_);
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp8_ = diorite_logger_output;
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fflush (_tmp8_);
#line 536 "Logger.c"
		}
		__finally41:
		{
			FILE* _tmp9_;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp9_ = diorite_logger_output;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 545 "Logger.c"
		}
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_clear_error (&_inner_error_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return;
#line 555 "Logger.c"
		}
	}
}


/**
 * Prints line to log with hint if specified
 * 
 * @param line    line to log
 */
void diorite_logger_log (const gchar* line) {
	GError * _inner_error_ = NULL;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (line != NULL);
#line 570 "Logger.c"
	{
		FILE* _tmp0_;
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = diorite_logger_output;
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_rec_mutex_lock (&__lock_diorite_logger_output);
#line 577 "Logger.c"
		{
			const gchar* _tmp1_;
			FILE* _tmp5_;
			const gchar* _tmp6_;
			FILE* _tmp7_;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp1_ = diorite_logger_hint;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp1_ != NULL) {
#line 587 "Logger.c"
				FILE* _tmp2_;
				const gchar* _tmp3_;
				FILE* _tmp4_;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp2_ = diorite_logger_output;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp3_ = diorite_logger_hint;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fputs (_tmp3_, _tmp2_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp4_ = diorite_logger_output;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fputc (' ', _tmp4_);
#line 601 "Logger.c"
			}
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp5_ = diorite_logger_output;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp6_ = line;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fputs (_tmp6_, _tmp5_);
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp7_ = diorite_logger_output;
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fflush (_tmp7_);
#line 613 "Logger.c"
		}
		__finally42:
		{
			FILE* _tmp8_;
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp8_ = diorite_logger_output;
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 622 "Logger.c"
		}
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_clear_error (&_inner_error_);
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return;
#line 632 "Logger.c"
		}
	}
}


static void diorite_logger_log_handler (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gboolean _tmp0_ = FALSE;
	GPatternSpec* _tmp1_;
	gboolean is_fatal_string = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	GLogLevelFlags _tmp11_;
	const gchar* _tmp12_;
	GLogLevelFlags _tmp13_;
	gboolean _tmp20_;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (message != NULL);
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp1_ = diorite_logger_fatal_string;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp1_ != NULL) {
#line 656 "Logger.c"
		GPatternSpec* _tmp2_;
		const gchar* _tmp3_;
		gboolean _tmp4_;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp2_ = diorite_logger_fatal_string;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp3_ = message;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp4_ = g_pattern_match_string (_tmp2_, _tmp3_);
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = _tmp4_;
#line 668 "Logger.c"
	} else {
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp0_ = FALSE;
#line 672 "Logger.c"
	}
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	is_fatal_string = _tmp0_;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp6_ = is_fatal_string;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (!_tmp6_) {
#line 680 "Logger.c"
		GLogLevelFlags _tmp7_;
		GLogLevelFlags _tmp8_;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp7_ = level;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp8_ = diorite_logger_display_level;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp5_ = _tmp7_ > _tmp8_;
#line 689 "Logger.c"
	} else {
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp5_ = FALSE;
#line 693 "Logger.c"
	}
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp5_) {
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		return;
#line 699 "Logger.c"
	}
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp10_ = domain;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp9_ = _tmp10_;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp9_ == NULL) {
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp9_ = "<unknown>";
#line 709 "Logger.c"
	}
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp11_ = level;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp12_ = message;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_print (_tmp9_, _tmp11_, _tmp12_);
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp13_ = level;
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	switch ((gint) _tmp13_) {
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_ERROR:
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case 6:
#line 725 "Logger.c"
		{
			const gchar* _tmp14_ = NULL;
			const gchar* _tmp15_;
			GLogLevelFlags _tmp16_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp15_ = domain;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp14_ = _tmp15_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp14_ == NULL) {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp14_ = "<unknown>";
#line 738 "Logger.c"
			}
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp16_ = level;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			diorite_logger_print (_tmp14_, _tmp16_, "Application will be terminated.");
#line 176 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 746 "Logger.c"
		}
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_CRITICAL:
#line 750 "Logger.c"
		{
			const gchar* _tmp17_ = NULL;
			const gchar* _tmp18_;
			GLogLevelFlags _tmp19_;
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp18_ = domain;
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp17_ = _tmp18_;
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp17_ == NULL) {
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp17_ = "<unknown>";
#line 763 "Logger.c"
			}
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp19_ = level;
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			diorite_logger_print (_tmp17_, _tmp19_, "Application will not function properly.");
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 771 "Logger.c"
		}
		default:
#line 171 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		break;
#line 776 "Logger.c"
	}
#line 182 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp20_ = is_fatal_string;
#line 182 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp20_) {
#line 782 "Logger.c"
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_;
#line 184 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp22_ = domain;
#line 184 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp21_ = _tmp22_;
#line 184 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (_tmp21_ == NULL) {
#line 184 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp21_ = "<unknown>";
#line 793 "Logger.c"
		}
#line 184 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_print (_tmp21_, G_LOG_LEVEL_ERROR, "Will abort because of fatal string match.");
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		abort ();
#line 799 "Logger.c"
	}
}


static void diorite_logger_print (const gchar* domain, GLogLevelFlags level, const gchar* message) {
	gchar* name = NULL;
	gchar* _tmp0_;
	gint color = 0;
	GLogLevelFlags _tmp1_;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	gchar* hint = NULL;
	gchar* _tmp13_;
	GError * _inner_error_ = NULL;
#line 189 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (domain != NULL);
#line 189 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (message != NULL);
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp0_ = g_strdup ("");
#line 191 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	name = _tmp0_;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	color = -1;
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp1_ = level;
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	switch ((gint) _tmp1_) {
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_CRITICAL:
#line 830 "Logger.c"
		{
			gchar* _tmp2_;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp2_ = g_strdup ("CRITICAL");
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp2_;
#line 197 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			color = DIORITE_LOGGER_COLOR_RED;
#line 198 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 843 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_ERROR:
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case 6:
#line 849 "Logger.c"
		{
			gchar* _tmp3_;
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp3_ = g_strdup ("ERROR");
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp3_;
#line 202 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			color = DIORITE_LOGGER_COLOR_RED;
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 862 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_WARNING:
#line 866 "Logger.c"
		{
			gchar* _tmp4_;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp4_ = g_strdup ("WARNING");
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp4_;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			color = DIORITE_LOGGER_COLOR_YELLOW;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 879 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_MESSAGE:
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_INFO:
#line 885 "Logger.c"
		{
			gchar* _tmp5_;
#line 210 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp5_ = g_strdup ("INFO");
#line 210 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 210 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp5_;
#line 211 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			color = DIORITE_LOGGER_COLOR_GREEN;
#line 212 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 898 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_DEBUG:
#line 902 "Logger.c"
		{
			gchar* _tmp6_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp6_ = g_strdup ("DEBUG");
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp6_;
#line 215 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			color = DIORITE_LOGGER_COLOR_BLUE;
#line 216 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 915 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_LEVEL_MASK:
#line 919 "Logger.c"
		{
			gchar* _tmp7_;
#line 218 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp7_ = g_strdup ("MASK");
#line 218 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 218 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp7_;
#line 219 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 930 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_FLAG_RECURSION:
#line 934 "Logger.c"
		{
			gchar* _tmp8_;
#line 221 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp8_ = g_strdup ("Recursion");
#line 221 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 221 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp8_;
#line 222 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 945 "Logger.c"
		}
#line 193 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		case G_LOG_FLAG_FATAL:
#line 949 "Logger.c"
		{
			gchar* _tmp9_;
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp9_ = g_strdup ("Fatal");
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp9_;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 960 "Logger.c"
		}
		default:
		{
			gchar* _tmp10_;
#line 227 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp10_ = g_strdup ("Unknown");
#line 227 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 227 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			name = _tmp10_;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			break;
#line 973 "Logger.c"
		}
	}
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp12_ = diorite_logger_hint;
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp11_ = _tmp12_;
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (_tmp11_ == NULL) {
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp11_ = "";
#line 984 "Logger.c"
	}
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_tmp13_ = g_strdup (_tmp11_);
#line 231 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	hint = _tmp13_;
#line 990 "Logger.c"
	{
		FILE* _tmp14_;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		_tmp14_ = diorite_logger_output;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_rec_mutex_lock (&__lock_diorite_logger_output);
#line 997 "Logger.c"
		{
			GDateTime* _tmp15_;
			gboolean _tmp59_ = FALSE;
			gboolean _tmp60_;
			FILE* _tmp73_;
#line 235 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp15_ = diorite_logger_time_ref;
#line 235 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp15_ != NULL) {
#line 1007 "Logger.c"
				GDateTime* now = NULL;
				GDateTime* _tmp16_;
				GTimeSpan diff = 0LL;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				GTimeSpan hours = 0LL;
				GTimeSpan _tmp27_;
				GTimeSpan _tmp28_;
				GTimeSpan minutes = 0LL;
				GTimeSpan _tmp36_;
				GTimeSpan _tmp37_;
				GTimeSpan seconds = 0LL;
				GTimeSpan _tmp45_;
				GTimeSpan _tmp46_;
				const gchar* _tmp54_;
				GTimeSpan _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
#line 237 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp16_ = g_date_time_new_now_local ();
#line 237 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				now = _tmp16_;
#line 1031 "Logger.c"
				{
					GDateTime* _tmp17_;
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp17_ = diorite_logger_time_ref;
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					g_rec_mutex_lock (&__lock_diorite_logger_time_ref);
#line 1038 "Logger.c"
					{
						GDateTime* _tmp18_;
						GDateTime* _tmp19_;
						GTimeSpan _tmp20_;
						GDateTime* _tmp21_;
						GDateTime* _tmp22_;
#line 241 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp18_ = now;
#line 241 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp19_ = diorite_logger_time_ref;
#line 241 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp20_ = g_date_time_difference (_tmp18_, _tmp19_);
#line 241 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						diff = _tmp20_;
#line 242 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp21_ = now;
#line 242 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp22_ = _g_date_time_ref0 (_tmp21_);
#line 242 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_g_date_time_unref0 (diorite_logger_time_ref);
#line 242 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						diorite_logger_time_ref = _tmp22_;
#line 1061 "Logger.c"
					}
					__finally44:
					{
						GDateTime* _tmp23_;
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_tmp23_ = diorite_logger_time_ref;
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						g_rec_mutex_unlock (&__lock_diorite_logger_time_ref);
#line 1070 "Logger.c"
					}
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_g_date_time_unref0 (now);
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_g_date_time_unref0 (now);
#line 1078 "Logger.c"
						{
							FILE* _tmp24_;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
							_tmp24_ = diorite_logger_output;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
							g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 1085 "Logger.c"
						}
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_g_free0 (hint);
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						_g_free0 (name);
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						g_clear_error (&_inner_error_);
#line 239 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
						return;
#line 1097 "Logger.c"
					}
				}
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp25_ = name;
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp26_ = g_strconcat (_tmp25_, " Δ", NULL);
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_g_free0 (name);
#line 244 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				name = _tmp26_;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp27_ = diff;
#line 245 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				hours = _tmp27_ / G_TIME_SPAN_HOUR;
#line 246 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp28_ = hours;
#line 246 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				if (_tmp28_ > ((GTimeSpan) 0)) {
#line 1116 "Logger.c"
					GTimeSpan _tmp29_;
					GTimeSpan _tmp30_;
					const gchar* _tmp31_;
					GTimeSpan _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
#line 248 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp29_ = diff;
#line 248 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp30_ = hours;
#line 248 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					diff = _tmp29_ - (_tmp30_ * G_TIME_SPAN_HOUR);
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp31_ = name;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp32_ = hours;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp33_ = g_strdup_printf ("%dh", (gint) _tmp32_);
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp34_ = _tmp33_;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp35_ = g_strconcat (_tmp31_, _tmp34_, NULL);
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (name);
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					name = _tmp35_;
#line 249 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (_tmp34_);
#line 1146 "Logger.c"
				}
#line 251 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp36_ = diff;
#line 251 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				minutes = _tmp36_ / G_TIME_SPAN_MINUTE;
#line 252 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp37_ = minutes;
#line 252 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				if (_tmp37_ > ((GTimeSpan) 0)) {
#line 1156 "Logger.c"
					GTimeSpan _tmp38_;
					GTimeSpan _tmp39_;
					const gchar* _tmp40_;
					GTimeSpan _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
					gchar* _tmp44_;
#line 254 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp38_ = diff;
#line 254 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp39_ = minutes;
#line 254 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					diff = _tmp38_ - (_tmp39_ * G_TIME_SPAN_MINUTE);
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp40_ = name;
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp41_ = minutes;
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp42_ = g_strdup_printf ("%02dm", (gint) _tmp41_);
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp43_ = _tmp42_;
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp44_ = g_strconcat (_tmp40_, _tmp43_, NULL);
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (name);
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					name = _tmp44_;
#line 255 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (_tmp43_);
#line 1186 "Logger.c"
				}
#line 257 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp45_ = diff;
#line 257 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				seconds = _tmp45_ / G_TIME_SPAN_SECOND;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp46_ = seconds;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				if (_tmp46_ > ((GTimeSpan) 0)) {
#line 1196 "Logger.c"
					GTimeSpan _tmp47_;
					GTimeSpan _tmp48_;
					const gchar* _tmp49_;
					GTimeSpan _tmp50_;
					gchar* _tmp51_;
					gchar* _tmp52_;
					gchar* _tmp53_;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp47_ = diff;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp48_ = seconds;
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					diff = _tmp47_ - (_tmp48_ * G_TIME_SPAN_SECOND);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp49_ = name;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp50_ = seconds;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp51_ = g_strdup_printf ("%02ds", (gint) _tmp50_);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp52_ = _tmp51_;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_tmp53_ = g_strconcat (_tmp49_, _tmp52_, NULL);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (name);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					name = _tmp53_;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
					_g_free0 (_tmp52_);
#line 1226 "Logger.c"
				}
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp54_ = name;
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp55_ = diff;
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp56_ = g_strdup_printf ("%06dus", (gint) _tmp55_);
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp57_ = _tmp56_;
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp58_ = g_strconcat (_tmp54_, _tmp57_, NULL);
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_g_free0 (name);
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				name = _tmp58_;
#line 263 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_g_free0 (_tmp57_);
#line 235 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_g_date_time_unref0 (now);
#line 1246 "Logger.c"
			}
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp60_ = diorite_logger_colorful;
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp60_) {
#line 1252 "Logger.c"
				gint _tmp61_;
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp61_ = color;
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp59_ = _tmp61_ >= 0;
#line 1258 "Logger.c"
			} else {
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp59_ = FALSE;
#line 1262 "Logger.c"
			}
#line 265 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			if (_tmp59_) {
#line 1266 "Logger.c"
				FILE* _tmp62_;
				const gchar* _tmp63_;
				gint _tmp64_;
				const gchar* _tmp65_;
				const gchar* _tmp66_;
				const gchar* _tmp67_;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp62_ = diorite_logger_output;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp63_ = hint;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp64_ = color;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp65_ = name;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp66_ = domain;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp67_ = message;
#line 266 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fprintf (_tmp62_, "%s\x1b[%dm[%-8s %5s]\x1b[0m %s\n", _tmp63_, DIORITE_LOGGER_COLOR_FOREGROUND + _tmp64_, _tmp65_, _tmp66_, _tmp67_);
#line 1287 "Logger.c"
			} else {
				FILE* _tmp68_;
				const gchar* _tmp69_;
				const gchar* _tmp70_;
				const gchar* _tmp71_;
				const gchar* _tmp72_;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp68_ = diorite_logger_output;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp69_ = hint;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp70_ = name;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp71_ = domain;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				_tmp72_ = message;
#line 268 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
				fprintf (_tmp68_, "%s[%-8s %5s] %s\n", _tmp69_, _tmp70_, _tmp71_, _tmp72_);
#line 1306 "Logger.c"
			}
#line 269 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp73_ = diorite_logger_output;
#line 269 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			fflush (_tmp73_);
#line 1312 "Logger.c"
		}
		__finally43:
		{
			FILE* _tmp74_;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_tmp74_ = diorite_logger_output;
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_rec_mutex_unlock (&__lock_diorite_logger_output);
#line 1321 "Logger.c"
		}
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (hint);
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			_g_free0 (name);
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			g_clear_error (&_inner_error_);
#line 233 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return;
#line 1335 "Logger.c"
		}
	}
#line 189 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (hint);
#line 189 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	_g_free0 (name);
#line 1342 "Logger.c"
}


DioriteLogger* diorite_logger_construct (GType object_type) {
	DioriteLogger* self = NULL;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	self = (DioriteLogger*) g_type_create_instance (object_type);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return self;
#line 1352 "Logger.c"
}


DioriteLogger* diorite_logger_new (void) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return diorite_logger_construct (DIORITE_TYPE_LOGGER);
#line 1359 "Logger.c"
}


static void diorite_value_logger_init (GValue* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	value->data[0].v_pointer = NULL;
#line 1366 "Logger.c"
}


static void diorite_value_logger_free_value (GValue* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (value->data[0].v_pointer) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_unref (value->data[0].v_pointer);
#line 1375 "Logger.c"
	}
}


static void diorite_value_logger_copy_value (const GValue* src_value, GValue* dest_value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (src_value->data[0].v_pointer) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		dest_value->data[0].v_pointer = diorite_logger_ref (src_value->data[0].v_pointer);
#line 1385 "Logger.c"
	} else {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1389 "Logger.c"
	}
}


static gpointer diorite_value_logger_peek_pointer (const GValue* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return value->data[0].v_pointer;
#line 1397 "Logger.c"
}


static gchar* diorite_value_logger_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (collect_values[0].v_pointer) {
#line 1404 "Logger.c"
		DioriteLogger * object;
		object = collect_values[0].v_pointer;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		if (object->parent_instance.g_class == NULL) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1411 "Logger.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1415 "Logger.c"
		}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = diorite_logger_ref (object);
#line 1419 "Logger.c"
	} else {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = NULL;
#line 1423 "Logger.c"
	}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return NULL;
#line 1427 "Logger.c"
}


static gchar* diorite_value_logger_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteLogger ** object_p;
	object_p = collect_values[0].v_pointer;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (!object_p) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1438 "Logger.c"
	}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (!value->data[0].v_pointer) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		*object_p = NULL;
#line 1444 "Logger.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		*object_p = value->data[0].v_pointer;
#line 1448 "Logger.c"
	} else {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		*object_p = diorite_logger_ref (value->data[0].v_pointer);
#line 1452 "Logger.c"
	}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return NULL;
#line 1456 "Logger.c"
}


GParamSpec* diorite_param_spec_logger (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteParamSpecLogger* spec;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_TYPE_LOGGER), NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return G_PARAM_SPEC (spec);
#line 1470 "Logger.c"
}


gpointer diorite_value_get_logger (const GValue* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER), NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return value->data[0].v_pointer;
#line 1479 "Logger.c"
}


void diorite_value_set_logger (GValue* value, gpointer v_object) {
	DioriteLogger * old;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	old = value->data[0].v_pointer;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (v_object) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_LOGGER));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = v_object;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_ref (value->data[0].v_pointer);
#line 1499 "Logger.c"
	} else {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = NULL;
#line 1503 "Logger.c"
	}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (old) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_unref (old);
#line 1509 "Logger.c"
	}
}


void diorite_value_take_logger (GValue* value, gpointer v_object) {
	DioriteLogger * old;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_LOGGER));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	old = value->data[0].v_pointer;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (v_object) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_LOGGER));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = v_object;
#line 1528 "Logger.c"
	} else {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		value->data[0].v_pointer = NULL;
#line 1532 "Logger.c"
	}
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (old) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		diorite_logger_unref (old);
#line 1538 "Logger.c"
	}
}


static void diorite_logger_class_init (DioriteLoggerClass * klass) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	diorite_logger_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	((DioriteLoggerClass *) klass)->finalize = diorite_logger_finalize;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_rec_mutex_init (&__lock_diorite_logger_output);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_rec_mutex_init (&__lock_diorite_logger_time_ref);
#line 1552 "Logger.c"
}


static void diorite_logger_instance_init (DioriteLogger * self) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	self->ref_count = 1;
#line 1559 "Logger.c"
}


static void diorite_logger_finalize (DioriteLogger * obj) {
	DioriteLogger * self;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_LOGGER, DioriteLogger);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_signal_handlers_destroy (self);
#line 1569 "Logger.c"
}


/**
 * Logger for GLib
 */
GType diorite_logger_get_type (void) {
	static volatile gsize diorite_logger_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_logger_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_value_logger_init, diorite_value_logger_free_value, diorite_value_logger_copy_value, diorite_value_logger_peek_pointer, "p", diorite_value_logger_collect_value, "p", diorite_value_logger_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteLogger), 0, (GInstanceInitFunc) diorite_logger_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_logger_type_id;
		diorite_logger_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteLogger", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_logger_type_id__volatile, diorite_logger_type_id);
	}
	return diorite_logger_type_id__volatile;
}


gpointer diorite_logger_ref (gpointer instance) {
	DioriteLogger * self;
	self = instance;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	g_atomic_int_inc (&self->ref_count);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	return instance;
#line 1597 "Logger.c"
}


void diorite_logger_unref (gpointer instance) {
	DioriteLogger * self;
	self = instance;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		DIORITE_LOGGER_GET_CLASS (self)->finalize (self);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Logger.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1610 "Logger.c"
	}
}



