/* MessageListener.c generated by valac 0.36.3, the Vala compiler
 * generated from MessageListener.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DIORITE_TYPE_HANDLER_ADAPTOR (diorite_handler_adaptor_get_type ())
#define DIORITE_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptor))
#define DIORITE_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptorClass))
#define DIORITE_IS_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_HANDLER_ADAPTOR))
#define DIORITE_IS_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_HANDLER_ADAPTOR))
#define DIORITE_HANDLER_ADAPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptorClass))

typedef struct _DioriteHandlerAdaptor DioriteHandlerAdaptor;
typedef struct _DioriteHandlerAdaptorClass DioriteHandlerAdaptorClass;
typedef struct _DioriteHandlerAdaptorPrivate DioriteHandlerAdaptorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _DioriteParamSpecHandlerAdaptor DioriteParamSpecHandlerAdaptor;

typedef GVariant* (*DioriteMessageHandler) (GObject* source, GVariant* params, void* user_data, GError** error);
typedef enum  {
	DIORITE_MESSAGE_ERROR_UNKNOWN,
	DIORITE_MESSAGE_ERROR_REMOTE_ERROR,
	DIORITE_MESSAGE_ERROR_UNSUPPORTED,
	DIORITE_MESSAGE_ERROR_IOERROR,
	DIORITE_MESSAGE_ERROR_INVALID_RESPONSE,
	DIORITE_MESSAGE_ERROR_INVALID_REQUEST,
	DIORITE_MESSAGE_ERROR_INVALID_ARGUMENTS,
	DIORITE_MESSAGE_ERROR_NOT_READY
} DioriteMessageError;
#define DIORITE_MESSAGE_ERROR diorite_message_error_quark ()
struct _DioriteHandlerAdaptor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioriteHandlerAdaptorPrivate * priv;
};

struct _DioriteHandlerAdaptorClass {
	GTypeClass parent_class;
	void (*finalize) (DioriteHandlerAdaptor *self);
};

struct _DioriteHandlerAdaptorPrivate {
	DioriteMessageHandler handler;
	gpointer handler_target;
	GDestroyNotify handler_target_destroy_notify;
	gchar* type_string;
};

struct _DioriteParamSpecHandlerAdaptor {
	GParamSpec parent_instance;
};


static gpointer diorite_handler_adaptor_parent_class = NULL;

GQuark diorite_message_error_quark (void);
#define DIORITE_TYPE_STRING_ANY "#ANY#"
GVariant* diorite_message_listener_echo_handler (GObject* source, GVariant* request, GError** error);
void diorite_message_listener_check_type_string (GVariant* data, const gchar* type_string, GError** error);
gpointer diorite_handler_adaptor_ref (gpointer instance);
void diorite_handler_adaptor_unref (gpointer instance);
GParamSpec* diorite_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_value_set_handler_adaptor (GValue* value, gpointer v_object);
void diorite_value_take_handler_adaptor (GValue* value, gpointer v_object);
gpointer diorite_value_get_handler_adaptor (const GValue* value);
GType diorite_handler_adaptor_get_type (void) G_GNUC_CONST;
#define DIORITE_HANDLER_ADAPTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptorPrivate))
enum  {
	DIORITE_HANDLER_ADAPTOR_DUMMY_PROPERTY
};
DioriteHandlerAdaptor* diorite_handler_adaptor_new (DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
DioriteHandlerAdaptor* diorite_handler_adaptor_construct (GType object_type, DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
void diorite_handler_adaptor_handle (DioriteHandlerAdaptor* self, GObject* source, GVariant* params, GVariant* * response, GError** error);
static void diorite_handler_adaptor_finalize (DioriteHandlerAdaptor * obj);


GQuark diorite_message_error_quark (void) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	return g_quark_from_static_string ("diorite_message_error-quark");
#line 111 "MessageListener.c"
}


static gpointer _g_variant_ref0 (gpointer self) {
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return self ? g_variant_ref (self) : NULL;
#line 118 "MessageListener.c"
}


GVariant* diorite_message_listener_echo_handler (GObject* source, GVariant* request, GError** error) {
	GVariant* result = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp0_ = request;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp1_ = _g_variant_ref0 (_tmp0_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	result = _tmp1_;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return result;
#line 136 "MessageListener.c"
}


void diorite_message_listener_check_type_string (GVariant* data, const gchar* type_string, GError** error) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp3_ = FALSE;
	GVariant* _tmp4_;
	GVariant* _tmp8_;
	GError * _inner_error_ = NULL;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp1_ = type_string;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (_tmp1_ != NULL) {
#line 151 "MessageListener.c"
		const gchar* _tmp2_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp2_ = type_string;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, DIORITE_TYPE_STRING_ANY) == 0;
#line 157 "MessageListener.c"
	} else {
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp0_ = FALSE;
#line 161 "MessageListener.c"
	}
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (_tmp0_) {
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		return;
#line 167 "MessageListener.c"
	}
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp4_ = data;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (_tmp4_ == NULL) {
#line 173 "MessageListener.c"
		const gchar* _tmp5_;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp5_ = type_string;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp3_ = _tmp5_ != NULL;
#line 179 "MessageListener.c"
	} else {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp3_ = FALSE;
#line 183 "MessageListener.c"
	}
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (_tmp3_) {
#line 187 "MessageListener.c"
		const gchar* _tmp6_;
		GError* _tmp7_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp6_ = type_string;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp7_ = g_error_new (DIORITE_MESSAGE_ERROR, DIORITE_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type null, expected '%s'.", _tmp6_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_inner_error_ = _tmp7_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_propagate_error (error, _inner_error_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		return;
#line 200 "MessageListener.c"
	}
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp8_ = data;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (_tmp8_ != NULL) {
#line 206 "MessageListener.c"
		const gchar* data_type_string = NULL;
		GVariant* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GVariant* _tmp14_;
		const gchar* _tmp15_;
		gboolean _tmp16_;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp9_ = data;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp10_ = g_variant_get_type_string (_tmp9_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		data_type_string = _tmp10_;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp11_ = type_string;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		if (_tmp11_ == NULL) {
#line 224 "MessageListener.c"
			const gchar* _tmp12_;
			GError* _tmp13_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_tmp12_ = data_type_string;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_tmp13_ = g_error_new (DIORITE_MESSAGE_ERROR, DIORITE_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected null.", _tmp12_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_inner_error_ = _tmp13_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			g_propagate_error (error, _inner_error_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			return;
#line 237 "MessageListener.c"
		}
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp14_ = data;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp15_ = type_string;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_tmp16_ = g_variant_check_format_string (_tmp14_, _tmp15_, FALSE);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		if (!_tmp16_) {
#line 247 "MessageListener.c"
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			GError* _tmp19_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_tmp17_ = data_type_string;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_tmp18_ = type_string;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_tmp19_ = g_error_new (DIORITE_MESSAGE_ERROR, DIORITE_MESSAGE_ERROR_INVALID_ARGUMENTS, "Invalid data type '%s', expected '%s'.", _tmp17_, _tmp18_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			_inner_error_ = _tmp19_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			return;
#line 263 "MessageListener.c"
		}
	}
}


DioriteHandlerAdaptor* diorite_handler_adaptor_construct (GType object_type, DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string) {
	DioriteHandlerAdaptor* self = NULL;
	DioriteMessageHandler _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self = (DioriteHandlerAdaptor*) g_type_create_instance (object_type);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp0_ = handler;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp0__target = handler_target;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp0__target_destroy_notify = handler_target_destroy_notify;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler_target = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler_target_destroy_notify = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	(self->priv->handler_target_destroy_notify == NULL) ? NULL : (self->priv->handler_target_destroy_notify (self->priv->handler_target), NULL);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target_destroy_notify = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler = _tmp0_;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target = _tmp0__target;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target_destroy_notify = _tmp0__target_destroy_notify;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp1_ = type_string;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_g_free0 (self->priv->type_string);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->type_string = _tmp2_;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler = NULL;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler_target = NULL;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	handler_target_destroy_notify = NULL;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return self;
#line 322 "MessageListener.c"
}


DioriteHandlerAdaptor* diorite_handler_adaptor_new (DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string) {
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return diorite_handler_adaptor_construct (DIORITE_TYPE_HANDLER_ADAPTOR, handler, handler_target, handler_target_destroy_notify, type_string);
#line 329 "MessageListener.c"
}


void diorite_handler_adaptor_handle (DioriteHandlerAdaptor* self, GObject* source, GVariant* params, GVariant* * response, GError** error) {
	GVariant* _vala_response = NULL;
	GVariant* _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_ = NULL;
	DioriteMessageHandler _tmp3_;
	void* _tmp3__target;
	GObject* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GError * _inner_error_ = NULL;
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_if_fail (self != NULL);
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_if_fail (source != NULL);
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp0_ = params;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp1_ = self->priv->type_string;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	diorite_message_listener_check_type_string (_tmp0_, _tmp1_, &_inner_error_);
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_propagate_error (error, _inner_error_);
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		return;
#line 361 "MessageListener.c"
	}
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp3_ = self->priv->handler;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp3__target = self->priv->handler_target;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp4_ = source;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp5_ = params;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp6_ = _tmp3_ (_tmp4_, _tmp5_, _tmp3__target, &_inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp2_ = _tmp6_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		return;
#line 381 "MessageListener.c"
	}
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp7_ = _tmp2_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_tmp2_ = NULL;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_g_variant_unref0 (_vala_response);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_vala_response = _tmp7_;
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_g_variant_unref0 (_tmp2_);
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (response) {
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		*response = _vala_response;
#line 397 "MessageListener.c"
	} else {
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		_g_variant_unref0 (_vala_response);
#line 401 "MessageListener.c"
	}
}


static void diorite_value_handler_adaptor_init (GValue* value) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	value->data[0].v_pointer = NULL;
#line 409 "MessageListener.c"
}


static void diorite_value_handler_adaptor_free_value (GValue* value) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (value->data[0].v_pointer) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		diorite_handler_adaptor_unref (value->data[0].v_pointer);
#line 418 "MessageListener.c"
	}
}


static void diorite_value_handler_adaptor_copy_value (const GValue* src_value, GValue* dest_value) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (src_value->data[0].v_pointer) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		dest_value->data[0].v_pointer = diorite_handler_adaptor_ref (src_value->data[0].v_pointer);
#line 428 "MessageListener.c"
	} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		dest_value->data[0].v_pointer = NULL;
#line 432 "MessageListener.c"
	}
}


static gpointer diorite_value_handler_adaptor_peek_pointer (const GValue* value) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return value->data[0].v_pointer;
#line 440 "MessageListener.c"
}


static gchar* diorite_value_handler_adaptor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (collect_values[0].v_pointer) {
#line 447 "MessageListener.c"
		DioriteHandlerAdaptor * object;
		object = collect_values[0].v_pointer;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		if (object->parent_instance.g_class == NULL) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 454 "MessageListener.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 458 "MessageListener.c"
		}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = diorite_handler_adaptor_ref (object);
#line 462 "MessageListener.c"
	} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = NULL;
#line 466 "MessageListener.c"
	}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return NULL;
#line 470 "MessageListener.c"
}


static gchar* diorite_value_handler_adaptor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioriteHandlerAdaptor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (!object_p) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 481 "MessageListener.c"
	}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (!value->data[0].v_pointer) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		*object_p = NULL;
#line 487 "MessageListener.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		*object_p = value->data[0].v_pointer;
#line 491 "MessageListener.c"
	} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		*object_p = diorite_handler_adaptor_ref (value->data[0].v_pointer);
#line 495 "MessageListener.c"
	}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return NULL;
#line 499 "MessageListener.c"
}


GParamSpec* diorite_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioriteParamSpecHandlerAdaptor* spec;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIORITE_TYPE_HANDLER_ADAPTOR), NULL);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return G_PARAM_SPEC (spec);
#line 513 "MessageListener.c"
}


gpointer diorite_value_get_handler_adaptor (const GValue* value) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_HANDLER_ADAPTOR), NULL);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return value->data[0].v_pointer;
#line 522 "MessageListener.c"
}


void diorite_value_set_handler_adaptor (GValue* value, gpointer v_object) {
	DioriteHandlerAdaptor * old;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_HANDLER_ADAPTOR));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	old = value->data[0].v_pointer;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (v_object) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_HANDLER_ADAPTOR));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = v_object;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		diorite_handler_adaptor_ref (value->data[0].v_pointer);
#line 542 "MessageListener.c"
	} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = NULL;
#line 546 "MessageListener.c"
	}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (old) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		diorite_handler_adaptor_unref (old);
#line 552 "MessageListener.c"
	}
}


void diorite_value_take_handler_adaptor (GValue* value, gpointer v_object) {
	DioriteHandlerAdaptor * old;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITE_TYPE_HANDLER_ADAPTOR));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	old = value->data[0].v_pointer;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (v_object) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITE_TYPE_HANDLER_ADAPTOR));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = v_object;
#line 571 "MessageListener.c"
	} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		value->data[0].v_pointer = NULL;
#line 575 "MessageListener.c"
	}
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (old) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		diorite_handler_adaptor_unref (old);
#line 581 "MessageListener.c"
	}
}


static void diorite_handler_adaptor_class_init (DioriteHandlerAdaptorClass * klass) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	diorite_handler_adaptor_parent_class = g_type_class_peek_parent (klass);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	((DioriteHandlerAdaptorClass *) klass)->finalize = diorite_handler_adaptor_finalize;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_type_class_add_private (klass, sizeof (DioriteHandlerAdaptorPrivate));
#line 593 "MessageListener.c"
}


static void diorite_handler_adaptor_instance_init (DioriteHandlerAdaptor * self) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv = DIORITE_HANDLER_ADAPTOR_GET_PRIVATE (self);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->ref_count = 1;
#line 602 "MessageListener.c"
}


static void diorite_handler_adaptor_finalize (DioriteHandlerAdaptor * obj) {
	DioriteHandlerAdaptor * self;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptor);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_signal_handlers_destroy (self);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	(self->priv->handler_target_destroy_notify == NULL) ? NULL : (self->priv->handler_target_destroy_notify (self->priv->handler_target), NULL);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler = NULL;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target = NULL;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	self->priv->handler_target_destroy_notify = NULL;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	_g_free0 (self->priv->type_string);
#line 622 "MessageListener.c"
}


GType diorite_handler_adaptor_get_type (void) {
	static volatile gsize diorite_handler_adaptor_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_handler_adaptor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { diorite_value_handler_adaptor_init, diorite_value_handler_adaptor_free_value, diorite_value_handler_adaptor_copy_value, diorite_value_handler_adaptor_peek_pointer, "p", diorite_value_handler_adaptor_collect_value, "p", diorite_value_handler_adaptor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioriteHandlerAdaptorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_handler_adaptor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteHandlerAdaptor), 0, (GInstanceInitFunc) diorite_handler_adaptor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType diorite_handler_adaptor_type_id;
		diorite_handler_adaptor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioriteHandlerAdaptor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&diorite_handler_adaptor_type_id__volatile, diorite_handler_adaptor_type_id);
	}
	return diorite_handler_adaptor_type_id__volatile;
}


gpointer diorite_handler_adaptor_ref (gpointer instance) {
	DioriteHandlerAdaptor * self;
	self = instance;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	g_atomic_int_inc (&self->ref_count);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	return instance;
#line 647 "MessageListener.c"
}


void diorite_handler_adaptor_unref (gpointer instance) {
	DioriteHandlerAdaptor * self;
	self = instance;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		DIORITE_HANDLER_ADAPTOR_GET_CLASS (self)->finalize (self);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageListener.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 660 "MessageListener.c"
	}
}



