/* MessageRouter.c generated by valac 0.36.3, the Vala compiler
 * generated from MessageRouter.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_MESSAGE_ROUTER (drt_message_router_get_type ())
#define DRT_MESSAGE_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouter))
#define DRT_MESSAGE_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouterClass))
#define DRT_IS_MESSAGE_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_MESSAGE_ROUTER))
#define DRT_IS_MESSAGE_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_MESSAGE_ROUTER))
#define DRT_MESSAGE_ROUTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouterClass))

typedef struct _DrtMessageRouter DrtMessageRouter;
typedef struct _DrtMessageRouterClass DrtMessageRouterClass;
typedef struct _DrtMessageRouterPrivate DrtMessageRouterPrivate;

#define DIORITE_TYPE_HANDLER_ADAPTOR (diorite_handler_adaptor_get_type ())
#define DIORITE_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptor))
#define DIORITE_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptorClass))
#define DIORITE_IS_HANDLER_ADAPTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_HANDLER_ADAPTOR))
#define DIORITE_IS_HANDLER_ADAPTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_HANDLER_ADAPTOR))
#define DIORITE_HANDLER_ADAPTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_HANDLER_ADAPTOR, DioriteHandlerAdaptorClass))

typedef struct _DioriteHandlerAdaptor DioriteHandlerAdaptor;
typedef struct _DioriteHandlerAdaptorClass DioriteHandlerAdaptorClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _diorite_handler_adaptor_unref0(var) ((var == NULL) ? NULL : (var = (diorite_handler_adaptor_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _DrtMessageRouter {
	GObject parent_instance;
	DrtMessageRouterPrivate * priv;
	GHashTable* handlers;
};

struct _DrtMessageRouterClass {
	GObjectClass parent_class;
	GVariant* (*handle_message) (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
};

typedef GVariant* (*DioriteMessageHandler) (GObject* source, GVariant* params, void* user_data, GError** error);
typedef enum  {
	DIORITE_MESSAGE_ERROR_UNKNOWN,
	DIORITE_MESSAGE_ERROR_REMOTE_ERROR,
	DIORITE_MESSAGE_ERROR_UNSUPPORTED,
	DIORITE_MESSAGE_ERROR_IOERROR,
	DIORITE_MESSAGE_ERROR_INVALID_RESPONSE,
	DIORITE_MESSAGE_ERROR_INVALID_REQUEST,
	DIORITE_MESSAGE_ERROR_INVALID_ARGUMENTS,
	DIORITE_MESSAGE_ERROR_NOT_READY
} DioriteMessageError;
#define DIORITE_MESSAGE_ERROR diorite_message_error_quark ()

static gpointer drt_message_router_parent_class = NULL;

GType drt_message_router_get_type (void) G_GNUC_CONST;
gpointer diorite_handler_adaptor_ref (gpointer instance);
void diorite_handler_adaptor_unref (gpointer instance);
GParamSpec* diorite_param_spec_handler_adaptor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void diorite_value_set_handler_adaptor (GValue* value, gpointer v_object);
void diorite_value_take_handler_adaptor (GValue* value, gpointer v_object);
gpointer diorite_value_get_handler_adaptor (const GValue* value);
GType diorite_handler_adaptor_get_type (void) G_GNUC_CONST;
enum  {
	DRT_MESSAGE_ROUTER_DUMMY_PROPERTY
};
DrtMessageRouter* drt_message_router_new (GHashTable* handlers);
DrtMessageRouter* drt_message_router_construct (GType object_type, GHashTable* handlers);
static void _g_free0_ (gpointer var);
static void _diorite_handler_adaptor_unref0_ (gpointer var);
void drt_message_router_add_handler (DrtMessageRouter* self, const gchar* message_name, const gchar* type_string, DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify);
#define DIORITE_TYPE_STRING_ANY "#ANY#"
GVariant* diorite_message_listener_echo_handler (GObject* source, GVariant* request, GError** error);
static GVariant* _diorite_message_listener_echo_handler_diorite_message_handler (GObject* source, GVariant* params, gpointer self, GError** error);
GVariant* drt_message_router_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
static GVariant* drt_message_router_real_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error);
GQuark diorite_message_error_quark (void);
void diorite_handler_adaptor_handle (DioriteHandlerAdaptor* self, GObject* source, GVariant* params, GVariant* * response, GError** error);
DioriteHandlerAdaptor* diorite_handler_adaptor_new (DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
DioriteHandlerAdaptor* diorite_handler_adaptor_construct (GType object_type, DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify, const gchar* type_string);
gboolean drt_message_router_remove_handler (DrtMessageRouter* self, const gchar* message_name);
static void drt_message_router_finalize (GObject * obj);


static gpointer _g_hash_table_ref0 (gpointer self) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 117 "MessageRouter.c"
}


static void _g_free0_ (gpointer var) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	var = (g_free (var), NULL);
#line 124 "MessageRouter.c"
}


static void _diorite_handler_adaptor_unref0_ (gpointer var) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	(var == NULL) ? NULL : (var = (diorite_handler_adaptor_unref (var), NULL));
#line 131 "MessageRouter.c"
}


static GVariant* _diorite_message_listener_echo_handler_diorite_message_handler (GObject* source, GVariant* params, gpointer self, GError** error) {
	GVariant* result;
	result = diorite_message_listener_echo_handler (source, params, error);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return result;
#line 140 "MessageRouter.c"
}


DrtMessageRouter* drt_message_router_construct (GType object_type, GHashTable* handlers) {
	DrtMessageRouter * self = NULL;
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_;
	GHashTable* _tmp7_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	self = (DrtMessageRouter*) g_object_new (object_type, NULL);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp1_ = handlers;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	if (_tmp1_ != NULL) {
#line 155 "MessageRouter.c"
		GHashTable* _tmp2_;
		GHashTable* _tmp3_;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp2_ = handlers;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp3_ = _g_hash_table_ref0 (_tmp2_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_g_hash_table_unref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp0_ = _tmp3_;
#line 166 "MessageRouter.c"
	} else {
		GHashFunc _tmp4_;
		GEqualFunc _tmp5_;
		GHashTable* _tmp6_;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp4_ = g_str_hash;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp5_ = g_str_equal;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, _diorite_handler_adaptor_unref0_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_g_hash_table_unref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp0_ = _tmp6_;
#line 181 "MessageRouter.c"
	}
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp7_ = _g_hash_table_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_g_hash_table_unref0 (self->handlers);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	self->handlers = _tmp7_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	drt_message_router_add_handler (self, "echo", DIORITE_TYPE_STRING_ANY, _diorite_message_listener_echo_handler_diorite_message_handler, NULL, NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_g_hash_table_unref0 (_tmp0_);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return self;
#line 195 "MessageRouter.c"
}


DrtMessageRouter* drt_message_router_new (GHashTable* handlers) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return drt_message_router_construct (DRT_TYPE_MESSAGE_ROUTER, handlers);
#line 202 "MessageRouter.c"
}


/**
 * Handle incoming request message
 * 
 * @param name    request name
 * @param data    request parameters
 * @return response data
 * @throws GLib.Error on failure
 */
static gpointer _diorite_handler_adaptor_ref0 (gpointer self) {
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return self ? diorite_handler_adaptor_ref (self) : NULL;
#line 217 "MessageRouter.c"
}


static GVariant* drt_message_router_real_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error) {
	GVariant* result = NULL;
	GHashTable* _tmp0_;
	GVariant* response = NULL;
	DioriteHandlerAdaptor* adaptor = NULL;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gconstpointer _tmp4_;
	DioriteHandlerAdaptor* _tmp5_;
	DioriteHandlerAdaptor* _tmp6_;
	DioriteHandlerAdaptor* _tmp9_;
	GObject* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp0_ = self->handlers;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	if (_tmp0_ == NULL) {
#line 244 "MessageRouter.c"
		GError* _tmp1_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp1_ = g_error_new_literal (DIORITE_MESSAGE_ERROR, DIORITE_MESSAGE_ERROR_UNSUPPORTED, "This message channel doesn't support requests.");
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_inner_error_ = _tmp1_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		return NULL;
#line 254 "MessageRouter.c"
	}
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	response = NULL;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp2_ = self->handlers;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp3_ = name;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp5_ = _diorite_handler_adaptor_ref0 ((DioriteHandlerAdaptor*) _tmp4_);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	adaptor = _tmp5_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp6_ = adaptor;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	if (_tmp6_ == NULL) {
#line 272 "MessageRouter.c"
		const gchar* _tmp7_;
		GError* _tmp8_;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp7_ = name;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_tmp8_ = g_error_new (DIORITE_MESSAGE_ERROR, DIORITE_MESSAGE_ERROR_UNSUPPORTED, "No handler for message '%s'", _tmp7_);
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_inner_error_ = _tmp8_;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		g_propagate_error (error, _inner_error_);
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_diorite_handler_adaptor_unref0 (adaptor);
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_g_variant_unref0 (response);
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		return NULL;
#line 289 "MessageRouter.c"
	}
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp9_ = adaptor;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp10_ = source;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp11_ = data;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	diorite_handler_adaptor_handle (_tmp9_, _tmp10_, _tmp11_, &_tmp12_, &_inner_error_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_g_variant_unref0 (response);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	response = _tmp12_;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		g_propagate_error (error, _inner_error_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_diorite_handler_adaptor_unref0 (adaptor);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		_g_variant_unref0 (response);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
		return NULL;
#line 313 "MessageRouter.c"
	}
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	result = response;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_diorite_handler_adaptor_unref0 (adaptor);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return result;
#line 321 "MessageRouter.c"
}


GVariant* drt_message_router_handle_message (DrtMessageRouter* self, GObject* source, const gchar* name, GVariant* data, GError** error) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return DRT_MESSAGE_ROUTER_GET_CLASS (self)->handle_message (self, source, name, data, error);
#line 330 "MessageRouter.c"
}


void drt_message_router_add_handler (DrtMessageRouter* self, const gchar* message_name, const gchar* type_string, DioriteMessageHandler handler, void* handler_target, GDestroyNotify handler_target_destroy_notify) {
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	DioriteMessageHandler _tmp3_;
	void* _tmp3__target;
	GDestroyNotify _tmp3__target_destroy_notify;
	const gchar* _tmp4_;
	DioriteHandlerAdaptor* _tmp5_;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_if_fail (self != NULL);
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_if_fail (message_name != NULL);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp0_ = self->handlers;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp1_ = message_name;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp3_ = handler;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp3__target = handler_target;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp3__target_destroy_notify = handler_target_destroy_notify;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler = NULL;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler_target = NULL;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler_target_destroy_notify = NULL;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp4_ = type_string;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp5_ = diorite_handler_adaptor_new (_tmp3_, _tmp3__target, _tmp3__target_destroy_notify, _tmp4_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_hash_table_insert (_tmp0_, _tmp2_, _tmp5_);
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler = NULL;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler_target = NULL;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	handler_target_destroy_notify = NULL;
#line 379 "MessageRouter.c"
}


gboolean drt_message_router_remove_handler (DrtMessageRouter* self, const gchar* message_name) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	g_return_val_if_fail (message_name != NULL, FALSE);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp0_ = self->handlers;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp1_ = message_name;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_tmp2_ = g_hash_table_remove (_tmp0_, _tmp1_);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	result = _tmp2_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	return result;
#line 402 "MessageRouter.c"
}


static void drt_message_router_class_init (DrtMessageRouterClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	drt_message_router_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	((DrtMessageRouterClass *) klass)->handle_message = (GVariant* (*) (DrtMessageRouter *, GObject*, const gchar*, GVariant*, GError**)) drt_message_router_real_handle_message;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	G_OBJECT_CLASS (klass)->finalize = drt_message_router_finalize;
#line 413 "MessageRouter.c"
}


static void drt_message_router_instance_init (DrtMessageRouter * self) {
}


static void drt_message_router_finalize (GObject * obj) {
	DrtMessageRouter * self;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_MESSAGE_ROUTER, DrtMessageRouter);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	_g_hash_table_unref0 (self->handlers);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/MessageRouter.vala"
	G_OBJECT_CLASS (drt_message_router_parent_class)->finalize (obj);
#line 429 "MessageRouter.c"
}


GType drt_message_router_get_type (void) {
	static volatile gsize drt_message_router_type_id__volatile = 0;
	if (g_once_init_enter (&drt_message_router_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtMessageRouterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_message_router_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtMessageRouter), 0, (GInstanceInitFunc) drt_message_router_instance_init, NULL };
		GType drt_message_router_type_id;
		drt_message_router_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtMessageRouter", &g_define_type_info, 0);
		g_once_init_leave (&drt_message_router_type_id__volatile, drt_message_router_type_id);
	}
	return drt_message_router_type_id__volatile;
}



