/* ObjectSpec.c generated by valac 0.36.3, the Vala compiler
 * generated from ObjectSpec.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DIORITEDB_TYPE_OBJECT_SPEC (dioritedb_object_spec_get_type ())
#define DIORITEDB_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpec))
#define DIORITEDB_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))
#define DIORITEDB_IS_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_IS_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_SPEC))
#define DIORITEDB_OBJECT_SPEC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecClass))

typedef struct _DioritedbObjectSpec DioritedbObjectSpec;
typedef struct _DioritedbObjectSpecClass DioritedbObjectSpecClass;
typedef struct _DioritedbObjectSpecPrivate DioritedbObjectSpecPrivate;
#define _dioritedb_object_spec_unref0(var) ((var == NULL) ? NULL : (var = (dioritedb_object_spec_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
typedef struct _DioritedbParamSpecObjectSpec DioritedbParamSpecObjectSpec;

struct _DioritedbObjectSpec {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioritedbObjectSpecPrivate * priv;
};

struct _DioritedbObjectSpecClass {
	GTypeClass parent_class;
	void (*finalize) (DioritedbObjectSpec *self);
};

struct _DioritedbObjectSpecPrivate {
	GType _object_type;
	GParamSpec* _primary_key;
	GParamSpec** _properties;
	gint _properties_length1;
	gint __properties_size_;
};

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()
struct _DioritedbParamSpecObjectSpec {
	GParamSpec parent_instance;
};


static gpointer dioritedb_object_spec_parent_class = NULL;

gpointer dioritedb_object_spec_ref (gpointer instance);
void dioritedb_object_spec_unref (gpointer instance);
GParamSpec* dioritedb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void dioritedb_value_set_object_spec (GValue* value, gpointer v_object);
void dioritedb_value_take_object_spec (GValue* value, gpointer v_object);
gpointer dioritedb_value_get_object_spec (const GValue* value);
GType dioritedb_object_spec_get_type (void) G_GNUC_CONST;
#define DIORITEDB_OBJECT_SPEC_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpecPrivate))
enum  {
	DIORITEDB_OBJECT_SPEC_DUMMY_PROPERTY
};
GQuark dioritedb_database_error_quark (void);
DioritedbObjectSpec* dioritedb_object_spec_new (GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error);
DioritedbObjectSpec* dioritedb_object_spec_construct (GType object_type, GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error);
GParamSpec** dioritedb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error);
DioritedbObjectSpec* dioritedb_object_spec_new_with_pspecs (GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error);
DioritedbObjectSpec* dioritedb_object_spec_construct_with_pspecs (GType object_type, GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error);
static void dioritedb_object_spec_set_object_type (DioritedbObjectSpec* self, GType value);
static void dioritedb_object_spec_set_properties (DioritedbObjectSpec* self, GParamSpec** value, int value_length1);
static void dioritedb_object_spec_set_primary_key (DioritedbObjectSpec* self, GParamSpec* value);
GType dioritedb_object_spec_get_object_type (DioritedbObjectSpec* self);
const gchar* dioritedb_object_spec_get_table_name (DioritedbObjectSpec* self);
GParamSpec* dioritedb_object_spec_get_primary_key (DioritedbObjectSpec* self);
GParamSpec** dioritedb_object_spec_get_properties (DioritedbObjectSpec* self, int* result_length1);
static GParamSpec** _vala_array_dup1 (GParamSpec** self, int length);
static void dioritedb_object_spec_finalize (DioritedbObjectSpec * obj);


static gpointer _g_param_spec_ref0 (gpointer self) {
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 122 "ObjectSpec.c"
}


DioritedbObjectSpec* dioritedb_object_spec_construct (GType object_type, GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error) {
	DioritedbObjectSpec* self = NULL;
	GType _tmp0_;
	gboolean _tmp1_;
	GObjectClass* class_spec = NULL;
	GType _tmp5_;
	GTypeClass* _tmp6_;
	GParamSpec* primary_pspec = NULL;
	GObjectClass* _tmp7_;
	const gchar* _tmp8_;
	GParamSpec* _tmp9_;
	GParamSpec* _tmp10_;
	GParamSpec* _tmp11_;
	GParamSpec** _tmp14_ = NULL;
	GObjectClass* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gint _tmp17_;
	GParamSpec** _tmp18_;
	gint _tmp14__length1;
	gint __tmp14__size_;
	GType _tmp19_;
	GParamSpec* _tmp20_;
	GError * _inner_error_ = NULL;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (primary_key != NULL, NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = type;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1_ = G_TYPE_IS_OBJECT (_tmp0_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (!_tmp1_) {
#line 158 "ObjectSpec.c"
		GType _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp2_ = type;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp3_ = g_type_name (_tmp2_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp4_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp3_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_inner_error_ = _tmp4_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_propagate_error (error, _inner_error_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_dioritedb_object_spec_unref0 (self);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 178 "ObjectSpec.c"
		} else {
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_clear_error (&_inner_error_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 186 "ObjectSpec.c"
		}
	}
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp5_ = type;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp6_ = g_type_class_ref (_tmp5_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	class_spec = (GObjectClass*) _tmp6_;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp7_ = class_spec;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp8_ = primary_key;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp9_ = g_object_class_find_property (_tmp7_, _tmp8_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp10_ = _g_param_spec_ref0 (_tmp9_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	primary_pspec = _tmp10_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp11_ = primary_pspec;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (_tmp11_ == NULL) {
#line 209 "ObjectSpec.c"
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp12_ = primary_key;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp13_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_NAME, "There is no property named '%s'.", _tmp12_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_inner_error_ = _tmp13_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_propagate_error (error, _inner_error_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_dioritedb_object_spec_unref0 (self);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 230 "ObjectSpec.c"
		} else {
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_clear_error (&_inner_error_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 242 "ObjectSpec.c"
		}
	}
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp15_ = class_spec;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp16_ = properties;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp16__length1 = properties_length1;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp18_ = dioritedb_create_param_spec_list (_tmp15_, _tmp16_, _tmp16__length1, &_tmp17_, &_inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp14_ = _tmp18_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp14__length1 = _tmp17_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	__tmp14__size_ = _tmp14__length1;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_propagate_error (error, _inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_dioritedb_object_spec_unref0 (self);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 273 "ObjectSpec.c"
		} else {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_clear_error (&_inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 285 "ObjectSpec.c"
		}
	}
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp19_ = type;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp20_ = primary_pspec;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self = (DioritedbObjectSpec*) dioritedb_object_spec_construct_with_pspecs (object_type, _tmp19_, _tmp20_, _tmp14_, _tmp14__length1, &_inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_propagate_error (error, _inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_tmp14_ = (g_free (_tmp14_), NULL);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_dioritedb_object_spec_unref0 (self);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 310 "ObjectSpec.c"
		} else {
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_tmp14_ = (g_free (_tmp14_), NULL);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_param_spec_unref0 (primary_pspec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_g_type_class_unref0 (class_spec);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_clear_error (&_inner_error_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 324 "ObjectSpec.c"
		}
	}
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp14_ = (g_free (_tmp14_), NULL);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_g_param_spec_unref0 (primary_pspec);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_g_type_class_unref0 (class_spec);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return self;
#line 335 "ObjectSpec.c"
}


DioritedbObjectSpec* dioritedb_object_spec_new (GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return dioritedb_object_spec_construct (DIORITEDB_TYPE_OBJECT_SPEC, type, primary_key, properties, properties_length1, error);
#line 342 "ObjectSpec.c"
}


DioritedbObjectSpec* dioritedb_object_spec_construct_with_pspecs (GType object_type, GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error) {
	DioritedbObjectSpec* self = NULL;
	GType _tmp0_;
	gboolean _tmp1_;
	GType _tmp5_;
	GParamSpec** _tmp6_;
	gint _tmp6__length1;
	GParamSpec* _tmp7_;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (primary_key != NULL, NULL);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self = (DioritedbObjectSpec*) g_type_create_instance (object_type);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = type;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1_ = G_TYPE_IS_OBJECT (_tmp0_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (!_tmp1_) {
#line 365 "ObjectSpec.c"
		GType _tmp2_;
		const gchar* _tmp3_;
		GError* _tmp4_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp2_ = type;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp3_ = g_type_name (_tmp2_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_tmp4_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp3_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		_inner_error_ = _tmp4_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_propagate_error (error, _inner_error_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			_dioritedb_object_spec_unref0 (self);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 385 "ObjectSpec.c"
		} else {
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return NULL;
#line 393 "ObjectSpec.c"
		}
	}
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp5_ = type;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	dioritedb_object_spec_set_object_type (self, _tmp5_);
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp6_ = properties;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp6__length1 = properties_length1;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	dioritedb_object_spec_set_properties (self, _tmp6_, _tmp6__length1);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp7_ = primary_key;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	dioritedb_object_spec_set_primary_key (self, _tmp7_);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return self;
#line 412 "ObjectSpec.c"
}


DioritedbObjectSpec* dioritedb_object_spec_new_with_pspecs (GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return dioritedb_object_spec_construct_with_pspecs (DIORITEDB_TYPE_OBJECT_SPEC, type, primary_key, properties, properties_length1, error);
#line 419 "ObjectSpec.c"
}


GType dioritedb_object_spec_get_object_type (DioritedbObjectSpec* self) {
	GType result;
	GType _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = self->priv->_object_type;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return result;
#line 434 "ObjectSpec.c"
}


static void dioritedb_object_spec_set_object_type (DioritedbObjectSpec* self, GType value) {
	GType _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_object_type = _tmp0_;
#line 446 "ObjectSpec.c"
}


const gchar* dioritedb_object_spec_get_table_name (DioritedbObjectSpec* self) {
	const gchar* result;
	GType _tmp0_;
	const gchar* _tmp1_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = self->priv->_object_type;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1_ = g_type_name (_tmp0_);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	result = _tmp1_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return result;
#line 464 "ObjectSpec.c"
}


GParamSpec* dioritedb_object_spec_get_primary_key (DioritedbObjectSpec* self) {
	GParamSpec* result;
	GParamSpec* _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = self->priv->_primary_key;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return result;
#line 479 "ObjectSpec.c"
}


static void dioritedb_object_spec_set_primary_key (DioritedbObjectSpec* self, GParamSpec* value) {
	GParamSpec* _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_primary_key = _tmp0_;
#line 491 "ObjectSpec.c"
}


GParamSpec** dioritedb_object_spec_get_properties (DioritedbObjectSpec* self, int* result_length1) {
	GParamSpec** result;
	GParamSpec** _tmp0_;
	gint _tmp0__length1;
	GParamSpec** _tmp1_;
	gint _tmp1__length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = self->priv->_properties;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0__length1 = self->priv->_properties_length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1_ = _tmp0_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1__length1 = _tmp0__length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (result_length1) {
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		*result_length1 = _tmp1__length1;
#line 515 "ObjectSpec.c"
	}
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	result = _tmp1_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return result;
#line 521 "ObjectSpec.c"
}


static GParamSpec** _vala_array_dup1 (GParamSpec** self, int length) {
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return g_memdup (self, length * sizeof (GParamSpec*));
#line 528 "ObjectSpec.c"
}


static void dioritedb_object_spec_set_properties (DioritedbObjectSpec* self, GParamSpec** value, int value_length1) {
	GParamSpec** _tmp0_;
	gint _tmp0__length1;
	GParamSpec** _tmp1_;
	gint _tmp1__length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp0__length1 = value_length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	_tmp1__length1 = _tmp0__length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_properties = (g_free (self->priv->_properties), NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_properties = _tmp1_;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_properties_length1 = _tmp1__length1;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->__properties_size_ = self->priv->_properties_length1;
#line 555 "ObjectSpec.c"
}


static void dioritedb_value_object_spec_init (GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	value->data[0].v_pointer = NULL;
#line 562 "ObjectSpec.c"
}


static void dioritedb_value_object_spec_free_value (GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dioritedb_object_spec_unref (value->data[0].v_pointer);
#line 571 "ObjectSpec.c"
	}
}


static void dioritedb_value_object_spec_copy_value (const GValue* src_value, GValue* dest_value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dest_value->data[0].v_pointer = dioritedb_object_spec_ref (src_value->data[0].v_pointer);
#line 581 "ObjectSpec.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dest_value->data[0].v_pointer = NULL;
#line 585 "ObjectSpec.c"
	}
}


static gpointer dioritedb_value_object_spec_peek_pointer (const GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return value->data[0].v_pointer;
#line 593 "ObjectSpec.c"
}


static gchar* dioritedb_value_object_spec_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (collect_values[0].v_pointer) {
#line 600 "ObjectSpec.c"
		DioritedbObjectSpec * object;
		object = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 607 "ObjectSpec.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 611 "ObjectSpec.c"
		}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = dioritedb_object_spec_ref (object);
#line 615 "ObjectSpec.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = NULL;
#line 619 "ObjectSpec.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return NULL;
#line 623 "ObjectSpec.c"
}


static gchar* dioritedb_value_object_spec_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioritedbObjectSpec ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (!object_p) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 634 "ObjectSpec.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (!value->data[0].v_pointer) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		*object_p = NULL;
#line 640 "ObjectSpec.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		*object_p = value->data[0].v_pointer;
#line 644 "ObjectSpec.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		*object_p = dioritedb_object_spec_ref (value->data[0].v_pointer);
#line 648 "ObjectSpec.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return NULL;
#line 652 "ObjectSpec.c"
}


GParamSpec* dioritedb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioritedbParamSpecObjectSpec* spec;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIORITEDB_TYPE_OBJECT_SPEC), NULL);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return G_PARAM_SPEC (spec);
#line 666 "ObjectSpec.c"
}


gpointer dioritedb_value_get_object_spec (const GValue* value) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_SPEC), NULL);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return value->data[0].v_pointer;
#line 675 "ObjectSpec.c"
}


void dioritedb_value_set_object_spec (GValue* value, gpointer v_object) {
	DioritedbObjectSpec * old;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_SPEC));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITEDB_TYPE_OBJECT_SPEC));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = v_object;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dioritedb_object_spec_ref (value->data[0].v_pointer);
#line 695 "ObjectSpec.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = NULL;
#line 699 "ObjectSpec.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dioritedb_object_spec_unref (old);
#line 705 "ObjectSpec.c"
	}
}


void dioritedb_value_take_object_spec (GValue* value, gpointer v_object) {
	DioritedbObjectSpec * old;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_SPEC));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	old = value->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (v_object) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITEDB_TYPE_OBJECT_SPEC));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = v_object;
#line 724 "ObjectSpec.c"
	} else {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		value->data[0].v_pointer = NULL;
#line 728 "ObjectSpec.c"
	}
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (old) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		dioritedb_object_spec_unref (old);
#line 734 "ObjectSpec.c"
	}
}


static void dioritedb_object_spec_class_init (DioritedbObjectSpecClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	dioritedb_object_spec_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	((DioritedbObjectSpecClass *) klass)->finalize = dioritedb_object_spec_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_type_class_add_private (klass, sizeof (DioritedbObjectSpecPrivate));
#line 746 "ObjectSpec.c"
}


static void dioritedb_object_spec_instance_init (DioritedbObjectSpec * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv = DIORITEDB_OBJECT_SPEC_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->ref_count = 1;
#line 755 "ObjectSpec.c"
}


static void dioritedb_object_spec_finalize (DioritedbObjectSpec * obj) {
	DioritedbObjectSpec * self;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_OBJECT_SPEC, DioritedbObjectSpec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_signal_handlers_destroy (self);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	self->priv->_properties = (g_free (self->priv->_properties), NULL);
#line 767 "ObjectSpec.c"
}


GType dioritedb_object_spec_get_type (void) {
	static volatile gsize dioritedb_object_spec_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_object_spec_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { dioritedb_value_object_spec_init, dioritedb_value_object_spec_free_value, dioritedb_value_object_spec_copy_value, dioritedb_value_object_spec_peek_pointer, "p", dioritedb_value_object_spec_collect_value, "p", dioritedb_value_object_spec_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbObjectSpecClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_object_spec_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbObjectSpec), 0, (GInstanceInitFunc) dioritedb_object_spec_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType dioritedb_object_spec_type_id;
		dioritedb_object_spec_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioritedbObjectSpec", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&dioritedb_object_spec_type_id__volatile, dioritedb_object_spec_type_id);
	}
	return dioritedb_object_spec_type_id__volatile;
}


gpointer dioritedb_object_spec_ref (gpointer instance) {
	DioritedbObjectSpec * self;
	self = instance;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	return instance;
#line 792 "ObjectSpec.c"
}


void dioritedb_object_spec_unref (gpointer instance) {
	DioritedbObjectSpec * self;
	self = instance;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		DIORITEDB_OBJECT_SPEC_GET_CLASS (self)->finalize (self);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/ObjectSpec.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 805 "ObjectSpec.c"
	}
}



