/* Query.c generated by valac 0.36.3, the Vala compiler
 * generated from Query.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define DIORITEDB_TYPE_QUERY (dioritedb_query_get_type ())
#define DIORITEDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_QUERY, DioritedbQuery))
#define DIORITEDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))
#define DIORITEDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))

typedef struct _DioritedbQuery DioritedbQuery;
typedef struct _DioritedbQueryClass DioritedbQueryClass;
typedef struct _DioritedbQueryPrivate DioritedbQueryPrivate;

#define DIORITEDB_TYPE_CONNECTION (dioritedb_connection_get_type ())
#define DIORITEDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnection))
#define DIORITEDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))
#define DIORITEDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))

typedef struct _DioritedbConnection DioritedbConnection;
typedef struct _DioritedbConnectionClass DioritedbConnectionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DioritedbConnectionPrivate DioritedbConnectionPrivate;

struct _DioritedbQuery {
	GObject parent_instance;
	DioritedbQueryPrivate * priv;
	sqlite3_stmt* statement;
	gint n_parameters;
	gboolean executed;
};

struct _DioritedbQueryClass {
	GObjectClass parent_class;
};

struct _DioritedbQueryPrivate {
	DioritedbConnection* _connection;
	GRecMutex __lock_executed;
};

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()
struct _DioritedbConnection {
	GObject parent_instance;
	DioritedbConnectionPrivate * priv;
	sqlite3* db;
};

struct _DioritedbConnectionClass {
	GObjectClass parent_class;
};


static gpointer dioritedb_query_parent_class = NULL;

GType dioritedb_query_get_type (void) G_GNUC_CONST;
GType dioritedb_connection_get_type (void) G_GNUC_CONST;
#define DIORITEDB_QUERY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_QUERY, DioritedbQueryPrivate))
enum  {
	DIORITEDB_QUERY_DUMMY_PROPERTY,
	DIORITEDB_QUERY_CONNECTION
};
GQuark dioritedb_database_error_quark (void);
DioritedbQuery* dioritedb_query_construct (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** error);
static void dioritedb_query_init (DioritedbQuery* self, DioritedbConnection* connection, const gchar* sql, GError** error);
DioritedbQuery* dioritedb_query_construct_out_error (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** _error_);
static void dioritedb_query_set_connection (DioritedbQuery* self, DioritedbConnection* value);
gint dioritedb_query_throw_on_error (DioritedbQuery* self, gint _result_, const gchar* sql, GError** error);
void dioritedb_query_reset (DioritedbQuery* self, gboolean clear_bindings, GError** error);
DioritedbQuery* dioritedb_query_bind (DioritedbQuery* self, gint index, GValue* value, GError** error);
DioritedbQuery* dioritedb_query_bind_null (DioritedbQuery* self, gint index, GError** error);
DioritedbQuery* dioritedb_query_bind_bool (DioritedbQuery* self, gint index, gboolean value, GError** error);
DioritedbQuery* dioritedb_query_bind_int (DioritedbQuery* self, gint index, gint value, GError** error);
DioritedbQuery* dioritedb_query_bind_int64 (DioritedbQuery* self, gint index, gint64 value, GError** error);
DioritedbQuery* dioritedb_query_bind_string (DioritedbQuery* self, gint index, const gchar* value, GError** error);
DioritedbQuery* dioritedb_query_bind_double (DioritedbQuery* self, gint index, gdouble value, GError** error);
DioritedbQuery* dioritedb_query_bind_bytes (DioritedbQuery* self, gint index, GBytes* value, GError** error);
DioritedbQuery* dioritedb_query_bind_byte_array (DioritedbQuery* self, gint index, GByteArray* value, GError** error);
gint dioritedb_query_check_index (DioritedbQuery* self, gint index, GError** error);
void dioritedb_query_check_not_executed (DioritedbQuery* self, GError** error);
DioritedbQuery* dioritedb_query_bind_blob (DioritedbQuery* self, gint index, guint8* value, int value_length1, GError** error);
void dioritedb_query_check_not_executed_and_set (DioritedbQuery* self, gboolean executed, GError** error);
gint dioritedb_convert_error (sqlite3* db, gint _result_, const gchar* sql, sqlite3_stmt* stm, GError** error);
DioritedbConnection* dioritedb_query_get_connection (DioritedbQuery* self);
static void dioritedb_query_finalize (GObject * obj);
static void _vala_dioritedb_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dioritedb_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DioritedbQuery* dioritedb_query_construct (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** error) {
	DioritedbQuery * self = NULL;
	DioritedbConnection* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self = (DioritedbQuery*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = connection;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = sql;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_init (self, _tmp0_, _tmp1_, &_inner_error_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_g_object_unref0 (self);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 168 "Query.c"
		} else {
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 176 "Query.c"
		}
	}
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return self;
#line 181 "Query.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return self ? g_error_copy (self) : NULL;
#line 188 "Query.c"
}


DioritedbQuery* dioritedb_query_construct_out_error (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** _error_) {
	GError* _vala_error = NULL;
	DioritedbQuery * self = NULL;
	GError * _inner_error_ = NULL;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self = (DioritedbQuery*) g_object_new (object_type, NULL);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_g_error_free0 (_vala_error);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_vala_error = NULL;
#line 206 "Query.c"
	{
		DioritedbConnection* _tmp0_;
		const gchar* _tmp1_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = connection;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = sql;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		dioritedb_query_init (self, _tmp0_, _tmp1_, &_inner_error_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 220 "Query.c"
				goto __catch2_dioritedb_database_error;
			}
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 229 "Query.c"
		}
	}
	goto __finally2;
	__catch2_dioritedb_database_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		GError* _tmp3_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		e = _inner_error_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = e;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = _g_error_copy0 (_tmp2_);
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_error_free0 (_vala_error);
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_vala_error = _tmp3_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_error_free0 (e);
#line 252 "Query.c"
	}
	__finally2:
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_clear_error (&_inner_error_);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return NULL;
#line 263 "Query.c"
	}
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_error_) {
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		*_error_ = _vala_error;
#line 269 "Query.c"
	} else {
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_error_free0 (_vala_error);
#line 273 "Query.c"
	}
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return self;
#line 277 "Query.c"
}


static void dioritedb_query_init (DioritedbQuery* self, DioritedbConnection* connection, const gchar* sql, GError** error) {
	DioritedbConnection* _tmp0_;
	DioritedbConnection* _tmp1_;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_ = NULL;
	gint _tmp8_;
	const gchar* _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_;
	GError * _inner_error_ = NULL;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (connection != NULL);
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (sql != NULL);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = connection;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_set_connection (self, _tmp0_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = connection;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = _tmp1_->db;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = sql;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = sql;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = strlen (_tmp4_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = _tmp5_;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp8_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, _tmp6_, &_tmp7_, NULL);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_sqlite3_finalize0 (self->statement);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->statement = _tmp7_;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp9_ = sql;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp8_, _tmp9_, &_inner_error_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return;
#line 335 "Query.c"
		} else {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return;
#line 343 "Query.c"
		}
	}
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp10_ = self->statement;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp11_ = sqlite3_bind_parameter_count (_tmp10_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->n_parameters = _tmp11_;
#line 352 "Query.c"
}


void dioritedb_query_reset (DioritedbQuery* self, gboolean clear_bindings, GError** error) {
	sqlite3_stmt* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (self != NULL);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = self->statement;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = sqlite3_reset (_tmp0_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp1_, NULL, &_inner_error_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_propagate_error (error, _inner_error_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return;
#line 375 "Query.c"
	}
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = clear_bindings;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp2_) {
#line 381 "Query.c"
		sqlite3_stmt* _tmp3_;
		gint _tmp4_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = self->statement;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp4_ = sqlite3_clear_bindings (_tmp3_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		dioritedb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return;
#line 396 "Query.c"
		}
	}
	{
		gboolean _tmp5_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp5_ = self->executed;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_rec_mutex_lock (&self->priv->__lock_executed);
#line 405 "Query.c"
		{
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			self->executed = FALSE;
#line 409 "Query.c"
		}
		__finally3:
		{
			gboolean _tmp6_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp6_ = self->executed;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_rec_mutex_unlock (&self->priv->__lock_executed);
#line 418 "Query.c"
		}
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return;
#line 426 "Query.c"
		}
	}
}


DioritedbQuery* dioritedb_query_bind (DioritedbQuery* self, gint index, GValue* value, GError** error) {
	DioritedbQuery* result = NULL;
	GValue* _tmp0_;
	GType type = 0UL;
	GValue* _tmp5_;
	GType _tmp6_;
	GType _tmp7_;
	GType _tmp14_;
	GType _tmp21_;
	GType _tmp28_;
	GType _tmp35_;
	GType _tmp42_;
	GType _tmp49_;
	GType _tmp56_;
	GType _tmp63_;
	GType _tmp73_;
	const gchar* _tmp74_;
	GError* _tmp75_;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = value;
#line 76 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp0_ == NULL) {
#line 457 "Query.c"
		DioritedbQuery* _tmp1_ = NULL;
		gint _tmp2_;
		DioritedbQuery* _tmp3_;
		DioritedbQuery* _tmp4_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = index;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = dioritedb_query_bind_null (self, _tmp2_, &_inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = _tmp3_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 476 "Query.c"
			} else {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 484 "Query.c"
			}
		}
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp4_ = _tmp1_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = NULL;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp4_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp1_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 497 "Query.c"
	}
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = value;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = G_VALUE_TYPE (_tmp5_);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	type = _tmp6_;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp7_ = type;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp7_ == G_TYPE_BOOLEAN) {
#line 509 "Query.c"
		DioritedbQuery* _tmp8_ = NULL;
		gint _tmp9_;
		GValue* _tmp10_;
		gboolean _tmp11_;
		DioritedbQuery* _tmp12_;
		DioritedbQuery* _tmp13_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp9_ = index;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp10_ = value;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp11_ = g_value_get_boolean (_tmp10_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp12_ = dioritedb_query_bind_bool (self, _tmp9_, _tmp11_, &_inner_error_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp8_ = _tmp12_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 534 "Query.c"
			} else {
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 542 "Query.c"
			}
		}
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp13_ = _tmp8_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp8_ = NULL;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp13_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp8_);
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 555 "Query.c"
	}
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp14_ = type;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp14_ == G_TYPE_INT) {
#line 561 "Query.c"
		DioritedbQuery* _tmp15_ = NULL;
		gint _tmp16_;
		GValue* _tmp17_;
		gint _tmp18_;
		DioritedbQuery* _tmp19_;
		DioritedbQuery* _tmp20_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp16_ = index;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp17_ = value;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp18_ = g_value_get_int (_tmp17_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp19_ = dioritedb_query_bind_int (self, _tmp16_, _tmp18_, &_inner_error_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp15_ = _tmp19_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 586 "Query.c"
			} else {
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 594 "Query.c"
			}
		}
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp20_ = _tmp15_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp15_ = NULL;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp20_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp15_);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 607 "Query.c"
	}
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp21_ = type;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp21_ == G_TYPE_INT64) {
#line 613 "Query.c"
		DioritedbQuery* _tmp22_ = NULL;
		gint _tmp23_;
		GValue* _tmp24_;
		gint64 _tmp25_;
		DioritedbQuery* _tmp26_;
		DioritedbQuery* _tmp27_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp23_ = index;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp24_ = value;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp25_ = g_value_get_int64 (_tmp24_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp26_ = dioritedb_query_bind_int64 (self, _tmp23_, _tmp25_, &_inner_error_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp22_ = _tmp26_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 638 "Query.c"
			} else {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 646 "Query.c"
			}
		}
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp27_ = _tmp22_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp22_ = NULL;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp27_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp22_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 659 "Query.c"
	}
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp28_ = type;
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp28_ == G_TYPE_STRING) {
#line 665 "Query.c"
		DioritedbQuery* _tmp29_ = NULL;
		gint _tmp30_;
		GValue* _tmp31_;
		const gchar* _tmp32_;
		DioritedbQuery* _tmp33_;
		DioritedbQuery* _tmp34_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp30_ = index;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp31_ = value;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp32_ = g_value_get_string (_tmp31_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp33_ = dioritedb_query_bind_string (self, _tmp30_, _tmp32_, &_inner_error_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp29_ = _tmp33_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 690 "Query.c"
			} else {
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 698 "Query.c"
			}
		}
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp34_ = _tmp29_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp29_ = NULL;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp34_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp29_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 711 "Query.c"
	}
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp35_ = type;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp35_ == G_TYPE_DOUBLE) {
#line 717 "Query.c"
		DioritedbQuery* _tmp36_ = NULL;
		gint _tmp37_;
		GValue* _tmp38_;
		gdouble _tmp39_;
		DioritedbQuery* _tmp40_;
		DioritedbQuery* _tmp41_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp37_ = index;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp38_ = value;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp39_ = g_value_get_double (_tmp38_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp40_ = dioritedb_query_bind_double (self, _tmp37_, _tmp39_, &_inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp36_ = _tmp40_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 742 "Query.c"
			} else {
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 750 "Query.c"
			}
		}
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp41_ = _tmp36_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp36_ = NULL;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp41_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp36_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 763 "Query.c"
	}
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp42_ = type;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp42_ == G_TYPE_FLOAT) {
#line 769 "Query.c"
		DioritedbQuery* _tmp43_ = NULL;
		gint _tmp44_;
		GValue* _tmp45_;
		gfloat _tmp46_;
		DioritedbQuery* _tmp47_;
		DioritedbQuery* _tmp48_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp44_ = index;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp45_ = value;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp46_ = g_value_get_float (_tmp45_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp47_ = dioritedb_query_bind_double (self, _tmp44_, (gdouble) _tmp46_, &_inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp43_ = _tmp47_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 794 "Query.c"
			} else {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 802 "Query.c"
			}
		}
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp48_ = _tmp43_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp43_ = NULL;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp48_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp43_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 815 "Query.c"
	}
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp49_ = type;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp49_ == G_TYPE_BYTES) {
#line 821 "Query.c"
		DioritedbQuery* _tmp50_ = NULL;
		gint _tmp51_;
		GValue* _tmp52_;
		void* _tmp53_;
		DioritedbQuery* _tmp54_;
		DioritedbQuery* _tmp55_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp51_ = index;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp52_ = value;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp53_ = g_value_get_boxed (_tmp52_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp54_ = dioritedb_query_bind_bytes (self, _tmp51_, (GBytes*) _tmp53_, &_inner_error_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp50_ = _tmp54_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 846 "Query.c"
			} else {
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 854 "Query.c"
			}
		}
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp55_ = _tmp50_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp50_ = NULL;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp55_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp50_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 867 "Query.c"
	}
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp56_ = type;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp56_ == G_TYPE_BYTE_ARRAY) {
#line 873 "Query.c"
		DioritedbQuery* _tmp57_ = NULL;
		gint _tmp58_;
		GValue* _tmp59_;
		void* _tmp60_;
		DioritedbQuery* _tmp61_;
		DioritedbQuery* _tmp62_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp58_ = index;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp59_ = value;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp60_ = g_value_get_boxed (_tmp59_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp61_ = dioritedb_query_bind_byte_array (self, _tmp58_, (GByteArray*) _tmp60_, &_inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp57_ = _tmp61_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 898 "Query.c"
			} else {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 906 "Query.c"
			}
		}
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp62_ = _tmp57_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp57_ = NULL;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp62_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp57_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 919 "Query.c"
	}
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp63_ = type;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp63_ == G_TYPE_POINTER) {
#line 925 "Query.c"
		GValue* _tmp64_;
		void* _tmp65_;
		GType _tmp70_;
		const gchar* _tmp71_;
		GError* _tmp72_;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp64_ = value;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp65_ = g_value_get_pointer (_tmp64_);
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_tmp65_ == NULL) {
#line 937 "Query.c"
			DioritedbQuery* _tmp66_ = NULL;
			gint _tmp67_;
			DioritedbQuery* _tmp68_;
			DioritedbQuery* _tmp69_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp67_ = index;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp68_ = dioritedb_query_bind_null (self, _tmp67_, &_inner_error_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp66_ = _tmp68_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
					g_propagate_error (error, _inner_error_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
					return NULL;
#line 956 "Query.c"
				} else {
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
					g_clear_error (&_inner_error_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
					return NULL;
#line 964 "Query.c"
				}
			}
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp69_ = _tmp66_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp66_ = NULL;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			result = _tmp69_;
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_g_object_unref0 (_tmp66_);
#line 98 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return result;
#line 977 "Query.c"
		}
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp70_ = type;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp71_ = g_type_name (_tmp70_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp72_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is supported only with a null pointer.", _tmp71_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_inner_error_ = _tmp72_;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 993 "Query.c"
		} else {
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1001 "Query.c"
		}
	}
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp73_ = type;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp74_ = g_type_name (_tmp73_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp75_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp74_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_inner_error_ = _tmp75_;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_propagate_error (error, _inner_error_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return NULL;
#line 1018 "Query.c"
	} else {
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_clear_error (&_inner_error_);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return NULL;
#line 1026 "Query.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return self ? g_object_ref (self) : NULL;
#line 1034 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_null (DioritedbQuery* self, gint index, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	DioritedbQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = index;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp0_, &_inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1060 "Query.c"
		} else {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1068 "Query.c"
		}
	}
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1081 "Query.c"
		} else {
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1089 "Query.c"
		}
	}
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->statement;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = index;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = sqlite3_bind_null (_tmp1_, _tmp2_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp3_, NULL, &_inner_error_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1108 "Query.c"
		} else {
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1116 "Query.c"
		}
	}
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp4_;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1125 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_bool (DioritedbQuery* self, gint index, gboolean value, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	DioritedbQuery* _tmp2_ = NULL;
	gint _tmp3_;
	DioritedbQuery* _tmp4_;
	DioritedbQuery* _tmp5_;
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = value;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp1_) {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = 1;
#line 1146 "Query.c"
	} else {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = 0;
#line 1150 "Query.c"
	}
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = index;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = dioritedb_query_bind_int (self, _tmp3_, _tmp0_, &_inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = _tmp4_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1166 "Query.c"
		} else {
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1174 "Query.c"
		}
	}
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = _tmp2_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = NULL;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp5_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_g_object_unref0 (_tmp2_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1187 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_int (DioritedbQuery* self, gint index, gint value, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	DioritedbQuery* _tmp5_;
	GError * _inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = index;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp0_, &_inner_error_);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1214 "Query.c"
		} else {
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1222 "Query.c"
		}
	}
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1235 "Query.c"
		} else {
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1243 "Query.c"
		}
	}
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->statement;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = index;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = value;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = sqlite3_bind_int (_tmp1_, _tmp2_, _tmp3_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1264 "Query.c"
		} else {
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1272 "Query.c"
		}
	}
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = _g_object_ref0 (self);
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp5_;
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1281 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_int64 (DioritedbQuery* self, gint index, gint64 value, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gint64 _tmp3_;
	gint _tmp4_;
	DioritedbQuery* _tmp5_;
	GError * _inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = index;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp0_, &_inner_error_);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1308 "Query.c"
		} else {
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1316 "Query.c"
		}
	}
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1329 "Query.c"
		} else {
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1337 "Query.c"
		}
	}
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->statement;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = index;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = value;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = sqlite3_bind_int64 (_tmp1_, _tmp2_, _tmp3_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1358 "Query.c"
		} else {
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1366 "Query.c"
		}
	}
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = _g_object_ref0 (self);
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp5_;
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1375 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_string (DioritedbQuery* self, gint index, const gchar* value, GError** error) {
	DioritedbQuery* result = NULL;
	const gchar* _tmp0_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	gint _tmp11_;
	DioritedbQuery* _tmp12_;
	GError * _inner_error_ = NULL;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = value;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp0_ == NULL) {
#line 1397 "Query.c"
		DioritedbQuery* _tmp1_ = NULL;
		gint _tmp2_;
		DioritedbQuery* _tmp3_;
		DioritedbQuery* _tmp4_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = index;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = dioritedb_query_bind_null (self, _tmp2_, &_inner_error_);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = _tmp3_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1416 "Query.c"
			} else {
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1424 "Query.c"
			}
		}
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp4_ = _tmp1_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = NULL;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp4_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp1_);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 1437 "Query.c"
	}
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = index;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp5_, &_inner_error_);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1451 "Query.c"
		} else {
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1459 "Query.c"
		}
	}
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1472 "Query.c"
		} else {
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 139 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1480 "Query.c"
		}
	}
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = self->statement;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp7_ = index;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp8_ = value;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp10_ = g_free;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp11_ = sqlite3_bind_text (_tmp6_, _tmp7_, _tmp9_, -1, _tmp10_);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp11_, NULL, &_inner_error_);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1505 "Query.c"
		} else {
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1513 "Query.c"
		}
	}
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp12_;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1522 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_double (DioritedbQuery* self, gint index, gdouble value, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	DioritedbQuery* _tmp5_;
	GError * _inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = index;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp0_, &_inner_error_);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1549 "Query.c"
		} else {
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1557 "Query.c"
		}
	}
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1570 "Query.c"
		} else {
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 147 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1578 "Query.c"
		}
	}
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->statement;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = index;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = value;
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = sqlite3_bind_double (_tmp1_, _tmp2_, _tmp3_);
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1599 "Query.c"
		} else {
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 148 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1607 "Query.c"
		}
	}
#line 149 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = _g_object_ref0 (self);
#line 149 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp5_;
#line 149 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1616 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_blob (DioritedbQuery* self, gint index, guint8* value, int value_length1, GError** error) {
	DioritedbQuery* result = NULL;
	gint _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_;
	DioritedbQuery* _tmp6_;
	GError * _inner_error_ = NULL;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = index;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp0_, &_inner_error_);
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1646 "Query.c"
		} else {
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1654 "Query.c"
		}
	}
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1667 "Query.c"
		} else {
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1675 "Query.c"
		}
	}
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->statement;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = index;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = value;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3__length1 = value_length1;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = value;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4__length1 = value_length1;
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = sqlite3_bind_blob (_tmp1_, _tmp2_, _tmp3_, _tmp4__length1, (GDestroyNotify) SQLITE_TRANSIENT);
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp5_, NULL, &_inner_error_);
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1702 "Query.c"
		} else {
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 157 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1710 "Query.c"
		}
	}
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = _g_object_ref0 (self);
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp6_;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1719 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_bytes (DioritedbQuery* self, gint index, GBytes* value, GError** error) {
	DioritedbQuery* result = NULL;
	GBytes* _tmp0_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	GBytes* _tmp8_;
	gsize _tmp9_;
	guint8* _tmp10_;
	GBytes* _tmp11_;
	gsize _tmp12_;
	gint _tmp13_;
	DioritedbQuery* _tmp14_;
	GError * _inner_error_ = NULL;
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = value;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp0_ == NULL) {
#line 1743 "Query.c"
		DioritedbQuery* _tmp1_ = NULL;
		gint _tmp2_;
		DioritedbQuery* _tmp3_;
		DioritedbQuery* _tmp4_;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = index;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = dioritedb_query_bind_null (self, _tmp2_, &_inner_error_);
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = _tmp3_;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1762 "Query.c"
			} else {
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1770 "Query.c"
			}
		}
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp4_ = _tmp1_;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = NULL;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp4_;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp1_);
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 1783 "Query.c"
	}
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = index;
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp5_, &_inner_error_);
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1797 "Query.c"
		} else {
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 166 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1805 "Query.c"
		}
	}
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1818 "Query.c"
		} else {
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 167 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1826 "Query.c"
		}
	}
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = self->statement;
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp7_ = index;
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp8_ = value;
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp10_ = g_bytes_get_data (_tmp8_, &_tmp9_);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp11_ = value;
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp12_ = g_bytes_get_size (_tmp11_);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp13_ = sqlite3_bind_blob (_tmp6_, _tmp7_, _tmp10_, (gint) _tmp12_, NULL);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp13_, NULL, &_inner_error_);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1853 "Query.c"
		} else {
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 168 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1861 "Query.c"
		}
	}
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp14_ = _g_object_ref0 (self);
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp14_;
#line 169 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 1870 "Query.c"
}


DioritedbQuery* dioritedb_query_bind_byte_array (DioritedbQuery* self, gint index, GByteArray* value, GError** error) {
	DioritedbQuery* result = NULL;
	GByteArray* _tmp0_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_;
	GByteArray* _tmp8_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	GByteArray* _tmp10_;
	guint _tmp11_;
	gint _tmp12_;
	DioritedbQuery* _tmp13_;
	GError * _inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = value;
#line 174 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp0_ == NULL) {
#line 1894 "Query.c"
		DioritedbQuery* _tmp1_ = NULL;
		gint _tmp2_;
		DioritedbQuery* _tmp3_;
		DioritedbQuery* _tmp4_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = index;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = dioritedb_query_bind_null (self, _tmp2_, &_inner_error_);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = _tmp3_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1913 "Query.c"
			} else {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return NULL;
#line 1921 "Query.c"
			}
		}
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp4_ = _tmp1_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = NULL;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		result = _tmp4_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (_tmp1_);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		return result;
#line 1934 "Query.c"
	}
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = index;
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_index (self, _tmp5_, &_inner_error_);
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1948 "Query.c"
		} else {
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1956 "Query.c"
		}
	}
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_check_not_executed (self, &_inner_error_);
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1969 "Query.c"
		} else {
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 178 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 1977 "Query.c"
		}
	}
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = self->statement;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp7_ = index;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp8_ = value;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp9_ = _tmp8_->data;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp9__length1 = (gint) _tmp8_->len;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp10_ = value;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp11_ = _tmp10_->len;
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp12_ = sqlite3_bind_blob (_tmp6_, _tmp7_, _tmp9_, (gint) _tmp11_, NULL);
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_throw_on_error (self, _tmp12_, NULL, &_inner_error_);
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 2006 "Query.c"
		} else {
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 179 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return NULL;
#line 2014 "Query.c"
		}
	}
#line 180 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp13_ = _g_object_ref0 (self);
#line 180 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp13_;
#line 180 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 2023 "Query.c"
}


void dioritedb_query_check_not_executed (DioritedbQuery* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (self != NULL);
#line 2031 "Query.c"
	{
		gboolean _tmp0_;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = self->executed;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_rec_mutex_lock (&self->priv->__lock_executed);
#line 2038 "Query.c"
		{
			gboolean _tmp1_;
#line 187 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp1_ = self->executed;
#line 187 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_tmp1_) {
#line 2045 "Query.c"
				sqlite3_stmt* _tmp2_;
				const gchar* _tmp3_;
				GError* _tmp4_;
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp2_ = self->statement;
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp3_ = sqlite3_sql (_tmp2_);
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp4_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_MISUSE, "Query has been already executed. |%s|", _tmp3_);
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_inner_error_ = _tmp4_;
#line 2057 "Query.c"
				goto __finally4;
			}
		}
		__finally4:
		{
			gboolean _tmp5_;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp5_ = self->executed;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_rec_mutex_unlock (&self->priv->__lock_executed);
#line 2068 "Query.c"
		}
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return;
#line 2078 "Query.c"
			} else {
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return;
#line 2086 "Query.c"
			}
		}
	}
}


void dioritedb_query_check_not_executed_and_set (DioritedbQuery* self, gboolean executed, GError** error) {
	GError * _inner_error_ = NULL;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (self != NULL);
#line 2097 "Query.c"
	{
		gboolean _tmp0_;
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = self->executed;
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_rec_mutex_lock (&self->priv->__lock_executed);
#line 2104 "Query.c"
		{
			gboolean _tmp1_;
			gboolean _tmp5_;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp1_ = self->executed;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_tmp1_) {
#line 2112 "Query.c"
				sqlite3_stmt* _tmp2_;
				const gchar* _tmp3_;
				GError* _tmp4_;
#line 197 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp2_ = self->statement;
#line 197 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp3_ = sqlite3_sql (_tmp2_);
#line 197 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_tmp4_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_MISUSE, "Query has been already executed. |%s|", _tmp3_);
#line 197 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				_inner_error_ = _tmp4_;
#line 2124 "Query.c"
				goto __finally5;
			}
#line 198 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp5_ = executed;
#line 198 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			self->executed = _tmp5_;
#line 2131 "Query.c"
		}
		__finally5:
		{
			gboolean _tmp6_;
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			_tmp6_ = self->executed;
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_rec_mutex_unlock (&self->priv->__lock_executed);
#line 2140 "Query.c"
		}
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_propagate_error (error, _inner_error_);
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return;
#line 2150 "Query.c"
			} else {
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				g_clear_error (&_inner_error_);
#line 194 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
				return;
#line 2158 "Query.c"
			}
		}
	}
}


gint dioritedb_query_check_index (DioritedbQuery* self, gint index, GError** error) {
	gint result = 0;
	gint _tmp0_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp17_;
	GError * _inner_error_ = NULL;
#line 202 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = self->n_parameters;
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp0_ == 0) {
#line 2178 "Query.c"
		sqlite3_stmt* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = self->statement;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp2_ = sqlite3_sql (_tmp1_);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp3_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_RANGE, "Query doesn't have parameters. |%s|", _tmp2_);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_inner_error_ = _tmp3_;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 2192 "Query.c"
			gint _tmp4_ = 0;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp4_;
#line 2198 "Query.c"
		} else {
			gint _tmp5_ = 0;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp5_;
#line 2207 "Query.c"
		}
	}
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp7_ = index;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp7_ <= 0) {
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp6_ = TRUE;
#line 2216 "Query.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp8_ = index;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp9_ = self->n_parameters;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp6_ = _tmp8_ > _tmp9_;
#line 2226 "Query.c"
	}
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (_tmp6_) {
#line 2230 "Query.c"
		gint _tmp10_;
		gint _tmp11_;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		GError* _tmp14_;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp10_ = index;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp11_ = self->n_parameters;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp12_ = self->statement;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp13_ = sqlite3_sql (_tmp12_);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp14_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_RANGE, "Index %d is not in range 1..%d. |%s|", _tmp10_, _tmp11_, _tmp13_);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_inner_error_ = _tmp14_;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 2250 "Query.c"
			gint _tmp15_ = 0;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp15_;
#line 2256 "Query.c"
		} else {
			gint _tmp16_ = 0;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp16_;
#line 2265 "Query.c"
		}
	}
#line 209 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp17_ = index;
#line 209 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp17_;
#line 209 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 2274 "Query.c"
}


gint dioritedb_query_throw_on_error (DioritedbQuery* self, gint _result_, const gchar* sql, GError** error) {
	gint result = 0;
	gint _tmp0_ = 0;
	DioritedbConnection* _tmp1_;
	sqlite3* _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp1_ = self->priv->_connection;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp2_ = _tmp1_->db;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp3_ = _result_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp4_ = sql;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp5_ = self->statement;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp6_ = dioritedb_convert_error (_tmp2_, _tmp3_, _tmp4_, _tmp5_, &_inner_error_);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = _tmp6_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 2308 "Query.c"
			gint _tmp7_ = 0;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_propagate_error (error, _inner_error_);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp7_;
#line 2314 "Query.c"
		} else {
			gint _tmp8_ = 0;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			g_clear_error (&_inner_error_);
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
			return _tmp8_;
#line 2323 "Query.c"
		}
	}
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp0_;
#line 214 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 2330 "Query.c"
}


DioritedbConnection* dioritedb_query_get_connection (DioritedbQuery* self) {
	DioritedbConnection* result;
	DioritedbConnection* _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_tmp0_ = self->priv->_connection;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	return result;
#line 2345 "Query.c"
}


static void dioritedb_query_set_connection (DioritedbQuery* self, DioritedbConnection* value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	if (dioritedb_query_get_connection (self) != value) {
#line 2354 "Query.c"
		DioritedbConnection* _tmp0_;
		DioritedbConnection* _tmp1_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp0_ = value;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		_g_object_unref0 (self->priv->_connection);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		self->priv->_connection = _tmp1_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_object_notify ((GObject *) self, "connection");
#line 2367 "Query.c"
	}
}


static void dioritedb_query_class_init (DioritedbQueryClass * klass) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	dioritedb_query_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_type_class_add_private (klass, sizeof (DioritedbQueryPrivate));
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dioritedb_query_get_property;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dioritedb_query_set_property;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	G_OBJECT_CLASS (klass)->finalize = dioritedb_query_finalize;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_QUERY_CONNECTION, g_param_spec_object ("connection", "connection", "connection", DIORITEDB_TYPE_CONNECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 2385 "Query.c"
}


static void dioritedb_query_instance_init (DioritedbQuery * self) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->priv = DIORITEDB_QUERY_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->statement = NULL;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->n_parameters = 0;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_rec_mutex_init (&self->priv->__lock_executed);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self->executed = FALSE;
#line 2400 "Query.c"
}


static void dioritedb_query_finalize (GObject * obj) {
	DioritedbQuery * self;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_QUERY, DioritedbQuery);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_g_object_unref0 (self->priv->_connection);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	_sqlite3_finalize0 (self->statement);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	g_rec_mutex_clear (&self->priv->__lock_executed);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	G_OBJECT_CLASS (dioritedb_query_parent_class)->finalize (obj);
#line 2416 "Query.c"
}


GType dioritedb_query_get_type (void) {
	static volatile gsize dioritedb_query_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_query_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbQuery), 0, (GInstanceInitFunc) dioritedb_query_instance_init, NULL };
		GType dioritedb_query_type_id;
		dioritedb_query_type_id = g_type_register_static (G_TYPE_OBJECT, "DioritedbQuery", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&dioritedb_query_type_id__volatile, dioritedb_query_type_id);
	}
	return dioritedb_query_type_id__volatile;
}


static void _vala_dioritedb_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioritedbQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_QUERY, DioritedbQuery);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		case DIORITEDB_QUERY_CONNECTION:
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		g_value_set_object (value, dioritedb_query_get_connection (self));
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		break;
#line 2443 "Query.c"
		default:
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		break;
#line 2449 "Query.c"
	}
}


static void _vala_dioritedb_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioritedbQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_QUERY, DioritedbQuery);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		case DIORITEDB_QUERY_CONNECTION:
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		dioritedb_query_set_connection (self, g_value_get_object (value));
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		break;
#line 2465 "Query.c"
		default:
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/Query.vala"
		break;
#line 2471 "Query.c"
	}
}



