/* Random.c generated by valac 0.36.3, the Vala compiler
 * generated from Random.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* diorite_random_hex (gint n_bits);
void diorite_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset);
void diorite_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator);
void diorite_random_bin (gint n_bits, guint8** _result_, int* _result__length1);


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @return Random binary data.
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1295 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1295 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1295 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1295 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1296 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1296 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 69 "Random.c"
		glong _tmp4_;
#line 1297 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1297 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1297 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 77 "Random.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1299 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1299 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1299 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1299 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 89 "Random.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1306 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 113 "Random.c"
		glong _tmp2_;
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 119 "Random.c"
	} else {
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 123 "Random.c"
	}
#line 1308 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 127 "Random.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1310 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1310 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1310 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1310 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 139 "Random.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1312 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1312 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1312 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 149 "Random.c"
	}
#line 1315 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1315 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 155 "Random.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1316 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1316 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1316 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1317 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1317 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 169 "Random.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1319 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1319 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1319 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 179 "Random.c"
	}
#line 1321 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1321 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 185 "Random.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1322 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1322 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1322 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 194 "Random.c"
	}
#line 1324 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1324 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1324 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1324 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1325 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1325 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1325 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1325 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1325 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 214 "Random.c"
}


gchar* diorite_random_hex (gint n_bits) {
	gchar* result = NULL;
	gint n_bytes = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint n_32bits = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint size = 0;
	gint _tmp8_;
	guint8* buffer = NULL;
	gint _tmp9_;
	guint8* _tmp10_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _result_ = NULL;
	guint8* _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gint _tmp20_;
	gint _tmp21_;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp0_ = n_bits;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	n_bytes = _tmp0_ / 8;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp1_ = n_bytes;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp2_ = n_bits;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if ((_tmp1_ * 8) < _tmp2_) {
#line 252 "Random.c"
		gint _tmp3_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp3_ = n_bytes;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		n_bytes = _tmp3_ + 1;
#line 258 "Random.c"
	}
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp4_ = n_bytes;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	n_32bits = _tmp4_ / 4;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp5_ = n_32bits;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp6_ = n_bytes;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if ((_tmp5_ * 4) < _tmp6_) {
#line 270 "Random.c"
		gint _tmp7_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp7_ = n_32bits;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		n_32bits = _tmp7_ + 1;
#line 276 "Random.c"
	}
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp8_ = n_32bits;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	size = _tmp8_ * 4;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp9_ = size;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp10_ = g_new0 (guint8, _tmp9_);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	buffer = _tmp10_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	buffer_length1 = _tmp9_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_buffer_size_ = buffer_length1;
#line 292 "Random.c"
	{
		guint offset = 0U;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		offset = (guint) 0;
#line 297 "Random.c"
		{
			gboolean _tmp11_ = FALSE;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
			_tmp11_ = TRUE;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
			while (TRUE) {
#line 304 "Random.c"
				guint _tmp13_;
				gint _tmp14_;
				guint32 _tmp15_;
				guint _tmp16_;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				if (!_tmp11_) {
#line 311 "Random.c"
					guint _tmp12_;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					_tmp12_ = offset;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					offset = _tmp12_ + 4;
#line 317 "Random.c"
				}
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp11_ = FALSE;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp13_ = offset;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp14_ = size;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				if (!((_tmp13_ + 4) <= ((guint) _tmp14_))) {
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					break;
#line 329 "Random.c"
				}
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp15_ = g_random_int ();
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp16_ = offset;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				diorite_uint32_to_bytes (&buffer, &buffer_length1, _tmp15_, _tmp16_);
#line 337 "Random.c"
			}
		}
	}
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp17_ = buffer;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp17__length1 = buffer_length1;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	diorite_bin_to_hex (_tmp17_, _tmp17__length1, &_tmp18_, '\0');
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_g_free0 (_result_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_result_ = _tmp18_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp20_ = size;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp21_ = n_bytes;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if (_tmp20_ == _tmp21_) {
#line 357 "Random.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp22_ = _result_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_g_free0 (_tmp19_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp19_ = _tmp23_;
#line 368 "Random.c"
	} else {
		const gchar* _tmp24_;
		gint _tmp25_;
		gchar* _tmp26_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp24_ = _result_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp25_ = n_bytes;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp26_ = string_substring (_tmp24_, (glong) 0, (glong) (_tmp25_ * 2));
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_g_free0 (_tmp19_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp19_ = _tmp26_;
#line 383 "Random.c"
	}
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	result = _tmp19_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_g_free0 (_result_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	buffer = (g_free (buffer), NULL);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	return result;
#line 393 "Random.c"
}


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @param result    Random binary data.
 */
void diorite_random_bin (gint n_bits, guint8** _result_, int* _result__length1) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gint n_bytes = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint n_32bits = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint size = 0;
	gint _tmp8_;
	gint _tmp9_;
	guint8* _tmp10_;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp0_ = n_bits;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	n_bytes = _tmp0_ / 8;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp1_ = n_bytes;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp2_ = n_bits;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if ((_tmp1_ * 8) < _tmp2_) {
#line 428 "Random.c"
		gint _tmp3_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp3_ = n_bytes;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		n_bytes = _tmp3_ + 1;
#line 434 "Random.c"
	}
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp4_ = n_bytes;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	n_32bits = _tmp4_ / 4;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp5_ = n_32bits;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp6_ = n_bytes;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if ((_tmp5_ * 4) < _tmp6_) {
#line 446 "Random.c"
		gint _tmp7_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_tmp7_ = n_32bits;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		n_32bits = _tmp7_ + 1;
#line 452 "Random.c"
	}
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp8_ = n_32bits;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	size = _tmp8_ * 4;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp9_ = size;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_tmp10_ = g_new0 (guint8, _tmp9_);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_vala_result = (g_free (_vala_result), NULL);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_vala_result = _tmp10_;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	_vala_result_length1 = _tmp9_;
#line 468 "Random.c"
	{
		guint offset = 0U;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		offset = (guint) 0;
#line 473 "Random.c"
		{
			gboolean _tmp11_ = FALSE;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
			_tmp11_ = TRUE;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
			while (TRUE) {
#line 480 "Random.c"
				guint _tmp13_;
				gint _tmp14_;
				guint32 _tmp15_;
				guint _tmp16_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				if (!_tmp11_) {
#line 487 "Random.c"
					guint _tmp12_;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					_tmp12_ = offset;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					offset = _tmp12_ + 4;
#line 493 "Random.c"
				}
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp11_ = FALSE;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp13_ = offset;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp14_ = size;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				if (!((_tmp13_ + 4) <= ((guint) _tmp14_))) {
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
					break;
#line 505 "Random.c"
				}
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp15_ = g_random_int ();
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				_tmp16_ = offset;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
				diorite_uint32_to_bytes (&_vala_result, &_vala_result_length1, _tmp15_, _tmp16_);
#line 513 "Random.c"
			}
		}
	}
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if (_result_) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		*_result_ = _vala_result;
#line 521 "Random.c"
	} else {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		_vala_result = (g_free (_vala_result), NULL);
#line 525 "Random.c"
	}
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
	if (_result__length1) {
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Random.vala"
		*_result__length1 = _vala_result_length1;
#line 531 "Random.c"
	}
}



