/* RawQuery.c generated by valac 0.36.3, the Vala compiler
 * generated from RawQuery.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define DIORITEDB_TYPE_QUERY (dioritedb_query_get_type ())
#define DIORITEDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_QUERY, DioritedbQuery))
#define DIORITEDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))
#define DIORITEDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))

typedef struct _DioritedbQuery DioritedbQuery;
typedef struct _DioritedbQueryClass DioritedbQueryClass;
typedef struct _DioritedbQueryPrivate DioritedbQueryPrivate;

#define DIORITEDB_TYPE_RAW_QUERY (dioritedb_raw_query_get_type ())
#define DIORITEDB_RAW_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQuery))
#define DIORITEDB_RAW_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQueryClass))
#define DIORITEDB_IS_RAW_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_RAW_QUERY))
#define DIORITEDB_IS_RAW_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_RAW_QUERY))
#define DIORITEDB_RAW_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_RAW_QUERY, DioritedbRawQueryClass))

typedef struct _DioritedbRawQuery DioritedbRawQuery;
typedef struct _DioritedbRawQueryClass DioritedbRawQueryClass;
typedef struct _DioritedbRawQueryPrivate DioritedbRawQueryPrivate;

#define DIORITEDB_TYPE_CONNECTION (dioritedb_connection_get_type ())
#define DIORITEDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnection))
#define DIORITEDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))
#define DIORITEDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))

typedef struct _DioritedbConnection DioritedbConnection;
typedef struct _DioritedbConnectionClass DioritedbConnectionClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DIORITEDB_TYPE_RESULT (dioritedb_result_get_type ())
#define DIORITEDB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_RESULT, DioritedbResult))
#define DIORITEDB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_RESULT, DioritedbResultClass))
#define DIORITEDB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_RESULT))
#define DIORITEDB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_RESULT))
#define DIORITEDB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_RESULT, DioritedbResultClass))

typedef struct _DioritedbResult DioritedbResult;
typedef struct _DioritedbResultClass DioritedbResultClass;

struct _DioritedbQuery {
	GObject parent_instance;
	DioritedbQueryPrivate * priv;
	sqlite3_stmt* statement;
	gint n_parameters;
	gboolean executed;
};

struct _DioritedbQueryClass {
	GObjectClass parent_class;
};

struct _DioritedbRawQuery {
	DioritedbQuery parent_instance;
	DioritedbRawQueryPrivate * priv;
};

struct _DioritedbRawQueryClass {
	DioritedbQueryClass parent_class;
};

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()

static gpointer dioritedb_raw_query_parent_class = NULL;

GType dioritedb_query_get_type (void) G_GNUC_CONST;
GType dioritedb_raw_query_get_type (void) G_GNUC_CONST;
enum  {
	DIORITEDB_RAW_QUERY_DUMMY_PROPERTY
};
GType dioritedb_connection_get_type (void) G_GNUC_CONST;
GQuark dioritedb_database_error_quark (void);
DioritedbRawQuery* dioritedb_raw_query_new (DioritedbConnection* connection, const gchar* sql, GError** error);
DioritedbRawQuery* dioritedb_raw_query_construct (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** error);
DioritedbQuery* dioritedb_query_construct_out_error (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** _error_);
GType dioritedb_result_get_type (void) G_GNUC_CONST;
DioritedbResult* dioritedb_raw_query_exec (DioritedbRawQuery* self, GCancellable* cancellable, GError** error);
void dioritedb_query_check_not_executed_and_set (DioritedbQuery* self, gboolean executed, GError** error);
DioritedbResult* dioritedb_result_new (DioritedbQuery* query);
DioritedbResult* dioritedb_result_construct (GType object_type, DioritedbQuery* query);
gboolean dioritedb_result_next (DioritedbResult* self, GCancellable* cancellable, GError** error);
DioritedbResult* dioritedb_raw_query_exec_select (DioritedbRawQuery* self, GCancellable* cancellable, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind (DioritedbRawQuery* self, gint index, GValue* value, GError** error);
DioritedbQuery* dioritedb_query_bind (DioritedbQuery* self, gint index, GValue* value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_null (DioritedbRawQuery* self, gint index, GError** error);
DioritedbQuery* dioritedb_query_bind_null (DioritedbQuery* self, gint index, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_bool (DioritedbRawQuery* self, gint index, gboolean value, GError** error);
DioritedbQuery* dioritedb_query_bind_bool (DioritedbQuery* self, gint index, gboolean value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_int (DioritedbRawQuery* self, gint index, gint value, GError** error);
DioritedbQuery* dioritedb_query_bind_int (DioritedbQuery* self, gint index, gint value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_int64 (DioritedbRawQuery* self, gint index, gint64 value, GError** error);
DioritedbQuery* dioritedb_query_bind_int64 (DioritedbQuery* self, gint index, gint64 value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_string (DioritedbRawQuery* self, gint index, const gchar* value, GError** error);
DioritedbQuery* dioritedb_query_bind_string (DioritedbQuery* self, gint index, const gchar* value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_double (DioritedbRawQuery* self, gint index, gdouble value, GError** error);
DioritedbQuery* dioritedb_query_bind_double (DioritedbQuery* self, gint index, gdouble value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_blob (DioritedbRawQuery* self, gint index, guint8* value, int value_length1, GError** error);
DioritedbQuery* dioritedb_query_bind_blob (DioritedbQuery* self, gint index, guint8* value, int value_length1, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_bytes (DioritedbRawQuery* self, gint index, GBytes* value, GError** error);
DioritedbQuery* dioritedb_query_bind_bytes (DioritedbQuery* self, gint index, GBytes* value, GError** error);
DioritedbRawQuery* dioritedb_raw_query_bind_byte_array (DioritedbRawQuery* self, gint index, GByteArray* value, GError** error);
DioritedbQuery* dioritedb_query_bind_byte_array (DioritedbQuery* self, gint index, GByteArray* value, GError** error);


static gpointer _g_error_copy0 (gpointer self) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return self ? g_error_copy (self) : NULL;
#line 163 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_construct (GType object_type, DioritedbConnection* connection, const gchar* sql, GError** error) {
	DioritedbRawQuery * self = NULL;
	GError* caught_error = NULL;
	DioritedbConnection* _tmp0_;
	const gchar* _tmp1_;
	GError* _tmp2_ = NULL;
	GError* _tmp3_;
	GError * _inner_error_ = NULL;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = connection;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = sql;
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	self = (DioritedbRawQuery*) dioritedb_query_construct_out_error (object_type, _tmp0_, _tmp1_, &_tmp2_);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_error_free0 (caught_error);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	caught_error = _tmp2_;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = caught_error;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (_tmp3_ != NULL) {
#line 193 "RawQuery.c"
		GError* _tmp4_;
		GError* _tmp5_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		_tmp4_ = caught_error;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		_tmp5_ = _g_error_copy0 (_tmp4_);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		_inner_error_ = _tmp5_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			_g_error_free0 (caught_error);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			_g_object_unref0 (self);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 212 "RawQuery.c"
		} else {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			_g_error_free0 (caught_error);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 222 "RawQuery.c"
		}
	}
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_error_free0 (caught_error);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return self;
#line 229 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_new (DioritedbConnection* connection, const gchar* sql, GError** error) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return dioritedb_raw_query_construct (DIORITEDB_TYPE_RAW_QUERY, connection, sql, error);
#line 236 "RawQuery.c"
}


DioritedbResult* dioritedb_raw_query_exec (DioritedbRawQuery* self, GCancellable* cancellable, GError** error) {
	DioritedbResult* result = NULL;
	DioritedbResult* _result_ = NULL;
	DioritedbResult* _tmp0_;
	DioritedbResult* _tmp1_;
	GCancellable* _tmp2_;
	GError * _inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	dioritedb_query_check_not_executed_and_set ((DioritedbQuery*) self, TRUE, &_inner_error_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		g_propagate_error (error, _inner_error_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		return NULL;
#line 257 "RawQuery.c"
	}
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = dioritedb_result_new ((DioritedbQuery*) self);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_result_ = _tmp0_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = _result_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = cancellable;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	dioritedb_result_next (_tmp1_, _tmp2_, &_inner_error_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		g_propagate_error (error, _inner_error_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		_g_object_unref0 (_result_);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		return NULL;
#line 277 "RawQuery.c"
	}
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _result_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 283 "RawQuery.c"
}


/**
 * Usage:
 * 
 * {{{
 * Result result = query.exec_select();
 * while (result.next())
 * {
 *        // process data
 * }
 * }}}
 */
DioritedbResult* dioritedb_raw_query_exec_select (DioritedbRawQuery* self, GCancellable* cancellable, GError** error) {
	DioritedbResult* result = NULL;
	DioritedbResult* _tmp0_;
	GError * _inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	dioritedb_query_check_not_executed_and_set ((DioritedbQuery*) self, TRUE, &_inner_error_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		g_propagate_error (error, _inner_error_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		return NULL;
#line 312 "RawQuery.c"
	}
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = dioritedb_result_new ((DioritedbQuery*) self);
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp0_;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 320 "RawQuery.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return self ? g_object_ref (self) : NULL;
#line 327 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind (DioritedbRawQuery* self, gint index, GValue* value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	GValue* _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 359 "RawQuery.c"
		} else {
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 367 "RawQuery.c"
		}
	}
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 376 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_null (DioritedbRawQuery* self, gint index, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	DioritedbQuery* _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbRawQuery* _tmp3_;
	GError * _inner_error_ = NULL;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = dioritedb_query_bind_null (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, &_inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = _tmp1_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp2_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 405 "RawQuery.c"
		} else {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 413 "RawQuery.c"
		}
	}
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _g_object_ref0 (self);
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp3_;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 422 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_bool (DioritedbRawQuery* self, gint index, gboolean value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	gboolean _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_bool (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 454 "RawQuery.c"
		} else {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 462 "RawQuery.c"
		}
	}
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 471 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_int (DioritedbRawQuery* self, gint index, gint value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_int (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 503 "RawQuery.c"
		} else {
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 83 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 511 "RawQuery.c"
		}
	}
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 520 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_int64 (DioritedbRawQuery* self, gint index, gint64 value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	gint64 _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_int64 (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 552 "RawQuery.c"
		} else {
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 560 "RawQuery.c"
		}
	}
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 569 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_string (DioritedbRawQuery* self, gint index, const gchar* value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	const gchar* _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_string (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 601 "RawQuery.c"
		} else {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 609 "RawQuery.c"
		}
	}
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 618 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_double (DioritedbRawQuery* self, gint index, gdouble value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	gdouble _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_double (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 650 "RawQuery.c"
		} else {
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 658 "RawQuery.c"
		}
	}
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 667 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_blob (DioritedbRawQuery* self, gint index, guint8* value, int value_length1, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1__length1 = value_length1;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_blob (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, _tmp1__length1, &_inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 702 "RawQuery.c"
		} else {
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 710 "RawQuery.c"
		}
	}
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 719 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_bytes (DioritedbRawQuery* self, gint index, GBytes* value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	GBytes* _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_bytes (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 751 "RawQuery.c"
		} else {
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 759 "RawQuery.c"
		}
	}
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 768 "RawQuery.c"
}


DioritedbRawQuery* dioritedb_raw_query_bind_byte_array (DioritedbRawQuery* self, gint index, GByteArray* value, GError** error) {
	DioritedbRawQuery* result = NULL;
	gint _tmp0_;
	GByteArray* _tmp1_;
	DioritedbQuery* _tmp2_;
	DioritedbQuery* _tmp3_;
	DioritedbRawQuery* _tmp4_;
	GError * _inner_error_ = NULL;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp0_ = index;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp1_ = value;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp2_ = dioritedb_query_bind_byte_array (G_TYPE_CHECK_INSTANCE_CAST (self, DIORITEDB_TYPE_QUERY, DioritedbQuery), _tmp0_, _tmp1_, &_inner_error_);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp3_ = _tmp2_;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_g_object_unref0 (_tmp3_);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_propagate_error (error, _inner_error_);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 800 "RawQuery.c"
		} else {
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			g_clear_error (&_inner_error_);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
			return NULL;
#line 808 "RawQuery.c"
		}
	}
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	result = _tmp4_;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	return result;
#line 817 "RawQuery.c"
}


static void dioritedb_raw_query_class_init (DioritedbRawQueryClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/RawQuery.vala"
	dioritedb_raw_query_parent_class = g_type_class_peek_parent (klass);
#line 824 "RawQuery.c"
}


static void dioritedb_raw_query_instance_init (DioritedbRawQuery * self) {
}


GType dioritedb_raw_query_get_type (void) {
	static volatile gsize dioritedb_raw_query_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_raw_query_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbRawQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_raw_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbRawQuery), 0, (GInstanceInitFunc) dioritedb_raw_query_instance_init, NULL };
		GType dioritedb_raw_query_type_id;
		dioritedb_raw_query_type_id = g_type_register_static (DIORITEDB_TYPE_QUERY, "DioritedbRawQuery", &g_define_type_info, 0);
		g_once_init_leave (&dioritedb_raw_query_type_id__volatile, dioritedb_raw_query_type_id);
	}
	return dioritedb_raw_query_type_id__volatile;
}



