/* Serialize.c generated by valac 0.36.3, the Vala compiler
 * generated from Serialize.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



#define DIORITE_SERIALIZE_ALIGN ((guint) 8)
gboolean diorite_serialize_variant (GVariant* variant, guint8* buffer, int buffer_length1, guint offset);
guint8* diorite_serialize_message (const gchar* name, GVariant* parameters, guint offset, int* result_length1);
GVariant* diorite_deserialize_variant (const gchar* type_sig, guint8* buffer, int buffer_length1, guint offset, gboolean trusted);
gboolean diorite_deserialize_message (guint8* buffer, int buffer_length1, gchar* * name, GVariant* * parameters, guint offset);
GVariant* diorite_serialize_error (GError* e);
GError* diorite_deserialize_error (GVariant* e);


/**
 * Serializes Variant to byte array at given offset.
 * 
 * @param variant    variant value to store
 * @param buffer     byte array to store variant at, must be large enough (see Varian.get_size())
 * @param offset     starting offset to store value at, must be aligned to 8 bytes
 * @return true on success, false if requirements haven't been met
 */
gboolean diorite_serialize_variant (GVariant* variant, guint8* buffer, int buffer_length1, guint offset) {
	gboolean result = FALSE;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	GVariant* _tmp2_;
	gsize _tmp3_;
	guint _tmp4_;
	guint8* p = NULL;
	guint8* _tmp5_;
	gint _tmp5__length1;
	guint _tmp6_;
	GVariant* _tmp7_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0_ = buffer;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0__length1 = buffer_length1;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = offset;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2_ = variant;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3_ = g_variant_get_size (_tmp2_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (((gsize) (_tmp0__length1 - _tmp1_)) >= _tmp3_, FALSE);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = offset;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail ((_tmp4_ % DIORITE_SERIALIZE_ALIGN) == ((guint) 0), FALSE);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = buffer;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5__length1 = buffer_length1;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp6_ = offset;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	p = ((guint8*) _tmp5_) + _tmp6_;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp7_ = variant;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_variant_store (_tmp7_, p);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = TRUE;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 108 "Serialize.c"
}


/**
 * Serializes message to byte array at given offset.
 * 
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return byte array with serialized message
 */
guint8* diorite_serialize_message (const gchar* name, GVariant* parameters, guint offset, int* result_length1) {
	guint8* result = NULL;
	const gchar* _tmp0_ = NULL;
	GVariant* _tmp1_;
	gchar* type_str = NULL;
	gchar* _tmp4_;
	guint variant_offset = 0U;
	guint _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	guint _tmp12_;
	gsize _tmp15_ = 0UL;
	GVariant* _tmp16_;
	guint32 buffer_size = 0U;
	guint _tmp19_;
	guint8* buffer = NULL;
	guint32 _tmp20_;
	guint8* _tmp21_;
	gint buffer_length1;
	gint _buffer_size_;
	guint8* p = NULL;
	guint8* _tmp22_;
	gint _tmp22__length1;
	guint size = 0U;
	const gchar* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	guint8* _tmp26_;
	guint _tmp27_;
	const gchar* _tmp28_;
	guint _tmp29_;
	guint _tmp30_;
	guint _tmp31_;
	const gchar* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	guint8* _tmp35_;
	guint _tmp36_;
	const gchar* _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	GVariant* _tmp41_;
	guint8* _tmp46_;
	gint _tmp46__length1;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = parameters;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (_tmp1_ != NULL) {
#line 175 "Serialize.c"
		GVariant* _tmp2_;
		const gchar* _tmp3_;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp2_ = parameters;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp3_ = g_variant_get_type_string (_tmp2_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp0_ = _tmp3_;
#line 184 "Serialize.c"
	} else {
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp0_ = "";
#line 188 "Serialize.c"
	}
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = g_strdup (_tmp0_);
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	type_str = _tmp4_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = offset;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp6_ = name;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp7_ = strlen (_tmp6_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp8_ = _tmp7_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp9_ = type_str;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp10_ = strlen (_tmp9_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp11_ = _tmp10_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	variant_offset = (guint) ((((_tmp5_ + _tmp8_) + 1) + _tmp11_) + 1);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp12_ = variant_offset;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if ((_tmp12_ % DIORITE_SERIALIZE_ALIGN) != ((guint) 0)) {
#line 214 "Serialize.c"
		guint _tmp13_;
		guint _tmp14_;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp13_ = variant_offset;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp14_ = variant_offset;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		variant_offset = _tmp13_ + (DIORITE_SERIALIZE_ALIGN - (_tmp14_ % DIORITE_SERIALIZE_ALIGN));
#line 223 "Serialize.c"
	}
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp16_ = parameters;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (_tmp16_ != NULL) {
#line 229 "Serialize.c"
		GVariant* _tmp17_;
		gsize _tmp18_;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp17_ = parameters;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp18_ = g_variant_get_size (_tmp17_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp15_ = _tmp18_;
#line 238 "Serialize.c"
	} else {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp15_ = (gsize) 0;
#line 242 "Serialize.c"
	}
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp19_ = variant_offset;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer_size = (guint32) (_tmp19_ + _tmp15_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp20_ = buffer_size;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp21_ = g_new0 (guint8, _tmp20_);
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer = _tmp21_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer_length1 = _tmp20_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_buffer_size_ = buffer_length1;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp22_ = buffer;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp22__length1 = buffer_length1;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	p = _tmp22_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp23_ = name;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp24_ = strlen (_tmp23_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp25_ = _tmp24_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	size = (guint) (_tmp25_ + 1);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp26_ = p;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp27_ = offset;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp28_ = name;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp29_ = size;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	memcpy (_tmp26_ + _tmp27_, (void*) _tmp28_, (gsize) _tmp29_);
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp30_ = offset;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp31_ = size;
#line 67 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	offset = _tmp30_ + _tmp31_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp32_ = type_str;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp33_ = strlen (_tmp32_);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp34_ = _tmp33_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	size = (guint) (_tmp34_ + 1);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp35_ = p;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp36_ = offset;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp37_ = type_str;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp38_ = size;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	memcpy (_tmp35_ + _tmp36_, (void*) _tmp37_, (gsize) _tmp38_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp39_ = offset;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp40_ = size;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	offset = _tmp39_ + _tmp40_;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp41_ = parameters;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (_tmp41_ != NULL) {
#line 316 "Serialize.c"
		GVariant* _tmp42_;
		guint8* _tmp43_;
		gint _tmp43__length1;
		guint _tmp44_;
		gboolean _tmp45_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp42_ = parameters;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp43_ = buffer;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp43__length1 = buffer_length1;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp44_ = variant_offset;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp45_ = diorite_serialize_variant (_tmp42_, _tmp43_, _tmp43__length1, _tmp44_);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_vala_assert (_tmp45_, "serialize_variant(parameters, buffer, variant_offset)");
#line 334 "Serialize.c"
	}
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp46_ = buffer;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp46__length1 = buffer_length1;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (result_length1) {
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		*result_length1 = _tmp46__length1;
#line 344 "Serialize.c"
	}
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = _tmp46_;
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (type_str);
#line 75 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 352 "Serialize.c"
}


/**
 * Deserializes Variant from byte array at given offset.
 * 
 * @param type_sig    valid variant type signature
 * @param buffer      byte array read data from. array will be freed asynchronously, see Variant.new_from_data
 * @param offset      starting offset to read data from, must be aligned to 8 bytes
 * @param trusted     whether data comes from trusted source
 * @return Variant on success, null if requirements haven't been met
 */
GVariant* diorite_deserialize_variant (const gchar* type_sig, guint8* buffer, int buffer_length1, guint offset, gboolean trusted) {
	GVariant* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	guint _tmp2_;
	guint8* real_data = NULL;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint _tmp4_;
	gint real_data_length1;
	gint _real_data_size_;
	guint8* _tmp5_;
	gint _tmp5__length1;
	guint _tmp6_;
	gint _tmp7_;
	GVariantType* type = NULL;
	const gchar* _tmp8_;
	GVariantType* _tmp9_;
	GVariant* variant = NULL;
	gboolean _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	GVariant* _tmp12_;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (type_sig != NULL, NULL);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0_ = type_sig;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = g_variant_type_string_is_valid (_tmp0_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (_tmp1_, NULL);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2_ = offset;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail ((_tmp2_ % DIORITE_SERIALIZE_ALIGN) == ((guint) 0), NULL);
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3_ = buffer;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3__length1 = buffer_length1;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = offset;
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	real_data = (guint8*) (((guint8*) _tmp3_) + _tmp4_);
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	real_data_length1 = sizeof (guint8) / sizeof (guint8);
#line 91 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_real_data_size_ = real_data_length1;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = buffer;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5__length1 = buffer_length1;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp6_ = offset;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	real_data_length1 = (gint) (_tmp5__length1 - _tmp6_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp7_ = real_data_length1;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp8_ = type_sig;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp9_ = g_variant_type_new (_tmp8_);
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	type = _tmp9_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp10_ = trusted;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp11_ = buffer;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp11__length1 = buffer_length1;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer = NULL;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer_length1 = 0;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp12_ = g_variant_new_from_data (type, real_data, real_data_length1, _tmp10_, g_free, _tmp11_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	variant = _tmp12_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = variant;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_variant_type_free0 (type);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer = (g_free (buffer), NULL);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 450 "Serialize.c"
}


/**
 * Deserializes message from byte array at given offset.
 * 
 * @param buffer    byte array to read data from, array will be freed asynchronously, see Variant.new_from_data
 * @param name      message name
 * @param parameters    message parameters
 * @param offset    starting offset to store data at, use for your own data (e.g. format signature)
 * @return true on success, false on failure (i. e. invalid data)
 */
gboolean diorite_deserialize_message (guint8* buffer, int buffer_length1, gchar* * name, GVariant* * parameters, guint offset) {
	gchar* _vala_name = NULL;
	GVariant* _vala_parameters = NULL;
	gboolean result = FALSE;
	guint32 limit = 0U;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	guint8* p = NULL;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint _tmp3_;
	guint8* index = NULL;
	guint8* _tmp4_;
	guint32 _tmp5_;
	void* _tmp6_;
	gboolean _tmp7_ = FALSE;
	guint8* _tmp8_;
	guint size = 0U;
	guint8* _tmp11_;
	guint8* _tmp12_;
	gchar* tmp_name = NULL;
	guint8* _tmp13_;
	guint _tmp14_;
	void* _tmp15_;
	gchar* _tmp16_;
	guint _tmp17_;
	guint _tmp18_;
	guint8* _tmp19_;
	guint _tmp20_;
	guint32 _tmp21_;
	guint _tmp22_;
	guint8* _tmp23_;
	guint32 _tmp24_;
	void* _tmp25_;
	gboolean _tmp26_ = FALSE;
	guint8* _tmp27_;
	guint8* _tmp30_;
	guint8* _tmp31_;
	gchar* type_str = NULL;
	guint8* _tmp32_;
	guint _tmp33_;
	void* _tmp34_;
	gchar* _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	const gchar* _tmp41_;
	gchar* _tmp47_;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (_vala_name);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_vala_name = NULL;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_variant_unref0 (_vala_parameters);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_vala_parameters = NULL;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0_ = buffer;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0__length1 = buffer_length1;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = offset;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	limit = (guint32) (_tmp0__length1 - _tmp1_);
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2_ = buffer;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2__length1 = buffer_length1;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3_ = offset;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	p = ((guint8*) _tmp2_) + _tmp3_;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = p;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = limit;
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp6_ = memchr (_tmp4_, 0, (gsize) _tmp5_);
#line 115 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	index = _tmp6_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp8_ = index;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (_tmp8_ != NULL) {
#line 548 "Serialize.c"
		guint8* _tmp9_;
		guint8* _tmp10_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp9_ = index;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp10_ = p;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp7_ = (_tmp9_ - _tmp10_) > ((gsize) 0);
#line 557 "Serialize.c"
	} else {
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp7_ = FALSE;
#line 561 "Serialize.c"
	}
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (_tmp7_, FALSE);
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp11_ = index;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp12_ = p;
#line 117 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	size = (guint) ((_tmp11_ - _tmp12_) + 1);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp13_ = p;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp14_ = size;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp15_ = g_memdup (_tmp13_, _tmp14_);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp16_ = g_strdup ((const gchar*) _tmp15_);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	tmp_name = _tmp16_;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp17_ = offset;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp18_ = size;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	offset = _tmp17_ + _tmp18_;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp19_ = p;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp20_ = size;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	p = _tmp19_ + _tmp20_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp21_ = limit;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp22_ = size;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	limit = _tmp21_ - _tmp22_;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp23_ = p;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp24_ = limit;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp25_ = memchr (_tmp23_, 0, (gsize) _tmp24_);
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	index = _tmp25_;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp27_ = index;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (_tmp27_ != NULL) {
#line 611 "Serialize.c"
		guint8* _tmp28_;
		guint8* _tmp29_;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp28_ = index;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp29_ = p;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp26_ = (_tmp28_ - _tmp29_) >= ((gsize) 0);
#line 620 "Serialize.c"
	} else {
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp26_ = FALSE;
#line 624 "Serialize.c"
	}
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (_tmp26_, FALSE);
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp30_ = index;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp31_ = p;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	size = (guint) ((_tmp30_ - _tmp31_) + 1);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp32_ = p;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp33_ = size;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp34_ = g_memdup (_tmp32_, _tmp33_);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp35_ = g_strdup ((const gchar*) _tmp34_);
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	type_str = _tmp35_;
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp36_ = offset;
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp37_ = size;
#line 129 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	offset = _tmp36_ + _tmp37_;
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp38_ = offset;
#line 131 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if ((_tmp38_ % DIORITE_SERIALIZE_ALIGN) != ((guint) 0)) {
#line 654 "Serialize.c"
		guint _tmp39_;
		guint _tmp40_;
#line 132 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp39_ = offset;
#line 132 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp40_ = offset;
#line 132 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		offset = _tmp39_ + (DIORITE_SERIALIZE_ALIGN - (_tmp40_ % DIORITE_SERIALIZE_ALIGN));
#line 663 "Serialize.c"
	}
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp41_ = type_str;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (g_strcmp0 (_tmp41_, "") != 0) {
#line 669 "Serialize.c"
		const gchar* _tmp42_;
		guint8* _tmp43_;
		gint _tmp43__length1;
		guint _tmp44_;
		GVariant* _tmp45_;
		GVariant* _tmp46_;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp42_ = type_str;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp43_ = buffer;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp43__length1 = buffer_length1;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		buffer = NULL;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		buffer_length1 = 0;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp44_ = offset;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp45_ = diorite_deserialize_variant (_tmp42_, _tmp43_, _tmp43__length1, _tmp44_, FALSE);
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_g_variant_unref0 (_vala_parameters);
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_vala_parameters = _tmp45_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_tmp46_ = _vala_parameters;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		g_return_val_if_fail (_tmp46_ != NULL, FALSE);
#line 698 "Serialize.c"
	}
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp47_ = tmp_name;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	tmp_name = NULL;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (_vala_name);
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_vala_name = _tmp47_;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = TRUE;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (type_str);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (tmp_name);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	buffer = (g_free (buffer), NULL);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (name) {
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		*name = _vala_name;
#line 720 "Serialize.c"
	} else {
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_g_free0 (_vala_name);
#line 724 "Serialize.c"
	}
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	if (parameters) {
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		*parameters = _vala_parameters;
#line 730 "Serialize.c"
	} else {
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
		_g_variant_unref0 (_vala_parameters);
#line 734 "Serialize.c"
	}
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 738 "Serialize.c"
}


GVariant* diorite_serialize_error (GError* e) {
	GVariant* result = NULL;
	GError* _tmp0_;
	GQuark _tmp1_;
	const gchar* _tmp2_;
	GError* _tmp3_;
	gint _tmp4_;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GVariant* _tmp7_;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0_ = e;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = _tmp0_->domain;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2_ = g_quark_to_string (_tmp1_);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3_ = e;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = _tmp3_->code;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = e;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp6_ = _tmp5_->message;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp7_ = g_variant_new ("(sis)", _tmp2_, _tmp4_, _tmp6_, NULL);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_variant_ref_sink (_tmp7_);
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = _tmp7_;
#line 146 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 774 "Serialize.c"
}


GError* diorite_deserialize_error (GVariant* e) {
	GError* result = NULL;
	gchar* domain = NULL;
	gint code = 0;
	gchar* message = NULL;
	GVariant* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
#line 149 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_return_val_if_fail (e != NULL, NULL);
#line 151 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	domain = NULL;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	code = 0;
#line 153 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	message = NULL;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp0_ = e;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	g_variant_get (_tmp0_, "(sis)", &domain, &code, &message, NULL);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp1_ = domain;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp2_ = g_quark_from_string (_tmp1_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp3_ = code;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp4_ = message;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_tmp5_ = g_error_new (_tmp2_, _tmp3_, "%s", _tmp4_);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	result = _tmp5_;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (message);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	_g_free0 (domain);
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/glib/Serialize.vala"
	return result;
#line 819 "Serialize.c"
}



