/* SocketChannel.c generated by valac 0.36.3, the Vala compiler
 * generated from SocketChannel.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gunixsocketaddress.h>


#define DRT_TYPE_DUPLEX_CHANNEL (drt_duplex_channel_get_type ())
#define DRT_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannel))
#define DRT_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))
#define DRT_IS_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_IS_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_DUPLEX_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))

typedef struct _DrtDuplexChannel DrtDuplexChannel;
typedef struct _DrtDuplexChannelClass DrtDuplexChannelClass;
typedef struct _DrtDuplexChannelPrivate DrtDuplexChannelPrivate;

#define DIORITE_TYPE_SOCKET_CHANNEL (diorite_socket_channel_get_type ())
#define DIORITE_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannel))
#define DIORITE_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannelClass))
#define DIORITE_IS_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_SOCKET_CHANNEL))
#define DIORITE_IS_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_SOCKET_CHANNEL))
#define DIORITE_SOCKET_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannelClass))

typedef struct _DioriteSocketChannel DioriteSocketChannel;
typedef struct _DioriteSocketChannelClass DioriteSocketChannelClass;
typedef struct _DioriteSocketChannelPrivate DioriteSocketChannelPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DrtDuplexChannel {
	GObject parent_instance;
	DrtDuplexChannelPrivate * priv;
};

struct _DrtDuplexChannelClass {
	GObjectClass parent_class;
	void (*close) (DrtDuplexChannel* self, GError** error);
};

struct _DioriteSocketChannel {
	DrtDuplexChannel parent_instance;
	DioriteSocketChannelPrivate * priv;
};

struct _DioriteSocketChannelClass {
	DrtDuplexChannelClass parent_class;
};

struct _DioriteSocketChannelPrivate {
	GSocketConnection* _connection;
	gboolean _can_read;
	gboolean _can_write;
	GSource* socket_source;
};

typedef enum  {
	DIORITE_IO_ERROR_CONN_FAILED,
	DIORITE_IO_ERROR_TIMEOUT,
	DIORITE_IO_ERROR_RW_FAILED,
	DIORITE_IO_ERROR_READ,
	DIORITE_IO_ERROR_WRITE,
	DIORITE_IO_ERROR_TOO_MANY_DATA,
	DIORITE_IO_ERROR_NOT_CONNECTED,
	DIORITE_IO_ERROR_OP_FAILED
} DioriteIOError;
#define DIORITE_IO_ERROR diorite_io_error_quark ()

static gpointer diorite_socket_channel_parent_class = NULL;

GType drt_duplex_channel_get_type (void) G_GNUC_CONST;
GType diorite_socket_channel_get_type (void) G_GNUC_CONST;
#define DIORITE_SOCKET_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannelPrivate))
enum  {
	DIORITE_SOCKET_CHANNEL_DUMMY_PROPERTY,
	DIORITE_SOCKET_CHANNEL_CONNECTION,
	DIORITE_SOCKET_CHANNEL_CAN_READ,
	DIORITE_SOCKET_CHANNEL_CAN_WRITE
};
GSocketConnection* diorite_socket_channel_get_connection (DioriteSocketChannel* self);
static void diorite_socket_channel_on_connection_closed (DioriteSocketChannel* self, GObject* o, GParamSpec* p);
static void _diorite_socket_channel_on_connection_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GSocketConnection* diorite_socket_channel_create_socket_from_name (const gchar* name, GError** error);
gchar* diorite_ipc_create_path (const gchar* name);
DioriteSocketChannel* diorite_socket_channel_new (guint id, const gchar* name, GSocketConnection* connection, guint timeout);
DioriteSocketChannel* diorite_socket_channel_construct (GType object_type, guint id, const gchar* name, GSocketConnection* connection, guint timeout);
DrtDuplexChannel* drt_duplex_channel_construct (GType object_type, guint id, const gchar* name, GInputStream* input, GOutputStream* output, guint timeout);
static void diorite_socket_channel_set_connection (DioriteSocketChannel* self, GSocketConnection* value);
static gboolean diorite_socket_channel_on_socket_source (DioriteSocketChannel* self, GSocket* socket, GIOCondition condition);
static gboolean _diorite_socket_channel_on_socket_source_gsocket_source_func (GSocket* socket, GIOCondition condition, gpointer self);
static void diorite_socket_channel_check_io_condition (DioriteSocketChannel* self);
GQuark diorite_io_error_quark (void);
DioriteSocketChannel* diorite_socket_channel_new_from_name (guint id, const gchar* name, guint timeout, GError** error);
DioriteSocketChannel* diorite_socket_channel_construct_from_name (GType object_type, guint id, const gchar* name, guint timeout, GError** error);
DioriteSocketChannel* diorite_socket_channel_new_from_socket (guint id, GSocket* socket, guint timeout, GError** error);
DioriteSocketChannel* diorite_socket_channel_construct_from_socket (GType object_type, guint id, GSocket* socket, guint timeout, GError** error);
static void diorite_socket_channel_real_close (DrtDuplexChannel* base, GError** error);
void drt_duplex_channel_set_closed (DrtDuplexChannel* self, gboolean value);
static void diorite_socket_channel_set_condition (DioriteSocketChannel* self, GIOCondition condition);
gboolean diorite_flags_is_set (gint value, gint flag);
gboolean diorite_socket_channel_get_can_read (DioriteSocketChannel* self);
static void diorite_socket_channel_set_can_read (DioriteSocketChannel* self, gboolean value);
gboolean diorite_socket_channel_get_can_write (DioriteSocketChannel* self);
static void diorite_socket_channel_set_can_write (DioriteSocketChannel* self, gboolean value);
gboolean drt_duplex_channel_get_closed (DrtDuplexChannel* self);
static void diorite_socket_channel_finalize (GObject * obj);
static void _vala_diorite_socket_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_socket_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _diorite_socket_channel_on_connection_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_on_connection_closed ((DioriteSocketChannel*) self, _sender, pspec);
#line 146 "SocketChannel.c"
}


GSocketConnection* diorite_socket_channel_create_socket_from_name (const gchar* name, GError** error) {
	GSocketConnection* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp2_;
	GUnixSocketAddress* _tmp3_;
	GSocket* socket = NULL;
	GSocket* _tmp4_;
	GSocketConnection* connection = NULL;
	GSocket* _tmp5_;
	GSocketConnection* _tmp6_;
	GSocketConnection* _tmp7_;
	GUnixSocketAddress* _tmp8_;
	GError * _inner_error_ = NULL;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = name;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = diorite_ipc_create_path (_tmp0_);
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	path = _tmp1_;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = path;
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp3_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp2_);
#line 38 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	address = _tmp3_;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp4_ = g_socket_new (G_SOCKET_FAMILY_UNIX, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, &_inner_error_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	socket = _tmp4_;
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_propagate_error (error, _inner_error_);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (address);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_free0 (path);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		return NULL;
#line 194 "SocketChannel.c"
	}
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp5_ = socket;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp6_ = g_socket_connection_factory_create_connection (_tmp5_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	connection = _tmp6_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp7_ = connection;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp8_ = address;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_socket_connection_connect (_tmp7_, (GSocketAddress*) _tmp8_, NULL, &_inner_error_);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_propagate_error (error, _inner_error_);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (connection);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (socket);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (address);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_free0 (path);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		return NULL;
#line 222 "SocketChannel.c"
	}
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	result = connection;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_object_unref0 (socket);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_object_unref0 (address);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_free0 (path);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 234 "SocketChannel.c"
}


static gboolean _diorite_socket_channel_on_socket_source_gsocket_source_func (GSocket* socket, GIOCondition condition, gpointer self) {
	gboolean result;
	result = diorite_socket_channel_on_socket_source ((DioriteSocketChannel*) self, socket, condition);
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 243 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_construct (GType object_type, guint id, const gchar* name, GSocketConnection* connection, guint timeout) {
	DioriteSocketChannel * self = NULL;
	guint _tmp0_;
	const gchar* _tmp1_;
	GSocketConnection* _tmp2_;
	GInputStream* _tmp3_;
	GInputStream* _tmp4_;
	GSocketConnection* _tmp5_;
	GOutputStream* _tmp6_;
	GOutputStream* _tmp7_;
	guint _tmp8_;
	GSocketConnection* _tmp9_;
	GSocketConnection* _tmp10_;
	GSocket* _tmp11_;
	GSocket* _tmp12_;
	GSource* _tmp13_;
	GSource* _tmp14_;
	GSocketConnection* _tmp15_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = id;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = name;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = connection;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp3_ = g_io_stream_get_input_stream ((GIOStream*) _tmp2_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp4_ = _tmp3_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp5_ = connection;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp6_ = g_io_stream_get_output_stream ((GIOStream*) _tmp5_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp7_ = _tmp6_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp8_ = timeout;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self = (DioriteSocketChannel*) drt_duplex_channel_construct (object_type, _tmp0_, _tmp1_, _tmp4_, _tmp7_, _tmp8_);
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp9_ = connection;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_set_connection (self, _tmp9_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp10_ = connection;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp11_ = g_socket_connection_get_socket (_tmp10_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp12_ = _tmp11_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp13_ = g_socket_create_source (_tmp12_, G_IO_IN | G_IO_OUT, NULL);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_source_unref0 (self->priv->socket_source);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self->priv->socket_source = _tmp13_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp14_ = self->priv->socket_source;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_source_set_callback (_tmp14_, (GSourceFunc) _diorite_socket_channel_on_socket_source_gsocket_source_func, g_object_ref (self), g_object_unref);
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_check_io_condition (self);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp15_ = connection;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::closed", (GCallback) _diorite_socket_channel_on_connection_closed_g_object_notify, self, G_CONNECT_AFTER);
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return self;
#line 317 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_new (guint id, const gchar* name, GSocketConnection* connection, guint timeout) {
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return diorite_socket_channel_construct (DIORITE_TYPE_SOCKET_CHANNEL, id, name, connection, timeout);
#line 324 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_construct_from_name (GType object_type, guint id, const gchar* name, guint timeout, GError** error) {
	DioriteSocketChannel * self = NULL;
	GError * _inner_error_ = NULL;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 333 "SocketChannel.c"
	{
		GSocketConnection* connection = NULL;
		const gchar* _tmp0_;
		GSocketConnection* _tmp1_;
		guint _tmp2_;
		const gchar* _tmp3_;
		GSocketConnection* _tmp4_;
		guint _tmp5_;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp0_ = name;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp1_ = diorite_socket_channel_create_socket_from_name (_tmp0_, &_inner_error_);
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		connection = _tmp1_;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 350 "SocketChannel.c"
			goto __catch51_g_error;
		}
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp2_ = id;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp3_ = name;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp4_ = connection;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp5_ = timeout;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		self = (DioriteSocketChannel*) diorite_socket_channel_construct (object_type, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (connection);
#line 365 "SocketChannel.c"
	}
	goto __finally51;
	__catch51_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		e = _inner_error_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_inner_error_ = NULL;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp6_ = name;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp7_ = e;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp8_ = _tmp7_->message;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp9_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", _tmp6_, _tmp8_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_inner_error_ = _tmp9_;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_error_free0 (e);
#line 391 "SocketChannel.c"
		goto __finally51;
	}
	__finally51:
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_propagate_error (error, _inner_error_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			_g_object_unref0 (self);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return NULL;
#line 405 "SocketChannel.c"
		} else {
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_clear_error (&_inner_error_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return NULL;
#line 413 "SocketChannel.c"
		}
	}
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return self;
#line 418 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_new_from_name (guint id, const gchar* name, guint timeout, GError** error) {
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return diorite_socket_channel_construct_from_name (DIORITE_TYPE_SOCKET_CHANNEL, id, name, timeout, error);
#line 425 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_construct_from_socket (GType object_type, guint id, GSocket* socket, guint timeout, GError** error) {
	DioriteSocketChannel * self = NULL;
	gchar* name = NULL;
	GSocket* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (socket != NULL, NULL);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = socket;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = g_socket_get_fd (_tmp0_);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = g_strdup_printf ("fd:%d", _tmp1_);
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	name = _tmp2_;
#line 446 "SocketChannel.c"
	{
		GSocketConnection* connection = NULL;
		GSocket* _tmp3_;
		GSocketConnection* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp3_ = socket;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp4_ = g_socket_connection_factory_create_connection (_tmp3_);
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		connection = _tmp4_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp5_ = id;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp6_ = timeout;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		self = (DioriteSocketChannel*) diorite_socket_channel_construct (object_type, _tmp5_, name, connection, _tmp6_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (connection);
#line 467 "SocketChannel.c"
	}
	goto __finally52;
	__catch52_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		GError* _tmp9_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		e = _inner_error_;
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp7_ = e;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp8_ = _tmp7_->message;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp9_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", name, _tmp8_);
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_inner_error_ = _tmp9_;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_error_free0 (e);
#line 490 "SocketChannel.c"
		goto __finally52;
	}
	__finally52:
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_propagate_error (error, _inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			_g_free0 (name);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			_g_object_unref0 (self);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return NULL;
#line 506 "SocketChannel.c"
		} else {
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			_g_free0 (name);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_clear_error (&_inner_error_);
#line 71 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return NULL;
#line 516 "SocketChannel.c"
		}
	}
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_free0 (name);
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return self;
#line 523 "SocketChannel.c"
}


DioriteSocketChannel* diorite_socket_channel_new_from_socket (guint id, GSocket* socket, guint timeout, GError** error) {
#line 68 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return diorite_socket_channel_construct_from_socket (DIORITE_TYPE_SOCKET_CHANNEL, id, socket, timeout, error);
#line 530 "SocketChannel.c"
}


static void diorite_socket_channel_real_close (DrtDuplexChannel* base, GError** error) {
	DioriteSocketChannel * self;
	GSocketConnection* _tmp0_;
	GError * _inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self = (DioriteSocketChannel*) base;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	drt_duplex_channel_set_closed ((DrtDuplexChannel*) self, TRUE);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_connection;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_io_stream_close ((GIOStream*) _tmp0_, NULL, &_inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		if (_inner_error_->domain == G_IO_ERROR) {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_propagate_error (error, _inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return;
#line 554 "SocketChannel.c"
		} else {
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			g_clear_error (&_inner_error_);
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
			return;
#line 562 "SocketChannel.c"
		}
	}
}


static void diorite_socket_channel_check_io_condition (DioriteSocketChannel* self) {
	GIOCondition condition = 0;
	GSocketConnection* _tmp0_;
	GSocket* _tmp1_;
	GSocket* _tmp2_;
	GIOCondition _tmp3_;
	GSource* _tmp4_;
	GMainContext* _tmp5_;
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_connection;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = g_socket_connection_get_socket (_tmp0_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = _tmp1_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp3_ = g_socket_condition_check (_tmp2_, G_IO_IN | G_IO_OUT);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	condition = _tmp3_;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_set_condition (self, condition);
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp4_ = self->priv->socket_source;
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp5_ = g_main_context_default ();
#line 97 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_source_attach (_tmp4_, _tmp5_);
#line 596 "SocketChannel.c"
}


static void diorite_socket_channel_set_condition (DioriteSocketChannel* self, GIOCondition condition) {
	gboolean read = FALSE;
	GIOCondition _tmp0_;
	gboolean _tmp1_;
	gboolean write = FALSE;
	GIOCondition _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 100 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = condition;
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = diorite_flags_is_set ((gint) _tmp0_, (gint) G_IO_IN);
#line 102 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	read = _tmp1_;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = condition;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp3_ = diorite_flags_is_set ((gint) _tmp2_, (gint) G_IO_OUT);
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	write = _tmp3_;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp4_ = self->priv->_can_read;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp5_ = read;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (_tmp4_ != _tmp5_) {
#line 631 "SocketChannel.c"
		gboolean _tmp6_;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp6_ = read;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		diorite_socket_channel_set_can_read (self, _tmp6_);
#line 637 "SocketChannel.c"
	}
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp7_ = self->priv->_can_write;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp8_ = write;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (_tmp7_ != _tmp8_) {
#line 645 "SocketChannel.c"
		gboolean _tmp9_;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp9_ = write;
#line 107 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		diorite_socket_channel_set_can_write (self, _tmp9_);
#line 651 "SocketChannel.c"
	}
}


static gboolean diorite_socket_channel_on_socket_source (DioriteSocketChannel* self, GSocket* socket, GIOCondition condition) {
	gboolean result = FALSE;
	GIOCondition _tmp0_;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (socket != NULL, FALSE);
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = condition;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_set_condition (self, _tmp0_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	result = FALSE;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 671 "SocketChannel.c"
}


static void diorite_socket_channel_on_connection_closed (DioriteSocketChannel* self, GObject* o, GParamSpec* p) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSocketConnection* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (o != NULL);
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (p != NULL);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = drt_duplex_channel_get_closed ((DrtDuplexChannel*) self);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp1_ = _tmp0_;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp2_ = self->priv->_connection;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_object_get ((GIOStream*) _tmp2_, "closed", &_tmp3_, NULL);
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp4_ = _tmp3_;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (_tmp1_ != _tmp4_) {
#line 699 "SocketChannel.c"
		GSocketConnection* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp5_ = self->priv->_connection;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_object_get ((GIOStream*) _tmp5_, "closed", &_tmp6_, NULL);
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp7_ = _tmp6_;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		drt_duplex_channel_set_closed ((DrtDuplexChannel*) self, _tmp7_);
#line 711 "SocketChannel.c"
	}
}


GSocketConnection* diorite_socket_channel_get_connection (DioriteSocketChannel* self) {
	GSocketConnection* result;
	GSocketConnection* _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_connection;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 727 "SocketChannel.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return self ? g_object_ref (self) : NULL;
#line 734 "SocketChannel.c"
}


static void diorite_socket_channel_set_connection (DioriteSocketChannel* self, GSocketConnection* value) {
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (diorite_socket_channel_get_connection (self) != value) {
#line 743 "SocketChannel.c"
		GSocketConnection* _tmp0_;
		GSocketConnection* _tmp1_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp0_ = value;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_g_object_unref0 (self->priv->_connection);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		self->priv->_connection = _tmp1_;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_object_notify ((GObject *) self, "connection");
#line 756 "SocketChannel.c"
	}
}


gboolean diorite_socket_channel_get_can_read (DioriteSocketChannel* self) {
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_can_read;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 772 "SocketChannel.c"
}


static void diorite_socket_channel_set_can_read (DioriteSocketChannel* self, gboolean value) {
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (diorite_socket_channel_get_can_read (self) != value) {
#line 781 "SocketChannel.c"
		gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp0_ = value;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		self->priv->_can_read = _tmp0_;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_object_notify ((GObject *) self, "can-read");
#line 789 "SocketChannel.c"
	}
}


gboolean diorite_socket_channel_get_can_write (DioriteSocketChannel* self) {
	gboolean result;
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_can_write;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	return result;
#line 805 "SocketChannel.c"
}


static void diorite_socket_channel_set_can_write (DioriteSocketChannel* self, gboolean value) {
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	if (diorite_socket_channel_get_can_write (self) != value) {
#line 814 "SocketChannel.c"
		gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		_tmp0_ = value;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		self->priv->_can_write = _tmp0_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_object_notify ((GObject *) self, "can-write");
#line 822 "SocketChannel.c"
	}
}


static void diorite_socket_channel_class_init (DioriteSocketChannelClass * klass) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	diorite_socket_channel_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_type_class_add_private (klass, sizeof (DioriteSocketChannelPrivate));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	((DrtDuplexChannelClass *) klass)->close = (void (*) (DrtDuplexChannel *, GError**)) diorite_socket_channel_real_close;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_socket_channel_get_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_socket_channel_set_property;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_socket_channel_finalize;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SOCKET_CHANNEL_CONNECTION, g_param_spec_object ("connection", "connection", "connection", g_socket_connection_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SOCKET_CHANNEL_CAN_READ, g_param_spec_boolean ("can-read", "can-read", "can-read", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_SOCKET_CHANNEL_CAN_WRITE, g_param_spec_boolean ("can-write", "can-write", "can-write", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 846 "SocketChannel.c"
}


static void diorite_socket_channel_instance_init (DioriteSocketChannel * self) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self->priv = DIORITE_SOCKET_CHANNEL_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self->priv->_can_read = FALSE;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self->priv->_can_write = FALSE;
#line 857 "SocketChannel.c"
}


static void diorite_socket_channel_finalize (GObject * obj) {
	DioriteSocketChannel * self;
	GSocketConnection* _tmp0_;
	guint _tmp1_;
	GQuark _tmp2_;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannel);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_tmp0_ = self->priv->_connection;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_signal_parse_name ("notify::closed", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _diorite_socket_channel_on_connection_closed_g_object_notify, self);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_object_unref0 (self->priv->_connection);
#line 33 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	_g_source_unref0 (self->priv->socket_source);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	G_OBJECT_CLASS (diorite_socket_channel_parent_class)->finalize (obj);
#line 880 "SocketChannel.c"
}


GType diorite_socket_channel_get_type (void) {
	static volatile gsize diorite_socket_channel_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_socket_channel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteSocketChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_socket_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteSocketChannel), 0, (GInstanceInitFunc) diorite_socket_channel_instance_init, NULL };
		GType diorite_socket_channel_type_id;
		diorite_socket_channel_type_id = g_type_register_static (DRT_TYPE_DUPLEX_CHANNEL, "DioriteSocketChannel", &g_define_type_info, 0);
		g_once_init_leave (&diorite_socket_channel_type_id__volatile, diorite_socket_channel_type_id);
	}
	return diorite_socket_channel_type_id__volatile;
}


static void _vala_diorite_socket_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteSocketChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannel);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CONNECTION:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_value_set_object (value, diorite_socket_channel_get_connection (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CAN_READ:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_value_set_boolean (value, diorite_socket_channel_get_can_read (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CAN_WRITE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		g_value_set_boolean (value, diorite_socket_channel_get_can_write (self));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 919 "SocketChannel.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 925 "SocketChannel.c"
	}
}


static void _vala_diorite_socket_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteSocketChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_SOCKET_CHANNEL, DioriteSocketChannel);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CONNECTION:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		diorite_socket_channel_set_connection (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CAN_READ:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		diorite_socket_channel_set_can_read (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		case DIORITE_SOCKET_CHANNEL_CAN_WRITE:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		diorite_socket_channel_set_can_write (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 953 "SocketChannel.c"
		default:
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/SocketChannel.vala"
		break;
#line 959 "SocketChannel.c"
	}
}



