/* String.c generated by valac 0.36.3, the Vala compiler
 * generated from String.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))



gboolean diorite_string_is_empty (const gchar* str);
gchar* diorite_string_null_if_empty (const gchar* str);
GSList* diorite_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens);
GSList* diorite_string_array_to_slist (gchar** array, int array_length1, gboolean strip);
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
GHashTable* diorite_string_semicolon_separated_set (const gchar* dataset, gboolean lowercase);
gint diorite_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gint diorite_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gchar* diorite_string_unmask (guint8* data, int data_length1);
gint diorite_string_utf16_strlen (const gchar* str);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Check whether string is empty, i.e. `null` or `""`.
 * 
 * @param str    string to test
 * @return true if string is empty, false otherwise
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 76 "String.c"
}


inline gboolean diorite_string_is_empty (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = str;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp1_ == NULL) {
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp0_ = TRUE;
#line 90 "String.c"
	} else {
		const gchar* _tmp2_;
		gchar _tmp3_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp2_ = str;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp3_ = string_get (_tmp2_, (glong) 0);
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp0_ = _tmp3_ == '\0';
#line 100 "String.c"
	}
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 106 "String.c"
}


/**
 * Ensure string is not empty but either non-empty or null
 * 
 * @param str    original string
 * @return original string if it isn't empty, null otherwise
 */
inline gchar* diorite_string_null_if_empty (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp6_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = str;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp2_ == NULL) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp1_ = TRUE;
#line 128 "String.c"
	} else {
		const gchar* _tmp3_;
		gchar _tmp4_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp3_ = str;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp4_ = string_get (_tmp3_, (glong) 0);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp1_ = _tmp4_ == '\0';
#line 138 "String.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp1_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp0_ = NULL;
#line 144 "String.c"
	} else {
		const gchar* _tmp5_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = str;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp0_ = _tmp5_;
#line 151 "String.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp6_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 159 "String.c"
}


/**	
 * Splits a string into a maximum of `max_tokens` pieces, using the given `delimiter` and ignoring
 * empty elements after stripping.
 * 
 * If `max_tokens` is reached, the remainder of string is appended to the last token.
 * 
 * @param data          a string to split
 * @param delimiter     a string which specifies the places at which to split the string. The delimiter is not
 *                      included in any of the resulting strings, unless `max_tokens` is reached.
 * @param max_tokens    the maximum number of pieces to split string into. If this is less than 1, the string 
 *                      is split completely.
 * @return resulting list of strings
 */
GSList* diorite_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens) {
	GSList* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GSList* _tmp8_;
	GSList* _tmp9_;
#line 62 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	g_return_val_if_fail (delimiter != NULL, NULL);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = data;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = diorite_string_is_empty (_tmp0_);
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp1_) {
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		result = NULL;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		return result;
#line 201 "String.c"
	}
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = data;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp3_ = delimiter;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp4_ = max_tokens;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp2_, _tmp3_, _tmp4_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp7_ = _tmp6_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp8_ = diorite_string_array_to_slist (_tmp7_, _vala_array_length (_tmp5_), TRUE);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp9_ = _tmp8_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp9_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 225 "String.c"
}


/**
 * Creates list from array of strings
 * 
 * @param array    string array
 * @param strip    strip array elements and ignore empty elements
 * @return resulting list of strings
 */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1207 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1208 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1208 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1209 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1209 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1210 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _result_;
#line 1210 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 255 "String.c"
}


static void _g_free0_ (gpointer var) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	var = (g_free (var), NULL);
#line 262 "String.c"
}


static void _g_slist_free__g_free0_ (GSList* self) {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	g_slist_free (self);
#line 271 "String.c"
}


GSList* diorite_string_array_to_slist (gchar** array, int array_length1, gboolean strip) {
	GSList* result = NULL;
	GSList* _result_ = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GSList* _tmp11_;
#line 79 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = NULL;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = array;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0__length1 = array_length1;
#line 287 "String.c"
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		item_collection = _tmp0_;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		item_collection_length1 = _tmp0__length1;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		for (item_it = 0; item_it < _tmp0__length1; item_it = item_it + 1) {
#line 299 "String.c"
			const gchar* item = NULL;
#line 80 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			item = item_collection[item_it];
#line 303 "String.c"
			{
				gboolean _tmp1_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp1_ = strip;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				if (!_tmp1_) {
#line 310 "String.c"
					const gchar* _tmp2_;
					gchar* _tmp3_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp2_ = item;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp3_ = g_strdup (_tmp2_);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_result_ = g_slist_prepend (_result_, _tmp3_);
#line 319 "String.c"
				} else {
					const gchar* _tmp4_;
					gboolean _tmp5_;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp4_ = item;
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp5_ = diorite_string_is_empty (_tmp4_);
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					if (!_tmp5_) {
#line 329 "String.c"
						gchar* stripped_item = NULL;
						const gchar* _tmp6_;
						gchar* _tmp7_;
						const gchar* _tmp8_;
						gboolean _tmp9_;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp6_ = item;
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp7_ = string_strip (_tmp6_);
#line 88 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						stripped_item = _tmp7_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp8_ = stripped_item;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp9_ = diorite_string_is_empty (_tmp8_);
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						if (!_tmp9_) {
#line 347 "String.c"
							gchar* _tmp10_;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp10_ = stripped_item;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							stripped_item = NULL;
#line 90 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_result_ = g_slist_prepend (_result_, _tmp10_);
#line 355 "String.c"
						}
#line 86 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_g_free0 (stripped_item);
#line 359 "String.c"
					}
				}
			}
		}
	}
#line 93 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = g_slist_reverse (_result_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp11_ = _result_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = NULL;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp11_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	__g_slist_free__g_free0_0 (_result_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 377 "String.c"
}


/**
 * Parse a string containing semicolon-separated set of items
 * 
 * @param dataset    semicolon-separated set of items
 * @return a set data structurecontaining all unique items from data set
 */
GHashTable* diorite_string_semicolon_separated_set (const gchar* dataset, gboolean lowercase) {
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = g_str_hash;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = g_str_equal;
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
#line 105 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = _tmp2_;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp3_ = dataset;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp4_ = diorite_string_is_empty (_tmp3_);
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (!_tmp4_) {
#line 409 "String.c"
		gchar** items = NULL;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint items_length1;
		gint _items_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = dataset;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ";", 0);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		items = _tmp7_;
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		items_length1 = _vala_array_length (_tmp6_);
#line 108 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_items_size_ = items_length1;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp8_ = items;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp8__length1 = items_length1;
#line 432 "String.c"
		{
			gchar** item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			item_collection = _tmp8_;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			item_collection_length1 = _tmp8__length1;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			for (item_it = 0; item_it < _tmp8__length1; item_it = item_it + 1) {
#line 444 "String.c"
				gchar* _tmp9_;
				gchar* item = NULL;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp9_ = g_strdup (item_collection[item_it]);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				item = _tmp9_;
#line 451 "String.c"
				{
					const gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar _tmp13_;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp10_ = item;
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp11_ = string_strip (_tmp10_);
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_g_free0 (item);
#line 111 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					item = _tmp11_;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp12_ = item;
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp13_ = string_get (_tmp12_, (glong) 0);
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					if (((gint) _tmp13_) != 0) {
#line 471 "String.c"
						gchar* _tmp14_ = NULL;
						gboolean _tmp15_;
						GHashTable* _tmp20_;
						gchar* _tmp21_;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp15_ = lowercase;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						if (_tmp15_) {
#line 480 "String.c"
							const gchar* _tmp16_;
							gchar* _tmp17_;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp16_ = item;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_g_free0 (_tmp14_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp14_ = _tmp17_;
#line 491 "String.c"
						} else {
							const gchar* _tmp18_;
							gchar* _tmp19_;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp18_ = item;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp19_ = g_strdup (_tmp18_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_g_free0 (_tmp14_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
							_tmp14_ = _tmp19_;
#line 503 "String.c"
						}
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp20_ = _result_;
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_tmp21_ = g_strdup (_tmp14_);
#line 113 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						g_hash_table_add (_tmp20_, _tmp21_);
#line 112 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
						_g_free0 (_tmp14_);
#line 513 "String.c"
					}
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_g_free0 (item);
#line 517 "String.c"
				}
			}
		}
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_free), NULL);
#line 523 "String.c"
	}
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _result_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 529 "String.c"
}


gint diorite_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = str;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = start_index;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = len;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp3_ = c;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp4_ = g_utf8_strchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = _tmp4_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp6_ = _result_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp6_ != NULL) {
#line 561 "String.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp7_ = _result_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp8_ = str;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
#line 570 "String.c"
	} else {
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = -1;
#line 574 "String.c"
	}
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp5_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 580 "String.c"
}


gint diorite_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = str;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = start_index;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = len;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp3_ = c;
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp4_ = g_utf8_strrchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
#line 127 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = _tmp4_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp6_ = _result_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp6_ != NULL) {
#line 612 "String.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp7_ = _result_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp8_ = str;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
#line 621 "String.c"
	} else {
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp5_ = -1;
#line 625 "String.c"
	}
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp5_;
#line 128 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 631 "String.c"
}


gchar* diorite_string_unmask (guint8* data, int data_length1) {
	gchar* result = NULL;
	gint length = 0;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	guint8 shift = 0U;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8 _tmp3_;
	guint8* _result_ = NULL;
	gint _tmp4_;
	guint8* _tmp5_;
	gint _result__length1;
	gint __result__size_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8 _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
#line 133 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = data;
#line 133 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0__length1 = data_length1;
#line 133 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	length = _tmp0__length1;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = length;
#line 134 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp1_ < 2) {
#line 135 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		result = NULL;
#line 135 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		return result;
#line 671 "String.c"
	}
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2_ = data;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp2__length1 = data_length1;
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp3_ = _tmp2_[0];
#line 136 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	shift = _tmp3_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp4_ = length;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp5_ = g_new0 (guint8, _tmp4_);
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = _tmp5_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result__length1 = _tmp4_;
#line 137 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	__result__size_ = _result__length1;
#line 691 "String.c"
	{
		gint i = 0;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		i = 1;
#line 696 "String.c"
		{
			gboolean _tmp6_ = FALSE;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			_tmp6_ = TRUE;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			while (TRUE) {
#line 703 "String.c"
				gint _tmp8_;
				gint _tmp9_;
				guint8 _tmp10_;
				guint8* _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				guint8 _tmp13_;
				guint8* _tmp14_;
				gint _tmp14__length1;
				gint _tmp15_;
				guint8* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				guint8 _tmp20_;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				if (!_tmp6_) {
#line 722 "String.c"
					gint _tmp7_;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_tmp7_ = i;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					i = _tmp7_ + 1;
#line 728 "String.c"
				}
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp6_ = FALSE;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp8_ = i;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp9_ = length;
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 138 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					break;
#line 740 "String.c"
				}
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp10_ = shift;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp11_ = data;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp11__length1 = data_length1;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp12_ = i;
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp13_ = _tmp11_[_tmp12_];
#line 140 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				if (_tmp10_ > _tmp13_) {
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					result = NULL;
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					_result_ = (g_free (_result_), NULL);
#line 141 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
					return result;
#line 760 "String.c"
				}
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp14_ = _result_;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp14__length1 = _result__length1;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp15_ = i;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp16_ = data;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp16__length1 = data_length1;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp17_ = i;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp18_ = _tmp16_[_tmp17_];
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp19_ = shift;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp14_[_tmp15_ - 1] = _tmp18_ - _tmp19_;
#line 142 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
				_tmp20_ = _tmp14_[_tmp15_ - 1];
#line 782 "String.c"
			}
		}
	}
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp21_ = _result_;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp21__length1 = _result__length1;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp22_ = length;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp21_[_tmp22_] = (guint8) 0;
#line 144 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp23_ = _tmp21_[_tmp22_];
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp24_ = _result_;
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp24__length1 = _result__length1;
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp25_ = g_strdup ((const gchar*) _tmp24_);
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = _tmp25_;
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_result_ = (g_free (_result_), NULL);
#line 145 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 808 "String.c"
}


/**
 * Return the number of UTF-16 code points to store given string.
 * 
 * It corresponds to JavaScript's String.length.
 * 
 * @param str    a string
 * @return a number of UTF-16 code points
 */
static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_;
	gunichar _tmp1_;
	gunichar _tmp2_;
#line 1105 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1106 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = *index;
#line 1106 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1106 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_vala_c = _tmp1_;
#line 1107 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp2_ = _vala_c;
#line 1107 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (_tmp2_ != ((gunichar) 0)) {
#line 838 "String.c"
		gint _tmp3_;
		gchar* _tmp4_;
#line 1108 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp3_ = *index;
#line 1108 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
#line 1108 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp4_ - ((gchar*) self));
#line 1109 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1109 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (c) {
#line 1109 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 853 "String.c"
		}
#line 1109 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 857 "String.c"
	} else {
#line 1111 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1111 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (c) {
#line 1111 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 865 "String.c"
		}
#line 1111 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 869 "String.c"
	}
#line 1105 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (c) {
#line 1105 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 875 "String.c"
	}
}


gint diorite_string_utf16_strlen (const gchar* str) {
	gint result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gint len = 0;
	gunichar c = 0U;
	gint i = 0;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp0_ = str;
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	_tmp1_ = diorite_string_is_empty (_tmp0_);
#line 158 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	if (_tmp1_) {
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		result = 0;
#line 159 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		return result;
#line 897 "String.c"
	}
#line 160 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	len = 0;
#line 161 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	c = (gunichar) 0;
#line 162 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	i = 0;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	while (TRUE) {
#line 907 "String.c"
		const gchar* _tmp2_;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint _tmp5_ = 0;
		gunichar _tmp6_;
		gint _tmp7_;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp2_ = str;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		c = _tmp3_;
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		if (!_tmp4_) {
#line 163 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			break;
#line 924 "String.c"
		}
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp6_ = c;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		if (((guint) _tmp6_) <= ((guint) 0xFFFF)) {
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			_tmp5_ = 1;
#line 932 "String.c"
		} else {
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
			_tmp5_ = 2;
#line 936 "String.c"
		}
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		_tmp7_ = len;
#line 164 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
		len = _tmp7_ + _tmp5_;
#line 942 "String.c"
	}
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	result = len;
#line 165 "/builddir/build/BUILD/diorite-4.4.0/src/glib/String.vala"
	return result;
#line 948 "String.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 955 "String.c"
		int i;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
				destroy_func (((gpointer*) array)[i]);
#line 963 "String.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	g_free (array);
#line 975 "String.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	if (array) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
		while (((gpointer*) array)[length]) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
			length++;
#line 988 "String.c"
		}
	}
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/glib/BaseBus.vala"
	return length;
#line 993 "String.c"
}



