/* X11.c generated by valac 0.36.3, the Vala compiler
 * generated from X11.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



GdkX11Window* diorite_x11_get_window_property_as_win (GdkWindow* window, const gchar* property);
gchar* diorite_x11_get_window_property_as_utf8 (GdkWindow* window, const gchar* property);
GdkX11Window* diorite_x11_get_net_wm_check_window (void);


/**
 * Retrieve window property of type window.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as {@link Gdk.X11.Window} on success,
 *                    null on failure such as invalid ``window``, non-existent ``property``
 *                    or different property type than {@link X.XA_WINDOW}.
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	return self ? g_object_ref (self) : NULL;
#line 62 "X11.c"
}


GdkX11Window* diorite_x11_get_window_property_as_win (GdkWindow* window, const gchar* property) {
	GdkX11Window* result = NULL;
	GdkX11Window* win = NULL;
	GdkX11Window* _result_ = NULL;
	GdkWindow* _tmp0_;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkX11Display* _tmp7_;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	GdkX11Display* _tmp8_;
	GdkX11Display* _tmp9_;
	Display* _tmp10_;
	GdkX11Window* _tmp11_;
	Window _tmp12_;
	GdkX11Display* _tmp13_;
	const gchar* _tmp14_;
	Atom _tmp15_;
	Atom _tmp16_ = {0};
	gint _tmp17_ = 0;
	gulong _tmp18_ = 0UL;
	gulong _tmp19_ = 0UL;
	void* _tmp20_ = NULL;
	GdkX11Display* _tmp21_;
	Atom _tmp22_;
	void* _tmp27_;
#line 37 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	g_return_val_if_fail (property != NULL, NULL);
#line 39 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_result_ = NULL;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp0_ = window;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp0_ != NULL) {
#line 104 "X11.c"
		GdkWindow* _tmp1_;
		GdkX11Window* _tmp2_;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp1_ = window;
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (win);
#line 41 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		win = _tmp2_;
#line 115 "X11.c"
	} else {
		GdkWindow* _tmp3_;
		GdkX11Window* _tmp4_;
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp3_ = gdk_get_default_root_window ();
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp3_) : NULL);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (win);
#line 43 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		win = _tmp4_;
#line 127 "X11.c"
	}
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp5_ = win;
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp6_ = gdk_window_get_display ((GdkWindow*) _tmp5_);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp6_) : NULL);
#line 44 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	display = _tmp7_;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp8_ = display;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	gdk_x11_display_error_trap_push (_tmp8_);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp9_ = display;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp10_ = gdk_x11_display_get_xdisplay (_tmp9_);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp11_ = win;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp12_ = gdk_x11_window_get_xid (_tmp11_);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp13_ = display;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp14_ = property;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp15_ = gdk_x11_get_xatom_by_name_for_display (_tmp13_, _tmp14_);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	XGetWindowProperty (_tmp10_, _tmp12_, _tmp15_, (glong) 0, G_MAXLONG, FALSE, XA_WINDOW, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_, (unsigned char **) (&_tmp20_));
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	type = _tmp16_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	format = _tmp17_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	n_items = _tmp18_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	bytes_after = _tmp19_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	data = _tmp20_;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp21_ = display;
#line 56 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	gdk_x11_display_error_trap_pop_ignored (_tmp21_);
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp22_ = type;
#line 58 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp22_ == XA_WINDOW) {
#line 175 "X11.c"
		Window xwin = 0;
		void* _tmp23_;
		GdkX11Display* _tmp24_;
		Window _tmp25_;
		GdkX11Window* _tmp26_;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp23_ = data;
#line 60 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		xwin = *((Window*) _tmp23_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp24_ = display;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp25_ = xwin;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp26_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp24_, _tmp25_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (_result_);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_result_ = _tmp26_;
#line 195 "X11.c"
	}
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp27_ = data;
#line 64 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp27_ != NULL) {
#line 201 "X11.c"
		void* _tmp28_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp28_ = data;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		XFree (_tmp28_);
#line 207 "X11.c"
	}
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	result = _result_;
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_g_object_unref0 (display);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_g_object_unref0 (win);
#line 66 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	return result;
#line 217 "X11.c"
}


/**
 * Retrieve window property of type UTF-8 string.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as string on success,
 *                    null on failure such as invalid ``window`` or non-existent ``property``.
 */
gchar* diorite_x11_get_window_property_as_utf8 (GdkWindow* window, const gchar* property) {
	gchar* result = NULL;
	GdkX11Window* win = NULL;
	GdkWindow* _tmp0_;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkX11Display* _tmp7_;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gchar* name = NULL;
	GdkX11Display* _tmp8_;
	GdkX11Display* _tmp9_;
	Display* _tmp10_;
	GdkX11Window* _tmp11_;
	Window _tmp12_;
	GdkX11Display* _tmp13_;
	const gchar* _tmp14_;
	Atom _tmp15_;
	GdkX11Display* _tmp16_;
	Atom _tmp17_;
	Atom _tmp18_ = {0};
	gint _tmp19_ = 0;
	gulong _tmp20_ = 0UL;
	gulong _tmp21_ = 0UL;
	void* _tmp22_ = NULL;
	GdkX11Display* _tmp23_;
	void* _tmp24_;
#line 78 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	g_return_val_if_fail (property != NULL, NULL);
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp0_ = window;
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp0_ != NULL) {
#line 266 "X11.c"
		GdkWindow* _tmp1_;
		GdkX11Window* _tmp2_;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp1_ = window;
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (win);
#line 82 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		win = _tmp2_;
#line 277 "X11.c"
	} else {
		GdkWindow* _tmp3_;
		GdkX11Window* _tmp4_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp3_ = gdk_get_default_root_window ();
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp3_) : NULL);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (win);
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		win = _tmp4_;
#line 289 "X11.c"
	}
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp5_ = win;
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp6_ = gdk_window_get_display ((GdkWindow*) _tmp5_);
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp6_) : NULL);
#line 85 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	display = _tmp7_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	name = NULL;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp8_ = display;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	gdk_x11_display_error_trap_push (_tmp8_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp9_ = display;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp10_ = gdk_x11_display_get_xdisplay (_tmp9_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp11_ = win;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp12_ = gdk_x11_window_get_xid (_tmp11_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp13_ = display;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp14_ = property;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp15_ = gdk_x11_get_xatom_by_name_for_display (_tmp13_, _tmp14_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp16_ = display;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp17_ = gdk_x11_get_xatom_by_name_for_display (_tmp16_, "UTF8_STRING");
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	XGetWindowProperty (_tmp10_, _tmp12_, _tmp15_, (glong) 0, G_MAXLONG, FALSE, _tmp17_, &_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_, (unsigned char **) (&_tmp22_));
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	type = _tmp18_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	format = _tmp19_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	n_items = _tmp20_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	bytes_after = _tmp21_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	data = _tmp22_;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp23_ = display;
#line 99 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	gdk_x11_display_error_trap_pop_ignored (_tmp23_);
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp24_ = data;
#line 101 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp24_ != NULL) {
#line 343 "X11.c"
		void* _tmp25_;
		gchar* _tmp26_;
		void* _tmp27_;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp25_ = data;
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp26_ = g_strdup ((const gchar*) _tmp25_);
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_free0 (name);
#line 103 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		name = _tmp26_;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_tmp27_ = data;
#line 104 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		XFree (_tmp27_);
#line 359 "X11.c"
	}
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	result = name;
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_g_object_unref0 (display);
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_g_object_unref0 (win);
#line 106 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	return result;
#line 369 "X11.c"
}


/**
 * Retrieve WM_CHECK Window of a compliant window manager
 * 
 * See [[http://standards.freedesktop.org/wm-spec/1.3/ar01s03.html|Extended Window Manager Hints]].
 * 
 * @return    WM_CHECK Window of a compliant window manager of null if there is not any
 */
GdkX11Window* diorite_x11_get_net_wm_check_window (void) {
	GdkX11Window* result = NULL;
	GdkX11Window* window = NULL;
	GdkX11Window* _tmp0_;
	GdkX11Window* _tmp1_;
	GdkX11Window* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkX11Window* _tmp4_;
	Window _tmp5_;
	GdkX11Window* _tmp6_;
	Window _tmp7_;
	gboolean _tmp8_;
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp0_ = diorite_x11_get_window_property_as_win (NULL, "_NET_SUPPORTING_WM_CHECK");
#line 119 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	window = _tmp0_;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp1_ = window;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp1_ == NULL) {
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		result = NULL;
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (window);
#line 121 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		return result;
#line 406 "X11.c"
	}
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp2_ = window;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp3_ = diorite_x11_get_window_property_as_win ((GdkWindow*) _tmp2_, "_NET_SUPPORTING_WM_CHECK");
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp4_ = _tmp3_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp5_ = gdk_x11_window_get_xid (_tmp4_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp6_ = window;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp7_ = gdk_x11_window_get_xid (_tmp6_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_tmp8_ = _tmp5_ != _tmp7_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	_g_object_unref0 (_tmp4_);
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	if (_tmp8_) {
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		result = NULL;
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		_g_object_unref0 (window);
#line 123 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
		return result;
#line 432 "X11.c"
	}
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	result = window;
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/X11.vala"
	return result;
#line 438 "X11.c"
}



