/* io.c generated by valac 0.36.3, the Vala compiler
 * generated from io.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gio/gunixsocketaddress.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DIORITE_IO_ERROR_CONN_FAILED,
	DIORITE_IO_ERROR_TIMEOUT,
	DIORITE_IO_ERROR_RW_FAILED,
	DIORITE_IO_ERROR_READ,
	DIORITE_IO_ERROR_WRITE,
	DIORITE_IO_ERROR_TOO_MANY_DATA,
	DIORITE_IO_ERROR_NOT_CONNECTED,
	DIORITE_IO_ERROR_OP_FAILED
} DioriteIOError;
#define DIORITE_IO_ERROR diorite_io_error_quark ()


GQuark diorite_io_error_quark (void);
GSocketService* diorite_create_socket_service (const gchar* path, GError** error);
GSocketConnection* diorite_create_socket_connection (const gchar* path, GCancellable* cancellable, GError** error);


GSocketService* diorite_create_socket_service (const gchar* path, GError** error) {
	GSocketService* result = NULL;
	const gchar* _tmp0_;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp1_;
	GUnixSocketAddress* _tmp2_;
	GSocketService* service = NULL;
	GSocketService* _tmp3_;
	GSocketAddress* effective_address = NULL;
	GError * _inner_error_ = NULL;
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_tmp0_ = path;
#line 30 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	unlink (_tmp0_);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_tmp1_ = path;
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_tmp2_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp1_);
#line 31 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	address = _tmp2_;
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_tmp3_ = g_socket_service_new ();
#line 32 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	service = _tmp3_;
#line 84 "io.c"
	{
		GSocketService* _tmp4_;
		GUnixSocketAddress* _tmp5_;
		GSocketAddress* _tmp6_ = NULL;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp4_ = service;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp5_ = address;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		g_socket_listener_add_address ((GSocketListener*) _tmp4_, (GSocketAddress*) _tmp5_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, NULL, &_tmp6_, &_inner_error_);
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_g_object_unref0 (effective_address);
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		effective_address = _tmp6_;
#line 36 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 101 "io.c"
			goto __catch63_g_error;
		}
	}
	goto __finally63;
	__catch63_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		e = _inner_error_;
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_inner_error_ = NULL;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp7_ = path;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp8_ = e;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp9_ = _tmp8_->message;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp10_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to add socket '%s'. %s", _tmp7_, _tmp9_);
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_inner_error_ = _tmp10_;
#line 40 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_g_error_free0 (e);
#line 129 "io.c"
		goto __finally63;
	}
	__finally63:
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		if (_inner_error_->domain == DIORITE_IO_ERROR) {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			g_propagate_error (error, _inner_error_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (effective_address);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (service);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (address);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			return NULL;
#line 147 "io.c"
		} else {
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (effective_address);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (service);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (address);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			g_clear_error (&_inner_error_);
#line 34 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			return NULL;
#line 161 "io.c"
		}
	}
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	result = service;
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_g_object_unref0 (effective_address);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	_g_object_unref0 (address);
#line 42 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	return result;
#line 172 "io.c"
}


GSocketConnection* diorite_create_socket_connection (const gchar* path, GCancellable* cancellable, GError** error) {
	GSocketConnection* result = NULL;
	GError * _inner_error_ = NULL;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 181 "io.c"
	{
		GUnixSocketAddress* address = NULL;
		const gchar* _tmp0_;
		GUnixSocketAddress* _tmp1_;
		GSocket* socket = NULL;
		GSocket* _tmp2_;
		GSocketConnection* connection = NULL;
		GSocket* _tmp3_;
		GSocketConnection* _tmp4_;
		GSocketConnection* _tmp5_;
		GUnixSocketAddress* _tmp6_;
		GCancellable* _tmp7_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp0_ = path;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp1_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp0_);
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		address = _tmp1_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp2_ = g_socket_new (G_SOCKET_FAMILY_UNIX, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, &_inner_error_);
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		socket = _tmp2_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (address);
#line 208 "io.c"
			goto __catch64_g_error;
		}
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp3_ = socket;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp4_ = g_socket_connection_factory_create_connection (_tmp3_);
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		connection = _tmp4_;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp5_ = connection;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp6_ = address;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp7_ = cancellable;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		g_socket_connection_connect (_tmp5_, (GSocketAddress*) _tmp6_, _tmp7_, &_inner_error_);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (connection);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (socket);
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
			_g_object_unref0 (address);
#line 233 "io.c"
			goto __catch64_g_error;
		}
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		result = connection;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_g_object_unref0 (socket);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_g_object_unref0 (address);
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		return result;
#line 244 "io.c"
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		e = _inner_error_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp8_ = path;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp9_ = e;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp10_ = _tmp9_->message;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_tmp11_ = g_error_new (DIORITE_IO_ERROR, DIORITE_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", _tmp8_, _tmp10_);
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_inner_error_ = _tmp11_;
#line 57 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		_g_error_free0 (e);
#line 270 "io.c"
		goto __finally64;
	}
	__finally64:
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
	if (_inner_error_->domain == DIORITE_IO_ERROR) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		g_propagate_error (error, _inner_error_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		return NULL;
#line 280 "io.c"
	} else {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/glib/io.vala"
		return NULL;
#line 288 "io.c"
	}
}



