/* main.c generated by valac 0.36.3, the Vala compiler
 * generated from main.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()


GQuark dioritedb_database_error_quark (void);
gboolean dioritedb_is_type_supported (GType* type);
static gboolean _g_type_equal (const GType * s1, const GType * s2);
GParamSpec** dioritedb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error);
gint dioritedb_convert_error (sqlite3* db, gint _result_, const gchar* sql, sqlite3_stmt* stm, GError** error);
void dioritedb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error);
gchar* dioritedb_escape_sql_id (const gchar* sql);


GQuark dioritedb_database_error_quark (void) {
#line 28 "/builddir/build/BUILD/diorite-4.4.0/src/db/Result.vala"
	return g_quark_from_static_string ("dioritedb_database_error-quark");
#line 70 "main.c"
}


static gboolean _g_type_equal (const GType * s1, const GType * s2) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (s1 == s2) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		return TRUE;
#line 79 "main.c"
	}
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (s1 == NULL) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		return FALSE;
#line 85 "main.c"
	}
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (s2 == NULL) {
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		return FALSE;
#line 91 "main.c"
	}
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	return (*s1) == (*s2);
#line 95 "main.c"
}


gboolean dioritedb_is_type_supported (GType* type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GType* _tmp9_;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp9_ = type;
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp9_ == NULL) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp8_ = TRUE;
#line 117 "main.c"
	} else {
		GType* _tmp10_;
		GType _tmp11_;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp10_ = type;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp11_ = G_TYPE_BOOLEAN;
#line 47 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp8_ = _g_type_equal (_tmp10_, &_tmp11_) == TRUE;
#line 127 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp8_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp7_ = TRUE;
#line 133 "main.c"
	} else {
		GType* _tmp12_;
		GType _tmp13_;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp12_ = type;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp13_ = G_TYPE_INT;
#line 48 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp7_ = _g_type_equal (_tmp12_, &_tmp13_) == TRUE;
#line 143 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp7_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = TRUE;
#line 149 "main.c"
	} else {
		GType* _tmp14_;
		GType _tmp15_;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp14_ = type;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp15_ = G_TYPE_INT64;
#line 49 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = _g_type_equal (_tmp14_, &_tmp15_) == TRUE;
#line 159 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp6_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp5_ = TRUE;
#line 165 "main.c"
	} else {
		GType* _tmp16_;
		GType _tmp17_;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp16_ = type;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp17_ = G_TYPE_STRING;
#line 50 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp5_ = _g_type_equal (_tmp16_, &_tmp17_) == TRUE;
#line 175 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp5_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp4_ = TRUE;
#line 181 "main.c"
	} else {
		GType* _tmp18_;
		GType _tmp19_;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp18_ = type;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp19_ = G_TYPE_DOUBLE;
#line 51 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp4_ = _g_type_equal (_tmp18_, &_tmp19_) == TRUE;
#line 191 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp4_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp3_ = TRUE;
#line 197 "main.c"
	} else {
		GType* _tmp20_;
		GType _tmp21_;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp20_ = type;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp21_ = G_TYPE_FLOAT;
#line 52 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp3_ = _g_type_equal (_tmp20_, &_tmp21_) == TRUE;
#line 207 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp3_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = TRUE;
#line 213 "main.c"
	} else {
		GType* _tmp22_;
		GType _tmp23_;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp22_ = type;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp23_ = G_TYPE_BYTES;
#line 53 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = _g_type_equal (_tmp22_, &_tmp23_) == TRUE;
#line 223 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp2_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp1_ = TRUE;
#line 229 "main.c"
	} else {
		GType* _tmp24_;
		GType _tmp25_;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp24_ = type;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp25_ = G_TYPE_BYTE_ARRAY;
#line 54 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp1_ = _g_type_equal (_tmp24_, &_tmp25_) == TRUE;
#line 239 "main.c"
	}
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp1_) {
#line 46 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = TRUE;
#line 245 "main.c"
	} else {
		GType* _tmp26_;
		GType _tmp27_;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp26_ = type;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp27_ = G_TYPE_POINTER;
#line 55 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = _g_type_equal (_tmp26_, &_tmp27_) == TRUE;
#line 255 "main.c"
	}
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	return result;
#line 261 "main.c"
}


GParamSpec** dioritedb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error) {
	GParamSpec** result = NULL;
	GParamSpec** properties_list = NULL;
	gint properties_list_length1 = 0;
	gint _properties_list_size_ = 0;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_;
	gint _tmp1__length1;
	GParamSpec** _tmp27_;
	gint _tmp27__length1;
	GError * _inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	g_return_val_if_fail (class_spec != NULL, NULL);
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp1_ = properties;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp1__length1 = properties_length1;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp1_ == NULL) {
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = TRUE;
#line 286 "main.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = properties;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2__length1 = properties_length1;
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = _tmp2__length1 == 0;
#line 296 "main.c"
	}
#line 63 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp0_) {
#line 300 "main.c"
		GObjectClass* _tmp3_;
		guint _tmp4_;
		GParamSpec** _tmp5_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp3_ = class_spec;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp5_ = g_object_class_list_properties (_tmp3_, &_tmp4_);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list = (g_free (properties_list), NULL);
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list = _tmp5_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list_length1 = _tmp4_;
#line 65 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_properties_list_size_ = properties_list_length1;
#line 316 "main.c"
	} else {
		gchar** _tmp6_;
		gint _tmp6__length1;
		GParamSpec** _tmp7_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = properties;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6__length1 = properties_length1;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp7_ = g_new0 (GParamSpec*, _tmp6__length1 + 1);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list = (g_free (properties_list), NULL);
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list = _tmp7_;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		properties_list_length1 = _tmp6__length1;
#line 69 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_properties_list_size_ = properties_list_length1;
#line 335 "main.c"
		{
			gint i = 0;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			i = 0;
#line 340 "main.c"
			{
				gboolean _tmp8_ = FALSE;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
				_tmp8_ = TRUE;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
				while (TRUE) {
#line 347 "main.c"
					gint _tmp10_;
					gchar** _tmp11_;
					gint _tmp11__length1;
					GParamSpec** _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_;
					GObjectClass* _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
					gint _tmp16_;
					const gchar* _tmp17_;
					GParamSpec* _tmp18_;
					GParamSpec* _tmp19_;
					GParamSpec** _tmp20_;
					gint _tmp20__length1;
					gint _tmp21_;
					GParamSpec* _tmp22_;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					if (!_tmp8_) {
#line 367 "main.c"
						gint _tmp9_;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp9_ = i;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						i = _tmp9_ + 1;
#line 373 "main.c"
					}
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp8_ = FALSE;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp10_ = i;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp11_ = properties;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp11__length1 = properties_length1;
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					if (!(_tmp10_ < _tmp11__length1)) {
#line 70 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						break;
#line 387 "main.c"
					}
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp12_ = properties_list;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp12__length1 = properties_list_length1;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp13_ = i;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp14_ = class_spec;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp15_ = properties;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp15__length1 = properties_length1;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp16_ = i;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp17_ = _tmp15_[_tmp16_];
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp18_ = g_object_class_find_property (_tmp14_, _tmp17_);
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp12_[_tmp13_] = _tmp18_;
#line 72 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp19_ = _tmp12_[_tmp13_];
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp20_ = properties_list;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp20__length1 = properties_list_length1;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp21_ = i;
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					_tmp22_ = _tmp20_[_tmp21_];
#line 73 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
					if (_tmp22_ == NULL) {
#line 421 "main.c"
						gchar** _tmp23_;
						gint _tmp23__length1;
						gint _tmp24_;
						const gchar* _tmp25_;
						GError* _tmp26_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp23_ = properties;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp23__length1 = properties_length1;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp24_ = i;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp25_ = _tmp23_[_tmp24_];
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_tmp26_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_NAME, "There is no property named '%s'.", _tmp25_);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						_inner_error_ = _tmp26_;
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
						if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							g_propagate_error (error, _inner_error_);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							properties_list = (g_free (properties_list), NULL);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							return NULL;
#line 447 "main.c"
						} else {
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							properties_list = (g_free (properties_list), NULL);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
							return NULL;
#line 457 "main.c"
						}
					}
				}
			}
		}
	}
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp27_ = properties_list;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp27__length1 = properties_list_length1;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (result_length1) {
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		*result_length1 = _tmp27__length1;
#line 472 "main.c"
	}
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	result = _tmp27_;
#line 77 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	return result;
#line 478 "main.c"
}


gint dioritedb_convert_error (sqlite3* db, gint _result_, const gchar* sql, sqlite3_stmt* stm, GError** error) {
	gint result = 0;
	gint _tmp0_;
	const gchar* _tmp2_ = NULL;
	sqlite3* _tmp3_;
	const gchar* _tmp6_ = NULL;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_;
	gchar* msg = NULL;
	gint _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	GError* _tmp15_;
	GError * _inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp0_ = _result_;
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	switch (_tmp0_) {
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		case SQLITE_OK:
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		case SQLITE_ROW:
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		case SQLITE_DONE:
#line 507 "main.c"
		{
			gint _tmp1_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			_tmp1_ = _result_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			result = _tmp1_;
#line 89 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			return result;
#line 516 "main.c"
		}
		default:
#line 84 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		break;
#line 521 "main.c"
	}
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp3_ = db;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp3_ != NULL) {
#line 527 "main.c"
		sqlite3* _tmp4_;
		const gchar* _tmp5_;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp4_ = db;
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp5_ = sqlite3_errmsg (_tmp4_);
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = _tmp5_;
#line 536 "main.c"
	} else {
#line 94 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = "(unknown database)";
#line 540 "main.c"
	}
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp7_ = stm;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp7_ != NULL) {
#line 546 "main.c"
		sqlite3_stmt* _tmp8_;
		const gchar* _tmp9_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp8_ = stm;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp9_ = sqlite3_sql (_tmp8_);
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = _tmp9_;
#line 555 "main.c"
	} else {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = NULL;
#line 559 "main.c"
	}
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp11_ = sql;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp10_ = _tmp11_;
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp10_ == NULL) {
#line 95 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp10_ = _tmp6_;
#line 569 "main.c"
	}
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp12_ = _result_;
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp13_ = g_strdup_printf ("SQLite Error %d: %s. |%s|", _tmp12_, _tmp2_, _tmp10_);
#line 92 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	msg = _tmp13_;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp14_ = msg;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp15_ = g_error_new_literal (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_GENERAL, _tmp14_);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_inner_error_ = _tmp15_;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
#line 585 "main.c"
		gint _tmp16_ = 0;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		g_propagate_error (error, _inner_error_);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_g_free0 (msg);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		return _tmp16_;
#line 593 "main.c"
	} else {
		gint _tmp17_ = 0;
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_g_free0 (msg);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		g_clear_error (&_inner_error_);
#line 96 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		return _tmp17_;
#line 604 "main.c"
	}
#line 81 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_g_free0 (msg);
#line 608 "main.c"
}


/**
 * Usage:
 * 
 * {{{
 * throw_if_cancelled(cancellable, GLib.Log.METHOD, GLib.Log.FILE, GLib.Log.LINE);
 * }}}
 */
void dioritedb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error) {
	gboolean _tmp0_ = FALSE;
	GCancellable* _tmp1_;
	GError * _inner_error_ = NULL;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp1_ = cancellable;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp1_ != NULL) {
#line 627 "main.c"
		GCancellable* _tmp2_;
		gboolean _tmp3_;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp2_ = cancellable;
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp3_ = g_cancellable_is_cancelled (_tmp2_);
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = _tmp3_;
#line 636 "main.c"
	} else {
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp0_ = FALSE;
#line 640 "main.c"
	}
#line 109 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	if (_tmp0_) {
#line 644 "main.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		GError* _tmp7_;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp4_ = method;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp5_ = file;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp6_ = line;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_tmp7_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Operation was cancelled in %s (%s:%d).", _tmp4_, _tmp5_, _tmp6_);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		_inner_error_ = _tmp7_;
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
		if (_inner_error_->domain == G_IO_ERROR) {
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			g_propagate_error (error, _inner_error_);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			return;
#line 665 "main.c"
		} else {
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
			return;
#line 673 "main.c"
		}
	}
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1380 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 688 "main.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 719 "main.c"
				goto __catch6_g_regex_error;
			}
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1382 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			return NULL;
#line 728 "main.c"
		}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 744 "main.c"
				goto __catch6_g_regex_error;
			}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
			return NULL;
#line 755 "main.c"
		}
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1383 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return result;
#line 769 "main.c"
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1385 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 783 "main.c"
	}
	__finally6:
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1381 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
		return NULL;
#line 794 "main.c"
	}
}


inline gchar* dioritedb_escape_sql_id (const gchar* sql) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	g_return_val_if_fail (sql != NULL, NULL);
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp0_ = sql;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	_tmp1_ = string_replace (_tmp0_, "\"", "\"\"");
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	result = _tmp1_;
#line 116 "/builddir/build/BUILD/diorite-4.4.0/src/db/main.vala"
	return result;
#line 813 "main.c"
}



