/* RichTextBuffer.c generated by valac 0.36.3, the Vala compiler
 * generated from RichTextBuffer.vala, do not modify */

/*
 * Copyright 2012-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <dioriteglib4.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <pango/pango.h>


#define DIORITE_TYPE_RICH_TEXT_BUFFER (diorite_rich_text_buffer_get_type ())
#define DIORITE_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBuffer))
#define DIORITE_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBufferClass))
#define DIORITE_IS_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_RICH_TEXT_BUFFER))
#define DIORITE_IS_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_RICH_TEXT_BUFFER))
#define DIORITE_RICH_TEXT_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBufferClass))

typedef struct _DioriteRichTextBuffer DioriteRichTextBuffer;
typedef struct _DioriteRichTextBufferClass DioriteRichTextBufferClass;
typedef struct _DioriteRichTextBufferPrivate DioriteRichTextBufferPrivate;
typedef struct _DioriteRichTextBufferTag DioriteRichTextBufferTag;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __g_queue_free__diorite_rich_text_buffer_tag_free0_0(var) ((var == NULL) ? NULL : (var = (_g_queue_free__diorite_rich_text_buffer_tag_free0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_markup_parse_context_unref0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_unref (var), NULL)))

#define DIORITE_TYPE_RICH_TEXT_LINK (diorite_rich_text_link_get_type ())
#define DIORITE_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLink))
#define DIORITE_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLinkClass))
#define DIORITE_IS_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_RICH_TEXT_LINK))
#define DIORITE_IS_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_RICH_TEXT_LINK))
#define DIORITE_RICH_TEXT_LINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLinkClass))

typedef struct _DioriteRichTextLink DioriteRichTextLink;
typedef struct _DioriteRichTextLinkClass DioriteRichTextLinkClass;
#define _diorite_rich_text_buffer_tag_free0(var) ((var == NULL) ? NULL : (var = (diorite_rich_text_buffer_tag_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	DIORITE_RICH_TEXT_BUFFER_IMAGE_REQUESTED_SIGNAL,
	DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_OPENED_SIGNAL,
	DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_CLOSED_SIGNAL,
	DIORITE_RICH_TEXT_BUFFER_LAST_SIGNAL
};
static guint diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_LAST_SIGNAL] = {0};
typedef struct _DioriteRichTextLinkPrivate DioriteRichTextLinkPrivate;

typedef gchar* (*DioriteImageLocator) (const gchar* uri, void* user_data);
struct _DioriteRichTextBuffer {
	GtkTextBuffer parent_instance;
	DioriteRichTextBufferPrivate * priv;
};

struct _DioriteRichTextBufferClass {
	GtkTextBufferClass parent_class;
	void (*image_requested) (DioriteRichTextBuffer* self, const gchar* uri, gint width, gint height);
};

struct _DioriteRichTextBufferPrivate {
	GdkRGBA* _link_color;
	DioriteImageLocator _image_locator;
	gpointer _image_locator_target;
	GDestroyNotify _image_locator_target_destroy_notify;
	GRegex* strip_spaces;
	gboolean insert_new_line;
	gboolean strip_left;
	gboolean in_paragraph;
	gboolean ignore_text;
	GQueue* tag_stack;
	GtkTextTag* tag_bold;
	GtkTextTag* tag_italic;
	GtkTextTag* tag_h1;
	GtkTextTag* tag_h2;
	GtkTextTag* tag_h3;
	GtkTextTag* tag_para;
	GtkTextTag* tag_dl;
	GtkTextTag* tag_dt;
	GtkTextTag* tag_dd;
	GtkTextTag* tag_ul;
	GtkTextTag* tag_li;
};

struct _DioriteRichTextBufferTag {
	gchar* name;
	GtkTextMark* mark;
	GtkTextTag* tag;
};

struct _DioriteRichTextLink {
	GtkTextTag parent_instance;
	DioriteRichTextLinkPrivate * priv;
};

struct _DioriteRichTextLinkClass {
	GtkTextTagClass parent_class;
};

struct _DioriteRichTextLinkPrivate {
	gchar* _uri;
};


static gpointer diorite_rich_text_buffer_parent_class = NULL;
static gpointer diorite_rich_text_link_parent_class = NULL;

GType diorite_rich_text_buffer_get_type (void) G_GNUC_CONST;
static void diorite_rich_text_buffer_tag_free (DioriteRichTextBufferTag * self);
#define DIORITE_RICH_TEXT_BUFFER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBufferPrivate))
enum  {
	DIORITE_RICH_TEXT_BUFFER_DUMMY_PROPERTY
};
static void _diorite_rich_text_buffer_tag_free0_ (gpointer var);
static void _g_queue_free__diorite_rich_text_buffer_tag_free0_ (GQueue* self);
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING1 "h1"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING2 "h2"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING3 "h3"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_PARAGRAPH "p"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_BOLD "b"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_ITALIC "i"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION_LIST "dl"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINED_TERM "dt"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION "dd"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_UNORDERED_LIST "ul"
#define DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_LIST_ITEM "li"
#define DIORITE_RICH_TEXT_BUFFER_IMAGE_PATH "path"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1 "h1"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2 "h2"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3 "h3"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_PARA "p"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK "br"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_BOLD "b"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_STRONG "strong"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC "i"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_EM "em"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINK "a"
#define DIORITE_RICH_TEXT_BUFFER_LINK_TARGET "href"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DL "dl"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DT "dt"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DD "dd"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE "img"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_UL "ul"
#define DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LI "li"
static void diorite_rich_text_buffer_start_tag (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, gchar** attr_names, int attr_names_length1, gchar** attr_values, int attr_values_length1, GError** error);
static void _diorite_rich_text_buffer_start_tag_gmarkup_parser_start_element_func (GMarkupParseContext* context, const gchar* element_name, gchar** attribute_names, gchar** attribute_values, gpointer self, GError** error);
static void diorite_rich_text_buffer_end_tag (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, GError** error);
static void _diorite_rich_text_buffer_end_tag_gmarkup_parser_end_element_func (GMarkupParseContext* context, const gchar* element_name, gpointer self, GError** error);
static void diorite_rich_text_buffer_element_text (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* text, gsize text_len, GError** error);
static void _diorite_rich_text_buffer_element_text_gmarkup_parser_text_func (GMarkupParseContext* context, const gchar* text, gsize text_len, gpointer self, GError** error);
DioriteRichTextBuffer* diorite_rich_text_buffer_new_with_table (GtkTextTagTable* tag_table);
DioriteRichTextBuffer* diorite_rich_text_buffer_construct_with_table (GType object_type, GtkTextTagTable* tag_table);
DioriteRichTextBuffer* diorite_rich_text_buffer_new (void);
DioriteRichTextBuffer* diorite_rich_text_buffer_construct (GType object_type);
gchar* diorite_rich_text_buffer_default_image_locator (DioriteRichTextBuffer* self, const gchar* uri);
void diorite_rich_text_buffer_load_from_file (DioriteRichTextBuffer* self, GFile* doc_file, GError** error);
void diorite_rich_text_buffer_clear (DioriteRichTextBuffer* self);
void diorite_rich_text_buffer_append_from_file (DioriteRichTextBuffer* self, GFile* doc_file, GError** error);
void diorite_rich_text_buffer_append (DioriteRichTextBuffer* self, const gchar* doc_text, GError** error);
void diorite_rich_text_buffer_load (DioriteRichTextBuffer* self, const gchar* doc_text, GError** error);
static void __lambda8_ (void);
static void ___lambda8__gdestroy_notify (void* data);
static gchar* diorite_rich_text_buffer_norm_whitespace (DioriteRichTextBuffer* self, const gchar* text);
void diorite_rich_text_buffer_append_tag_to_stack (DioriteRichTextBuffer* self, const gchar* name, GtkTextTag* text_tag);
GType diorite_rich_text_link_get_type (void) G_GNUC_CONST;
static DioriteRichTextLink* diorite_rich_text_buffer_create_link_tag (DioriteRichTextBuffer* self, const gchar* uri);
static DioriteRichTextBufferTag* diorite_rich_text_buffer_tag_new (const gchar* name, GtkTextMark* mark, GtkTextTag* tag);
void diorite_rich_text_buffer_close_tag_from_stack (DioriteRichTextBuffer* self, const gchar* name, GError** error);
DioriteRichTextLink* diorite_rich_text_link_new (const gchar* uri);
DioriteRichTextLink* diorite_rich_text_link_construct (GType object_type, const gchar* uri);
GdkRGBA* diorite_rich_text_buffer_get_link_color (DioriteRichTextBuffer* self);
static void diorite_rich_text_buffer_find_link_and_set_color (DioriteRichTextBuffer* self, GtkTextTag* tag);
static GdkPixbuf* diorite_rich_text_buffer_get_missing_image_pixbuf (DioriteRichTextBuffer* self);
void diorite_rich_text_buffer_insert_image_at_cursor (DioriteRichTextBuffer* self, const gchar* path, gint width, gint height);
static gboolean* _bool_dup (gboolean* self);
void diorite_rich_text_buffer_insert_pixbuf_at_cursor (DioriteRichTextBuffer* self, GdkPixbuf* pixbuf);
void diorite_rich_text_buffer_set_link_color (DioriteRichTextBuffer* self, GdkRGBA* value);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
static void _diorite_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach (GtkTextTag* tag, gpointer self);
DioriteImageLocator diorite_rich_text_buffer_get_image_locator (DioriteRichTextBuffer* self, gpointer* result_target);
void diorite_rich_text_buffer_set_image_locator (DioriteRichTextBuffer* self, DioriteImageLocator value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
static void diorite_rich_text_buffer_real_image_requested (DioriteRichTextBuffer* self, const gchar* uri, gint width, gint height);
static void g_cclosure_user_marshal_VOID__STRING_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * diorite_rich_text_buffer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gchar* _diorite_rich_text_buffer_default_image_locator_diorite_image_locator (const gchar* uri, gpointer self);
static void diorite_rich_text_buffer_tag_instance_init (DioriteRichTextBufferTag * self);
static void diorite_rich_text_buffer_finalize (GObject * obj);
static void _vala_diorite_rich_text_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_rich_text_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define DIORITE_RICH_TEXT_LINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLinkPrivate))
enum  {
	DIORITE_RICH_TEXT_LINK_DUMMY_PROPERTY,
	DIORITE_RICH_TEXT_LINK_URI
};
const gchar* diorite_rich_text_link_get_uri (DioriteRichTextLink* self);
void diorite_rich_text_link_set_uri (DioriteRichTextLink* self, const gchar* value);
static void diorite_rich_text_link_finalize (GObject * obj);
static void _vala_diorite_rich_text_link_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_rich_text_link_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gint _vala_array_length (gpointer array);

static const GMarkupParser DIORITE_RICH_TEXT_BUFFER_parser = {_diorite_rich_text_buffer_start_tag_gmarkup_parser_start_element_func, _diorite_rich_text_buffer_end_tag_gmarkup_parser_end_element_func, _diorite_rich_text_buffer_element_text_gmarkup_parser_text_func, NULL, NULL};

static void _diorite_rich_text_buffer_tag_free0_ (gpointer var) {
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	(var == NULL) ? NULL : (var = (diorite_rich_text_buffer_tag_free (var), NULL));
#line 236 "RichTextBuffer.c"
}


static void _g_queue_free__diorite_rich_text_buffer_tag_free0_ (GQueue* self) {
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_queue_foreach (self, (GFunc) _diorite_rich_text_buffer_tag_free0_, NULL);
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_queue_free (self);
#line 245 "RichTextBuffer.c"
}


static void _diorite_rich_text_buffer_start_tag_gmarkup_parser_start_element_func (GMarkupParseContext* context, const gchar* element_name, gchar** attribute_names, gchar** attribute_values, gpointer self, GError** error) {
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_start_tag ((DioriteRichTextBuffer*) self, context, element_name, attribute_names, _vala_array_length (attribute_names), attribute_values, _vala_array_length (attribute_values), error);
#line 252 "RichTextBuffer.c"
}


static void _diorite_rich_text_buffer_end_tag_gmarkup_parser_end_element_func (GMarkupParseContext* context, const gchar* element_name, gpointer self, GError** error) {
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_end_tag ((DioriteRichTextBuffer*) self, context, element_name, error);
#line 259 "RichTextBuffer.c"
}


static void _diorite_rich_text_buffer_element_text_gmarkup_parser_text_func (GMarkupParseContext* context, const gchar* text, gsize text_len, gpointer self, GError** error) {
#line 150 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_element_text ((DioriteRichTextBuffer*) self, context, text, text_len, error);
#line 266 "RichTextBuffer.c"
}


/**
 * Creates new Simple Document Buffer.
 * 
 * @param tag_table    Custom text table.!
 */
DioriteRichTextBuffer* diorite_rich_text_buffer_construct_with_table (GType object_type, GtkTextTagTable* tag_table) {
	DioriteRichTextBuffer * self = NULL;
	GtkTextTagTable* _tmp0_;
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (tag_table != NULL, NULL);
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = tag_table;
#line 177 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = (DioriteRichTextBuffer*) g_object_new (object_type, "tag-table", _tmp0_, NULL);
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self;
#line 286 "RichTextBuffer.c"
}


DioriteRichTextBuffer* diorite_rich_text_buffer_new_with_table (GtkTextTagTable* tag_table) {
#line 175 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return diorite_rich_text_buffer_construct_with_table (DIORITE_TYPE_RICH_TEXT_BUFFER, tag_table);
#line 293 "RichTextBuffer.c"
}


/**
 * Creates new Simple Document Buffer.
 */
DioriteRichTextBuffer* diorite_rich_text_buffer_construct (GType object_type) {
	DioriteRichTextBuffer * self = NULL;
#line 185 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = (DioriteRichTextBuffer*) g_object_new (object_type, NULL);
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self;
#line 306 "RichTextBuffer.c"
}


DioriteRichTextBuffer* diorite_rich_text_buffer_new (void) {
#line 183 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return diorite_rich_text_buffer_construct (DIORITE_TYPE_RICH_TEXT_BUFFER);
#line 313 "RichTextBuffer.c"
}


gchar* diorite_rich_text_buffer_default_image_locator (DioriteRichTextBuffer* self, const gchar* uri) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = uri;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = _tmp1_;
#line 230 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 333 "RichTextBuffer.c"
}


/**
 * Loads document from file.
 * 
 * @param doc_file    document file to load
 * @throws MarkupError on failure
 */
void diorite_rich_text_buffer_load_from_file (DioriteRichTextBuffer* self, GFile* doc_file, GError** error) {
	GFile* _tmp0_;
	GError * _inner_error_ = NULL;
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (doc_file != NULL);
#line 260 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_clear (self);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = doc_file;
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_append_from_file (self, _tmp0_, &_inner_error_);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 364 "RichTextBuffer.c"
		} else {
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 261 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 372 "RichTextBuffer.c"
		}
	}
}


/**
 * Appends content of a document from file.
 * 
 * @param doc_file    document file to load
 * @throws MarkupError on failure
 */
void diorite_rich_text_buffer_append_from_file (DioriteRichTextBuffer* self, GFile* doc_file, GError** error) {
	gchar* doc_text = NULL;
	GError * _inner_error_ = NULL;
#line 270 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 270 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (doc_file != NULL);
#line 391 "RichTextBuffer.c"
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = doc_file;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = diorite_system_read_file (_tmp1_, &_inner_error_);
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = _tmp2_;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 405 "RichTextBuffer.c"
			goto __catch4_g_error;
		}
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = _tmp0_;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = NULL;
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (doc_text);
#line 275 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		doc_text = _tmp3_;
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_tmp0_);
#line 418 "RichTextBuffer.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		e = _inner_error_;
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = NULL;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = doc_file;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp6_ = _tmp5_;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = g_error_new (G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT, "Unable to read file %s.", _tmp6_);
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp8_ = _tmp7_;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_tmp6_);
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = _tmp8_;
#line 279 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_error_free0 (e);
#line 449 "RichTextBuffer.c"
		goto __finally4;
	}
	__finally4:
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_free0 (doc_text);
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 463 "RichTextBuffer.c"
		} else {
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_free0 (doc_text);
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 273 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 473 "RichTextBuffer.c"
		}
	}
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_append (self, doc_text, &_inner_error_);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_free0 (doc_text);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 488 "RichTextBuffer.c"
		} else {
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_free0 (doc_text);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 281 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 498 "RichTextBuffer.c"
		}
	}
#line 270 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (doc_text);
#line 503 "RichTextBuffer.c"
}


/**
 * Loads a document.
 * 
 * @param doc_text    Content of a document to load.
 * @throws MarkupError on failure
 */
void diorite_rich_text_buffer_load (DioriteRichTextBuffer* self, const gchar* doc_text, GError** error) {
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
#line 290 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 290 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (doc_text != NULL);
#line 292 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_clear (self);
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = doc_text;
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_append (self, _tmp0_, &_inner_error_);
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 534 "RichTextBuffer.c"
		} else {
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 293 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 542 "RichTextBuffer.c"
		}
	}
}


/**
 * Appends content of a document.
 * 
 * @param doc_text    Content of a document to load.
 * @throws MarkupError on failure
 */
static void __lambda8_ (void) {
}


static void ___lambda8__gdestroy_notify (void* data) {
#line 304 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	__lambda8_ ();
#line 561 "RichTextBuffer.c"
}


void diorite_rich_text_buffer_append (DioriteRichTextBuffer* self, const gchar* doc_text, GError** error) {
	GMarkupParseContext* context = NULL;
	GMarkupParseContext* _tmp0_;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 302 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 302 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (doc_text != NULL);
#line 304 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = g_markup_parse_context_new (&DIORITE_RICH_TEXT_BUFFER_parser, 0, self, ___lambda8__gdestroy_notify);
#line 304 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	context = _tmp0_;
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = doc_text;
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_markup_parse_context_parse (context, _tmp1_, (gssize) -1, &_inner_error_);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_markup_parse_context_unref0 (context);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 592 "RichTextBuffer.c"
		} else {
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_markup_parse_context_unref0 (context);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 305 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 602 "RichTextBuffer.c"
		}
	}
#line 302 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_markup_parse_context_unref0 (context);
#line 607 "RichTextBuffer.c"
}


static gchar* diorite_rich_text_buffer_norm_whitespace (DioriteRichTextBuffer* self, const gchar* text) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 308 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 618 "RichTextBuffer.c"
	{
		gchar* _tmp0_ = NULL;
		GRegex* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = self->priv->strip_spaces;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = text;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = g_regex_replace (_tmp1_, _tmp2_, (gssize) -1, 0, " ", 0, &_inner_error_);
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = _tmp3_;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 637 "RichTextBuffer.c"
				goto __catch5_g_regex_error;
			}
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return NULL;
#line 646 "RichTextBuffer.c"
		}
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = _tmp0_;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = NULL;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		result = _tmp4_;
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_tmp0_);
#line 312 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		return result;
#line 658 "RichTextBuffer.c"
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 310 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		e = _inner_error_;
#line 310 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = NULL;
#line 316 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp5_ = e;
#line 316 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp6_ = _tmp5_->message;
#line 316 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_warning ("RichTextBuffer.vala:316: Unable to strip spaces, Regex failed: %s", _tmp6_);
#line 317 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = text;
#line 317 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 317 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		result = _tmp8_;
#line 317 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_error_free0 (e);
#line 317 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		return result;
#line 688 "RichTextBuffer.c"
	}
	__finally5:
#line 310 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 310 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_clear_error (&_inner_error_);
#line 310 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return NULL;
#line 697 "RichTextBuffer.c"
}


/**
 * Clears buffer and resets parser.
 */
void diorite_rich_text_buffer_clear (DioriteRichTextBuffer* self) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	GQueue* _tmp2_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter _tmp3_ = {0};
	GtkTextIter _tmp4_ = {0};
#line 324 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 326 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->insert_new_line = FALSE;
#line 326 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->insert_new_line;
#line 326 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->strip_left = _tmp0_;
#line 326 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = self->priv->strip_left;
#line 326 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->in_paragraph = _tmp1_;
#line 327 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = self->priv->tag_stack;
#line 327 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_queue_clear (_tmp2_);
#line 329 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_get_bounds ((GtkTextBuffer*) self, &_tmp3_, &_tmp4_);
#line 329 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	start = _tmp3_;
#line 329 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	end = _tmp4_;
#line 330 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_delete ((GtkTextBuffer*) self, &start, &end);
#line 736 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_start_tag (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, gchar** attr_names, int attr_names_length1, gchar** attr_values, int attr_values_length1, GError** error) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	GError * _inner_error_ = NULL;
#line 333 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 333 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (context != NULL);
#line 333 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (name != NULL);
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = name;
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = _tmp0_;
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if ((((((_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2))) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3))) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_PARA))) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DL))) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_UL))) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 761 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp4_;
#line 344 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp4_ = self->priv->in_paragraph;
#line 344 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (!_tmp4_) {
#line 769 "RichTextBuffer.c"
					gboolean _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					GQuark _tmp9_ = 0U;
#line 346 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp5_ = self->priv->insert_new_line;
#line 346 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (_tmp5_) {
#line 348 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						self->priv->insert_new_line = FALSE;
#line 349 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
#line 782 "RichTextBuffer.c"
					}
#line 351 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->in_paragraph = TRUE;
#line 352 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->strip_left = TRUE;
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp6_ = name;
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp7_ = _tmp6_;
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp9_ = (NULL == _tmp7_) ? 0 : g_quark_from_string (_tmp7_);
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (_tmp9_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 798 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp10_;
								GtkTextTag* _tmp11_;
#line 356 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp10_ = name;
#line 356 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp11_ = self->priv->tag_h1;
#line 356 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp10_, _tmp11_);
#line 357 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 811 "RichTextBuffer.c"
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2)) {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 817 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp12_;
								GtkTextTag* _tmp13_;
#line 359 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp12_ = name;
#line 359 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp13_ = self->priv->tag_h2;
#line 359 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp12_, _tmp13_);
#line 360 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 830 "RichTextBuffer.c"
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3)) {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 836 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp14_;
								GtkTextTag* _tmp15_;
#line 362 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp14_ = name;
#line 362 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp15_ = self->priv->tag_h3;
#line 362 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp14_, _tmp15_);
#line 363 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 849 "RichTextBuffer.c"
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DL)) {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 855 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp16_;
								GtkTextTag* _tmp17_;
#line 365 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								self->priv->ignore_text = TRUE;
#line 366 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp16_ = name;
#line 366 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp17_ = self->priv->tag_dl;
#line 366 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp16_, _tmp17_);
#line 367 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 870 "RichTextBuffer.c"
							}
						}
					} else if (_tmp9_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_UL)) {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 876 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp18_;
								GtkTextTag* _tmp19_;
#line 369 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								self->priv->ignore_text = TRUE;
#line 370 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp18_ = name;
#line 370 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp19_ = self->priv->tag_ul;
#line 370 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp18_, _tmp19_);
#line 371 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 891 "RichTextBuffer.c"
							}
						}
					} else {
#line 353 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						switch (0) {
#line 897 "RichTextBuffer.c"
							default:
							{
								const gchar* _tmp20_;
								GtkTextTag* _tmp21_;
#line 373 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp20_ = name;
#line 373 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp21_ = self->priv->tag_para;
#line 373 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								diorite_rich_text_buffer_append_tag_to_stack (self, _tmp20_, _tmp21_);
#line 374 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 910 "RichTextBuffer.c"
							}
						}
					}
				} else {
					const gchar* _tmp22_;
#line 379 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp22_ = name;
#line 379 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:379: Ignored start tag: %s", _tmp22_);
#line 920 "RichTextBuffer.c"
				}
#line 381 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 924 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 930 "RichTextBuffer.c"
			default:
			{
#line 383 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
#line 384 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				self->priv->strip_left = TRUE;
#line 385 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 939 "RichTextBuffer.c"
			}
		}
	} else if ((_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_BOLD)) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_STRONG))) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 945 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp23_;
#line 388 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp23_ = self->priv->in_paragraph;
#line 388 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp23_) {
#line 953 "RichTextBuffer.c"
					const gchar* _tmp24_;
					GtkTextTag* _tmp25_;
#line 390 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp24_ = name;
#line 390 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp25_ = self->priv->tag_bold;
#line 390 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp24_, _tmp25_);
#line 962 "RichTextBuffer.c"
				} else {
					const gchar* _tmp26_;
#line 394 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp26_ = name;
#line 394 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:394: Ignored start tag: %s", _tmp26_);
#line 969 "RichTextBuffer.c"
				}
#line 396 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 973 "RichTextBuffer.c"
			}
		}
	} else if ((_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC)) || (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_EM))) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 979 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp27_;
#line 399 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp27_ = self->priv->in_paragraph;
#line 399 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp27_) {
#line 987 "RichTextBuffer.c"
					const gchar* _tmp28_;
					GtkTextTag* _tmp29_;
#line 401 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp28_ = name;
#line 401 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp29_ = self->priv->tag_italic;
#line 401 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp28_, _tmp29_);
#line 996 "RichTextBuffer.c"
				} else {
					const gchar* _tmp30_;
#line 405 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp30_ = name;
#line 405 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:405: Ignored start tag: %s", _tmp30_);
#line 1003 "RichTextBuffer.c"
				}
#line 407 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1007 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINK)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1013 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp31_;
#line 409 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp31_ = self->priv->in_paragraph;
#line 409 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp31_) {
#line 1021 "RichTextBuffer.c"
					gint i = 0;
					gint _tmp39_;
					gchar** _tmp40_;
					gint _tmp40__length1;
					gchar* uri = NULL;
					gchar** _tmp42_;
					gint _tmp42__length1;
					gint _tmp43_;
					const gchar* _tmp44_;
					gchar* _tmp45_;
					const gchar* _tmp46_;
					const gchar* _tmp47_;
					DioriteRichTextLink* _tmp48_;
					{
						gboolean _tmp32_ = FALSE;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						i = 0;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp32_ = TRUE;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						while (TRUE) {
#line 1043 "RichTextBuffer.c"
							gint _tmp34_;
							gchar** _tmp35_;
							gint _tmp35__length1;
							gchar** _tmp36_;
							gint _tmp36__length1;
							gint _tmp37_;
							const gchar* _tmp38_;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (!_tmp32_) {
#line 1053 "RichTextBuffer.c"
								gint _tmp33_;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp33_ = i;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								i = _tmp33_ + 1;
#line 1059 "RichTextBuffer.c"
							}
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp32_ = FALSE;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp34_ = i;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp35_ = attr_names;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp35__length1 = attr_names_length1;
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (!(_tmp34_ < _tmp35__length1)) {
#line 412 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 1073 "RichTextBuffer.c"
							}
#line 414 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp36_ = attr_names;
#line 414 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp36__length1 = attr_names_length1;
#line 414 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp37_ = i;
#line 414 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp38_ = _tmp36_[_tmp37_];
#line 414 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (g_strcmp0 (_tmp38_, DIORITE_RICH_TEXT_BUFFER_LINK_TARGET) == 0) {
#line 415 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 1087 "RichTextBuffer.c"
							}
						}
					}
#line 417 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp39_ = i;
#line 417 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp40_ = attr_values;
#line 417 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp40__length1 = attr_values_length1;
#line 417 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (_tmp39_ >= _tmp40__length1) {
#line 1099 "RichTextBuffer.c"
						GError* _tmp41_;
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp41_ = g_error_new (G_MARKUP_ERROR, G_MARKUP_ERROR_MISSING_ATTRIBUTE, "Missing attribute '%s' for element '%s'.", DIORITE_RICH_TEXT_BUFFER_LINK_TARGET, DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINK);
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_inner_error_ = _tmp41_;
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1111 "RichTextBuffer.c"
						} else {
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 419 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1119 "RichTextBuffer.c"
						}
					}
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp42_ = attr_values;
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp42__length1 = attr_values_length1;
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp43_ = i;
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp44_ = _tmp42_[_tmp43_];
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp45_ = g_strdup (_tmp44_);
#line 421 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					uri = _tmp45_;
#line 422 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp46_ = name;
#line 422 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp47_ = uri;
#line 422 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp48_ = diorite_rich_text_buffer_create_link_tag (self, _tmp47_);
#line 422 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp46_, (GtkTextTag*) _tmp48_);
#line 409 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_g_free0 (uri);
#line 1144 "RichTextBuffer.c"
				} else {
					const gchar* _tmp49_;
#line 426 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp49_ = name;
#line 426 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:426: Ignored start tag: %s", _tmp49_);
#line 1151 "RichTextBuffer.c"
				}
#line 428 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1155 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DT)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1161 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp50_;
#line 430 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp50_ = self->priv->in_paragraph;
#line 430 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp50_) {
#line 1169 "RichTextBuffer.c"
					const gchar* _tmp51_;
					GtkTextTag* _tmp52_;
#line 432 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp51_ = name;
#line 432 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp52_ = self->priv->tag_dt;
#line 432 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp51_, _tmp52_);
#line 433 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = FALSE;
#line 1180 "RichTextBuffer.c"
				} else {
					const gchar* _tmp53_;
#line 437 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp53_ = name;
#line 437 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:437: Ignored start tag: %s", _tmp53_);
#line 1187 "RichTextBuffer.c"
				}
#line 439 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1191 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DD)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1197 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp54_;
#line 441 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp54_ = self->priv->in_paragraph;
#line 441 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp54_) {
#line 1205 "RichTextBuffer.c"
					const gchar* _tmp55_;
					GtkTextTag* _tmp56_;
#line 443 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp55_ = name;
#line 443 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp56_ = self->priv->tag_dd;
#line 443 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp55_, _tmp56_);
#line 444 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = FALSE;
#line 1216 "RichTextBuffer.c"
				} else {
					const gchar* _tmp57_;
#line 448 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp57_ = name;
#line 448 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:448: Ignored start tag: %s", _tmp57_);
#line 1223 "RichTextBuffer.c"
				}
#line 450 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1227 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LI)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1233 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp58_;
#line 452 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp58_ = self->priv->in_paragraph;
#line 452 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp58_) {
#line 1241 "RichTextBuffer.c"
					const gchar* _tmp59_;
					GtkTextTag* _tmp60_;
#line 454 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp59_ = name;
#line 454 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp60_ = self->priv->tag_li;
#line 454 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_append_tag_to_stack (self, _tmp59_, _tmp60_);
#line 455 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "• ", -1);
#line 456 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = FALSE;
#line 1254 "RichTextBuffer.c"
				} else {
					const gchar* _tmp61_;
#line 460 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp61_ = name;
#line 460 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:460: Ignored start tag: %s", _tmp61_);
#line 1261 "RichTextBuffer.c"
				}
#line 462 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1265 "RichTextBuffer.c"
			}
		}
	} else if (_tmp3_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE)) {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1271 "RichTextBuffer.c"
			default:
			{
				gchar* src = NULL;
				gint width = 0;
				gint height = 0;
				const gchar* _tmp84_;
#line 464 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				src = NULL;
#line 465 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				width = -1;
#line 466 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				height = -1;
#line 1284 "RichTextBuffer.c"
				{
					gint j = 0;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					j = 0;
#line 1289 "RichTextBuffer.c"
					{
						gboolean _tmp62_ = FALSE;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp62_ = TRUE;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						while (TRUE) {
#line 1296 "RichTextBuffer.c"
							gint _tmp64_;
							gchar** _tmp65_;
							gint _tmp65__length1;
							gchar** _tmp66_;
							gint _tmp66__length1;
							gint _tmp67_;
							const gchar* _tmp68_;
							const gchar* _tmp69_;
							GQuark _tmp71_ = 0U;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							static GQuark _tmp70_label0 = 0;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							static GQuark _tmp70_label1 = 0;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							static GQuark _tmp70_label2 = 0;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (!_tmp62_) {
#line 1314 "RichTextBuffer.c"
								gint _tmp63_;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								_tmp63_ = j;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								j = _tmp63_ + 1;
#line 1320 "RichTextBuffer.c"
							}
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp62_ = FALSE;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp64_ = j;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp65_ = attr_names;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp65__length1 = attr_names_length1;
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (!(_tmp64_ < _tmp65__length1)) {
#line 468 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								break;
#line 1334 "RichTextBuffer.c"
							}
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp66_ = attr_names;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp66__length1 = attr_names_length1;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp67_ = j;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp68_ = _tmp66_[_tmp67_];
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp69_ = _tmp68_;
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							_tmp71_ = (NULL == _tmp69_) ? 0 : g_quark_from_string (_tmp69_);
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							if (_tmp71_ == ((0 != _tmp70_label0) ? _tmp70_label0 : (_tmp70_label0 = g_quark_from_static_string ("src")))) {
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								switch (0) {
#line 1352 "RichTextBuffer.c"
									default:
									{
										gchar** _tmp72_;
										gint _tmp72__length1;
										gint _tmp73_;
										const gchar* _tmp74_;
										gchar* _tmp75_;
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp72_ = attr_values;
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp72__length1 = attr_values_length1;
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp73_ = j;
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp74_ = _tmp72_[_tmp73_];
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp75_ = g_strdup (_tmp74_);
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_g_free0 (src);
#line 473 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										src = _tmp75_;
#line 474 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										break;
#line 1376 "RichTextBuffer.c"
									}
								}
							} else if (_tmp71_ == ((0 != _tmp70_label1) ? _tmp70_label1 : (_tmp70_label1 = g_quark_from_static_string ("width")))) {
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								switch (0) {
#line 1382 "RichTextBuffer.c"
									default:
									{
										gchar** _tmp76_;
										gint _tmp76__length1;
										gint _tmp77_;
										const gchar* _tmp78_;
										gint _tmp79_;
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp76_ = attr_values;
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp76__length1 = attr_values_length1;
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp77_ = j;
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp78_ = _tmp76_[_tmp77_];
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp79_ = atoi (_tmp78_);
#line 476 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										width = _tmp79_;
#line 477 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										break;
#line 1404 "RichTextBuffer.c"
									}
								}
							} else if (_tmp71_ == ((0 != _tmp70_label2) ? _tmp70_label2 : (_tmp70_label2 = g_quark_from_static_string ("height")))) {
#line 470 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
								switch (0) {
#line 1410 "RichTextBuffer.c"
									default:
									{
										gchar** _tmp80_;
										gint _tmp80__length1;
										gint _tmp81_;
										const gchar* _tmp82_;
										gint _tmp83_;
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp80_ = attr_values;
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp80__length1 = attr_values_length1;
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp81_ = j;
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp82_ = _tmp80_[_tmp81_];
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										_tmp83_ = atoi (_tmp82_);
#line 479 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										height = _tmp83_;
#line 480 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
										break;
#line 1432 "RichTextBuffer.c"
									}
								}
							}
						}
					}
				}
#line 484 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp84_ = src;
#line 484 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp84_ != NULL) {
#line 1443 "RichTextBuffer.c"
					const gchar* _tmp85_;
					gint _tmp86_;
					gint _tmp87_;
#line 485 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp85_ = src;
#line 485 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp86_ = width;
#line 485 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp87_ = height;
#line 485 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_signal_emit (self, diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_IMAGE_REQUESTED_SIGNAL], 0, _tmp85_, _tmp86_, _tmp87_);
#line 1455 "RichTextBuffer.c"
				}
#line 486 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_g_free0 (src);
#line 486 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1461 "RichTextBuffer.c"
			}
		}
	} else {
#line 336 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		switch (0) {
#line 1467 "RichTextBuffer.c"
			default:
			{
				gboolean _tmp88_;
#line 488 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp88_ = self->priv->in_paragraph;
#line 488 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp88_) {
#line 1475 "RichTextBuffer.c"
					const gchar* _tmp89_;
					gchar** _tmp90_;
					gint _tmp90__length1;
					gchar** _tmp91_;
					gint _tmp91__length1;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp89_ = name;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp90_ = attr_names;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp90__length1 = attr_names_length1;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp91_ = attr_values;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp91__length1 = attr_values_length1;
#line 490 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_signal_emit (self, diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_OPENED_SIGNAL], 0, _tmp89_, _tmp90_, _tmp90__length1, _tmp91_, _tmp91__length1);
#line 1493 "RichTextBuffer.c"
				} else {
					const gchar* _tmp92_;
#line 494 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp92_ = name;
#line 494 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_debug ("RichTextBuffer.vala:494: Ignored start tag: %s", _tmp92_);
#line 1500 "RichTextBuffer.c"
				}
#line 496 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				break;
#line 1504 "RichTextBuffer.c"
			}
		}
	}
}


/**
 * Appends tag to a stack at current position.
 * 
 * @param name        tag name
 * @param text_tag    tag format
 */
void diorite_rich_text_buffer_append_tag_to_stack (DioriteRichTextBuffer* self, const gchar* name, GtkTextTag* text_tag) {
	GtkTextIter iter = {0};
	GtkTextIter _tmp0_ = {0};
	DioriteRichTextBufferTag* tag = NULL;
	const gchar* _tmp1_;
	GtkTextIter _tmp2_;
	GtkTextMark* _tmp3_;
	GtkTextTag* _tmp4_;
	DioriteRichTextBufferTag* _tmp5_;
	GQueue* _tmp6_;
	DioriteRichTextBufferTag* _tmp7_;
#line 506 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 506 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (name != NULL);
#line 506 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (text_tag != NULL);
#line 509 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_get_end_iter ((GtkTextBuffer*) self, &_tmp0_);
#line 509 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	iter = _tmp0_;
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = name;
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = iter;
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = gtk_text_buffer_create_mark ((GtkTextBuffer*) self, NULL, &_tmp2_, TRUE);
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp4_ = text_tag;
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp5_ = diorite_rich_text_buffer_tag_new (_tmp1_, _tmp3_, _tmp4_);
#line 510 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	tag = _tmp5_;
#line 511 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp6_ = self->priv->tag_stack;
#line 511 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp7_ = tag;
#line 511 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	tag = NULL;
#line 511 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_queue_push_tail (_tmp6_, _tmp7_);
#line 506 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_diorite_rich_text_buffer_tag_free0 (tag);
#line 1560 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_end_tag (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* name, GError** error) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
#line 514 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 514 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (context != NULL);
#line 514 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (name != NULL);
#line 517 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->in_paragraph;
#line 517 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp0_) {
#line 1577 "RichTextBuffer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		GQuark _tmp4_ = 0U;
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = name;
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = _tmp1_;
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if ((((_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING1)) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING2))) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_HEADING3))) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_PARA))) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1591 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp5_;
#line 525 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
#line 526 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->insert_new_line = TRUE;
#line 527 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->in_paragraph = FALSE;
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp5_ = name;
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_close_tag_from_stack (self, _tmp5_, &_inner_error_);
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1613 "RichTextBuffer.c"
						} else {
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 528 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1621 "RichTextBuffer.c"
						}
					}
#line 529 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = FALSE;
#line 530 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1628 "RichTextBuffer.c"
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DL)) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_UL))) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1634 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp6_;
#line 533 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->insert_new_line = TRUE;
#line 534 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->in_paragraph = FALSE;
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp6_ = name;
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_close_tag_from_stack (self, _tmp6_, &_inner_error_);
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1654 "RichTextBuffer.c"
						} else {
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 535 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1662 "RichTextBuffer.c"
						}
					}
#line 536 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = FALSE;
#line 537 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1669 "RichTextBuffer.c"
				}
			}
		} else if (((((_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_BOLD)) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_STRONG))) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_ITALIC))) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_EM))) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINK))) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1675 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp7_;
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp7_ = name;
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_close_tag_from_stack (self, _tmp7_, &_inner_error_);
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1691 "RichTextBuffer.c"
						} else {
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 543 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1699 "RichTextBuffer.c"
						}
					}
#line 544 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1704 "RichTextBuffer.c"
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DT)) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_DD))) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1710 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp8_;
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp8_ = name;
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_close_tag_from_stack (self, _tmp8_, &_inner_error_);
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1726 "RichTextBuffer.c"
						} else {
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 547 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1734 "RichTextBuffer.c"
						}
					}
#line 548 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
#line 549 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = TRUE;
#line 550 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1743 "RichTextBuffer.c"
				}
			}
		} else if (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LI)) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1749 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp9_;
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp9_ = name;
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					diorite_rich_text_buffer_close_tag_from_stack (self, _tmp9_, &_inner_error_);
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_propagate_error (error, _inner_error_);
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1765 "RichTextBuffer.c"
						} else {
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							g_clear_error (&_inner_error_);
#line 552 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
							return;
#line 1773 "RichTextBuffer.c"
						}
					}
#line 553 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, "\n", -1);
#line 554 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					self->priv->ignore_text = TRUE;
#line 555 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1782 "RichTextBuffer.c"
				}
			}
		} else if ((_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_IMAGE)) || (_tmp4_ == g_quark_from_string (DIORITE_RICH_TEXT_BUFFER_INPUT_TAG_LINE_BREAK))) {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1788 "RichTextBuffer.c"
				default:
				{
#line 558 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1793 "RichTextBuffer.c"
				}
			}
		} else {
#line 519 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			switch (0) {
#line 1799 "RichTextBuffer.c"
				default:
				{
					const gchar* _tmp10_;
#line 560 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp10_ = name;
#line 560 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					g_signal_emit (self, diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_CLOSED_SIGNAL], 0, _tmp10_);
#line 561 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					break;
#line 1809 "RichTextBuffer.c"
				}
			}
		}
	} else {
		const gchar* _tmp11_;
#line 566 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp11_ = name;
#line 566 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_debug ("RichTextBuffer.vala:566: Ignored end tag: %s", _tmp11_);
#line 1819 "RichTextBuffer.c"
	}
}


/**
 * Closes tag from stack and applies its formating.
 * 
 * @param name    tag name
 * @throws MarkupError when name doesn't match nme of the last opened tag.
 */
static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1412 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1413 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = self;
#line 1413 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 1838 "RichTextBuffer.c"
}


void diorite_rich_text_buffer_close_tag_from_stack (DioriteRichTextBuffer* self, const gchar* name, GError** error) {
	DioriteRichTextBufferTag* tag = NULL;
	GQueue* _tmp0_;
	gpointer _tmp1_;
	DioriteRichTextBufferTag* _tmp2_;
	DioriteRichTextBufferTag* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	DioriteRichTextBufferTag* _tmp18_;
	GtkTextMark* _tmp19_;
	GtkTextIter _tmp20_ = {0};
	GtkTextIter _tmp21_ = {0};
	DioriteRichTextBufferTag* _tmp22_;
	GtkTextTag* _tmp23_;
	GtkTextIter _tmp24_;
	GtkTextIter _tmp25_;
	DioriteRichTextBufferTag* _tmp26_;
	GtkTextMark* _tmp27_;
	GError * _inner_error_ = NULL;
#line 576 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 576 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (name != NULL);
#line 578 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->tag_stack;
#line 578 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = g_queue_pop_tail (_tmp0_);
#line 578 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	tag = (DioriteRichTextBufferTag*) _tmp1_;
#line 579 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = tag;
#line 579 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp2_ == NULL) {
#line 1877 "RichTextBuffer.c"
		GError* _tmp3_;
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = g_error_new_literal (G_MARKUP_ERROR, G_MARKUP_ERROR_PARSE, "Attempt to close $(name), but not tag is open.");
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = _tmp3_;
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_diorite_rich_text_buffer_tag_free0 (tag);
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 1891 "RichTextBuffer.c"
		} else {
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_diorite_rich_text_buffer_tag_free0 (tag);
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 581 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 1901 "RichTextBuffer.c"
		}
	}
#line 583 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp4_ = tag;
#line 583 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp5_ = _tmp4_->name;
#line 583 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp6_ = name;
#line 583 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) != 0) {
#line 1912 "RichTextBuffer.c"
		GQueue* _tmp7_;
		DioriteRichTextBufferTag* _tmp8_;
		DioriteRichTextBufferTag* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		GError* _tmp16_;
		GError* _tmp17_;
#line 585 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = self->priv->tag_stack;
#line 585 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp8_ = tag;
#line 585 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		tag = NULL;
#line 585 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_queue_push_tail (_tmp7_, _tmp8_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp9_ = tag;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp10_ = _tmp9_->name;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp11_ = string_to_string (_tmp10_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp12_ = name;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp13_ = string_to_string (_tmp12_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp14_ = g_strconcat ("Expected tag ", _tmp11_, ", found ", _tmp13_, NULL);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp15_ = _tmp14_;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp16_ = g_error_new_literal (G_MARKUP_ERROR, G_MARKUP_ERROR_PARSE, _tmp15_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp17_ = _tmp16_;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_tmp15_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = _tmp17_;
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (_inner_error_->domain == G_MARKUP_ERROR) {
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_propagate_error (error, _inner_error_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_diorite_rich_text_buffer_tag_free0 (tag);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 1962 "RichTextBuffer.c"
		} else {
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_diorite_rich_text_buffer_tag_free0 (tag);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 586 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 1972 "RichTextBuffer.c"
		}
	}
#line 589 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp18_ = tag;
#line 589 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp19_ = _tmp18_->mark;
#line 589 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &_tmp20_, _tmp19_);
#line 589 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	start = _tmp20_;
#line 590 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_get_end_iter ((GtkTextBuffer*) self, &_tmp21_);
#line 590 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	end = _tmp21_;
#line 591 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp22_ = tag;
#line 591 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp23_ = _tmp22_->tag;
#line 591 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp24_ = start;
#line 591 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp25_ = end;
#line 591 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_apply_tag ((GtkTextBuffer*) self, _tmp23_, &_tmp24_, &_tmp25_);
#line 592 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp26_ = tag;
#line 592 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp27_ = _tmp26_->mark;
#line 592 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_delete_mark ((GtkTextBuffer*) self, _tmp27_);
#line 576 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_diorite_rich_text_buffer_tag_free0 (tag);
#line 2005 "RichTextBuffer.c"
}


static gchar* string_chug (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1199 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1200 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1200 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1201 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1201 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	g_strchug (_tmp1_);
#line 1202 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	result = _result_;
#line 1202 "/builddir/build/BUILD/diorite-4.4.0/vapi/glib-2.0.vapi"
	return result;
#line 2028 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_element_text (DioriteRichTextBuffer* self, GMarkupParseContext* context, const gchar* text, gsize text_len, GError** error) {
	const gchar* _tmp0_;
	gchar* _result_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp8_;
	const gchar* _tmp11_;
	gboolean _tmp12_;
	const gchar* _tmp13_;
#line 595 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 595 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (context != NULL);
#line 595 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (text != NULL);
#line 597 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = text;
#line 597 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 598 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		return;
#line 2056 "RichTextBuffer.c"
	}
#line 600 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = text;
#line 600 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = diorite_rich_text_buffer_norm_whitespace (self, _tmp1_);
#line 600 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_result_ = _tmp2_;
#line 601 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = _result_;
#line 601 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (g_strcmp0 (_tmp3_, " ") == 0) {
#line 602 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_result_);
#line 602 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		return;
#line 2072 "RichTextBuffer.c"
	}
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp5_ = self->priv->ignore_text;
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp5_) {
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = TRUE;
#line 2080 "RichTextBuffer.c"
	} else {
		gboolean _tmp6_;
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp6_ = self->priv->in_paragraph;
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = !_tmp6_;
#line 2087 "RichTextBuffer.c"
	}
#line 604 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp4_) {
#line 2091 "RichTextBuffer.c"
		const gchar* _tmp7_;
#line 606 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = text;
#line 606 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_warning ("RichTextBuffer.vala:606: Ignored text: '%s'", _tmp7_);
#line 607 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_result_);
#line 607 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		return;
#line 2101 "RichTextBuffer.c"
	}
#line 610 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp8_ = self->priv->strip_left;
#line 610 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp8_) {
#line 2107 "RichTextBuffer.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 612 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp9_ = _result_;
#line 612 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp10_ = string_chug (_tmp9_);
#line 612 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_result_);
#line 612 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_result_ = _tmp10_;
#line 613 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		self->priv->strip_left = FALSE;
#line 2120 "RichTextBuffer.c"
	}
#line 616 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp11_ = _result_;
#line 616 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp12_ = g_str_has_suffix (_tmp11_, " ");
#line 616 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp12_) {
#line 617 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		self->priv->strip_left = TRUE;
#line 2130 "RichTextBuffer.c"
	}
#line 618 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp13_ = _result_;
#line 618 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_insert_at_cursor ((GtkTextBuffer*) self, _tmp13_, -1);
#line 595 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (_result_);
#line 2138 "RichTextBuffer.c"
}


static DioriteRichTextLink* diorite_rich_text_buffer_create_link_tag (DioriteRichTextBuffer* self, const gchar* uri) {
	DioriteRichTextLink* result = NULL;
	DioriteRichTextLink* tag = NULL;
	const gchar* _tmp0_;
	DioriteRichTextLink* _tmp1_;
	GtkTextTagTable* _tmp2_;
	GtkTextTagTable* _tmp3_;
	DioriteRichTextLink* _tmp4_;
	GdkRGBA* _tmp5_;
	GdkRGBA* _tmp6_;
	DioriteRichTextLink* weak_tag = NULL;
	DioriteRichTextLink* _tmp10_;
#line 622 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 622 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 624 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = uri;
#line 624 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = diorite_rich_text_link_new (_tmp0_);
#line 624 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	tag = _tmp1_;
#line 625 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) self);
#line 625 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = _tmp2_;
#line 625 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp4_ = tag;
#line 625 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_tag_table_add (_tmp3_, (GtkTextTag*) _tmp4_);
#line 626 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp5_ = diorite_rich_text_buffer_get_link_color (self);
#line 626 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp6_ = _tmp5_;
#line 626 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp6_ != NULL) {
#line 2178 "RichTextBuffer.c"
		DioriteRichTextLink* _tmp7_;
		GdkRGBA* _tmp8_;
		GdkRGBA* _tmp9_;
#line 628 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = tag;
#line 628 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp8_ = diorite_rich_text_buffer_get_link_color (self);
#line 628 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp9_ = _tmp8_;
#line 628 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_object_set ((GtkTextTag*) _tmp7_, "foreground-rgba", _tmp9_, NULL);
#line 2190 "RichTextBuffer.c"
	}
#line 630 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp10_ = tag;
#line 630 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	weak_tag = _tmp10_;
#line 631 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = weak_tag;
#line 631 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_object_unref0 (tag);
#line 631 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 2202 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_find_link_and_set_color (DioriteRichTextBuffer* self, GtkTextTag* tag) {
	GtkTextTag* _tmp0_;
#line 634 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 634 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (tag != NULL);
#line 636 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = tag;
#line 636 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DIORITE_TYPE_RICH_TEXT_LINK)) {
#line 2216 "RichTextBuffer.c"
		GtkTextTag* _tmp1_;
		GdkRGBA* _tmp2_;
		GdkRGBA* _tmp3_;
#line 637 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = tag;
#line 637 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = diorite_rich_text_buffer_get_link_color (self);
#line 637 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = _tmp2_;
#line 637 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_object_set (_tmp1_, "foreground-rgba", _tmp3_, NULL);
#line 2228 "RichTextBuffer.c"
	}
}


static GdkPixbuf* diorite_rich_text_buffer_get_missing_image_pixbuf (DioriteRichTextBuffer* self) {
	GdkPixbuf* result = NULL;
	GtkOffscreenWindow* widget = NULL;
	GtkOffscreenWindow* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
#line 640 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 642 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = (GtkOffscreenWindow*) gtk_offscreen_window_new ();
#line 642 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_object_ref_sink (_tmp0_);
#line 642 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	widget = _tmp0_;
#line 643 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = gtk_widget_render_icon ((GtkWidget*) widget, GTK_STOCK_MISSING_IMAGE, GTK_ICON_SIZE_DIALOG, NULL);
#line 643 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	pixbuf = _tmp1_;
#line 644 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_widget_destroy ((GtkWidget*) widget);
#line 645 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = pixbuf;
#line 645 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_object_unref0 (widget);
#line 645 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 2259 "RichTextBuffer.c"
}


/**
 * Inserts image at cursor
 * 
 * @param path      path to image file (missing image icon will be shown if path is null)
 * @param width     image width (-1 to use original width)
 * @param height    image height (-1 to use original height)
 */
static gboolean* _bool_dup (gboolean* self) {
	gboolean* dup;
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	dup = g_new0 (gboolean, 1);
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return dup;
#line 2278 "RichTextBuffer.c"
}


static gpointer __bool_dup0 (gpointer self) {
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self ? _bool_dup (self) : NULL;
#line 2285 "RichTextBuffer.c"
}


void diorite_rich_text_buffer_insert_image_at_cursor (DioriteRichTextBuffer* self, const gchar* path, gint width, gint height) {
	GdkPixbuf* pixbuf = NULL;
	gboolean real_size = FALSE;
	gint real_width = 0;
	gint real_height = 0;
	const gchar* _tmp0_;
	GdkPixbuf* _tmp35_;
	GError * _inner_error_ = NULL;
#line 655 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 658 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	real_size = TRUE;
#line 659 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	real_width = -1;
#line 660 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	real_height = -1;
#line 661 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = path;
#line 661 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp0_ == NULL) {
#line 2309 "RichTextBuffer.c"
		GdkPixbuf* _tmp1_;
#line 663 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = diorite_rich_text_buffer_get_missing_image_pixbuf (self);
#line 663 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_object_unref0 (pixbuf);
#line 663 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		pixbuf = _tmp1_;
#line 2317 "RichTextBuffer.c"
	} else {
		{
			GdkPixbuf* _tmp2_ = NULL;
			const gchar* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			gint _tmp13_;
			GdkPixbuf* _tmp28_;
			gboolean _tmp29_;
			gboolean* _tmp30_;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp3_ = path;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp4_ = width;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp5_ = height;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp6_ = gdk_pixbuf_new_from_file_at_size (_tmp3_, _tmp4_, _tmp5_, &_inner_error_);
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp2_ = _tmp6_;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2347 "RichTextBuffer.c"
				goto __catch6_g_error;
			}
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp7_ = _tmp2_;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp2_ = NULL;
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_object_unref0 (pixbuf);
#line 669 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			pixbuf = _tmp7_;
#line 670 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp8_ = pixbuf;
#line 670 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp9_ = path;
#line 670 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 670 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_object_set_data_full ((GObject*) _tmp8_, DIORITE_RICH_TEXT_BUFFER_IMAGE_PATH, _tmp10_, g_free);
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp13_ = height;
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (_tmp13_ != -1) {
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp12_ = TRUE;
#line 2372 "RichTextBuffer.c"
			} else {
				gint _tmp14_;
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp14_ = width;
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp12_ = _tmp14_ != -1;
#line 2379 "RichTextBuffer.c"
			}
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (_tmp12_) {
#line 2383 "RichTextBuffer.c"
				const gchar* _tmp15_;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				GdkPixbufFormat* _tmp18_;
#line 673 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp15_ = path;
#line 673 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp18_ = gdk_pixbuf_get_file_info (_tmp15_, &_tmp16_, &_tmp17_);
#line 673 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				real_width = _tmp16_;
#line 673 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				real_height = _tmp17_;
#line 673 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp11_ = _tmp18_ != NULL;
#line 2398 "RichTextBuffer.c"
			} else {
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp11_ = FALSE;
#line 2402 "RichTextBuffer.c"
			}
#line 672 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (_tmp11_) {
#line 2406 "RichTextBuffer.c"
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				gint _tmp21_;
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				_tmp21_ = height;
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp21_ == -1) {
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp20_ = TRUE;
#line 2416 "RichTextBuffer.c"
				} else {
					gint _tmp22_;
					gint _tmp23_;
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp22_ = height;
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp23_ = real_height;
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp20_ = _tmp22_ == _tmp23_;
#line 2426 "RichTextBuffer.c"
				}
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				if (_tmp20_) {
#line 2430 "RichTextBuffer.c"
					gboolean _tmp24_ = FALSE;
					gint _tmp25_;
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp25_ = width;
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					if (_tmp25_ == -1) {
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp24_ = TRUE;
#line 2439 "RichTextBuffer.c"
					} else {
						gint _tmp26_;
						gint _tmp27_;
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp26_ = width;
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp27_ = real_width;
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
						_tmp24_ = _tmp26_ == _tmp27_;
#line 2449 "RichTextBuffer.c"
					}
#line 676 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp19_ = _tmp24_;
#line 2453 "RichTextBuffer.c"
				} else {
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
					_tmp19_ = FALSE;
#line 2457 "RichTextBuffer.c"
				}
#line 675 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
				real_size = _tmp19_;
#line 2461 "RichTextBuffer.c"
			}
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp28_ = pixbuf;
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp29_ = real_size;
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp30_ = __bool_dup0 (&_tmp29_);
#line 678 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_object_set_data_full ((GObject*) _tmp28_, "has_real_size", _tmp30_, g_free);
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_object_unref0 (_tmp2_);
#line 2473 "RichTextBuffer.c"
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			GdkPixbuf* _tmp31_;
			const gchar* _tmp32_;
			GError* _tmp33_;
			const gchar* _tmp34_;
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			e = _inner_error_;
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_inner_error_ = NULL;
#line 682 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp31_ = diorite_rich_text_buffer_get_missing_image_pixbuf (self);
#line 682 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_object_unref0 (pixbuf);
#line 682 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			pixbuf = _tmp31_;
#line 683 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp32_ = path;
#line 683 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp33_ = e;
#line 683 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_tmp34_ = _tmp33_->message;
#line 683 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_warning ("RichTextBuffer.vala:683: Unable to load image %s: %s", _tmp32_, _tmp34_);
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_error_free0 (e);
#line 2503 "RichTextBuffer.c"
		}
		__finally6:
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			_g_object_unref0 (pixbuf);
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 667 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			return;
#line 2516 "RichTextBuffer.c"
		}
	}
#line 687 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp35_ = pixbuf;
#line 687 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_insert_pixbuf_at_cursor (self, _tmp35_);
#line 655 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_object_unref0 (pixbuf);
#line 2525 "RichTextBuffer.c"
}


/**
 * Inserts pixbuf at cursor
 * 
 * @param pixbuf    pixbuf to insert
 */
void diorite_rich_text_buffer_insert_pixbuf_at_cursor (DioriteRichTextBuffer* self, GdkPixbuf* pixbuf) {
	GtkTextIter iter = {0};
	GtkTextMark* _tmp0_;
	GtkTextIter _tmp1_ = {0};
	GtkTextIter _tmp2_;
	GdkPixbuf* _tmp3_;
#line 695 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 695 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (pixbuf != NULL);
#line 698 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = gtk_text_buffer_get_insert ((GtkTextBuffer*) self);
#line 698 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self, &_tmp1_, _tmp0_);
#line 698 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	iter = _tmp1_;
#line 699 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = iter;
#line 699 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = pixbuf;
#line 699 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	gtk_text_buffer_insert_pixbuf ((GtkTextBuffer*) self, &_tmp2_, _tmp3_);
#line 2556 "RichTextBuffer.c"
}


GdkRGBA* diorite_rich_text_buffer_get_link_color (DioriteRichTextBuffer* self) {
	GdkRGBA* result;
	GdkRGBA* _tmp0_;
#line 118 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->_link_color;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = _tmp0_;
#line 120 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 2571 "RichTextBuffer.c"
}


static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self) {
	GdkRGBA* dup;
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	dup = g_new0 (GdkRGBA, 1);
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	memcpy (dup, self, sizeof (GdkRGBA));
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return dup;
#line 2583 "RichTextBuffer.c"
}


static gpointer __gdk_rgba_dup0 (gpointer self) {
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self ? _gdk_rgba_dup (self) : NULL;
#line 2590 "RichTextBuffer.c"
}


static void _diorite_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach (GtkTextTag* tag, gpointer self) {
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_find_link_and_set_color ((DioriteRichTextBuffer*) self, tag);
#line 2597 "RichTextBuffer.c"
}


void diorite_rich_text_buffer_set_link_color (DioriteRichTextBuffer* self, GdkRGBA* value) {
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
#line 122 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = value;
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = __gdk_rgba_dup0 (_tmp0_);
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (self->priv->_link_color);
#line 124 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_link_color = _tmp1_;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = self->priv->_link_color;
#line 125 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp2_ != NULL) {
#line 2619 "RichTextBuffer.c"
		GtkTextTagTable* _tmp3_;
		GtkTextTagTable* _tmp4_;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) self);
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = _tmp3_;
#line 126 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		gtk_text_tag_table_foreach (_tmp4_, _diorite_rich_text_buffer_find_link_and_set_color_gtk_text_tag_table_foreach, self);
#line 2628 "RichTextBuffer.c"
	}
}


DioriteImageLocator diorite_rich_text_buffer_get_image_locator (DioriteRichTextBuffer* self, gpointer* result_target) {
	DioriteImageLocator result;
	DioriteImageLocator _tmp0_;
	void* _tmp0__target;
	DioriteImageLocator _tmp1_;
	void* _tmp1__target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->_image_locator;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0__target = self->priv->_image_locator_target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = _tmp0_;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1__target = _tmp0__target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	*result_target = _tmp1__target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = _tmp1_;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 2655 "RichTextBuffer.c"
}


void diorite_rich_text_buffer_set_image_locator (DioriteRichTextBuffer* self, DioriteImageLocator value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	DioriteImageLocator _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = value;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0__target = value_target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0__target_destroy_notify = value_target_destroy_notify;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value_target = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value_target_destroy_notify = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	(self->priv->_image_locator_target_destroy_notify == NULL) ? NULL : (self->priv->_image_locator_target_destroy_notify (self->priv->_image_locator_target), NULL);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target_destroy_notify = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator = _tmp0_;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target = _tmp0__target;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target_destroy_notify = _tmp0__target_destroy_notify;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value_target = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	value_target_destroy_notify = NULL;
#line 2699 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_real_image_requested (DioriteRichTextBuffer* self, const gchar* uri, gint width, gint height) {
	DioriteImageLocator _tmp0_;
	void* _tmp0__target;
	DioriteImageLocator _tmp1_;
	void* _tmp1__target;
#line 222 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (uri != NULL);
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = diorite_rich_text_buffer_get_image_locator (self, &_tmp0__target);
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = _tmp0_;
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1__target = _tmp0__target;
#line 224 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (_tmp1_ != NULL) {
#line 2718 "RichTextBuffer.c"
		DioriteImageLocator _tmp2_;
		void* _tmp2__target;
		DioriteImageLocator _tmp3_;
		void* _tmp3__target;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = diorite_rich_text_buffer_get_image_locator (self, &_tmp2__target);
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = _tmp2_;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3__target = _tmp2__target;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = uri;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp5_ = _tmp3_ (_tmp4_, _tmp3__target);
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp6_ = _tmp5_;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp7_ = width;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp8_ = height;
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		diorite_rich_text_buffer_insert_image_at_cursor (self, _tmp6_, _tmp7_, _tmp8_);
#line 225 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (_tmp6_);
#line 2748 "RichTextBuffer.c"
	}
}


static void g_cclosure_user_marshal_VOID__STRING_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_INT_INT) (gpointer data1, const char* arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (n_param_values == 4);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data1 = closure->data;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data2 = param_values->data[0].v_pointer;
#line 2768 "RichTextBuffer.c"
	} else {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data1 = param_values->data[0].v_pointer;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data2 = closure->data;
#line 2774 "RichTextBuffer.c"
	}
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	callback = (GMarshalFunc_VOID__STRING_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 2780 "RichTextBuffer.c"
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT) (gpointer data1, const char* arg_1, gpointer arg_2, gint arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (n_param_values == 6);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data1 = closure->data;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data2 = param_values->data[0].v_pointer;
#line 2799 "RichTextBuffer.c"
	} else {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data1 = param_values->data[0].v_pointer;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		data2 = closure->data;
#line 2805 "RichTextBuffer.c"
	}
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	callback = (GMarshalFunc_VOID__STRING_BOXED_INT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), g_value_get_boxed (param_values + 4), g_value_get_int (param_values + 5), data2);
#line 2811 "RichTextBuffer.c"
}


static gchar* _diorite_rich_text_buffer_default_image_locator_diorite_image_locator (const gchar* uri, gpointer self) {
	gchar* result;
	result = diorite_rich_text_buffer_default_image_locator ((DioriteRichTextBuffer*) self, uri);
#line 210 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 2820 "RichTextBuffer.c"
}


static GObject * diorite_rich_text_buffer_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DioriteRichTextBuffer * self;
	GtkTextTag* _tmp5_;
	GtkTextTag* _tmp6_;
	GtkTextTag* _tmp7_;
	GtkTextTag* _tmp8_;
	GtkTextTag* _tmp9_;
	GtkTextTag* _tmp10_;
	GtkTextTag* _tmp11_;
	GtkTextTag* _tmp12_;
	GtkTextTag* _tmp13_;
	GtkTextTag* _tmp14_;
	GtkTextTag* _tmp15_;
	GError * _inner_error_ = NULL;
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	parent_class = G_OBJECT_CLASS (diorite_rich_text_buffer_parent_class);
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBuffer);
#line 2846 "RichTextBuffer.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = g_regex_new ("(\n|\\s)+", 0, 0, &_inner_error_);
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = _tmp1_;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2859 "RichTextBuffer.c"
				goto __catch7_g_regex_error;
			}
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
			g_clear_error (&_inner_error_);
#line 2866 "RichTextBuffer.c"
		}
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp2_ = _tmp0_;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = NULL;
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_regex_unref0 (self->priv->strip_spaces);
#line 192 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		self->priv->strip_spaces = _tmp2_;
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_regex_unref0 (_tmp0_);
#line 2878 "RichTextBuffer.c"
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		e = _inner_error_;
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_inner_error_ = NULL;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp3_ = e;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp4_ = _tmp3_->message;
#line 196 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_error ("RichTextBuffer.vala:196: Failed to compile strip space regex: %s", _tmp4_);
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_error_free0 (e);
#line 2898 "RichTextBuffer.c"
	}
	__finally7:
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 190 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_clear_error (&_inner_error_);
#line 2907 "RichTextBuffer.c"
	}
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp5_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_BOLD, "weight", PANGO_WEIGHT_BOLD, NULL);
#line 199 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_bold = _tmp5_;
#line 200 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp6_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_ITALIC, "style", PANGO_STYLE_ITALIC, NULL);
#line 200 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_italic = _tmp6_;
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp7_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING1, "scale", PANGO_SCALE_XX_LARGE, "weight", PANGO_WEIGHT_HEAVY, NULL);
#line 201 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_h1 = _tmp7_;
#line 202 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp8_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING2, "scale", PANGO_SCALE_X_LARGE, "weight", PANGO_WEIGHT_BOLD, NULL);
#line 202 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_h2 = _tmp8_;
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp9_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_HEADING3, "scale", PANGO_SCALE_LARGE, "weight", PANGO_WEIGHT_BOLD, NULL);
#line 203 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_h3 = _tmp9_;
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp10_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_PARAGRAPH, NULL);
#line 204 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_para = _tmp10_;
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp11_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION_LIST, NULL);
#line 205 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_dl = _tmp11_;
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp12_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINED_TERM, "weight", PANGO_WEIGHT_BOLD, NULL);
#line 206 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_dt = _tmp12_;
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp13_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_DEFINITION, "left-margin", 50, NULL);
#line 207 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_dd = _tmp13_;
#line 208 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp14_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_UNORDERED_LIST, NULL);
#line 208 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_ul = _tmp14_;
#line 209 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp15_ = gtk_text_buffer_create_tag ((GtkTextBuffer*) self, DIORITE_RICH_TEXT_BUFFER_TEXT_TAG_LIST_ITEM, "left-margin", 13, "indent", -13, NULL);
#line 209 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_li = _tmp15_;
#line 210 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_set_image_locator (self, _diorite_rich_text_buffer_default_image_locator_diorite_image_locator, g_object_ref (self), g_object_unref);
#line 188 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return obj;
#line 2957 "RichTextBuffer.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 712 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self ? g_object_ref (self) : NULL;
#line 2964 "RichTextBuffer.c"
}


static DioriteRichTextBufferTag* diorite_rich_text_buffer_tag_new (const gchar* name, GtkTextMark* mark, GtkTextTag* tag) {
	DioriteRichTextBufferTag* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkTextMark* _tmp2_;
	GtkTextMark* _tmp3_;
	GtkTextTag* _tmp4_;
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (mark != NULL, NULL);
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = g_slice_new0 (DioriteRichTextBufferTag);
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_tag_instance_init (self);
#line 711 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = name;
#line 711 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 711 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (self->name);
#line 711 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->name = _tmp1_;
#line 712 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp2_ = mark;
#line 712 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 712 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_object_unref0 (self->mark);
#line 712 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->mark = _tmp3_;
#line 713 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp4_ = tag;
#line 713 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->tag = _tmp4_;
#line 709 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self;
#line 3007 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_tag_instance_init (DioriteRichTextBufferTag * self) {
}


static void diorite_rich_text_buffer_tag_free (DioriteRichTextBufferTag * self) {
#line 705 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (self->name);
#line 706 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_object_unref0 (self->mark);
#line 703 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_slice_free (DioriteRichTextBufferTag, self);
#line 3022 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_class_init (DioriteRichTextBufferClass * klass) {
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_parent_class = g_type_class_peek_parent (klass);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_type_class_add_private (klass, sizeof (DioriteRichTextBufferPrivate));
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	((DioriteRichTextBufferClass *) klass)->image_requested = diorite_rich_text_buffer_real_image_requested;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_rich_text_buffer_get_property;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_rich_text_buffer_set_property;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->constructor = diorite_rich_text_buffer_constructor;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_rich_text_buffer_finalize;
#line 3041 "RichTextBuffer.c"
	/**
	 * Emitted when image is about to be inserted.
	 * 
	 * The default handler inserts image with path retrieved by image_locator.
	 * 
	 * @param uri       image uri
	 * @param width     image width
	 * @param height    image height
	 */
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_IMAGE_REQUESTED_SIGNAL] = g_signal_new ("image_requested", DIORITE_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DioriteRichTextBufferClass, image_requested), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT_INT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
#line 3053 "RichTextBuffer.c"
	/**
	 * Emitted when an unknown in-line tag is opened. You can use provided
	 * information to create custom Gtk.TextTag and add it to tag stack via
	 * append_tag_to_stack().
	 * 
	 * @param name           tag name
	 * @param attr_names     names of attributes
	 * @param attr_values    values of attributes
	 */
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_OPENED_SIGNAL] = g_signal_new ("unknown_tag_opened", DIORITE_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_INT_BOXED_INT, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRV, G_TYPE_INT, G_TYPE_STRV, G_TYPE_INT);
#line 3065 "RichTextBuffer.c"
	/**
	 * Emitted when an unknown in-line tag is closed. You can use provided
	 * information to close custom Gtk.TextTag via close_tag_from_stack().
	 * 
	 * @param name    tag name
	 */
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_buffer_signals[DIORITE_RICH_TEXT_BUFFER_UNKNOWN_TAG_CLOSED_SIGNAL] = g_signal_new ("unknown_tag_closed", DIORITE_TYPE_RICH_TEXT_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 3074 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_instance_init (DioriteRichTextBuffer * self) {
	GQueue* _tmp0_;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv = DIORITE_RICH_TEXT_BUFFER_GET_PRIVATE (self);
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_link_color = NULL;
#line 152 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->insert_new_line = FALSE;
#line 153 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->strip_left = FALSE;
#line 154 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->in_paragraph = FALSE;
#line 155 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->ignore_text = FALSE;
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = g_queue_new ();
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->tag_stack = _tmp0_;
#line 3096 "RichTextBuffer.c"
}


static void diorite_rich_text_buffer_finalize (GObject * obj) {
	DioriteRichTextBuffer * self;
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBuffer);
#line 114 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (self->priv->_link_color);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	(self->priv->_image_locator_target_destroy_notify == NULL) ? NULL : (self->priv->_image_locator_target_destroy_notify (self->priv->_image_locator_target), NULL);
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target = NULL;
#line 130 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv->_image_locator_target_destroy_notify = NULL;
#line 151 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_regex_unref0 (self->priv->strip_spaces);
#line 156 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	__g_queue_free__diorite_rich_text_buffer_tag_free0_0 (self->priv->tag_stack);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (diorite_rich_text_buffer_parent_class)->finalize (obj);
#line 3120 "RichTextBuffer.c"
}


/**
 * Rich Text Buffer is used to load a XML-like document with
 * a limited formating.
 * 
 * Simple Document buffer supports a very very limited subset of HTML, you should
 * use WebKitGtk to render HTML documents. Supported tags are:
 * 
 * * <h1>, <h2>, <h3> - headings
 * * <p> - a paragraph
 * * <br /> - line break
 * * <b> - bold text
 * * <strong> - alias for <b>
 * * <i> - italic text
 * * <em> - alias for <i>
 * * <a href="uri"> - a link
 * * <dl> - a definition list
 * * <dt> - the defined term (must be inside <dl>)
 * * <dd> - definition (must be inside <dl>)
 * * <img src="uri" width="" height="" /> - an image
 * * <ul> - unordered list (bullets)
 * * <li> - list item
 * 
 * Tag <a> is inserted as anonymous Diorite.SimpleDocLink, <img> is inserted as Gtk.Pixbuf.
 * Other tags are inserted as Gtk.TextTags with names TEXT_TAG_*.
 */
GType diorite_rich_text_buffer_get_type (void) {
	static volatile gsize diorite_rich_text_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_rich_text_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteRichTextBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_rich_text_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteRichTextBuffer), 0, (GInstanceInitFunc) diorite_rich_text_buffer_instance_init, NULL };
		GType diorite_rich_text_buffer_type_id;
		diorite_rich_text_buffer_type_id = g_type_register_static (gtk_text_buffer_get_type (), "DioriteRichTextBuffer", &g_define_type_info, 0);
		g_once_init_leave (&diorite_rich_text_buffer_type_id__volatile, diorite_rich_text_buffer_type_id);
	}
	return diorite_rich_text_buffer_type_id__volatile;
}


static void _vala_diorite_rich_text_buffer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteRichTextBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBuffer);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	switch (property_id) {
#line 3166 "RichTextBuffer.c"
		default:
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3172 "RichTextBuffer.c"
	}
}


static void _vala_diorite_rich_text_buffer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteRichTextBuffer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_RICH_TEXT_BUFFER, DioriteRichTextBuffer);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	switch (property_id) {
#line 3182 "RichTextBuffer.c"
		default:
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 61 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3188 "RichTextBuffer.c"
	}
}


/**
 * Creates new link text tag.
 * 
 * @param uri    Target URI of the link
 */
DioriteRichTextLink* diorite_rich_text_link_construct (GType object_type, const gchar* uri) {
	DioriteRichTextLink * self = NULL;
	const gchar* _tmp0_;
#line 731 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 733 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = uri;
#line 733 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = (DioriteRichTextLink*) g_object_new (object_type, "underline", PANGO_UNDERLINE_SINGLE, "uri", _tmp0_, NULL);
#line 731 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return self;
#line 3209 "RichTextBuffer.c"
}


DioriteRichTextLink* diorite_rich_text_link_new (const gchar* uri) {
#line 731 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return diorite_rich_text_link_construct (DIORITE_TYPE_RICH_TEXT_LINK, uri);
#line 3216 "RichTextBuffer.c"
}


const gchar* diorite_rich_text_link_get_uri (DioriteRichTextLink* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_tmp0_ = self->priv->_uri;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	result = _tmp0_;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	return result;
#line 3231 "RichTextBuffer.c"
}


void diorite_rich_text_link_set_uri (DioriteRichTextLink* self, const gchar* value) {
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_return_if_fail (self != NULL);
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	if (g_strcmp0 (value, diorite_rich_text_link_get_uri (self)) != 0) {
#line 3240 "RichTextBuffer.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp0_ = value;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		_g_free0 (self->priv->_uri);
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		self->priv->_uri = _tmp1_;
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_object_notify ((GObject *) self, "uri");
#line 3253 "RichTextBuffer.c"
	}
}


static void diorite_rich_text_link_class_init (DioriteRichTextLinkClass * klass) {
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	diorite_rich_text_link_parent_class = g_type_class_peek_parent (klass);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_type_class_add_private (klass, sizeof (DioriteRichTextLinkPrivate));
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_rich_text_link_get_property;
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_rich_text_link_set_property;
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_rich_text_link_finalize;
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_RICH_TEXT_LINK_URI, g_param_spec_string ("uri", "Link uri", "Target URI of the link.", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3271 "RichTextBuffer.c"
}


static void diorite_rich_text_link_instance_init (DioriteRichTextLink * self) {
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self->priv = DIORITE_RICH_TEXT_LINK_GET_PRIVATE (self);
#line 3278 "RichTextBuffer.c"
}


static void diorite_rich_text_link_finalize (GObject * obj) {
	DioriteRichTextLink * self;
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLink);
#line 724 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	_g_free0 (self->priv->_uri);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	G_OBJECT_CLASS (diorite_rich_text_link_parent_class)->finalize (obj);
#line 3290 "RichTextBuffer.c"
}


/**
 * A text tag for links that holds link's URI.
 */
GType diorite_rich_text_link_get_type (void) {
	static volatile gsize diorite_rich_text_link_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_rich_text_link_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteRichTextLinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_rich_text_link_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteRichTextLink), 0, (GInstanceInitFunc) diorite_rich_text_link_instance_init, NULL };
		GType diorite_rich_text_link_type_id;
		diorite_rich_text_link_type_id = g_type_register_static (gtk_text_tag_get_type (), "DioriteRichTextLink", &g_define_type_info, 0);
		g_once_init_leave (&diorite_rich_text_link_type_id__volatile, diorite_rich_text_link_type_id);
	}
	return diorite_rich_text_link_type_id__volatile;
}


static void _vala_diorite_rich_text_link_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteRichTextLink * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLink);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	switch (property_id) {
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		case DIORITE_RICH_TEXT_LINK_URI:
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		g_value_set_string (value, diorite_rich_text_link_get_uri (self));
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3320 "RichTextBuffer.c"
		default:
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3326 "RichTextBuffer.c"
	}
}


static void _vala_diorite_rich_text_link_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteRichTextLink * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_RICH_TEXT_LINK, DioriteRichTextLink);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
	switch (property_id) {
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		case DIORITE_RICH_TEXT_LINK_URI:
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		diorite_rich_text_link_set_uri (self, g_value_get_string (value));
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3342 "RichTextBuffer.c"
		default:
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 721 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/RichTextBuffer.vala"
		break;
#line 3348 "RichTextBuffer.c"
	}
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/Labels.vala"
	if (array) {
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/Labels.vala"
		while (((gpointer*) array)[length]) {
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/Labels.vala"
			length++;
#line 3362 "RichTextBuffer.c"
		}
	}
#line 45 "/builddir/build/BUILD/diorite-4.4.0/src/gtk/Labels.vala"
	return length;
#line 3367 "RichTextBuffer.c"
}



